package de.mannheim.uni.index;

import java.io.IOException;

import org.apache.lucene.document.Document;
import org.apache.lucene.index.IndexWriter;
import org.apache.lucene.search.IndexSearcher;
import org.apache.lucene.store.Directory;

public interface IIndex {
	IndexSearcher getIndexSearcher();
	IndexWriter getIndexWriter();
	void closeIndexWriter();
	void closeIndexReader();
	int getNmDocs();
	void closeDir() throws IOException;
	Directory getDir();
	default Document getDocument(Integer i) {
		try {
			return getIndexSearcher().doc(i);
		}
		catch(IOException e) {
			throw new RuntimeException(e);
		}
	}
}
