package de.mannheim.uni;

import java.text.NumberFormat;
import java.text.ParseException;
import java.util.Locale;

public class NumericLocaleDeterminer {

	public static Double parse(String entryString) throws ParseException {
		NumberFormat format = null;

		
		String value = entryString.replaceAll("[^0-9\\,\\.\\-Ee\\+]", "");
		int firstOccur = value.indexOf('.');
		int commaOccur = value.indexOf(',');
		int lastOccur = value.lastIndexOf('.');
		if(firstOccur != -1) {
			if(lastOccur != firstOccur) {
				format =  NumberFormat.getInstance(Locale.GERMAN);
			}
			else {
				
				if(commaOccur != -1 && commaOccur > firstOccur) {
					format =  NumberFormat.getInstance(Locale.GERMAN);
					
				}
			}
		} 
		
		if(format == null) {
			if(commaOccur != -1) {
				int lastCommaOccur = value.lastIndexOf(',');
				
				if(lastOccur == -1 && lastCommaOccur != entryString.length() - 4) {
					format = NumberFormat.getInstance(Locale.GERMAN);
				}
			} 
		}

		if(format == null) {
			format = NumberFormat.getInstance(Locale.US);
		}

		Number number = format.parse(value);
		Double typedValue = number.doubleValue();
		
		return typedValue;
	}
	public static void main(String[] args) throws ParseException {
		System.out.println(parse("1000"));
		System.out.println(parse("1,000"));
		System.out.println(parse("1.000"));
		System.out.println(parse("1,000.14"));
		System.out.println(parse("1.000,14"));
		System.out.println(parse("1,00014"));
		System.out.println(parse("1.00014"));
		System.out.println(parse("1.000.014"));
		System.out.println(parse("1,000,014"));
	}
}
