package de.mannheim.uni.expansion.tablefusion.core.matching.impl.reference;

import java.util.Collection;
import java.util.HashMap;
import java.util.Map;

import de.mannheim.uni.expansion.data.dbpedia.kbtables.RepsitoryTableRow;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.matching.correspondences.Correspondence;
import de.mannheim.uni.matching.dbpedia.model.TableRow;

public class MatchedColumnData {

	private final Collection<Correspondence<TableRow>> refinedInstanceMappings;

	public MatchedColumnData(Collection<Correspondence<TableRow>> refinedInstanceMappings) {
		this.refinedInstanceMappings = refinedInstanceMappings;
	}



	public Collection<Correspondence<TableRow>> getRefinedInstanceMappings() {
		return refinedInstanceMappings;
	}

	// @Deprecated
	// public ClassId getHighestClass() {
	// Double maxSimilarity = null;
	// Table classTable = null;
	//
	// for (Table first : classSimilarity.getFirstDimension()) {
	// for (Table second : classSimilarity.getMatches(first)) {
	// if (maxSimilarity == null) {
	// maxSimilarity = classSimilarity.get(first, second);
	// classTable = second;
	// } else {
	// double sim = classSimilarity.get(first, second);
	// if (sim > maxSimilarity) {
	// maxSimilarity = sim;
	// classTable = second;
	// }
	//
	// }
	// }
	// }
	//
	// String header = classTable.getHeader();
	//
	// return new ClassId(header.substring(0, header.length() - 4));
	// }

	/**
	 * Uses the refined instance mappings to return a Map where row index is
	 * mapped to the matched instance
	 * 
	 * @return
	 */
	public Map<Integer, InstanceId> getRowInstanceMatches() {

		Map<Integer, InstanceId> map = new HashMap<Integer, InstanceId>();

		for (Correspondence<TableRow> c : this.refinedInstanceMappings) {
			Integer index = c.getFirst().getRowIndex();
			if (c.getSecond() instanceof RepsitoryTableRow) {

				InstanceId instance = ((RepsitoryTableRow) c.getSecond()).getInstanceId();

				map.put(index, instance);
			} else {
				throw new IllegalStateException("How can this not be RepositoryTableRow");
			}

		}

		return map;
	}
}
