package de.uni_mannheim.informatik.dws.expansion.matching;

import java.io.FileNotFoundException;
import java.io.IOException;

import javax.inject.Inject;
import javax.inject.Named;

import de.mannheim.uni.expansion.columnmatching.CMProperties;
import de.mannheim.uni.expansion.data.tables.reader.InvalidTableException;
import de.mannheim.uni.expansion.tablefusion.core.matching.impl.reference.MatchingDataBuilder;
import de.mannheim.uni.matching.dbpedia.algorithm.KeyIndex;
import de.mannheim.uni.matching.dbpedia.algorithm.WebtableToDBpediaMatchingProcess;
import de.mannheim.uni.matching.dbpedia.algorithm.WebtableToDBpediaMatchingProcess.tableType;
import de.mannheim.uni.matching.dbpedia.model.MatchingParameters;
import de.mannheim.uni.matching.dbpedia.model.MatchingResult;
import de.mannheim.uni.matching.process.Configuration;

public class SimpleMatchingService {

	final MatchingParameters matchingParameters;


	final String equivalentProperties;

	final Configuration configuration;

	// final ColumnMatchesForTable columnMatchesForTable;
	//
	// final CellMatchesWriter cellMatchesWriter = new CellMatchesWriter();

	@Inject
	public SimpleMatchingService(MatchingParameters matchingParameters, 
			@Named(CMProperties.SURFACE_FORMS) String surface, @Named(CMProperties.REDIRECTS) String redirects,
 @Named(CMProperties.EQUIVALENT_PROPERTIES) String eqProps,
			@Named(CMProperties.MATCHING_CONFIG) Configuration configuration) {

		this.matchingParameters = matchingParameters;
		this.matchingParameters.setTableType(tableType.jsonWebTable);
		this.equivalentProperties = eqProps;
		this.configuration = configuration;
		// this.columnMatchesForTable = columnMatchesForTable;

		// try {
//			Preprocessing.loadSurfaceForms(surface);
		// Preprocessing.loadRedirects(redirects);
		// } catch (FileNotFoundException e) {
		// // TODO Auto-generated catch block
		// e.printStackTrace();
		// } catch (IOException e) {
		// // TODO Auto-generated catch block
		// e.printStackTrace();
		// }

	}

	public void matchTable(MatchingDataBuilder matchingDataBuilder, KeyIndex luceneIndex, String matchingFile, String outputFolder)
			throws FileNotFoundException, IOException, InvalidTableException {


		String webtablePath = matchingFile;

		WebtableToDBpediaMatchingProcess m = new WebtableToDBpediaMatchingProcess();

		m.outputFolder = outputFolder;

		m.setMatchingParameters(matchingParameters);
		m.setLuceneIndex(luceneIndex.getLuceneIndex());
		m.setData(matchingDataBuilder.getMatchingData());

		// m.getData().loadEquivalentProperties(equivalentProperties);

		// TableColumnBuilder.computeStatistiscs = true;

		Configuration c = configuration.clone();
		c.getConfig().put(WebtableToDBpediaMatchingProcess.PAR_WEBTABLE, webtablePath);
		c.getConfig().put(WebtableToDBpediaMatchingProcess.PAR_EVALUATE, false);
		c.getConfig().put(WebtableToDBpediaMatchingProcess.PAR_TABLE_TYPE, WebtableToDBpediaMatchingProcess.tableType.jsonWebTable);
		m.run(c);
		MatchingResult mr = m.getResult();

		mr.write(tableType.jsonWebTable, outputFolder);
	}

}
