package de.mannheim.uni.expansion.data;

import java.rmi.RemoteException;
import java.util.Optional;
import java.util.concurrent.ConcurrentHashMap;

public class RemoteInterfaceWithCache {
	protected <K, O> O cacheGetter(ConcurrentHashMap<K, Optional<O>> map, K key, ValueGetter<K, O> valueGetter) {
		try {
			Optional<O> optional = map.get(key);

			if (optional == null) {
				O o = valueGetter.getValue(key);

				if (o == null) {
					map.putIfAbsent(key, Optional.empty());
					return null;
				} else {
					map.putIfAbsent(key, Optional.of(o));
					return o;
				}
			} else {
				if (optional.isPresent()) {
					return optional.get();
				} else {
					return null;
				}
			}

		} catch (RemoteException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	String nullReplacementString = new String("NULL REPLACEMENT STRING");

	@FunctionalInterface
	protected interface ValueGetter<K, O> {
		O getValue(K key) throws RemoteException;
	}

}
