package de.mannheim.uni.expansion.data.dbpedia.kbtables;

import java.util.Collection;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.repository.OntologyRepository;
import de.mannheim.uni.tableprocessor.model.Table;
import de.uni_mannheim.dws.expansion.data.kb.repository.KnowledgeBase;
import de.uni_mannheim.dws.expansion.data.ontology.model.ValueConverter;

public class RepositoryTableList implements Collection<Table> {

	private final KnowledgeBase dbPediaRepository;
	private final int size;
	private final OntologyRepository ontologyRepository;
	private final ValueConverter valueConverter;

	private final Set<ClassId> allowedClasses;

	public RepositoryTableList(KnowledgeBase dbPediaRepository, OntologyRepository ontologyRepository, ValueConverter valueConverter) {
		this.dbPediaRepository = dbPediaRepository;
		this.ontologyRepository = ontologyRepository;
		this.valueConverter = valueConverter;
		size = dbPediaRepository.getTotalNumberOfClasses();
		this.allowedClasses = null;
	}

	public RepositoryTableList(KnowledgeBase dbPediaRepository, OntologyRepository ontologyRepository, ValueConverter valueConverter,
			Set<ClassId> allowedClasses) {
		this.dbPediaRepository = dbPediaRepository;
		this.ontologyRepository = ontologyRepository;
		this.valueConverter = valueConverter;
		size = allowedClasses.size();
		this.allowedClasses = new HashSet<ClassId>(allowedClasses);
	}

	@Override
	public boolean add(Table e) {
		throw new UnsupportedOperationException();
	}

	@Override
	public boolean addAll(Collection<? extends Table> c) {
		throw new UnsupportedOperationException();
	}

	@Override
	public void clear() {
		throw new UnsupportedOperationException();

	}

	@Override
	public boolean contains(Object o) {
		throw new UnsupportedOperationException();
	}

	@Override
	public boolean containsAll(Collection<?> c) {
		throw new UnsupportedOperationException();
	}

	@Override
	public boolean isEmpty() {
		throw new UnsupportedOperationException();
	}

	@Override
	public Iterator<Table> iterator() {

		final Iterator<ClassId> classes;

		if (allowedClasses != null)
			classes = allowedClasses.iterator();
		else
			classes = dbPediaRepository.getClasses().iterator();

		return new Iterator<Table>() {

			@Override
			public Table next() {
				if (classes.hasNext()) {

					return new RepositoryTable(dbPediaRepository, ontologyRepository, valueConverter, classes.next());
				}

				return null;
			}

			@Override
			public boolean hasNext() {
				if (classes.hasNext()) {

					return true;

				}

				return false;
			}
		};
	}

	@Override
	public boolean remove(Object o) {
		throw new UnsupportedOperationException();
	}

	@Override
	public boolean removeAll(Collection<?> c) {
		throw new UnsupportedOperationException();
	}

	@Override
	public boolean retainAll(Collection<?> c) {
		throw new UnsupportedOperationException();
	}

	@Override
	public int size() {
		return size;
	}

	@Override
	public Object[] toArray() {
		throw new UnsupportedOperationException();
	}

	@Override
	public <T> T[] toArray(T[] a) {
		throw new UnsupportedOperationException();
	}

}
