package de.mannheim.uni.expansion.data.ontology.model.repository;

import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.ClassPropertyId;
import de.mannheim.uni.expansion.data.ontology.model.ListType;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.ValueType;

public interface OntologyRepository {

	public boolean isReferenceField(PropertyId propertyId);

	public ValueType getDataType(PropertyId propertyId);

	public Set<ClassId> getRange(ClassPropertyId propertyId);

	public Set<ClassId> getSubClasses(ClassId classId);

	public Set<ClassId> getParentClasses(ClassId classId);

	public Set<PropertyId> getAllPropertyParent(PropertyId propertyId);

	public Set<PropertyId> getDirectPropertyParent(PropertyId propertyId);

	public Set<ClassId> getDirectParentClasses(ClassId classId);
	// PropertyOntology get(PropertyId propertyId);

	public boolean isTimeDependent(PropertyId propertyId);

	public boolean isListType(PropertyId propertyId);

	public boolean isListType(ListType listType, PropertyId propertyId);

	public Set<ClassId> getDomain(ClassPropertyId propertyId);

	// ClassOntology get(ClassId classId);

	// ColumnDataType getDataType(ClassPropertyId classPropertyId);

	// ColumnDataType getDataType(ClassId classId, PropertyId propertyId);

	// Set<ClassId> getSubClasses(ClassId classId);
}
