package de.mannheim.uni.expansion.data.tables.model;

import java.util.Collections;
import java.util.Map;

import javax.inject.Inject;

import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;

public class AnnotatedTableColumn {

	private final Map<Integer, AbstractObject> values;

	@Inject
	public AnnotatedTableColumn(Map<Integer, AbstractObject> values) {
		this.values = Collections.unmodifiableMap(values);
	}

	public Map<Integer, AbstractObject> getValues() {
		return values;
	}

	public AbstractObject getValue(int row) {
		return values.get(row);
	}

}
