package de.mannheim.uni.expansion.data.tables.model;

import java.io.Serializable;

public class AnnotatedTableId implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	final private String id;
	private transient Integer hashCode;

	public AnnotatedTableId(String id) {
		this.id = id;
	}

	@Override
	public String toString() {
		return id;
	}

	public String getTableName() {
		return id;
	}

	@Override
	public int hashCode() {
		if (hashCode == null) {
			final int prime = 31;
			int result = 1;
			result = prime * result + ((id == null) ? 0 : id.hashCode());
			hashCode = result;
		}
		return hashCode;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		if (this.hashCode() != obj.hashCode())
			return false;
		AnnotatedTableId other = (AnnotatedTableId) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}

	public static int compare(AnnotatedTableId t1, AnnotatedTableId t2) {
		int c1 = t1.getTableName().compareTo(t2.getTableName());

		return c1;
	}

}
