package de.mannheim.uni.expansion.data.tables.model;

import java.io.Serializable;

import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;

public class AnnotatedTablePropertyId implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final AnnotatedTableId tableId;
	private final PropertyId propertyId;

	public AnnotatedTablePropertyId(AnnotatedTableId tableId, PropertyId propertyId) {
		super();
		this.tableId = tableId;
		this.propertyId = propertyId;
	}

	public AnnotatedTableId getTableId() {
		return tableId;
	}

	public PropertyId getPropertyId() {
		return propertyId;
	}

	@Override
	public String toString() {
		return "AnnotatedTablePropertyId [tableId=" + tableId + ", propertyId=" + propertyId + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((propertyId == null) ? 0 : propertyId.hashCode());
		result = prime * result + ((tableId == null) ? 0 : tableId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		AnnotatedTablePropertyId other = (AnnotatedTablePropertyId) obj;
		if (propertyId == null) {
			if (other.propertyId != null)
				return false;
		} else if (!propertyId.equals(other.propertyId))
			return false;
		if (tableId == null) {
			if (other.tableId != null)
				return false;
		} else if (!tableId.equals(other.tableId))
			return false;
		return true;
	}

}
