package de.mannheim.uni.expansion.data.tables.model;

public class CellIdx {
	private final ColumnIdx columnIdx;
	private final RowIdx rowIdx;

	public CellIdx(Integer columnIdx, Integer rowIdx) {
		super();
		this.columnIdx = new ColumnIdx(columnIdx);
		this.rowIdx = new RowIdx(rowIdx);
	}

	public CellIdx(ColumnIdx columnIdx, RowIdx rowIdx) {
		super();
		this.columnIdx = columnIdx;
		this.rowIdx = rowIdx;
	}

	public ColumnIdx getColumnIdx() {
		return columnIdx;
	}

	public RowIdx getRowIdx() {
		return rowIdx;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((columnIdx == null) ? 0 : columnIdx.hashCode());
		result = prime * result + ((rowIdx == null) ? 0 : rowIdx.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		CellIdx other = (CellIdx) obj;
		if (columnIdx == null) {
			if (other.columnIdx != null)
				return false;
		} else if (!columnIdx.equals(other.columnIdx))
			return false;
		if (rowIdx == null) {
			if (other.rowIdx != null)
				return false;
		} else if (!rowIdx.equals(other.rowIdx))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "CellIdx [columnIdx=" + columnIdx + ", rowIdx=" + rowIdx + "]";
	}

}