package de.mannheim.uni.expansion.data.tables.model;

public class ColumnIdx extends Number implements Comparable<ColumnIdx> {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final Integer columnIdx;
	private transient int hashCode;

	public ColumnIdx(Integer columnIdx) {
		super();
		this.columnIdx = columnIdx;
	}

	public Integer getColumnIdx() {
		return columnIdx;
	}

	@Override
	public int hashCode() {
		if (hashCode == 0) {
			int prime = 31;
			int result = 1;
			final int columnIdxHash = (columnIdx == null) ? 0 : columnIdx.hashCode();
			result = prime * result + columnIdxHash;
			if (result == 0) {
				prime = 92821;
				result = 1;
				result = prime * result + (columnIdxHash);
			}
			if (result == 0) {
				result = 1;
			}
			hashCode = result;
		}

		return hashCode;
	}

	@Override
	public boolean equals(Object obj) {
		if (this.hashCode() != obj.hashCode())
			return false;
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		if (this.hashCode() != obj.hashCode())
			return false;
		ColumnIdx other = (ColumnIdx) obj;
		if (columnIdx == null) {
			if (other.columnIdx != null)
				return false;
		} else if (!columnIdx.equals(other.columnIdx))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "ColumnIdx [columnIdx=" + columnIdx + "]";
	}

	@Override
	public int intValue() {
		return columnIdx;
	}

	@Override
	public long longValue() {
		return columnIdx;
	}

	@Override
	public float floatValue() {
		return columnIdx;
	}

	@Override
	public double doubleValue() {
		return columnIdx;
	}

	public static int compare(ColumnIdx a, ColumnIdx b) {
		return Integer.compare(a.getColumnIdx(), b.getColumnIdx());
	}

	@Override
	public int compareTo(ColumnIdx o) {
		return ColumnIdx.compare(this, o);
	}

}
