package de.mannheim.uni.expansion.data.tables.model;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.ValueType;

public class DataTemp implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private AnnotatedTableId id;
	private AnnotatedTableMetaData metaData;

	private Map<CellIdx, AbstractObject> values;
	private Map<CellIdx, String> strings;

	private Map<ColumnIdx, ValueType> dataTypes;

	private Map<ColumnIdx, AbstractObject> columnHeaders;

	private ColumnIdx keyColumn;

	@SuppressWarnings("unused")
	private DataTemp() {

	}

	public DataTemp(AnnotatedTablesReaderData data) {
		this.id = data.getId();
		this.metaData = data.getMetaData();
		this.values = data.getTableData().getValues();
		this.strings = data.getTableData().getStringValues();
		this.dataTypes = new HashMap<>(data.getTableData().getDataTypes());
		this.columnHeaders = new HashMap<>(data.getTableData().getColumnHeaders());
		this.keyColumn = data.getTableData().getKeyColumnIndex();

	}

	public AnnotatedTablesReaderData getData() {
		return new AnnotatedTablesReaderData(id, metaData, new AnnotatedTable(values, strings, dataTypes, keyColumn, columnHeaders));
	}
}