package de.mannheim.uni.expansion.data.tables.model;

import java.io.Serializable;

import de.mannheim.uni.utils.DomainUtils;

public class DomainSource implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private final String source;

	public DomainSource(String source) {
		this.source = source;
	}

	public static String getHost(String url) {
		// if (url == null || url.length() == 0)
		// return "";
		//
		// int doubleslash = url.indexOf("//");
		// if (doubleslash == -1)
		// doubleslash = 0;
		// else
		// doubleslash += 2;
		//
		// int end = url.indexOf('/', doubleslash);
		// end = end >= 0 ? end : url.length();
		//
		// int port = url.indexOf(':', doubleslash);
		// end = (port > 0 && port < end) ? port : end;
		//
		// return url.substring(doubleslash, end);

		String ret = DomainUtils.getSubDomainFromWholeUrl(url);
		// System.out.println(url + ">>" + ret);
		return ret;
	}

	public HostId getHostId() {

		String domain = getHost(source);
		return new HostId(domain);

	}

	public String getPLD() {
		return DomainUtils.getPayLevelDomainFromWholeURL(source);

	}

	public String getSource() {
		return source;
	}

	@Override
	public String toString() {
		return "DomainSource [source=" + source + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((source == null) ? 0 : source.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		DomainSource other = (DomainSource) obj;
		if (source == null) {
			if (other.source != null)
				return false;
		} else if (!source.equals(other.source))
			return false;
		return true;
	}

}
