package de.mannheim.uni.expansion.data.tables.model;

import java.io.Serializable;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;

public class InstanceIndexComposite implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final Integer index;
	private final InstanceId instanceId;

	public InstanceIndexComposite(Integer index, InstanceId instanceId) {
		super();
		this.index = index;
		this.instanceId = instanceId;
	}

	public Integer getIndex() {
		return index;
	}

	public InstanceId getInstanceId() {
		return instanceId;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((index == null) ? 0 : index.hashCode());
		result = prime * result + ((instanceId == null) ? 0 : instanceId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		InstanceIndexComposite other = (InstanceIndexComposite) obj;
		if (index == null) {
			if (other.index != null)
				return false;
		} else if (!index.equals(other.index))
			return false;
		if (instanceId == null) {
			if (other.instanceId != null)
				return false;
		} else if (!instanceId.equals(other.instanceId))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "[index=" + index + ", instanceId=" + instanceId + "]";
	}

}