package de.mannheim.uni.expansion.data.tables.model;

import java.io.Serializable;

import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;

public class PropertyIndexComposite implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final Integer index;
	private final PropertyId propertyId;

	public PropertyIndexComposite(Integer index, PropertyId propertyId) {
		this.index = index;
		this.propertyId = propertyId;
	}

	public Integer getIndex() {
		return index;
	}

	public PropertyId getPropertyId() {
		return propertyId;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((index == null) ? 0 : index.hashCode());
		result = prime * result + ((propertyId == null) ? 0 : propertyId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		PropertyIndexComposite other = (PropertyIndexComposite) obj;
		if (index == null) {
			if (other.index != null)
				return false;
		} else if (!index.equals(other.index))
			return false;
		if (propertyId == null) {
			if (other.propertyId != null)
				return false;
		} else if (!propertyId.equals(other.propertyId))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "PropertyIndexComposite [index=" + index + ", propertyId=" + propertyId + "]";
	}

}