package de.mannheim.uni.expansion.data.tables.model;

public class RowIdx implements Comparable<RowIdx> {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final Integer rowIdx;
	private transient int hashCode = 0;

	public RowIdx(Integer rowIdx) {
		super();
		this.rowIdx = rowIdx;
	}

	public Integer getRowIdx() {
		return rowIdx;
	}

	@Override
	public int hashCode() {
		if (hashCode == 0) {
			int prime = 31;
			int result = 1;
			final int rowIdxHash = (rowIdx == null) ? 0 : rowIdx.hashCode();
			result = prime * result + rowIdxHash;
			if (result == 0) {
				prime = 92821;
				result = 1;
				result = prime * result + (rowIdxHash);
			}
			if (result == 0) {
				result = 1;
			}
			hashCode = result;
		}
		return hashCode;
	}

	@Override
	public boolean equals(Object obj) {
		if (this.hashCode() != obj.hashCode())
			return false;
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		RowIdx other = (RowIdx) obj;
		if (rowIdx == null) {
			if (other.rowIdx != null)
				return false;
		} else if (!rowIdx.equals(other.rowIdx))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "RowIdx [rowIdx=" + rowIdx + "]";
	}

	public static int compare(RowIdx a, RowIdx b) {
		return Integer.compare(a.getRowIdx(), b.getRowIdx());
	}

	@Override
	public int compareTo(RowIdx o) {
		return RowIdx.compare(this, o);
	}

}
