package de.mannheim.uni.expansion.data.tables.model;

import java.util.Set;

import de.mannheim.uni.expansion.utils.UuidStringId;

public class TableIdsSet {

	private final UuidStringId id;

	private final Set<AnnotatedTableId> tableIds;

	public TableIdsSet(Set<AnnotatedTableId> tableIds) {
		super();
		this.tableIds = tableIds;
		this.id = new UuidStringId();
	}

	public TableIdsSet(Set<AnnotatedTableId> tableIds, UuidStringId id) {
		super();
		this.tableIds = tableIds;
		this.id = id;

	}

	public Set<AnnotatedTableId> getTableIds() {
		return tableIds;
	}

	public UuidStringId getId() {
		return id;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		result = prime * result + ((tableIds == null) ? 0 : tableIds.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		TableIdsSet other = (TableIdsSet) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		if (tableIds == null) {
			if (other.tableIds != null)
				return false;
		} else if (!tableIds.equals(other.tableIds))
			return false;
		return true;
	}


}
