package de.mannheim.uni.expansion.data.tables.model;

import java.util.Comparator;

public class TableRowIdPair {
	private final TableRowId id1;
	private final TableRowId id2;

	private final static Comparator<TableRowId> comp = (t1, t2) -> {
		return TableRowId.compare(t1, t2);

	};

	public TableRowIdPair(TableRowId id1, TableRowId id2) {

		int compare = comp.compare(id1, id2);
		if (compare == 0) {
			throw new IllegalStateException("A Table Row ID Pair can not be between the same entry");
		} else if (compare < 0) {
			this.id1 = id1;
			this.id2 = id2;
		} else {
			this.id1 = id2;
			this.id2 = id1;
		}
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id1 == null) ? 0 : id1.hashCode());
		result = prime * result + ((id2 == null) ? 0 : id2.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		TableRowIdPair other = (TableRowIdPair) obj;
		if (id1 == null) {
			if (other.id1 != null)
				return false;
		} else if (!id1.equals(other.id1))
			return false;
		if (id2 == null) {
			if (other.id2 != null)
				return false;
		} else if (!id2.equals(other.id2))
			return false;
		return true;
	}

	public TableRowId getId1() {
		return id1;
	}

	public TableRowId getId2() {
		return id2;
	}

	public static int compare(TableRowIdPair pair1, TableRowIdPair pair2) {
		int c1 = TableRowId.compare(pair1.id1, pair2.id1);
		if (c1 != 0) {
			return c1;
		} else {
			int c2 = TableRowId.compare(pair1.id2, pair2.id2);

			return c2;

		}
	}

}
