package de.mannheim.uni.expansion.data.tables.model;

import java.util.Set;

import de.mannheim.uni.expansion.utils.UuidStringId;

public class TableRowIdsSet {

	private final UuidStringId id;

	private final Set<TableRowId> rowIds;

	public TableRowIdsSet(Set<TableRowId> tableIds) {
		super();
		this.rowIds = tableIds;
		this.id = new UuidStringId();
	}

	public TableRowIdsSet(Set<TableRowId> tableIds, UuidStringId id) {
		super();
		this.rowIds = tableIds;
		this.id = id;

	}

	public Set<TableRowId> getRowIds() {
		return rowIds;
	}

	public UuidStringId getId() {
		return id;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		result = prime * result + ((rowIds == null) ? 0 : rowIds.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		TableRowIdsSet other = (TableRowIdsSet) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		if (rowIds == null) {
			if (other.rowIds != null)
				return false;
		} else if (!rowIds.equals(other.rowIds))
			return false;
		return true;
	}

}
