package de.mannheim.uni.expansion.data.tables.reader;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.zip.GZIPOutputStream;

import org.apache.commons.compress.archivers.tar.TarArchiveEntry;
import org.apache.commons.compress.archivers.tar.TarArchiveOutputStream;

public class BadAnnotatedTablesWriter {

	TarArchiveOutputStream tarFile;

	public BadAnnotatedTablesWriter(String fileName) throws FileNotFoundException, IOException {
		tarFile = new TarArchiveOutputStream(new GZIPOutputStream(new FileOutputStream(fileName)));

	}

	public synchronized void writeEntry(String name, byte[] bytes) throws IOException {

		TarArchiveEntry entry = new TarArchiveEntry(name);
		entry.setSize(bytes.length);

		tarFile.putArchiveEntry(entry);

		tarFile.write(bytes);

		tarFile.closeArchiveEntry();
	}

	public synchronized void finishAndClose() throws IOException {

		tarFile.finish();

		tarFile.close();
	}
}
