package de.mannheim.uni.expansion.data.tables.reader;

import java.lang.reflect.Field;

import com.esotericsoftware.kryo.Kryo;
import com.esotericsoftware.kryo.Serializer;
import com.esotericsoftware.kryo.factories.SerializerFactory;
import com.esotericsoftware.kryo.serializers.CompatibleFieldSerializer;
import com.esotericsoftware.kryo.serializers.FieldSerializer.CachedField;

public class CustomKryoSerializerFactory implements SerializerFactory {

	@SuppressWarnings("rawtypes")
	@Override
	public Serializer makeSerializer(Kryo kryo, Class<?> type) {
		try {
			Serializer<?> serializer = new CompatibleFieldSerializer<>(kryo, type);
			Field fieldsField;
			fieldsField = serializer.getClass().getDeclaredField("fields");

			Field transientFieldsField = serializer.getClass().getDeclaredField("transientFields");
			CachedField[] fields = (CachedField[]) fieldsField.get(serializer);
			CachedField[] transientFields = (CachedField[]) transientFieldsField.get(serializer);
			CachedField[] newFields = new CachedField[fields.length + transientFields.length];
			int i = 0;
			for (CachedField f : fields) {
				newFields[i] = f;
				i++;
			}
			for (CachedField f : transientFields) {
				newFields[i] = f;
				i++;
			}
			fieldsField.setAccessible(true);
			fieldsField.set(serializer, newFields);
			return serializer;

		} catch (NoSuchFieldException | SecurityException | IllegalArgumentException | IllegalAccessException e) {
			throw new RuntimeException(e);
		}
	}

}
