package de.uni_mannheim.dws.expansion.data.utils.kryo;

import java.util.function.Consumer;

import javax.inject.Inject;

public class ConcurrentKryoAdapter {
	private final ConcurrentKryoReader kryoReader;

	private final ConcurrentKryoWriter kryoWriter;

	@Inject
	public ConcurrentKryoAdapter(ConcurrentKryoReader kryoReader, ConcurrentKryoWriter kryoWriter) {
		this.kryoReader = kryoReader;
		this.kryoWriter = kryoWriter;
	}

	public <T> void runForEachTable(Class<T> clazz, Consumer<T> fullConsumer, String folder, String prefix) {
		kryoReader.runForEachTable(clazz, fullConsumer, folder, prefix);
	}

	@Deprecated
	public <T> void runForEachTableWithReferences(Class<T> clazz, Consumer<T> fullConsumer, String folder, String prefix) {
		kryoReader.runForEachTableWithReferences(clazz, fullConsumer, folder, prefix);
	}

	public <T> void runForEachTable(Class<T> clazz, Consumer<T> fullConsumer, String folder, String prefix, int batchSize, boolean reportProgress) {
		kryoReader.runForEachTable(clazz, fullConsumer, folder, prefix, batchSize, reportProgress);
	}

	public <T> void runForEachTable(Class<T> clazz, Consumer<T> fullConsumer, String folder, String prefix, int batchSize) {
		kryoReader.runForEachTable(clazz, fullConsumer, folder, prefix, batchSize);

	}

	public <T> void writeAll(T poisen, Iterable<T> data, int size, String folder, String prefix, int groupNum) {
		kryoWriter.writeAll(poisen, data, size, folder, prefix, groupNum);
	}

	@Deprecated
	public <T> void writeAllWithReferences(T poisen, Iterable<T> data, int size, String folder, String prefix, int groupNum) {
		kryoWriter.writeAllWithReferences(poisen, data, size, folder, prefix, groupNum);
	}

}
