package de.mannheim.uni.expansion.tablefusion.core.fusing.impl.base;

import java.util.Collections;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.fusing.impl.generic.GenericMajorityMedianFuser;
import de.mannheim.uni.expansion.tablefusion.core.fusing.impl.generic.GenericMedianFuser;
import de.mannheim.uni.expansion.tablefusion.core.fusing.impl.generic.GenericMedianFuser.Comparer;
import de.mannheim.uni.expansion.tablefusion.core.fusing.impl.generic.GenericMedianFuser.ListSorter;
import de.mannheim.uni.expansion.tablefusion.core.fusing.impl.generic.GenericMedianFuser.Medianizer;
import de.mannheim.uni.expansion.tablefusion.core.fusing.impl.generic.GenericMedianFuser.TypeCaster;
import de.mannheim.uni.expansion.tablefusion.core.fusing.impl.generic.GenericMedianFuser.TypeChecker;
import de.mannheim.uni.expansion.tablefusion.core.similarity.SimilarityCalculator;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.QuantityObject;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.ValueType;

public class BaseNumericFuser extends GenericMajorityMedianFuser<QuantityObject> {

	private final static TypeChecker<QuantityObject> typeChecker = (o) -> {

		if (o instanceof QuantityObject) {
			return true;
		}

		// else if (o instanceof String) {
		// // TODO: Wrong Place for fix
		// String s = (String) o;
		// s = s.replace("&nbsp;", "").trim();
		// try {
		// Double d = Double.valueOf(s);
		// return true;
		// } catch (NumberFormatException fe) {
		// return false;
		// }
		// }

		return false;
	};

	private final static TypeCaster<QuantityObject> typeCaster = (o) -> {

		if (o instanceof QuantityObject) {
			return (QuantityObject) o;
		} else {
			return null;
		}

		// if (o instanceof Double) {
		// Double d = (Double) o;
		// return d;
		// } else if (o instanceof String) {
		// // TODO: Wrong Place for fix
		// String s = (String) o;
		// s = s.replace("&nbsp;", "").trim();
		// try {
		// Double d = Double.valueOf(s);
		// return d;
		// } catch (NumberFormatException fe) {
		// // if (s.length() > 0)
		// // System.err.println("WARNING: Value not numeric: " +
		// // o);
		// }
		// }
		//
		// return null;
	};

	private final static ListSorter<QuantityObject> listSorter = (list) -> {
		Collections.sort(list);
	};

	private final static Comparer<QuantityObject> comparer = (object, other) -> {
		return object.compareTo(other);
	};

	private final static Medianizer<QuantityObject> medianizer = (sortedSet, threshold) -> {
		return GenericMedianFuser.defaultMedianizer(sortedSet, threshold, QuantityObject::averager);
	};

	@Inject
	public BaseNumericFuser(SimilarityCalculator sc) {
		super(new GenericMedianFuser<>(typeChecker, typeCaster, listSorter, QuantityObject::averager, comparer, medianizer), sc.getMeasure(ValueType.QUANTITY));
	}

}
