package de.uni_mannheim.informatik.dws.attribute;

import java.util.HashMap;
import java.util.Map;
import java.util.Optional;

import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTablesReaderData;
import de.mannheim.uni.expansion.data.tables.model.PropertyIndexComposite;
import de.mannheim.uni.expansion.data.tables.model.TableColumnId;
import de.mannheim.uni.expansion.data.tables.reader.AnnotatedTableFilter;
import de.uni_mannheim.informatik.dws.attribute.model.AttributeMappings;
import de.uni_mannheim.informatik.dws.attribute.model.PropertyMapping;

public class AttributeMappingsFilter implements AnnotatedTableFilter {

	private final AttributeMappings mappings;

	public AttributeMappingsFilter(AttributeMappings mappings) {
		super();
		this.mappings = mappings;
	}

	@Override
	public Optional<AnnotatedTablesReaderData> filter(AnnotatedTablesReaderData data) {

		if (data.getId().getTableName().equals("1346981172231_1347011264447_3050.arc9167679534671747539#2935814_0_7628926464279511553")) {
			int sdf = 123;
		}
		Map<Integer, PropertyId> newProperties = new HashMap<>();
		Map<PropertyIndexComposite, Double> scores = new HashMap<>();

		for (int i = 0; i < data.getTableData().getColumns().size(); i++) {
			Optional<PropertyMapping> mapping = mappings.getMapping(new TableColumnId(data.getId(), i));
			if (mapping.isPresent()) {
				newProperties.put(i, mapping.get().getPropertyId());
				scores.put(new PropertyIndexComposite(i, mapping.get().getPropertyId()), mapping.get().getScore());
			}
		}

		return Optional.of(new AnnotatedTablesReaderData(data.getId(),
				data.getMetaData().rebuilder().setProperties(newProperties).setAllPropertyScores(scores).build(), data.getTableData()));
	}

}
