package de.uni_mannheim.informatik.dws.attribute.evaluation;

public class AttributeMappingsPerformance {

	private final int correct;
	private final int wrong;
	private final int maxCorrect;

	private final double precision;
	private final double recall;
	private final double fMeasure;

	public AttributeMappingsPerformance(int correct, int wrong, int maxCorrect) {
		super();

		this.correct = correct;
		this.wrong = wrong;
		this.maxCorrect = maxCorrect;
		double precision = Double.NaN;
		precision = ((double) correct) / (correct + wrong);
		if (Double.isNaN(precision)) {
			this.precision = 0;
		} else {
			this.precision = precision;
		}
		if (maxCorrect == 0) {
			this.recall = 1.0;
		} else {
			this.recall = ((double) correct) / (maxCorrect);
		}

		// this.aRecall = (this.recall + this.precision) / 2.0;

		double fMeasure = 2 * ((this.precision * recall) / (this.precision + recall));
		if (Double.isNaN(fMeasure))
			this.fMeasure = 0.0;
		else
			this.fMeasure = fMeasure;

	}

	public int getCorrect() {
		return correct;
	}

	public int getWrong() {
		return wrong;
	}

	public int getOverlapping() {
		return wrong + correct;
	}

	public int getMaxCorrect() {
		return maxCorrect;
	}

	public double getPrecision() {
		return precision;
	}

	public double getRecall() {
		return recall;
	}

	public double getfMeasure() {
		return fMeasure;
	}

}
