package de.uni_mannheim.informatik.dws.expansion.matching.testing;

import dagger.ObjectGraph;
import de.mannheim.uni.expansion.data.ontology.model.repository.OntologyRepository;
import de.mannheim.uni.expansion.utils.PersistentParallel4;
import de.uni_mannheim.dws.expansion.data.kb.repository.KnowledgeBase;
import de.uni_mannheim.informatik.dws.expansion.matching.KnowledgeBaseModule;
import de.uni_mannheim.informatik.dws.expansion.matching.testing.cases.DefaultTestCases;

public class EvaluateTestingTables {

	public static void main(String[] args) {

		String dataHome = null;

		if (args.length > 0 && args[0] != null && !args[0].equals("")) {
			dataHome = args[0];
		}

		String kbName = null;

		if (args.length > 1 && args[1] != null && !args[1].equals("")) {
			kbName = args[1];
		}

		String testName = null;

		if (args.length > 2 && args[2] != null && !args[2].equals("")) {
			testName = args[2];
		}

		String kbHome = dataHome + "/kbs/" + kbName + "/";
		String kbPath = kbHome + "/kb/";
		String ontologyRepositoryFile = kbHome + "/ontology.kryo";
		String luceneIndexCache = kbHome + "/lucene/";

		String outputFolder = dataHome + "/tests/";

		KnowledgeBaseModule kbModule = new KnowledgeBaseModule(kbPath, ontologyRepositoryFile, luceneIndexCache);

		ObjectGraph graph = ObjectGraph.create(kbModule);

		KnowledgeBase kb = graph.get(KnowledgeBase.class);
		OntologyRepository ontologyRepository = graph.get(OntologyRepository.class);

		TestingFramework testingFramework = new TestingFramework(DefaultTestCases.getDefaultCases(), kb, ontologyRepository);

		String uuid = testName;

		run(testingFramework, outputFolder, uuid);

		try {
			PersistentParallel4.close();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static void run(TestingFramework testingFramework, String outputFolder, String uuid) {
		testingFramework.runTestCases(outputFolder + uuid);

		int sdf = 123;
	}

}
