package de.uni_mannheim.informatik.dws.matching;

import java.util.concurrent.ConcurrentHashMap;

import de.mannheim.uni.expansion.data.dbpedia.kbtables.RepositoryTable;
import de.mannheim.uni.expansion.data.dbpedia.kbtables.RepositoryTableColumn;
import de.mannheim.uni.expansion.utils.CHMHelper;
import de.mannheim.uni.matching.dbpedia.model.adapters.TableColumnToCellHierarchyAdapter;
import de.mannheim.uni.matching.dbpedia.model.adapters.TableColumnToCellHierarchyAdapter.TableColumnCacheGetter;
import de.mannheim.uni.matching.dbpedia.model.adapters.TableToRowHierarchyAdapter;
import de.mannheim.uni.matching.dbpedia.model.adapters.TableToRowHierarchyAdapter.TableCacheGetter;
import de.mannheim.uni.tableprocessor.model.Table;
import de.mannheim.uni.tableprocessor.model.TableColumn;

public class TableCacheSetter {

	public static void setCaches() {
		ConcurrentHashMap<Object, Table> tableMap = new ConcurrentHashMap<>();
		TableToRowHierarchyAdapter.setCacheSynchronizedIfNotExists(new TableCacheGetter() {

			@Override
			public Table get(Table t) {
				if (t instanceof RepositoryTable) {
					return CHMHelper.getFromCHM(tableMap, t.getIdObject(), () -> t);
				} else {
					return t;
				}
			}
		});

		ConcurrentHashMap<Object, TableColumn> tableColumnMap = new ConcurrentHashMap<>();
		TableColumnToCellHierarchyAdapter.setCacheSynchronizedIfNotExists(new TableColumnCacheGetter() {

			@Override
			public TableColumn get(TableColumn tc) {
				if (tc instanceof RepositoryTableColumn) {
					return CHMHelper.getFromCHM(tableColumnMap, tc.getHashCodeObject(), () -> tc);
				} else {
					return tc;
				}
			}

			@Override
			public TableColumn getRaw(Object tc) {
				return tableColumnMap.get(tc);
				// if (tc instanceof RepositoryTableColumn) {
				// return CHMHelper.getFromCHM(tableColumnMap,
				// tc.getHashCodeObject(), () -> tc);
				// } else {
				// return tc;
				// }
			}
		});
	}

}
