package expansion.matching;

import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Optional;

import de.uni_mannheim.informatik.dws.expansion.matching.IndexBuilder;

public class LetterCombinerTest {

	public static void main(String[] args) {

		Map<String, String> testCandidates = new LinkedHashMap<>();
		testCandidates.put("", "");
		testCandidates.put("Y O", "YO");
		testCandidates.put("Y O Simmons", "YO Simmons");
		testCandidates.put("Y O Simmons M O F ", "YO Simmons MOF ");
		testCandidates.put("Angela Merkel ", "Angela Merkel ");
		testCandidates.put("F C Barcelona", "FC Barcelona");
		testCandidates.put("BarcelonaF C ", "BarcelonaF C ");
		testCandidates.put("Barcelona F C ", "Barcelona FC ");
		testCandidates.put(" H H F C ", " HHFC ");
		testCandidates.put(" S E K SONDEREINSATZKOMMANDA MA ", " SEK SONDEREINSATZKOMMANDA MA ");
		testCandidates.put("GEORGE W BUSH", "GEORGE W BUSH");
		testCandidates.put("banwell caves  banwell bone cave  1", "banwell caves  banwell bone cave  1");
		testCandidates.put("banwell caves f m banwell bone cave  1", "banwell caves fm banwell bone cave  1");
		testCandidates.put("banwell caves  f m  banwell bone cave  1", "banwell caves  fm  banwell bone cave  1");

		for (Entry<String, String> candidate : testCandidates.entrySet()) {

			Optional<String> ret = IndexBuilder.lettersCombiner(candidate.getKey());
			if (candidate.getValue().equals(candidate.getKey()) && !ret.isPresent()) {
				System.out.println("OK: " + candidate.getKey() + " : " + candidate.getValue());
			} else if (!ret.isPresent()) {
				System.out.println("FAIL: " + candidate.getKey() + " : " + candidate.getKey());
			} else if (!ret.get().equals(candidate.getValue())) {
				System.out.println("FAIL: " + candidate.getKey() + " : '" + ret.get() + "'");
			} else {
				System.out.println("OK: " + candidate.getKey() + " : " + candidate.getValue());
			}
		}
	}

}
