package de.uni_mannheim.informatik.dws.expansion.model.utils.performance;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId; 
import de.mannheim.uni.expansion.utils.containers.Pair;
import de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulators.ColumnList;
import de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulators.ColumnListDirectOutputter;

public class ColumnListExtendedOutputterGenerator {

	
	@Inject
	public ColumnListExtendedOutputterGenerator() {
	
	}
	public <X> ColumnListExtendedOutputter<X> generate(ColumnList<X> columnList) {
		
		return new ColumnListExtendedOutputter<>(columnList);
	}
	
	public class ColumnListExtendedOutputter<X>  extends ColumnListDirectOutputter<X>{
		 
		
		private ColumnListExtendedOutputter(ColumnList<X> columnList) {
			super(columnList);
		}
		
		public String outputWithoutHeader( String run, ClassId classId, X content) {
			return output(run, classId,content, false);
		}
		
		public String outputWithHeader(String run, ClassId classId, X content) {
			return output(run, classId, content, true);
		}
		
		private String output(String run, ClassId classId,X content, boolean header) {
			
			List<Pair<String,String>> prefix = new ArrayList<>();
			prefix.add(new Pair<>("RUN", run));
			prefix.add(new Pair<>("ClassId", classId.getFinalPart()));
			
			return output(content, prefix, header);
		}
	}
}
