package de.uni_mannheim.informatik.dws.expansion.model.utils.thresholdpacks;

import java.util.HashMap;
import java.util.Map;

import de.mannheim.uni.expansion.data.ontology.model.ClassPropertyId;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;

public class ThresholdClassPropertyId implements ThresholdContainer {
	private final Map<ClassPropertyId, Double> scores;

	public ThresholdClassPropertyId(Map<ClassPropertyId, Double> scores) {
		this.scores = new HashMap<>(scores);
	}

	@Override
	public Double getScore(ClassId classId, PropertyId propertyId, InstanceId instanceId) {
		return scores.get(new ClassPropertyId(classId, propertyId));
	}

	@Override
	public String toString() {
		return "ThresholdClassPropertyId [scores=" + scores + "]";
	}

}
