package de.uni_mannheim.informatik.dws.expansion.model.utils.thresholdpacks;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;

public class ThresholdContainerWithFallback implements ThresholdContainer {
	private final ThresholdContainer mainThreshold;
	private final ThresholdContainer fallback;

	public ThresholdContainerWithFallback(ThresholdContainer mainThreshold, ThresholdContainer fallback) {
		super();
		this.mainThreshold = mainThreshold;
		this.fallback = fallback;
	}

	@Override
	public Double getScore(ClassId classId, PropertyId propertyId, InstanceId instanceId) {
		Double score = mainThreshold.getScore(classId, propertyId, instanceId);
		if(score != null) {
			return score;
		}
		else {
			return fallback.getScore(classId, propertyId, instanceId);
		}
	}

	@Override
	public String toString() {
		return "ThresholdContainerWithFallback [mainThreshold=" + mainThreshold + ", fallback=" + fallback + "]";
	}
	
	

}
