package de.mannheim.uni.expansion.data.ontology.model;

import java.io.Serializable;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;

public class ClassInstanceId implements Serializable {

	/**
	 *  
	 */
	private static final long serialVersionUID = 1L;

	private final ClassId classId;
	private final InstanceId instanceId;

	public ClassId getClassId() {
		return classId;
	}

	public InstanceId getInstanceId() {
		return instanceId;
	}

	public ClassInstanceId(ClassId classId, InstanceId instanceId) {
		super();
		this.classId = classId;
		this.instanceId = instanceId;
	}

	@Override
	public String toString() {
		return "" + classId + "<>" + instanceId;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((classId == null) ? 0 : classId.hashCode());
		result = prime * result + ((instanceId == null) ? 0 : instanceId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ClassInstanceId other = (ClassInstanceId) obj;
		if (classId == null) {
			if (other.classId != null)
				return false;
		} else if (!classId.equals(other.classId))
			return false;
		if (instanceId == null) {
			if (other.instanceId != null)
				return false;
		} else if (!instanceId.equals(other.instanceId))
			return false;
		return true;
	}

}