package de.mannheim.uni.expansion.data.ontology.model;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;

public class PropertyInstanceId {

	private final PropertyId propertyId;

	private final InstanceId instanceId;

	public PropertyInstanceId(PropertyId propertyId, InstanceId instanceId) {
		super();
		this.propertyId = propertyId;
		this.instanceId = instanceId;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((instanceId == null) ? 0 : instanceId.hashCode());
		result = prime * result + ((propertyId == null) ? 0 : propertyId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof PropertyInstanceId))
			return false;
		PropertyInstanceId other = (PropertyInstanceId) obj;
		if (instanceId == null) {
			if (other.instanceId != null)
				return false;
		} else if (!instanceId.equals(other.instanceId))
			return false;
		if (propertyId == null) {
			if (other.propertyId != null)
				return false;
		} else if (!propertyId.equals(other.propertyId))
			return false;
		return true;
	}

	public PropertyId getPropertyId() {
		return propertyId;
	}

	public InstanceId getInstanceId() {
		return instanceId;
	}

}
