package de.mannheim.uni.expansion.data.ontology.model;

import java.io.Serializable;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;

public class ValueId implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final InstanceId instanceId;

	private final PropertyId propertyId;

	public ValueId(InstanceId instanceId, PropertyId propertyId) {
		super();
		// if (!propertyId.getClass().equals(PropertyId.class)) {
		// throw new IllegalStateException("WE DO NOT YET SUPPORT VALUEID FOR
		// QUALIFIERS");
		// }
		this.instanceId = instanceId;
		this.propertyId = propertyId;
	}

	public ValueId(TripleId tid) {
		this.instanceId = tid.getInstanceId();
		this.propertyId = tid.getPropertyId();
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((propertyId == null) ? 0 : propertyId.hashCode());
		result = prime * result + ((instanceId == null) ? 0 : instanceId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ValueId other = (ValueId) obj;
		if (propertyId == null) {
			if (other.propertyId != null)
				return false;
		} else if (!propertyId.equals(other.propertyId))
			return false;
		if (instanceId == null) {
			if (other.instanceId != null)
				return false;
		} else if (!instanceId.equals(other.instanceId))
			return false;
		return true;
	}

	public InstanceId getInstanceId() {
		return instanceId;
	}

	public PropertyId getPropertyId() {
		return propertyId;
	}

	@Override
	public String toString() {
		return "[instance=" + instanceId + ", property=" + propertyId + "]";
	}

}
