package de.mannheim.uni.expansion.data.ontology.model.instances;

import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;

public class QualifierId extends PropertyId {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private final PropertyId main;
	private final PropertyId qualifier;

	public QualifierId(PropertyId main, PropertyId qualifier) {
		super(main.getPropertyId() + "::" + qualifier.getPropertyId());
		this.main = main;
		this.qualifier = qualifier;
	}

	public PropertyId getMain() {
		return main;
	}

	public PropertyId getQualifier() {
		return qualifier;
	}

	public String toCombinedString() {
		return main.toCombinedString() + "::" + qualifier.toCombinedString();
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((main == null) ? 0 : main.hashCode());
		result = prime * result + ((qualifier == null) ? 0 : qualifier.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		QualifierId other = (QualifierId) obj;
		if (main == null) {
			if (other.main != null)
				return false;
		} else if (!main.equals(other.main))
			return false;
		if (qualifier == null) {
			if (other.qualifier != null)
				return false;
		} else if (!qualifier.equals(other.qualifier))
			return false;
		return true;
	}

}
