package de.mannheim.uni.expansion.data.ontology.model.properties;

import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;

public class ObjectPropertyOntology extends PropertyOntology {

	public ObjectPropertyOntology(PropertyId id, ClassId domain, ClassId range, Set<PropertyId> subPropertyOf, PropertyId wasDerivedFrom) {
		super(id, domain, subPropertyOf, wasDerivedFrom);

		this.range = range;
	}

	private final ClassId range;

	public ClassId getRange() {
		return range;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = super.hashCode();
		result = prime * result + ((range == null) ? 0 : range.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (!super.equals(obj))
			return false;
		if (getClass() != obj.getClass())
			return false;
		ObjectPropertyOntology other = (ObjectPropertyOntology) obj;
		if (range == null) {
			if (other.range != null)
				return false;
		} else if (!range.equals(other.range))
			return false;
		return true;
	}

}
