package de.uni_mannheim.dws.expansion.data.ontology.model;

import java.io.Serializable;

import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;

public class PropertyValuePair implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final PropertyId propertyId;
	private final AbstractObject abstractObject;

	public PropertyValuePair(PropertyId propertyId, AbstractObject abstractObject) {
		super();
		this.propertyId = propertyId;
		this.abstractObject = abstractObject;
	}

	public PropertyId getPropertyId() {
		return propertyId;
	}

	public AbstractObject getAbstractObject() {
		return abstractObject;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((abstractObject == null) ? 0 : abstractObject.hashCode());
		result = prime * result + ((propertyId == null) ? 0 : propertyId.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof PropertyValuePair))
			return false;
		PropertyValuePair other = (PropertyValuePair) obj;
		if (abstractObject == null) {
			if (other.abstractObject != null)
				return false;
		} else if (!abstractObject.equals(other.abstractObject))
			return false;
		if (propertyId == null) {
			if (other.propertyId != null)
				return false;
		} else if (!propertyId.equals(other.propertyId))
			return false;
		return true;
	}

}
