package de.uni_mannheim.dws.expansion.data.ontology.model.fusedvalue;

import java.util.List;

import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.QualifiedValueHolder;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.Qualifier;

public class QualifiedFusedValueHolder extends QualifiedValueHolder {

	private final FusedValue fusedValue;

	@Override
	public AbstractObject getValue() {
		return fusedValue.getSingle();
	}

	public FusedValue getFusedValue() {
		return fusedValue;
	}

	public QualifiedFusedValueHolder(FusedValue fusedValue, List<Qualifier> qualifiers) {
		super(qualifiers);
		this.fusedValue = fusedValue;

	}

	public QualifiedFusedValueHolder(FusedValue fusedValue) {
		super();
		this.fusedValue = fusedValue;

	}

}
