package de.uni_mannheim.dws.expansion.data.ontology.model.measurement;

public class UnitConverter {

	public static void main(String[] args) {

		UnitConverter uc = new UnitConverter();

		System.out.println(uc.convert(100.0, UnitOfMeasurement.WEIGHT_POUND, UnitOfMeasurement.WEIGHT_KG));

		System.out.println(uc.convert(100.0, UnitOfMeasurement.WEIGHT_POUND, UnitOfMeasurement.WEIGHT_POUND));

		System.out.println(uc.convert(100.0, UnitOfMeasurement.WEIGHT_KG, UnitOfMeasurement.WEIGHT_POUND));
		System.out.println(uc.convert(45.359237, UnitOfMeasurement.WEIGHT_KG, UnitOfMeasurement.WEIGHT_POUND));

	}

	public double convert(double value, UnitOfMeasurement currentUnit, UnitOfMeasurement targetUnit) {

		if (currentUnit.equals(targetUnit)) {
			return value;
		} else if (!currentUnit.getMeasurementType().equals(targetUnit.getMeasurementType())) {
			throw new IllegalStateException("Measure Types are not equal. This number can not be convertet to the target unit");
		} else if (currentUnit.equals(currentUnit.getMeasurementType().getMainUnit())) {
			double v3 = value / targetUnit.getConversionFactor();
			return v3;
		} else {
			double v2 = value * currentUnit.getConversionFactor();

			if (targetUnit.equals(targetUnit.getMeasurementType().getMainUnit())) {
				return v2;
			} else {
				double v3 = v2 / targetUnit.getConversionFactor();
				return v3;
			}
		}

	}
}
