package de.uni_mannheim.dws.expansion.data.ontology.model.measurement;

public enum UnitOfMeasurement {
	WEIGHT_POUND(MeasurementType.WEIGHT, 0.45359237), WEIGHT_KG(MeasurementType.WEIGHT, 1.0);

	private final MeasurementType measurementType;
	private final double conversionFactor;

	private UnitOfMeasurement(MeasurementType measurementType, double conversionFactor) {
		this.measurementType = measurementType;
		this.conversionFactor = conversionFactor;

	}

	public MeasurementType getMeasurementType() {
		return measurementType;
	}

	public double getConversionFactor() {
		return conversionFactor;
	}

}
