package de.uni_mannheim.dws.expansion.data.ontology.model.objects;

import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.ValueType;

public class BooleanObject extends AbstractObject {

	private final boolean value;

	public BooleanObject(boolean value) {
		super();
		this.value = value;
	}

	public boolean getValue() {
		return value;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + (value ? 1231 : 1237);
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		BooleanObject other = (BooleanObject) obj;
		if (value != other.value)
			return false;
		return true;
	}

	@Override
	public String toString() {
		return this.readableString();
	}

	@Override
	public String readableString() {
		return Boolean.toString(value);
	}

	@Override
	public ValueType getType() {
		return ValueType.BOOLEAN;
	}

}
