package de.uni_mannheim.dws.expansion.data.ontology.model.objects;

import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.ValueType;

public class CategoricalIntObject extends AbstractObject implements Comparable<CategoricalIntObject> {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final long value;

	public CategoricalIntObject(long value) {
		super();
		this.value = value;
	}

	public long getValue() {
		return value;
	}

	@Override
	public int compareTo(CategoricalIntObject o) {
		return Long.compare(value, o.value);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + (int) (value ^ (value >>> 32));
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof CategoricalIntObject))
			return false;
		CategoricalIntObject other = (CategoricalIntObject) obj;
		if (value != other.value)
			return false;
		return true;
	}

	@Override
	public String readableString() {
		return String.valueOf(value);
	}

	@Override
	public ValueType getType() {
		return ValueType.CATEGORICAL_INT;
	}

	@Override
	public String toString() {
		return readableString();
	}

}
