package de.uni_mannheim.dws.expansion.data.ontology.model.objects;

import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.ValueType;

public class StringObject extends AbstractObject {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final String string;

	public StringObject(String string) {
		this.string = string;
	}

	public String getString() {
		return string;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((string == null) ? 0 : string.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		StringObject other = (StringObject) obj;
		if (string == null) {
			if (other.string != null)
				return false;
		} else if (!string.equals(other.string))
			return false;
		return true;
	}

	@Override
	public String readableString() {
		return string;
	}

	@Override
	public String toString() {
		return this.readableString();
	}

	@Override
	public ValueType getType() {
		return ValueType.STRING;
	}

}
