package de.uni_mannheim.dws.expansion.data.ontology.model.objects;

import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.ValueType;

public class UrlObject extends AbstractObject {

	private final String url;

	public UrlObject(String url) {
		super();
		this.url = url;
	}

	public String getUrl() {
		return url;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((url == null) ? 0 : url.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		UrlObject other = (UrlObject) obj;
		if (url == null) {
			if (other.url != null)
				return false;
		} else if (!url.equals(other.url))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return this.readableString();
	}

	@Override
	public String readableString() {
		return url;
	}

	@Override
	public ValueType getType() {
		return ValueType.URL;
	}

}
