package de.uni_mannheim.dws.expansion.data.ontology.model.qualifiers;

import de.mannheim.uni.expansion.data.ontology.model.AbstractQualifier;

public class TimestampPointInTime extends AbstractQualifier {

	private final int year;

	public TimestampPointInTime(int year) {
		this.year = year;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + year;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		TimestampPointInTime other = (TimestampPointInTime) obj;
		if (year != other.year)
			return false;
		return true;
	}

	public int getYear() {
		return year;
	}

	@Override
	public String toString() {
		return "TimestampPointInTime [year=" + year + "]";
	}

}
