package de.uni_mannheim.dws.expansion.data.ontology.model.types;

import java.util.Map;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.QualifiedValueList;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.ValueType;

public class WikidataParsedProperty extends WikidataParsedObject {

	private final PropertyId propertyId;
	private final ValueType valueType;

	public WikidataParsedProperty(Map<PropertyId, QualifiedValueList> valuesMap, String label, Map<String, String> labels, Map<String, Set<String>> aliases,
			PropertyId propertyId, ValueType valueType) {
		super(valuesMap, label, labels, aliases);
		this.propertyId = propertyId;
		this.valueType = valueType;
	}

	public PropertyId getPropertyId() {
		return propertyId;
	}

	public ValueType getValueType() {
		return valueType;
	}

}
