package de.uni_mannheim.dws.expansion.data.ontology.model.valueholders;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import com.google.common.collect.ImmutableList;

import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;

public class QualifiedValueList implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private final List<QualifiedValueHolder> claims;

	private final Map<AbstractObject, List<Integer>> valueIndex;

	private final Map<Qualifier, List<Integer>> qualifiers;

	// private final Map<PropertyId, List<Integer>> qualifierPropertyMap;

	public QualifiedValueList(List<QualifiedValueHolder> claims) {
		this.claims = ImmutableList.copyOf(claims);
		// this.valueIndex = getValueIndexMap(this.claims);
		this.valueIndex = null;
		// this.qualifiers = buildQualifierMap(claims);
		this.qualifiers = null;
		// this.qualifierPropertyMap = buildQualifierPropertyMap(claims);

	}

	// private Map<PropertyId, List<Integer>>
	// buildQualifierPropertyMap(List<QualifiedValueHolder> claims) {
	//
	// Map<PropertyId, List<Integer>> ret = new HashMap<>();
	// for (int i = 0; i < claims.size(); i++) {
	// QualifiedValueHolder claim = this.claims.get(i);
	// if (claim.getQualifiers() != null) {
	// for (Qualifier e : claim.getQualifiers()) {
	// CHMHelper.getFromMap(ret, e.getQualifier(), () -> new
	// ArrayList<>()).add(i);
	// }
	// }
	// }
	//
	// Builder<PropertyId, List<Integer>> builder = ImmutableMap.builder();
	// ret.entrySet().stream().forEach((e) -> {
	// builder.put(e.getKey(), ImmutableList.copyOf(e.getValue()));
	//
	// });
	// return builder.build();
	//
	// }

	public QualifiedValueList() {
		this.claims = new ArrayList<>();
		this.valueIndex = null;
		this.qualifiers = null;
		// this.qualifierPropertyMap = new HashMap<>();

	}

	public QualifiedValueList(AbstractObject value) {
		List<QualifiedValueHolder> claims = new ArrayList<>();
		claims.add(new QualifiedAbstractObjectHolder(value));
		this.claims = ImmutableList.copyOf(claims);
		// this.valueIndex = getValueIndexMap(getClaims());
		this.valueIndex = null;
		this.qualifiers = null;
	}

	public static QualifiedValueList fromList(List<AbstractObject> list) {
		List<QualifiedValueHolder> claims = new ArrayList<>();
		for (AbstractObject value : list) {
			claims.add(new QualifiedAbstractObjectHolder(value));
		}

		return new QualifiedValueList(claims);
	}

	// private Map<Qualifier, List<Integer>> getQualifiers() {
	// return this.qualifiers;
	// }

	// private Map<AbstractObject, List<Integer>>
	// getValueIndexMap(List<QualifiedValueHolder> claims) {
	// Map<AbstractObject, List<Integer>> valueIndexMap = new HashMap<>();
	//
	// for (int i = 0; i < claims.size(); i++) {
	// QualifiedValueHolder qvh = claims.get(i);
	// CHMHelper.getFromMap(valueIndexMap, qvh.getValue(), () -> new
	// ArrayList<>()).add(i);
	//
	// }
	// try {
	// return ImmutableMap.copyOf(valueIndexMap);
	// } catch (Exception e) {
	// e.printStackTrace();
	// return null;
	// }
	//
	// }

	public List<QualifiedValueHolder> getClaims() {
		return claims;
	}

	public boolean hasValue(AbstractObject value) {
		// return valueIndex.containsKey(value);

		for (int i = 0; i < this.claims.size(); i++) {
			if (this.claims.get(i).getValue().equals(value)) {
				return true;
			}
		}

		return false;

	}

	// public List<QualifiedValueHolder> getValues(Object key) {
	// if (valueIndex.containsKey(key)) {
	// List<Integer> indeces = valueIndex.get(key);
	// List<QualifiedValueHolder> list = new ArrayList<>();
	// for (Integer index : indeces) {
	// list.add(claims.get(index));
	// }
	// return list;
	// }
	// return null;
	// }

	public boolean hasQualifier(PropertyId anId) {
		for (int i = 0; i < this.claims.size(); i++) {
			if (this.claims.get(i).getQualifierIds().contains(anId)) {
				return true;
			}
		}

		return false;

		// return claims.stream().filter((e) -> {
		// return e.hasQualifier(anId);
		// }).findFirst().isPresent();
	}

	public boolean isEmpty() {
		return claims.isEmpty();
	}

	public int size() {
		return claims.size();
	}

	public boolean isList() {
		return claims.size() > 1;
	}

	// private Map<Qualifier, List<Integer>>
	// buildQualifierMap(List<QualifiedValueHolder> claims) {
	// Map<Qualifier, List<Integer>> ret = new HashMap<>();
	// for (int i = 0; i < claims.size(); i++) {
	// QualifiedValueHolder claim = this.claims.get(i);
	// if (claim.getQualifiers() != null) {
	// for (Qualifier e : claim.getQualifiers()) {
	// CHMHelper.getFromMap(ret, e, () -> new ArrayList<>()).add(i);
	// }
	// }
	// }
	//
	// Builder<Qualifier, List<Integer>> builder = ImmutableMap.builder();
	// ret.entrySet().stream().forEach((e) -> {
	// builder.put(e.getKey(), ImmutableList.copyOf(e.getValue()));
	//
	// });
	// return builder.build();
	// }

	@Deprecated
	public AbstractObject getAnyObject() {
		return this.claims.get(0).getValue();
	}

	public QualifiedValueHolder getClaim(int qualifiedValueHolderIndex) {
		return claims.get(qualifiedValueHolderIndex);
	}

	@Override
	public String toString() {
		return "QualifiedValueList [claims=" + claims + ", qualifiers=" + qualifiers + "]";
	}

	// private Set<AbstractObject> getForQualifiers(Set<Qualifier> qualifiers) {
	//
	// if (qualifiers.isEmpty()) {
	// return valueIndex.keySet();
	//
	// } else {
	// Map<Integer, MutableInt> map = new HashMap<>();
	//
	// for (Qualifier q : qualifiers) {
	//
	// for (Integer in : this.getQualifiers().get(q)) {
	// CHMHelper.getFromMap(map, in, () -> new MutableInt()).increment();
	// }
	//
	// }
	//
	// Set<AbstractObject> values = new HashSet<>();
	//
	// for (Entry<Integer, MutableInt> e : map.entrySet()) {
	// if (e.getValue().intValue() == qualifiers.size()) {
	// values.add(this.claims.get(e.getKey()).getValue());
	// }
	// }
	// return values;
	// }
	//
	// }

}
