package de.uni_mannheim.dws.expansion.data.ontology.model.valueholders;

import java.io.Serializable;

import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;

public class Qualifier implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final PropertyId qualifier;
	private final AbstractObject qualifierValue;

	public Qualifier(PropertyId qualifier, AbstractObject qualifierValue) {
		this.qualifier = qualifier;
		this.qualifierValue = qualifierValue;
	}

	public PropertyId getQualifier() {
		return qualifier;
	}

	public AbstractObject getQualifierValue() {
		return qualifierValue;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((qualifier == null) ? 0 : qualifier.hashCode());
		result = prime * result + ((qualifierValue == null) ? 0 : qualifierValue.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Qualifier other = (Qualifier) obj;
		if (qualifier == null) {
			if (other.qualifier != null)
				return false;
		} else if (!qualifier.equals(other.qualifier))
			return false;
		if (qualifierValue == null) {
			if (other.qualifierValue != null)
				return false;
		} else if (!qualifierValue.equals(other.qualifierValue))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "Qualifier [qualifier=" + qualifier + ", qualifierValue=" + qualifierValue + "]";
	}

}
