package de.uni_mannheim.dws.expansion.data.ontology.model.valuepairs;

import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;

public class ScoreSortedAbstractPair implements AbstractClassPair {

	private final AbstractObject value;
	private final Double score;

	public ScoreSortedAbstractPair(AbstractObject value, Double score) {
		this.value = value;
		this.score = score;
	}

	@Override
	public int compareTo(AbstractClassPair o) {
		return Double.compare(score, o.getScore());
	}

	@Override
	public AbstractObject getValue() {
		return value;
	}

	@Override
	public Double getScore() {
		return score;
	}

	@Override
	public String toString() {
		return "ScorePair [value=" + value + ", score=" + score + "]";
	}

}
