package de.uni_mannheim.dws.expansion.data.ontology.model.valuepairs;

import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.QualifiedValueHolder;

public class ScoreSortedValueHolderPair implements ValueHolderPiar {
	private final QualifiedValueHolder value;
	private final Double score;

	public ScoreSortedValueHolderPair(QualifiedValueHolder value, Double score) {
		super();
		this.value = value;
		this.score = score;
	}

	@Override
	public int compareTo(ValueHolderPiar o) {
		return Double.compare(score, o.getScore());
	}

	public QualifiedValueHolder getValue() {
		return value;
	}

	public Double getScore() {
		return score;
	}

	@Override
	public String toString() {
		return "ScoreSortedValueHolderPair [value=" + value + ", score=" + score + "]";
	}

}
