package de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulateables;

import java.util.function.BinaryOperator;

public class AccumDouble implements Accumulateable<AccumDouble> {

	public static AccumDouble empty() {
		return new AccumDouble(0.0);
	}

	private static final BinaryOperator<AccumDouble> accumulator = (a, b) -> {
		return new AccumDouble(a.get() + b.get());
	};

	private final double val;

	public AccumDouble(double val) {
		this.val = val;
	}

	public double get() {
		return val;
	}

	@Override
	public BinaryOperator<AccumDouble> getAccumulator() {
		return accumulator;
	}

	@Override
	public String toString() {
		return String.valueOf(val);
	}

	@Override
	public AccumDouble accumulate(AccumDouble other) {
		if (other instanceof AccumDouble) {
			AccumDouble oDouble = (AccumDouble) other;
			return new AccumDouble(val + oDouble.val);
		} else {
			throw new IllegalStateException("This is not the same Accumateable Class");
		}
	}

	public Double getValue() {
		return val;
	}

	// @Override
	// public AccumDouble copy() {
	// return new AccumDouble(val);
	// }

	@Override
	public Class<AccumDouble> getAcumClass() {
		return AccumDouble.class;
	}

}
