package de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulateables;

import java.util.function.BinaryOperator;

public class AccumInteger implements Accumulateable<AccumInteger> {

	public static AccumInteger empty() {
		return new AccumInteger(0);
	}

	private static final BinaryOperator<AccumInteger> accumulator = (a, b) -> {
		return new AccumInteger(a.get() + b.get());
	};

	private final int val;

	public AccumInteger(int val) {
		this.val = val;
	}

	public int get() {
		return val;
	}

	@Override
	public BinaryOperator<AccumInteger> getAccumulator() {
		return accumulator;
	}

	@Override
	public String toString() {
		return String.valueOf(val);
	}

	@Override
	public AccumInteger accumulate(AccumInteger other) {
		if (other instanceof AccumInteger) {
			AccumInteger oInt = (AccumInteger) other;
			return new AccumInteger(val + oInt.val);
		} else {
			throw new IllegalStateException("This is not the same Accumateable Class");
		}
	}

	public Integer getValue() {
		return val;
	}

	// @Override
	// public AccumInteger copy() {
	// return new AccumInteger(val);
	// }

	@Override
	public Class<AccumInteger> getAcumClass() {
		return AccumInteger.class;
	}

}
