package de.uni_mannheim.informatik.dws.expansion.samples;

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.atomic.AtomicInteger;

import de.mannheim.uni.expansion.utils.PersistentParallel6;

public class ParallelizeTest5 {

	private static ThreadLocal<AtomicInteger> counter = new ThreadLocal<>();
	private static LinkedBlockingQueue<AtomicInteger> counterList = new LinkedBlockingQueue<>();

	public static AtomicInteger getThreadLocalMutableInt() {
		AtomicInteger mi = counter.get();
		if (mi == null) {
			mi = new AtomicInteger();
			counter.set(mi);
			counterList.add(mi);
		}
		return mi;
	}

	public static int getAllThreadhLocalsSum() {
		int sum = 0;
		for (AtomicInteger mi : counterList) {
			sum += mi.intValue();
		}
		return sum;
	}

	public static void main(String[] args) {

		Scanner in = new Scanner(System.in);
		in.hasNextInt();
		long startTime = System.nanoTime();

		List<Integer> list = new ArrayList<>();

		for (int i = 0; i < 1000; i++) {
			list.add(i);
		}

		int sum = 150 * 1000000 + 150 * 100000 + 700 * 10000;

		//
		// PersistentParallel3<Integer> pp3 = new
		// PersistentParallel3<>("OUTER");
		//
		// PersistentParallel3<Integer> inner = new
		// PersistentParallel3<>("INNER");
		//

		List<Integer> innerListM = new ArrayList<>();
		for (int ii = 0; ii < 1000000; ii++) {
			innerListM.add(ii);
		}

		List<Integer> innerListK = new ArrayList<>();
		for (int ii = 0; ii < 100000; ii++) {
			innerListK.add(ii);
		}

		try {
			PersistentParallel6.runAndFinish(list, (i) -> {

				if (i >= 850) {

					PersistentParallel6.runAndFinish(innerListM, (e) -> {
						AtomicInteger mi = getThreadLocalMutableInt();
						mi.addAndGet(1);
						doMath();
					} , "INNER", true);

					// for (int f = 0; f < 1000000; f++) {
					// mi.addAndGet(1);
					// tan(atan(tan(atan(tan(atan(tan(atan(tan(atan(0.5))))))))));
					// }
				} else if (i >= 700) {
					// List<Integer> innerList = new ArrayList<>();
					// for (int ii = 0; ii < 100000; ii++) {
					// innerList.add(ii);
					// }

					PersistentParallel6.runAndFinish(innerListK, (e) -> {
						AtomicInteger mi = getThreadLocalMutableInt();
						mi.addAndGet(1);
						doMath();
					} , "INNER", true);

					// for (int f = 0; f < 100000; f++) {
					// mi.addAndGet(1);
					// tan(atan(tan(atan(tan(atan(tan(atan(tan(atan(0.5))))))))));
					// }
				} else {

					List<Integer> innerList = new ArrayList<>();
					// for (int ii = 0; ii < 10000; ii++) {
					// innerList.add(ii);
					// }
					// PersistentParallel6.runAndFinish(innerList, (e) -> {
					// mi.addAndGet(1);
					// tan(atan(tan(atan(tan(atan(tan(atan(tan(atan(0.5))))))))));
					// } , "INNER");
					AtomicInteger mi = getThreadLocalMutableInt();
					for (int f = 0; f < 10000; f++) {
						mi.addAndGet(1);
						doMath();
					}
				}

			} , "OUTER");
			System.out.println("Test:   " + sum);
			System.out.println("Result: " + getAllThreadhLocalsSum());
			long estimatedTime = System.nanoTime() - startTime;

			double seconds = (double) estimatedTime / 1000000000.0;
			System.out.println(seconds);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		try {
			PersistentParallel6.close();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public static void doMath() {
		tan(atan(tan(atan(tan(atan(tan(atan(tan(atan(0.5))))))))));
	}

	public static double tan(double a) {
		return Math.tan(a);
	}

	public static double atan(double a) {
		return Math.atan(a);
	}

}
