package de.uni_mannheim.informatik.dws.expansion.samples.dbpedia;

import java.util.Optional;
import java.util.concurrent.ConcurrentLinkedQueue;

import de.mannheim.uni.expansion.data.tables.model.AnnotatedTablesReaderData;
import de.mannheim.uni.expansion.data.tables.reader.AnnotatedTableFilter;
import de.mannheim.uni.expansion.data.tables.repository.AnnotatedTablesRepository;
import de.mannheim.uni.expansion.data.tables.repository.memory.AnnotatedTablesRepositoryImplMemory;

public class DuplicateCurrentStateOfTableRepositoryFilter implements AnnotatedTableFilter {

	private final ConcurrentLinkedQueue<AnnotatedTablesReaderData> queue = new ConcurrentLinkedQueue<>();

	@Override
	public Optional<AnnotatedTablesReaderData> filter(AnnotatedTablesReaderData data) {
		queue.add(data);
		return Optional.of(data);
	}

	public AnnotatedTablesRepository getRepository() {
		return new AnnotatedTablesRepositoryImplMemory(queue);
	}

}
