package de.uni_mannheim.informatik.dws.expansion.samples.dbpedia;

import java.util.HashSet;
import java.util.Set;

import de.mannheim.uni.expansion.ThreadLocalList;
import de.mannheim.uni.expansion.data.ontology.model.ValueId;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.ontology.model.repository.OntologyRepository;
import de.mannheim.uni.expansion.data.ontology.model.repository.OntologyRepositoryImpl;
import de.mannheim.uni.expansion.utils.PersistentParallel6;
import de.uni_mannheim.dws.expansion.data.PropertiesExpansionData;
import de.uni_mannheim.dws.expansion.data.kb.repository.KBValueContainer;
import de.uni_mannheim.dws.expansion.data.kb.repository.KBValueCreator;
import de.uni_mannheim.dws.expansion.data.kb.repository.KnowledgeBase;
import de.uni_mannheim.dws.expansion.data.kb.repository.KnowledgeBaseImpl;

public class KbClassFilter implements KBValueCreator {

	private final Set<ClassId> classes;
	// private final Set<ClassId> allClasses;
	private final OntologyRepository unfilteredOntology;

	public KbClassFilter(Set<ClassId> classes, KnowledgeBaseImpl kb, OntologyRepository unfilteredOntology) {
		this.classes = new HashSet<>(classes);
		this.unfilteredOntology = unfilteredOntology;
		// this.allClasses = getAllClasses(kb);

	}

	// public Set<ClassId> getAllClasses(KnowledgeBase kb) {
	//
	// Set<ClassId> allClasses = Collections.newSetFromMap(new
	// ConcurrentHashMap<>());
	//
	// allClasses.addAll(classes);
	//
	// PersistentParallel6.runAndFinish(classes, (classId) -> {
	// for (Entry<PropertyId, Integer> propertyEntry :
	// kb.getProperties(classId).entrySet()) {
	// if (unfilteredOntology.isReferenceField(propertyEntry.getKey())) {
	// PersistentParallel6.runAndFinish(kb.getInstances(classId,
	// propertyEntry.getKey()), (instanceId) -> {
	//
	// Optional<List<AbstractObject>> qvl = kb.getValuesAsList(instanceId,
	// propertyEntry.getKey());
	//
	// if (qvl.isPresent()) {
	//
	// for (AbstractObject q : qvl.get()) {
	// if (q instanceof InstanceId) {
	// allClasses.addAll(kb.getClasses((InstanceId) q));
	// }
	// }
	// }
	//
	// }, this.getClass());
	// }
	// }
	// }, this.getClass());
	// return null;
	// }

	@Override
	public KBValueContainer getMatchedValues(KnowledgeBase kb) {

		// final Set<InstanceId> removeValues = new HashSet<>();

		ThreadLocalList<Set<ValueId>> list = new ThreadLocalList<>();

		Set<InstanceId> keepInstances = new HashSet<>();

		for (ClassId setId : this.classes) {

			if (kb.hasClass(setId)) {
				keepInstances.addAll(kb.getInstances(setId).keySet());
			}

		}

		PersistentParallel6.runAndFinish(kb.getValueIds(), (vid) -> {
			if (!keepInstances.contains(vid.getInstanceId()) && !vid.getPropertyId().equals(PropertiesExpansionData.LABEL_PROPERTY)) {
				list.getOrCreate(() -> new HashSet<>()).add(vid);
			}

		}, this.getClass());

		// PersistentParallel6.runAndFinish(removeInstances, (instanceId) -> {
		// for (ClassId setId : kb.getClasses(instanceId)) {
		// for (PropertyId propertyId : kb.getProperties(setId).keySet()) {
		// removeValues.add(new ValueId(instanceId, propertyId));
		// }
		// }
		// }, this.getClass());

		// Set<Pair<InstanceId, ClassId>> removeSetMappings = new HashSet<>();

		// for (ClassId setId : classes) {
		// for (InstanceId instance : kb.getInstances(setId).keySet()) {
		// if (removeInstances.contains(instance)) {
		// removeInstances.remove(instance);
		// // HashSet<ClassId> mappings = new
		// // HashSet<>(kb.getClasses(instance));
		// // mappings.removeAll(allClasses);
		// // for (ClassId mapping : mappings) {
		// // removeSetMappings.add(new Pair<>(instance, mapping));
		// // }
		// }
		//
		// }
		// }

		Set<ValueId> removeValues = new HashSet<>();
		for (Set<ValueId> set : list.getCurrentList()) {
			removeValues.addAll(set);
		}

		return KBValueContainer.defaultConfig().rebuilder().setRemoveValues(removeValues).build();

	}

	public OntologyRepositoryImpl filterOntology(OntologyRepositoryImpl old) {
		return old;

		// Map<PropertyId, ValueType> propertyDataType =
		// old.getPropertyDataType();
		// Set<PropertyId> propertyTimeDependent =
		// old.getPropertyTimeDependent();
		// Map<ClassId, Set<ClassId>> parents = old.getParents();
		// Map<ClassId, Set<ClassId>> children = old.getChildren();
		// Map<ClassPropertyId, Set<ClassId>> propertyRange = new HashMap<>();
		//
		// for (Entry<ClassPropertyId, Set<ClassId>> entry :
		// old.getPropertyRange().entrySet()) {
		// Set<ClassId> newSet = new HashSet<>();
		//
		// for (ClassId classId : entry.getValue()) {
		// if (allClasses.contains(classId)) {
		// newSet.add(classId);
		// }
		// }
		//
		// if (!newSet.isEmpty()) {
		// propertyRange.put(entry.getKey(), newSet);
		// }
		//
		// }
		//
		// return new OntologyRepositoryImpl(propertyDataType,
		// propertyTimeDependent, propertyRange, parents, children);

	}

}
