package de.uni_mannheim.informatik.dws.expansion.samples.dbpedia;

import java.io.IOException;
import java.util.Map;
import java.util.Set;

import javax.inject.Inject;

import dagger.Module;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.tables.reader.AnnotatedTablesWriterConcurrent;
import de.mannheim.uni.expansion.data.tables.repository.AnnotatedTablesRepository;
import de.mannheim.uni.expansion.utils.PersistentParallel6;
import de.uni_mannheim.informatik.dws.expansion.samples.setExtension.ClassConstants;
import de.uni_mannheim.informatik.dws.expansion.samples.setExtension.ExtractTablesForGoldStandardRun;
import de.uni_mannheim.informatik.dws.expansion.samples.setExtension.SetExtension;
import de.uni_mannheim.informatik.dws.expansion.utils.remote.RepositoryLoading;

public class ProcessCSVTables {

	@Module(injects = { ProcessCSVTables.class }, library = true, complete = false)
	public static class TablesConverterModule {

	}

	public static void main(String[] args) throws ClassNotFoundException, IOException, InterruptedException {
		// String dataHomeTemp = null;
		//
		// if (args.length > 0 && args[0] != null && !args[0].equals("")) {
		// dataHomeTemp = args[0];
		// }
		//
		// String kbName = null;
		//
		// if (args.length > 1 && args[1] != null && !args[1].equals("")) {
		// kbName = args[1];
		// }
		//
		// String mappingsName = null;
		//
		// if (args.length > 2 && args[2] != null && !args[2].equals("")) {
		// mappingsName = args[2];
		// }
		//
		// if(mappingsName.equals("none")) {
		// mappingsName = "";
		// }
		// else {
		// mappingsName = "/tables/" + mappingsName;
		// }
		// String dataHome = dataHomeTemp;
		//
		// String kbPath = dataHome + "/caches/kbs/" + kbName + "/kb/";
		// String ontologyRepositoryFile = dataHome + "/caches/kbs/" + kbName +
		// "/ontology.kryo";
		// String luceneIndexCache = dataHome + "/caches/kbs/" + kbName +
		// "/lucene/";
		//
		//
		// String mappingsFolder = dataHome + "/" + mappingsName + "/mappings/";
		// String cacheFolder = dataHome + "/" + mappingsName + "/tables_01/";
		// String columnMappingsFolder = dataHome + "/" + mappingsName +
		// "/columnMappings/";
		//
		// if (mappingsName.equals("none")) {
		//
		// }
		//
		// // String resultsFolder = dataHome + "/" + mappingsName +
		// "/results/";
		// // String problemsFolder = dataHome + "/" + mappingsName +
		// "/problems/";
		// //
		// // String optimizingFolder = dataHome + "/" + mappingsName +
		// // "/optimizing/";
		//
		// String heidelTimeConfigPath = dataHome +
		// "/configs/heidelTime/config.props";
		// String emptyFile = dataHome + "/configs/empty.txt";
		// String candidateSelectionConfig = dataHome + "/configs/config.conf";
		// String matchingConfig = dataHome + "/configs/config.conf";
		// UnitParser.unitPath = dataHome + "/configs/Units/Convertible";
		//
		// SimilarityModule similarityModule = new SimilarityModule();
		//// MatchingModule matchingModule = new MatchingModule(true,
		// columnMappingsFolder, candidateSelectionConfig, matchingConfig,
		// emptyFile);
		// HeidelTimeModule heidelTimeModule = new
		// HeidelTimeModule(heidelTimeConfigPath);
		// TablesModule tableModule = TablesModule.csvWithCache(mappingsFolder,
		// cacheFolder, false);
		//
		// UnitParser.unitPath = dataHome + "/Units/Convertible";
		//
		// UnitParser.readInUnits();
		//
		// KnowledgeBaseModule kbModule = new KnowledgeBaseModule(kbPath,
		// ontologyRepositoryFile, luceneIndexCache);
		//
		// ObjectGraph graph = ObjectGraph.create(new TablesConverterModule(),
		// tableModule, kbModule, tableModule, heidelTimeModule,
		// similarityModule);
		//
		// tableModule.setClassFilter(graph.get(KnowledgeBase.class));
		// List<AnnotatedTableFilter> filters = new ArrayList<>();
		// filters.add(new PropertiesDBpediaTableFilter());
		// filters.add(new PopulationDensityFixer());
		// filters.add(new NFLPropertiesDensity());
		// filters.add(new RuntimePropertyFixer());
		//
		// tableModule.setFilters(filters);

		Map<ClassId, Set<ClassId>> topClasses = ExtractTablesForGoldStandardRun.getClassesWithHierarchy();
		topClasses.remove(ClassConstants.single);
		topClasses.remove(ClassConstants.placeClass);

		SetExtension setExtension = new SetExtension(args, topClasses.keySet(), ExtractTablesForGoldStandardRun.getMinPropertyDensity(),
				RepositoryLoading.REMOTE_LOAD_REMOTELY, -1);

		ProcessCSVTables converter = setExtension.getGraph().get(ProcessCSVTables.class);
		//
		converter.run();

		PersistentParallel6.close();

	}

	@Inject
	protected AnnotatedTablesWriterConcurrent annotatedTablesWriter;

	@Inject
	protected AnnotatedTablesRepository tablesRepository;

	// @Inject
	// protected ColumnMatchesWriter columnMatchesWriter;

	public ProcessCSVTables() {

	}

	public void run() throws ClassNotFoundException, IOException, InterruptedException {

		annotatedTablesWriter.writeAll(tablesRepository);

		// columnMatchesWriter.run();

	}

}
