package de.uni_mannheim.informatik.dws.expansion.samples.dbpedia;

import java.util.HashSet;
import java.util.Optional;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTablesReaderData;
import de.mannheim.uni.expansion.data.tables.reader.AnnotatedTableFilter;

public class TableClassFilter implements AnnotatedTableFilter {
	private final Set<ClassId> classes;

	public TableClassFilter(Set<ClassId> classes) {
		this.classes = new HashSet<>(classes);
	}

	@Override
	public Optional<AnnotatedTablesReaderData> filter(AnnotatedTablesReaderData data) {
		if (classes.contains(data.getMetaData().getDbPediaClass())) {

			if (!data.getMetaData().getAllProperties().isEmpty()) {
				int sdf = 123;
			}

			return Optional.of(data);
		}

		return Optional.empty();
	}

}
