package de.uni_mannheim.informatik.dws.expansion.samples.dbpedia.musicalWork;

import java.util.HashSet;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import java.util.stream.Collectors;

import de.mannheim.uni.expansion.data.ontology.model.ClassPropertyId;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.repository.OntologyAdapter;
import de.mannheim.uni.expansion.data.ontology.model.repository.OntologyRepositoryImpl;
import de.mannheim.uni.expansion.utils.CHMHelper;
import de.uni_mannheim.informatik.dws.expansion.samples.setExtension.ClassConstants;
import de.uni_mannheim.informatik.dws.expansion.samples.setExtension.PropertyConstants;

public class MusicalBandOntologyAdapter implements OntologyAdapter {

	@Override
	public OntologyRepositoryImpl adapt(OntologyRepositoryImpl input) {

		Map<ClassPropertyId, Set<ClassId>> propertyRange = input.getPropertyRange().entrySet().stream()
				.collect(Collectors.toMap(Entry::getKey, (e) -> new HashSet<>(e.getValue())));

		CHMHelper.getFromMap(propertyRange, new ClassPropertyId(ClassConstants.musicalWorkClass, PropertyConstants.musicalArtist), () -> new HashSet<>())
				.add(ClassConstants.band);

		return new OntologyRepositoryImpl(input.getPropertyDataType(), input.getPropertyTimeDependent(), input.getPropertyDomain(), propertyRange,
				input.getParents(), input.getChildren(), input.getPropertyParents());
	}

}
