package de.uni_mannheim.informatik.dws.expansion.samples.postMatching;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import dagger.Module;
import dagger.ObjectGraph;
import de.mannheim.uni.expansion.tablefusion.modules.HeidelTimeModule;
import de.mannheim.uni.expansion.tablefusion.modules.MatchingModule;
import de.mannheim.uni.expansion.tablefusion.modules.RankingModule;
import de.mannheim.uni.expansion.tablefusion.modules.SimilarityModule;
import de.mannheim.uni.expansion.tablefusion.modules.TableFusionModule;
import de.mannheim.uni.expansion.tablefusion.modules.TablesModule;
import de.mannheim.uni.expansion.utils.PersistentParallel4;
import de.mannheim.uni.units.UnitParser;
import de.uni_mannheim.dws.expansion.data.kb.repository.KBValueCreator;
import de.uni_mannheim.informatik.dws.expansion.matching.KnowledgeBaseModule;
import de.uni_mannheim.informatik.dws.expansion.tools.converters.datasets.worldbank.CountryListFixer;
import expansion.set.strategies.clustersplitters.unaryattributes.UnaryAttributeAdapter;

public class UnaryAttributeTester {

	@Module(injects = { UnaryAttributeAdapter.class }, library = true, complete = false)
	public static class FusionModule {

	}

	public static void main(String[] args) throws IOException {
		System.out.println("adfasdf");
		String dataHome = null;

		if (args.length > 0 && args[0] != null && !args[0].equals("")) {
			dataHome = args[0];
		}

		String mappingsName = null;

		if (args.length > 0 && args[1] != null && !args[1].equals("")) {
			mappingsName = args[1];
		}

		mappingsName = "/tables/" + mappingsName;

		String kbPath = dataHome + "/kb/";
		String ontologyRepositoryFile = dataHome + "/ontology.kryo";
		String luceneIndexCache = dataHome + "/lucene/";

		String mappingsFolder = dataHome + "/" + mappingsName + "/mappings/";
		String cacheFolder = dataHome + "/" + mappingsName + "/cache/";
		String resultsFolder = dataHome + "/" + mappingsName + "/results/";
		String problemsFolder = dataHome + "/" + mappingsName + "/problems/";

		String optimizingFolder = dataHome + "/" + mappingsName + "/optimizing/";

		String columnMappingsFolder = dataHome + "/" + mappingsName + "/columnMappings/";
		String heidelTimeConfigPath = dataHome + "/heidelTime/config.props";
		String emptyFile = dataHome + "/empty.txt";
		String candidateSelectionConfig = dataHome + "/config.conf";
		String matchingConfig = dataHome + "/config.conf";
		UnitParser.unitPath = dataHome + "/Units/Convertible";
		String maxDiffsFolder = dataHome + "/" + "maxDiffs/";
		String thresholdsFolder = dataHome + "/" + "thresholds/";
		String maxDiffsFileQKBTMapped = dataHome + "/" + "maxDiffs_qkbt_mapped.json";
		String maxDiffsFileNewTS = dataHome + "/" + "maxDiffs_new_ts.json";
		String maxDiffsFileNewTSPropgated = dataHome + "/" + "maxDiffs_new_ts_propagated.json";

		String rankingsFile = dataHome + "/" + mappingsName + "/rankings/filtered.tsv.gz";

		KnowledgeBaseModule kbModule = new KnowledgeBaseModule(kbPath, ontologyRepositoryFile, luceneIndexCache);

		SimilarityModule similarityModule = new SimilarityModule();
		MatchingModule matchingModule = new MatchingModule(true, columnMappingsFolder, candidateSelectionConfig, matchingConfig, emptyFile);
		TablesModule tableModule = TablesModule.withCache(mappingsFolder, cacheFolder, true);
		HeidelTimeModule heidelTimeModule = new HeidelTimeModule(heidelTimeConfigPath);
		TableFusionModule tableFusionModule = new TableFusionModule(resultsFolder, problemsFolder, null, null, optimizingFolder, null);
		RankingModule rankingModule = new RankingModule(emptyFile, rankingsFile);

		List<KBValueCreator> valueCreatorList = new ArrayList<>();
		valueCreatorList.add(new CountryListFixer(dataHome + "/" + "countrycodes.txt"));
		valueCreatorList.add(new OfficeHolderFixer());
		kbModule.setValueCreatorList(valueCreatorList);
		// RUN WITHOUT OTSU FILTERING
		String unaryFile = dataHome + "/unary";
		{
			ObjectGraph graph = ObjectGraph.create(tableFusionModule, kbModule, tableModule, heidelTimeModule, matchingModule, similarityModule, rankingModule,
					new FusionModule());

			UnaryAttributeAdapter rep = graph.get(UnaryAttributeAdapter.class);

			rep.getUnaryAttributes(unaryFile);

			int sdf = 123;
		}

		try {
			PersistentParallel4.close();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		// System.exit(0);

	}

}
