package de.uni_mannheim.informatik.dws.expansion.samples.setExtension;

import java.util.Optional;
import java.util.concurrent.atomic.AtomicInteger;

import de.mannheim.uni.expansion.data.tables.model.AnnotatedTablesReaderData;
import de.mannheim.uni.expansion.data.tables.reader.AnnotatedTableFilter;

public class BadDecodedTableFilter implements AnnotatedTableFilter {

	AtomicInteger ai = new AtomicInteger(0);

	@Override
	public Optional<AnnotatedTablesReaderData> filter(AnnotatedTablesReaderData data) {
		boolean done = false;
		boolean remove = false;
		for (String s : data.getTableData().getStringTable().values()) {
			for (int i = 0; i < s.length(); i++) {
				if ((int) s.charAt(i) == 65533) {
					remove = true;
					ai.incrementAndGet();
					done = true;
					break;
				}
			}
			if (done)
				break;
		}

		if (remove) {
			return Optional.empty();
		} else {
			return Optional.of(data);
		}
	}

	public int getCount() {
		return ai.intValue();
	}

}
