package de.uni_mannheim.informatik.dws.expansion.samples.setExtension;

import java.io.IOException;

import de.mannheim.uni.expansion.tablefusion.modules.AbstractsModule;
import de.mannheim.uni.expansion.tablefusion.modules.SimilarityModule;
import de.mannheim.uni.expansion.utils.PersistentParallel6;
import de.mannheim.uni.expansion.utils.SimpleLockableConcurrentCache;
import de.uni_mannheim.informatik.dws.expansion.matching.KnowledgeBaseModule;

public class FullPipeline {

	public static void log(String log) {
		System.out.println("PIPELINE_MESSAGE: " + log);
	}

	public static void main(String[] args) throws IOException {
		KnowledgeBaseModule.CACHE_KEY_INDEX_STATICALLY = true;
		AbstractsModule.CACHE_ABSTRACTS_STATICALLY = true;
		SimilarityModule.CACHE_NUMERIC_RANGE_STATICALLY = true;
		KnowledgeBaseModule.CACHE_KNOWLEDGE_BASE_STATICALLY = true;
		int totalRuns = 1;

		//
		// log("" + 0 + "a - PIPELINE RUN AND LEARN CLUSTERING AND NEW ENTITY
		// MATCHING WEIGHTS");
		// GSRun.main(new String[] { args[0], args[1], args[2], "true", "true",
		// "0" });

		String secondary = "true";
		if (args.length > 3 && args[3].equals("false")) {
			secondary = "false";
		}

		String allTablesMatch = "false";
		if (args.length > 4 && args[4].equals("true")) {
			allTablesMatch = "true";
		}

		for (int currentRun = 1; currentRun <= totalRuns; currentRun++) {

			if (currentRun > 0 && false) {
				log("" + currentRun + "bTEMP - Evaluate Column Mappings Run");
				ColumnReMatcherRun.main(new String[] { args[0], args[1], args[2], "true", "true", String.valueOf(currentRun - 1), secondary });
				PersistentParallel6.restart();
				SimpleLockableConcurrentCache.clearAllCaches();
			}

			if (false) {
				if (currentRun > 0) {
					log("" + currentRun + "b -   RUN ADAPT TABLES WITH COLUMN MAPPINGS FOR NEXT PIPELINE RUN");
					KbOntologyAndTablesAdapter.main(
							new String[] { args[0], args[1], args[2], "true", "true", "false", String.valueOf(currentRun - 1), secondary, allTablesMatch });
					PersistentParallel6.restart();
					SimpleLockableConcurrentCache.clearAllCaches();
				} else {
					log("" + currentRun + "b -   remove columnMappings");
					KbOntologyAndTablesAdapter
							.main(new String[] { args[0], args[1], args[2], "true", "false", "false", String.valueOf(-1), secondary, allTablesMatch });
					PersistentParallel6.restart();
					SimpleLockableConcurrentCache.clearAllCaches();
				}
			}

			log("" + currentRun + "a -   PIPELINE RUN AND LEARN CLUSTERING AND NEW ENTITY MATCHING WEIGHTS");
			GSRun.main(new String[] { args[0], args[1], args[2], "true", "true", String.valueOf(currentRun) });
			PersistentParallel6.restart();
			SimpleLockableConcurrentCache.clearAllCaches();

		}

		int df = 123;

	}
}
