package de.uni_mannheim.informatik.dws.expansion.samples.setExtension;

import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.uni_mannheim.informatik.ds.expansion.utils.learning.LearnedModel;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.LearnedModelRepository;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.OptimizableClass;
import expansion.set.entitymatching.modelLearning.EM_LearnedModelRepository;
import expansion.set.entitymatching.modelLearning.EntityMatchingModel;
import expansion.set.optimizing.LearnedModelAdapter;

public class OutputLearnedModels {

	public static void main(String[] args) {

		LearnedModelAdapter adapter = new LearnedModelAdapter();
		Map<ClassId, Set<ClassId>> allParents = ExtractTablesForGoldStandardRun.getClassesWithHierarchy();

		Map<ClassId, EM_LearnedModelRepository> instanceWeightsRepository = adapter.readModels((modelMap) -> new EM_LearnedModelRepository(modelMap),
				allParents.keySet(), "D:/newStuff/instanceMatchingModelsFull1");

		for (Entry<ClassId, EM_LearnedModelRepository> entry : instanceWeightsRepository.entrySet()) {
			System.out.println(entry.getKey().getFinalPart());
			for (Entry<OptimizableClass, EntityMatchingModel> innerEntry : entry.getValue().getMap().entrySet()) {
				System.out.println(innerEntry.getKey().toString());
				System.out.println(innerEntry.getValue().toString());
			}
		}

		Map<ClassId, LearnedModelRepository> clusteringWeightsRepository = adapter.readModels((modelMap) -> new LearnedModelRepository(modelMap),
				allParents.keySet(), "D:/newStuff/clusteringModelsFull1");

		for (Entry<ClassId, LearnedModelRepository> entry : clusteringWeightsRepository.entrySet()) {
			System.out.println(entry.getKey().getFinalPart());
			for (Entry<OptimizableClass, LearnedModel> innerEntry : entry.getValue().getMap().entrySet()) {
				System.out.println(innerEntry.getKey().toString());
				System.out.println(innerEntry.getValue().toString());
			}
		}
	}
}
