package de.uni_mannheim.informatik.dws.expansion.samples.setExtension;

import java.io.IOException;
import java.util.HashSet;
import java.util.Set;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.utils.PersistentParallel6;
import expansion.set.profiling.SetExpansionSuitabilityProfiler;

public class SetExtensionSecondProfiling {
	public static void main(String[] args) throws IOException {
		SetExtension setExtension = new SetExtension(args);

		SetExtensionSecondProfiling profiling = setExtension.getGraph().get(SetExtensionSecondProfiling.class);
		Set<ClassId> classes = new HashSet<>();
		classes.add(ClassConstants.placeClass);
		classes.add(ClassConstants.musicalWorkClass);

		profiling.profiler.measureAndStoreSuitability(classes, true, setExtension.getResultsFolder() + "/suitability/", "SUITABILITY");

		try {
			PersistentParallel6.close();
		} catch (InterruptedException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private final SetExpansionSuitabilityProfiler profiler;

	@Inject
	public SetExtensionSecondProfiling(SetExpansionSuitabilityProfiler profiler) {
		this.profiler = profiler;
	}
}
