package de.uni_mannheim.informatik.dws.expansion.samples.t4ltee;

import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId.InstanceIdStyle;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.uni_mannheim.informatik.dws.expansion.samples.setExtension.ExtendedKnowledgeBaseValueCreator;
import expansion.set.evaluation.goldstandard.GoldStandardClusters;
import expansion.set.gscreation.GsOutputReader;

public class TransformT4LTEE {

	public static void main(String[] args) {
		GsOutputReader reader = new GsOutputReader(InstanceIdStyle.DBPEDIA_URI);

		String gsOutputFolder = "C:/Users/yaser/docs/documents/2019/Releases/WT4LTEE/unfiltered/";
		String mappingsFolder = "C:/Users/yaser/docs/documents/2019/Releases/WT4LTEE/mappings/";

		ExtendedKnowledgeBaseValueCreator extendedKnowledgeBaseValueCreator = new ExtendedKnowledgeBaseValueCreator(mappingsFolder);

		Map<String, InstanceId> positionIndexNormalized = extendedKnowledgeBaseValueCreator.getPositionIndexNormalized();

		// String luceneIndexCache = mappingsFolder + "lucene/";
		// MKDIR.createDirUnchecked(new File(luceneIndexCache));

		String instanceMappingsFolder = gsOutputFolder + "/instances/";
		String newInstancesFile = gsOutputFolder + "/newInstances.csv";
		String processedInstancesFile = gsOutputFolder + "/processed.csv";
		String processedTablesFile = gsOutputFolder + "/processedTables.csv";
		String tableClassesFile = gsOutputFolder + "/classes_GS.csv";
		String factsFile = gsOutputFolder + "/facts.csv";

		Map<AnnotatedTableId, ClassId> tableClasses = reader.readTableClasses(tableClassesFile);
		Set<AnnotatedTableId> processedTables = reader.readListOfTables(processedTablesFile);
		Set<InstanceId> processedInstancesNonFinal = reader.readInstancesList(processedInstancesFile);
		GoldStandardClusters mappings = reader.getMapping(instanceMappingsFolder, processedTables);
		GoldStandardClusters fullMappings = reader.getMapping(instanceMappingsFolder, null);
		Set<InstanceId> processedInstances = processedInstancesNonFinal.stream().filter((e) -> mappings.getCluster(e) != null).collect(Collectors.toSet());
		Set<InstanceId> missingInstances = processedInstancesNonFinal.stream().filter((e) -> mappings.getCluster(e) == null).collect(Collectors.toSet());
		Set<InstanceId> newInstances = reader.readInstancesList(newInstancesFile);

	}

}
