package de.uni_mannheim.informatik.dws.expansion.samples.thresholds;

import java.io.IOException;

import javax.inject.Named;

import dagger.Module;
import dagger.ObjectGraph;
import dagger.Provides;
import de.mannheim.uni.expansion.tablefusion.NamedProperties;
import de.mannheim.uni.expansion.tablefusion.modules.SimilarityModule;
import de.mannheim.uni.expansion.tablefusion.optimization.ThresholdFinder;

public class ThresholdFinding {

	@Module(injects = { ThresholdFinder.class }, library = true, complete = false)
	public static class ThresholdFindingModule {

		private final String optimizingFolder;

		private ThresholdFindingModule(String optimizingFolder) {
			this.optimizingFolder = optimizingFolder;

		}

		@Provides
		@Named(NamedProperties.OPTIMIZING_FOLDER)
		String getOptimizingFolder() {
			return this.optimizingFolder;
		}

	}

	public static void main(String[] args) throws IOException {
		String dataHome = null;

		if (args.length > 0 && args[0] != null && !args[0].equals("")) {
			dataHome = args[0];
		}

		ObjectGraph graph = ObjectGraph.create(new ThresholdFindingModule(dataHome + "/optimizing"), new SimilarityModule());

		ThresholdFinder finder = graph.get(ThresholdFinder.class);
		finder.findThreshold();

	}
}
