package expansion.set.clustering;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.UUID;

import com.fasterxml.uuid.Generators;

import expansion.set.clustering.model.RowCluster;

public class ClusterList {
	private final UUID uuid = Generators.timeBasedGenerator().generate();

	private final List<RowCluster> clusterList;

	public ClusterList(Collection<RowCluster> clusterList) {

		this.clusterList = Collections.unmodifiableList(new ArrayList<>(clusterList));
	}

	public UUID getUuid() {
		return uuid;
	}

	public List<RowCluster> getClusterList() {
		return clusterList;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((uuid == null) ? 0 : uuid.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ClusterList other = (ClusterList) obj;
		if (uuid == null) {
			if (other.uuid != null)
				return false;
		} else if (!uuid.equals(other.uuid))
			return false;
		return true;
	}

}
