package expansion.set.clustering;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import de.mannheim.uni.expansion.tablefusion.evaluation.analyzer.FusionConfig;
import de.uni_mannheim.informatik.dws.expansion.model.utils.thresholdpacks.ThresholdContainer;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.LearnedModelRepository;
import expansion.set.evaluation.SetExpansionStrategiesConfig;

public class RowClusteringConfig {

	private final SetExpansionStrategiesConfig setExpansionStrategiesConfig;
	private final List<ThresholdContainer> thresholdContainers;
	private final LearnedModelRepository weightsRepository;
	private final boolean withCache;
	private final boolean disableBlocking;
	private final FusionConfig fusionConfig;

	public RowClusteringConfig(SetExpansionStrategiesConfig setExpansionStrategiesConfig, List<ThresholdContainer> thresholdContainers,
			FusionConfig fusionConfig) {
		super();
		this.setExpansionStrategiesConfig = setExpansionStrategiesConfig;
		this.thresholdContainers = Collections.unmodifiableList(new ArrayList<>(thresholdContainers));
		this.weightsRepository = null;
		this.withCache = true;
		this.disableBlocking = true;
		this.fusionConfig = fusionConfig;
	}
	public RowClusteringConfig(SetExpansionStrategiesConfig setExpansionStrategiesConfig, List<ThresholdContainer> thresholdContainers,
			LearnedModelRepository weightsRepository, FusionConfig fusionConfig) {
		super();
		this.setExpansionStrategiesConfig = setExpansionStrategiesConfig;
		this.thresholdContainers = Collections.unmodifiableList(new ArrayList<>(thresholdContainers));
		this.weightsRepository = weightsRepository;
		this.withCache = true;
		this.disableBlocking = true;
		this.fusionConfig = fusionConfig;
	}

	public RowClusteringConfig(SetExpansionStrategiesConfig setExpansionStrategiesConfig, List<ThresholdContainer> thresholdContainers,
			LearnedModelRepository weightsRepository, boolean withCache, FusionConfig fusionConfig) {
		super();
		this.setExpansionStrategiesConfig = setExpansionStrategiesConfig;
		this.thresholdContainers = Collections.unmodifiableList(new ArrayList<>(thresholdContainers));
		this.weightsRepository = weightsRepository;
		this.withCache = withCache;
		this.disableBlocking = withCache;
		this.fusionConfig = fusionConfig;
	}

	public RowClusteringConfig(SetExpansionStrategiesConfig setExpansionStrategiesConfig, List<ThresholdContainer> thresholdContainers,
			LearnedModelRepository weightsRepository, boolean withCache, boolean disableBlocking, FusionConfig fusionConfig) {
		super();
		this.setExpansionStrategiesConfig = setExpansionStrategiesConfig;
		this.thresholdContainers = Collections.unmodifiableList(new ArrayList<>(thresholdContainers));
		this.weightsRepository = weightsRepository;
		this.withCache = withCache;
		this.disableBlocking = disableBlocking;
		this.fusionConfig = fusionConfig;
	}


	public SetExpansionStrategiesConfig getSetExpansionStrategiesConfig() {
		return setExpansionStrategiesConfig;
	}

	public List<ThresholdContainer> getThresholdContainers() {
		return thresholdContainers;
	}

	public LearnedModelRepository getWeightsRepository() {
		return weightsRepository;
	}

	public boolean isWithCache() {
		return withCache;
	}

	public boolean isDisableBlocking() {
		return disableBlocking;
	}

	public FusionConfig getFusionConfig() {
		return fusionConfig;
	}


}
