package expansion.set.clustering.model;

import java.util.Set;
import java.util.stream.Collectors;

import de.mannheim.uni.expansion.data.tables.model.TableRowId;
import expansion.set.clustering.model.RowCluster.ClusterEntryKey;
import expansion.set.clustering.model.similarities.RowClusterSimilarities;
import expansion.set.strategies.rowclusterers.ClusterSimilarities;

public class ClusterSimilaritiesImpl implements ClusterSimilarities {

	private final RowClusterSimilarities similarities;
	private final RowCluster rowCluster;

	public ClusterSimilaritiesImpl(RowCluster rowCluster, RowClusterSimilarities similarities) {
		super();
		this.similarities = similarities;
		this.rowCluster = rowCluster;
	}

	@Override
	public double get(ClusterEntryKey key) {
		return similarities.get(rowCluster.getRows(), rowCluster.getClassId(), key);
	}

	@Override
	public Set<Integer> regionQuery(Integer point, double eps) {
		TableRowId tableRowId = rowCluster.getRows().get(point);
		Set<TableRowId> candidates = similarities.regionQuery(rowCluster, tableRowId, eps);
		return candidates.stream().map((e) -> rowCluster.getIndex(e)).collect(Collectors.toSet());

	}

}
