package expansion.set.clustering.model;

import java.util.UUID;

import com.fasterxml.uuid.Generators;

public class RowClusterUUID {

	private final UUID uuid = Generators.timeBasedGenerator().generate();

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((uuid == null) ? 0 : uuid.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		RowClusterUUID other = (RowClusterUUID) obj;
		if (uuid == null) {
			if (other.uuid != null)
				return false;
		} else if (!uuid.equals(other.uuid))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return   uuid.toString();
	}
	
	
	public static int compare(RowClusterUUID id1, RowClusterUUID id2) {
		return id1.uuid.compareTo(id2.uuid);
	}

}
