package expansion.set.clustering.model.similarities;

import java.util.Map;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.tables.model.TableRowIdPair;
import de.uni_mannheim.informatik.ds.expansion.utils.learning.EvaluationMethod;
import de.uni_mannheim.informatik.ds.expansion.utils.learning.LearnedModel;

public interface LearnableRowClusterSimilarities extends RowClusterSimilarities {
	public static final String MATCH_CLASS = "MATCH";
	public static final String NOT_A_MATCH_CLASS = "NOT_A_MATCH";

	public static String getLabel(boolean isMatch) {
		if (isMatch) {
			return MATCH_CLASS;
		} else {
			return NOT_A_MATCH_CLASS;
		}
	}

	public static class PairLearningData {
		private final boolean isMatch;
		private final double weight;

		public PairLearningData(boolean isMatch, double weight) {
			super();
			this.isMatch = isMatch;
			this.weight = weight;
		}

		public boolean isMatch() {
			return isMatch;
		}

		public double getWeight() {
			return weight;
		}

		public String getLabel() {
			if (isMatch) {
				return MATCH_CLASS;
			} else {
				return NOT_A_MATCH_CLASS;
			}
		}

		@Override
		public String toString() {
			return "PairLearningData [isMatch=" + isMatch + ", weight=" + weight + "]";
		}

	}

	LearnedModel learn(Map<TableRowIdPair, PairLearningData> pairs, ClassId classId, EvaluationMethod evaluationMethod);
}
