package expansion.set.clustering.model.similarities;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.tables.model.TableRowId;
import expansion.set.clustering.model.RowCluster;
import expansion.set.clustering.model.RowCluster.ClusterEntryKey;

public class RowClusterConstantSimilarities implements RowClusterSimilarities {
	private final double sim;
	private final String name;
	public RowClusterConstantSimilarities(double sim) {
		this.sim = sim;
		this.name = "CONSTANT";
	}

	public RowClusterConstantSimilarities(double sim, String name) {
		this.sim = sim;
		this.name = name;
	}

	@Override
	public double get(List<TableRowId> rows, ClassId classId, ClusterEntryKey key) {
		return sim;
	}


	@Override
	public Set<TableRowId> regionQuery(RowCluster cluster, TableRowId point, double eps) {
		Set<TableRowId> newSet = new HashSet<>(cluster.getRows());

		newSet.remove(point);
		return newSet;
	}

	@Override
	public String getName() {
		return name;
	}

}
