package expansion.set.distant_supervision;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.LearnedModelRepository;
import expansion.set.entitymatching.modelLearning.EM_LearnedModelRepository;
import expansion.set.entitymatching.run.EntityMatchingRun;
import expansion.set.strategies.SetExpansionStrategy;

public class DS_Container {

	private final Map<ClassId, LearnedModelRepository> rowClustering;
	private final Map<ClassId, EM_LearnedModelRepository> newDetection;
	private final List<SetExpansionStrategy> clusteringStrategies;
	private final List<EntityMatchingRun> ndRuns;

	public DS_Container(Map<ClassId, LearnedModelRepository> rowClustering, List<SetExpansionStrategy> clusteringStrategies,
			Map<ClassId, EM_LearnedModelRepository> newDetection) {
		super();
		this.rowClustering = rowClustering;
		this.clusteringStrategies = clusteringStrategies;
		this.newDetection = newDetection;
		this.ndRuns = new ArrayList<>();
	}

	public DS_Container(Map<ClassId, LearnedModelRepository> rowClustering, List<SetExpansionStrategy> clusteringStrategies,
			Map<ClassId, EM_LearnedModelRepository> newDetection, List<EntityMatchingRun> ndRuns) {
		super();
		this.rowClustering = rowClustering;
		this.clusteringStrategies = clusteringStrategies;
		this.newDetection = newDetection;
		this.ndRuns = ndRuns;
	}

	public List<SetExpansionStrategy> getClusteringStrategies() {
		return clusteringStrategies;
	}

	public Map<ClassId, LearnedModelRepository> getRowClustering() {
		return rowClustering;
	}

	public boolean hasNewDetection() {
		return newDetection != null;
	}

	public boolean hasClustering() {
		return rowClustering != null;
	}

	public Map<ClassId, EM_LearnedModelRepository> getNewDetection() {
		return newDetection;
	}

	public List<EntityMatchingRun> getNewDetectionRuns() {
		return ndRuns;
	}

}
