package expansion.set.distant_supervision.scorables;

import de.mannheim.uni.expansion.utils.Scorable;
import expansion.set.clustering.model.RowClusterUUID;

public class RowClusterUUIDScorable implements Scorable, Comparable<RowClusterUUIDScorable> {
	private final Double d;
	private final RowClusterUUID pair;

	public RowClusterUUIDScorable(Double d, RowClusterUUID pair) {
		super();
		this.d = d;
		this.pair = pair;
	}


	@Override
	public Double getScore() {
		return d;
	}

	public RowClusterUUID getUUID() {
		return pair;
	}


	@Override
	public int compareTo(RowClusterUUIDScorable o) {
		return d.compareTo(o.d);
	}

}
