package expansion.set.distant_supervision.scorables;

import de.mannheim.uni.expansion.data.tables.model.TableRowIdPair;
import de.mannheim.uni.expansion.utils.Scorable;

public class TableRowIdPairScorable implements Scorable, Comparable<TableRowIdPairScorable> {
	private final Double d;
	private final TableRowIdPair pair;

	public TableRowIdPairScorable(Double d, TableRowIdPair pair) {
		super();
		this.d = d;
		this.pair = pair;
	}


	@Override
	public Double getScore() {
		return d;
	}

	public TableRowIdPair getPair() {
		return pair;
	}


	@Override
	public int compareTo(TableRowIdPairScorable o) {
		return d.compareTo(o.d);
	}

}
