package expansion.set.entitymatching;

import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import java.util.stream.Collectors;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.utils.ImmuMaker;
import de.mannheim.uni.expansion.utils.containers.Pair;
import expansion.set.clustering.model.RowClusterUUID;
import expansion.set.creation.Entity;
import expansion.set.evaluation.matching.ScoredEntity;

public class EntityMatcherWeightedResults {

	private final Map<InstanceId, List<ScoredEntity>> existingEntities;
	private final Map<InstanceId, List<ScoredEntity>> badEntities;
	private final List<ScoredEntity> newEntities;

	public EntityMatcherWeightedResults(Map<InstanceId, List<ScoredEntity>> existingEntities, Map<InstanceId, List<ScoredEntity>> badEntities,
			List<ScoredEntity> newEntities) {
		super();
		this.existingEntities = ImmuMaker.withList(existingEntities);
		this.badEntities = ImmuMaker.withList(badEntities);
		this.newEntities = ImmuMaker.list(newEntities);
	}

	public Map<InstanceId, List<ScoredEntity>> getExistingEntities() {
		return existingEntities;
	}

	public List<Entity> getBadEntities() {
		return badEntities.values().stream().flatMap((e) -> e.stream()).map((e) -> e.getEntity()).collect(Collectors.toList());
	}

	public Map<InstanceId, List<ScoredEntity>> getBadEntitiesMap() {
		return badEntities;
	}

	public List<ScoredEntity> getNewEntities() {
		return newEntities;
	}

	public Map<InstanceId, List<Entity>> getExistingEntitiesUnscored() {
		return existingEntities.entrySet().stream()
				.collect(Collectors.toMap(Entry::getKey, (e) -> e.getValue().stream().map(ScoredEntity::getEntity).collect(Collectors.toList())));
	}

	public Set<Pair<RowClusterUUID, InstanceId>> getPairMatches() {
		Set<Pair<RowClusterUUID, InstanceId>> set = new HashSet<>();
		for (Entry<InstanceId, List<ScoredEntity>> entry : existingEntities.entrySet()) {
			// for()
		}

		// TODO Auto-generated method stub
		return null;
	}

}
