package expansion.set.entitymatching.candidateselection;

import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.utils.ImmuMaker;

public class CandidateSelectionConfig {

	private final Map<ClassId, Set<ClassId>> allParents;

	private final Map<ClassId, Set<ClassId>> allParentsWithSelf;

	public CandidateSelectionConfig(Map<ClassId, Set<ClassId>> allParents) {
		this.allParents = ImmuMaker.mapWithSet(allParents);

		Map<ClassId, Set<ClassId>> allParentsWithSelf = new HashMap<>();
		for (Entry<ClassId, Set<ClassId>> entry : allParents.entrySet()) {
			Set<ClassId> innerClassIds = new HashSet<>(entry.getValue());
			innerClassIds.add(entry.getKey());
			allParentsWithSelf.put(entry.getKey(), Collections.unmodifiableSet(innerClassIds));
		}
		this.allParentsWithSelf = Collections.unmodifiableMap(allParentsWithSelf);
	}

	public Map<ClassId, Set<ClassId>> getAllParents() {
		return allParents;
	}

	public Map<ClassId, Set<ClassId>> getAllParentsWithSelf() {
		return allParentsWithSelf;
	}

}
