package expansion.set.entitymatching.candidateselection.strategies;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Optional;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.utils.containers.Tri;
import de.uni_mannheim.informatik.dws.matching.LabelMatcher;
import de.uni_mannheim.informatik.dws.matching.LabelMatcher.MatchStrictness;
import expansion.set.creation.Entity;
import expansion.set.entitymatching.candidateselection.CandidateSelection;
import expansion.set.entitymatching.candidateselection.CandidateSelectionConfig;
import expansion.set.entitymatching.candidateselection.CandidateSelectionResults;
import expansion.set.entitymatching.candidateselection.CandidateSelectionResults.CandidateSelectionResultKey;

public class CandidateSelection_Label implements CandidateSelection {

	@Inject
	protected LabelMatcher labelMatcher;

	@Inject
	public CandidateSelection_Label() {
	}

	public static CandidateSelectionResultKey<Double> CS_LABEL_SCORE = new CandidateSelectionResultKey<>("CS_LABEL_SCORE", Double.class);
	public static CandidateSelectionResultKey<Double> CS_PRIME_LABEL_SCORE = new CandidateSelectionResultKey<>("CS_PRIME_LABEL_SCORE", Double.class);

	public static CandidateSelectionResultKey<Double> CS_TYPE_SCORE = new CandidateSelectionResultKey<>("CS_TYPE_SCORE", Double.class);

	@Override
	public Optional<Map<InstanceId, CandidateSelectionResults>> run(Entity entity, CandidateSelectionConfig config) {

		// Set<TableRowId> rowId = new HashSet<>();
		// // rowId.add(new TableRowId());
		// // rowId.add(new TableRowId());
		// // rowId.add(new TableRowId());
		// rowId.add(new
		// TableRowId("1346981172268_1346989751042_496.arc8325315411675738751#19733164_0_4378818471678203207",
		// 15));
		// // rowId.add(new
		// //
		// TableRowId("1346876860614_1346890714966_383.arc6704915426463825928#80472872_1_6749123631237958046",
		// // 9));
		// // rowId.add(new
		// //
		// TableRowId("1346981172231_1347009637666_1623.arc2035420803784423551#8157737_1_7371407078293434892",
		// // 23));
		//
		// for (TableRowId rowIdd : entity.getRowCluster().getRows()) {
		// if (rowId.contains(rowIdd)) {
		// int sdf = 123;
		// break;
		// }
		// }

		Optional<Map<InstanceId, Tri<Double, Double, Double>>> matches = labelMatcher.getMatchesFull(entity.getLabels().keySet(),
				config.getAllParentsWithSelf().get(entity.getClassId()),
				MatchStrictness.NON_STRICT);

		if (matches.isPresent()) {
			Map<InstanceId, CandidateSelectionResults> ret = new HashMap<>();

			for (Entry<InstanceId, Tri<Double, Double, Double>> entry : matches.get().entrySet()) {

				double something = labelMatcher.getLabelSim(MatchStrictness.NON_STRICT, entity.getLabels().keySet(), entry.getKey(), true, false);

				CandidateSelectionResults results = CandidateSelectionResults.builder().put(CS_LABEL_SCORE, entry.getValue().getB())
						.put(CS_TYPE_SCORE, entry.getValue().getC()).put(CS_PRIME_LABEL_SCORE, entry.getValue().getA()).build();

				ret.put(entry.getKey(), results);
			}

			return Optional.of(ret);
		} else {
			return Optional.empty();
		}
	}

}
