package expansion.set.entitymatching.matchers;

import java.util.Map;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.expansion.utils.ImmuMaker;
import expansion.set.clustering.ClustererInput;

public class EntityMatcherConfig {

	private final ClustererInput input;
	private final Set<PropertyId> nonTailProperties;
	private final Map<ClassId, Set<ClassId>> allParents;

	public EntityMatcherConfig(ClustererInput input, Set<PropertyId> nonTailProperties, Map<ClassId, Set<ClassId>> allParents) {
		super();
		this.input = input;
		this.nonTailProperties = ImmuMaker.set(nonTailProperties);
		this.allParents = ImmuMaker.mapWithSet(allParents);
	}

	public ClustererInput getClustererInput() {
		return input;
	}

	public Set<PropertyId> getNonTailProperties() {
		return nonTailProperties;
	}

	public Map<ClassId, Set<ClassId>> getAllParents() {
		return allParents;
	}

}
