package expansion.set.entitymatching.matchers;

import java.io.Serializable;

public class EntityMatcherStrategy implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final String name;
	private final Class<? extends EntityMatcher> clazz;
	private final boolean ranked;

	public EntityMatcherStrategy(String name, Class<? extends EntityMatcher> clazz) {
		super();
		this.name = name;
		this.clazz = clazz;
		this.ranked = false;
	}

	public EntityMatcherStrategy(String name, Class<? extends EntityMatcher> clazz, boolean ranked) {
		super();
		this.name = name;
		this.clazz = clazz;
		this.ranked = ranked;
	}


	public String getName() {
		return name;
	}

	public Class<? extends EntityMatcher> getClazz() {
		return clazz;
	}



	public boolean isRanked() {
		return ranked;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((clazz == null) ? 0 : clazz.getName().hashCode());
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		result = prime * result + (ranked ? 1231 : 1237);
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof EntityMatcherStrategy))
			return false;
		EntityMatcherStrategy other = (EntityMatcherStrategy) obj;
		if (clazz == null) {
			if (other.clazz != null)
				return false;
		} else if (!clazz.getName().equals(other.clazz.getName()))
			return false;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		if (ranked != other.ranked)
			return false;
		return true;
	}

}
