package expansion.set.entitymatching.matchers.strategies;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.utils.WeightedScore;
import de.uni_mannheim.dws.expansion.data.kb.degree.DegreeRepository;
import expansion.set.creation.Entity;
import expansion.set.entitymatching.candidateselection.CandidateSelectionResults;
import expansion.set.entitymatching.candidateselection.CandidateSelectionStrategy;
import expansion.set.entitymatching.matchers.EntityMatcher;
import expansion.set.entitymatching.matchers.EntityMatcherConfig;

public class EntityMatcher_Indegree implements EntityMatcher {

	@Inject
	protected DegreeRepository degreeRepository;

	@Override
	public List<WeightedScore> run(EntityMatcherConfig config, Entity entity, InstanceId instanceId,
			Map<CandidateSelectionStrategy, CandidateSelectionResults> csResults) {
		List<WeightedScore> ret = new ArrayList<>();
		ret.add(new WeightedScore(degreeRepository.getNumIndegree(instanceId), 1.0));
		return ret;
	}

	@Override
	public void prepare(EntityMatcherConfig config, List<Entity> entities, Set<InstanceId> candidatesSet) {
		// TODO Auto-generated method stub

	}

}
