package expansion.set.entitymatching.matchers.strategies;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.utils.WeightedScore;
import expansion.set.creation.Entity;
import expansion.set.entitymatching.candidateselection.CandidateSelectionResults;
import expansion.set.entitymatching.candidateselection.CandidateSelectionStrategies;
import expansion.set.entitymatching.candidateselection.CandidateSelectionStrategy;
import expansion.set.entitymatching.candidateselection.strategies.CandidateSelection_Label;
import expansion.set.entitymatching.matchers.EntityMatcher;
import expansion.set.entitymatching.matchers.EntityMatcherConfig;

public class EntityMatcher_Type implements EntityMatcher {

	@Inject
	public EntityMatcher_Type() {
	}

	@Override
	public List<WeightedScore> run(EntityMatcherConfig config, Entity entity, InstanceId instanceId,
			Map<CandidateSelectionStrategy, CandidateSelectionResults> csResults) {
		List<WeightedScore> ret = new ArrayList<>();

		// if
		// (instanceId.getInstanceId().equals("http://dbpedia.org/resource/Aliens_&_Rainbows"))
		// {
		// int sdf = 123;
		// }

		CandidateSelectionResults results = csResults.get(CandidateSelectionStrategies.LABEL);
		if (results == null) {
			results = csResults.get(CandidateSelectionStrategies.RANDOM);

		}

		if (results == null) {
			results = csResults.get(CandidateSelectionStrategies.ATTRIBUTE);

		}

		ret.add(new WeightedScore(results.get(CandidateSelection_Label.CS_TYPE_SCORE).get(), 1.0));

		return ret;
	}

	@Override
	public void prepare(EntityMatcherConfig config, List<Entity> entities, Set<InstanceId> candidatesSet) {

	}
}
