package expansion.set.entitymatching.modelLearning;

import java.util.Map;
import java.util.function.Function;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.utils.containers.Pair;
import de.uni_mannheim.informatik.ds.expansion.utils.learning.OutputableModel;
import expansion.set.clustering.model.RowClusterUUID;
import expansion.set.entitymatching.EntityMatcherFullResults;
import expansion.set.entitymatching.EntityMatcherSingleResults;
import expansion.set.entitymatching.EntityMatcherWeightedResults;

public abstract class EntityMatchingModel implements OutputableModel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 5118340049934815842L;

	public abstract EntityMatcherWeightedResults apply(EntityMatcherFullResults fullRun);

	public abstract Function<InstanceId, Double> getOtherModelSupplier(Map<InstanceId, EntityMatcherSingleResults> candidates);

	public abstract Map<Pair<RowClusterUUID, InstanceId>, Pair<Boolean, Double>> getFullResults(EntityMatcherFullResults fullRun);

}
