package expansion.set.entitymatching.run;

import expansion.set.entitymatching.candidateselection.CandidateSelectionStrategies;
import expansion.set.entitymatching.matchers.EntityMatcherStrategies;
import expansion.set.entitymatching.modelLearning.simpleWeights.SimpleEntityMatchingWeightLearner;
import expansion.set.entitymatching.modelLearning.weights.EntityMatchingWeightLearner;
import expansion.set.entitymatching.modelLearning.weka.randomforest.EntityMatchingWekaRFDescretizedWithSWLearner;
import expansion.set.entitymatching.modelLearning.weka.randomforest.EntityMatchingWekaRFLearner;
import expansion.set.entitymatching.modelLearning.weka.randomforest.EntityMatchingWekaRFNewLearner;
import expansion.set.entitymatching.modelLearning.weka.randomforest.EntityMatchingWekaRFNew_ET_Learner;
import expansion.set.entitymatching.modelLearning.weka.randomforest.EntityMatchingWekaRFWithSWLearner;
import expansion.set.entitymatching.modelLearning.weka.regression.EntityMatchingWekaLinearLearner;
import expansion.set.entitymatching.modelLearning.weka.regression.EntityMatchingWekaLogisticLearner;

public class EntityMatchingRunRepository {
	

	public static EntityMatchingRun CS_LABEL_EM_LABEL = EntityMatchingRun.builder("CS_LABEL_EM_LABEL", SimpleEntityMatchingWeightLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL)
			.addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL).build();

	public static EntityMatchingRun CS_LABEL_EM_PRIME_SURFACE_LABEL = EntityMatchingRun
			.builder("CS_LABEL_EM_PRIME_SURFACE_LABEL", SimpleEntityMatchingWeightLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS).build();

	public static EntityMatchingRun CS_LABEL_EM_LABEL_TYPE = EntityMatchingRun.builder("CS_LABEL_EM_LABEL_TYPE", EntityMatchingWekaRFWithSWLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).build();

	public static EntityMatchingRun CS_LABEL_EM_LABEL_TYPE_INDEGREE = EntityMatchingRun
			.builder("CS_LABEL_EM_LABEL_TYPE_INDEGREE", EntityMatchingWekaRFWithSWLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.INDEGREE).build();

	public static EntityMatchingRun CS_LABEL_EM_LABEL_TYPE_BOW = EntityMatchingRun
			.builder("CS_LABEL_EM_LABEL_TYPE_BOW", EntityMatchingWekaRFWithSWLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).build();

	public static EntityMatchingRun CS_LABEL_EM_LABEL_TYPE_INDEGREE_BOW = EntityMatchingRun
			.builder("CS_LABEL_EM_LABEL_TYPE_INDEGREE_BOW", EntityMatchingWekaRFWithSWLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.INDEGREE).addEntityMatcher(EntityMatcherStrategies.BOW)
			.build();

	public static EntityMatchingRun CS_LABEL_EM_LABEL_TYPE_INDEGREE_BOW_ATTRIBUTE = EntityMatchingRun
			.builder("CS_LABEL_EM_LABEL_TYPE_INDEGREE_BOW_ATTRIBUTE", EntityMatchingWekaRFWithSWLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW)
			.addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE).build();

	public static EntityMatchingRun CS_LABEL_EM_LABEL_TYPE_INDEGREE_BOW_ATTRIBUTE_IMPLICIT = EntityMatchingRun
			.builder("CS_LABEL_EM_LABEL_TYPE_INDEGREE_BOW_ATTRIBUTE_IMPLICIT", EntityMatchingWekaRFWithSWLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW)
			.addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).build();

	public static EntityMatchingRun CS_LABEL_EM_LABEL_TYPE_INDEGREE_BOW_ATTRIBUTE_WITH_INDEGREE = EntityMatchingRun
			.builder("CS_LABEL_EM_LABEL_TYPE_INDEGREE_BOW_ATTRIBUTE_WITH_INDEGREE", EntityMatchingWekaRFWithSWLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.INDEGREE).addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW)
			.addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).build();

	// public static EntityMatchingRun
	// CS_LABEL_EM_LABEL_TYPE_INDEGREE_BOW_ATTRIBUTE_IMPLICIT =
	// EntityMatchingRun
	// .builder("CS_LABEL_EM_LABEL_TYPE_INDEGREE_BOW_ATTRIBUTE_IMPLICIT").addCandidateSelection(CandidateSelectionStrategies.LABEL)
	// .addEntityMatcher(EntityMatcherStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.INDEGREE)
	// .addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
	// .addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).build();


	public static EntityMatchingRun CS_LABEL_EM_LABEL_TYPE_ATTRIBUTE = EntityMatchingRun
			.builder("CS_LABEL_EM_LABEL_TYPE_ATTRIBUTE", EntityMatchingWeightLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE).build();

	public static EntityMatchingRun CS_LABEL_EM_LABEL_TYPE_IMPLICIT_ATTRIBUTE = EntityMatchingRun
			.builder("CS_LABEL_EM_LABEL_TYPE_IMPLICIT_ATTRIBUTE", EntityMatchingWeightLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).build();

	public static EntityMatchingRun CS_LABEL_EM_ALL = EntityMatchingRun.builder("CS_LABEL_EM_ALL", EntityMatchingWeightLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL)
			.addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS).addEntityMatcher(EntityMatcherStrategies.TYPE)
			.addEntityMatcher(EntityMatcherStrategies.BOW)
			.addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE)
			.addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).build();

	public static EntityMatchingRun SW_CS_LABEL_EM_ALL = EntityMatchingRun.builder("SW_CS_LABEL_EM_ALL", SimpleEntityMatchingWeightLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
			.addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE)
			.build();

	public static EntityMatchingRun RF_CS_LABEL_EM_LABEL = EntityMatchingRun.builder("RF_CS_LABEL_EM_LABEL", EntityMatchingWekaRFLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS).build();

	public static EntityMatchingRun RF_CS_LABEL_EM_LABEL_TYPE = EntityMatchingRun.builder("RF_CS_LABEL_EM_LABEL_TYPE", EntityMatchingWekaRFLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).build();

	public static EntityMatchingRun RF_CS_LABEL_EM_LABEL_TYPE_BOW = EntityMatchingRun
			.builder("RF_CS_LABEL_EM_LABEL_TYPE_BOW", EntityMatchingWekaRFLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).build();

	public static EntityMatchingRun RF_CS_LABEL_EM_LABEL_TYPE_BOW_INDEGREE = EntityMatchingRun
			.builder("RF_CS_LABEL_EM_LABEL_TYPE_BOW_INDEGREE", EntityMatchingWekaRFLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.INDEGREE)
			.build();

	public static EntityMatchingRun RF_CS_LABEL_EM_LABEL_TYPE_BOW_INDEGREE_ATT = EntityMatchingRun
			.builder("RF_CS_LABEL_EM_LABEL_TYPE_BOW_INDEGREE_ATT", EntityMatchingWekaRFLearner.class).addCandidateSelection(CandidateSelectionStrategies.LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS).addEntityMatcher(EntityMatcherStrategies.TYPE)
			.addEntityMatcher(EntityMatcherStrategies.BOW)
			.addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE).build();

	public static EntityMatchingRun RF_SW_CS_LABEL_EM_ALL = EntityMatchingRun.builder("RF_SW_CS_LABEL_EM_ALL", EntityMatchingWekaRFWithSWLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
			.addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE)
			.build();

	public static EntityMatchingRun CONTAINER_ND_ALL = EntityMatchingRun.builder("CONTAINER_ND_ALL", EntityMatchingWekaRFWithSWLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
			.addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE).build();

	public static EntityMatchingRun RF_ET_CS_LABEL_EM_ALL = EntityMatchingRun.builder("RF_ET_CS_LABEL_EM_ALL", EntityMatchingWekaRFNew_ET_Learner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
			.addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE)
			.addEntityMatcher(EntityMatcherStrategies.INDEGREE_NEW).build();

	public static EntityMatchingRun RFDES_SW_CS_LABEL_EM_ALL = EntityMatchingRun
			.builder("RFDES_SW_CS_LABEL_EM_ALL", EntityMatchingWekaRFDescretizedWithSWLearner.class).addCandidateSelection(CandidateSelectionStrategies.LABEL)
			.addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS).addEntityMatcher(EntityMatcherStrategies.TYPE)
			.addEntityMatcher(EntityMatcherStrategies.BOW)
			.addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE)
			.addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).build();

	public static EntityMatchingRun RF_CS_LABEL_EM_ALL = EntityMatchingRun.builder("RF_CS_LABEL_EM_ALL", EntityMatchingWekaRFLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
			.addEntityMatcher(EntityMatcherStrategies.INDEGREE).addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).build();

	public static EntityMatchingRun RF_NEW_CS_LABEL_EM_ALL = EntityMatchingRun.builder("RF_NEW_CS_LABEL_EM_ALL", EntityMatchingWekaRFNewLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
			.addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE)
			.build();

	public static EntityMatchingRun LIN_CS_LABEL_EM_ALL = EntityMatchingRun.builder("LIN_CS_LABEL_EM_ALL", EntityMatchingWekaLinearLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
			.addEntityMatcher(EntityMatcherStrategies.INDEGREE).addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).build();

	public static EntityMatchingRun LOG_CS_LABEL_EM_ALL = EntityMatchingRun.builder("LOG_CS_LABEL_EM_ALL", EntityMatchingWekaLogisticLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
			.addEntityMatcher(EntityMatcherStrategies.INDEGREE).addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).build();

	// WA
	public static EntityMatchingRun WA_LABEL_LABELSF = EntityMatchingRun.builder("WA_LABEL_LABELSF", SimpleEntityMatchingWeightLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.build();

	public static EntityMatchingRun WA_LABEL_LABELSF_TYPE = EntityMatchingRun.builder("WA_LABEL_LABELSF_TYPE", SimpleEntityMatchingWeightLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE)

			.build();

	public static EntityMatchingRun WA_LABEL_LABELSF_TYPE_BOW = EntityMatchingRun.builder("WA_LABEL_LABELSF_TYPE_BOW", SimpleEntityMatchingWeightLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL)
			.addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW)

			.build();

	public static EntityMatchingRun WA_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE = EntityMatchingRun
			.builder("WA_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE", SimpleEntityMatchingWeightLearner.class).addCandidateSelection(CandidateSelectionStrategies.LABEL)
			.addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE)
			.addEntityMatcher(EntityMatcherStrategies.BOW)
			.addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)

			.build();

	public static EntityMatchingRun WA_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT = EntityMatchingRun
			.builder("WA_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT", SimpleEntityMatchingWeightLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL)
			.addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE)
			.addEntityMatcher(EntityMatcherStrategies.BOW)
			.addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).build();

	public static EntityMatchingRun WA_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREE = EntityMatchingRun
			.builder("WA_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREE", SimpleEntityMatchingWeightLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
			.addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE).build();

	public static EntityMatchingRun WA_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREENEW = EntityMatchingRun
			.builder("WA_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREENEW", SimpleEntityMatchingWeightLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
			.addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE_NEW).build();

	public static EntityMatchingRun WA_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREE_INDEGREENEW = EntityMatchingRun
			.builder("WA_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREE_INDEGREENEW", SimpleEntityMatchingWeightLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
			.addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE)
			.addEntityMatcher(EntityMatcherStrategies.INDEGREE_NEW).build();

	// public static EntityMatchingRun
	// WA_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREE_INDEGREENEW_LABELSF
	// = EntityMatchingRun.builder("WA_LABEL_LABELSF",
	// SimpleEntityMatchingWeightLearner.class)
	// .addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
	//
	// .addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
	// .addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE)
	// .addEntityMatcher(EntityMatcherStrategies.INDEGREE_NEW)
	// .addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
	//
	// .build();

	// RF

	public static EntityMatchingRun RF_LABEL_LABELSF = EntityMatchingRun.builder("RF_LABEL_LABELSF", EntityMatchingWekaRFNewLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)


			.build();

	public static EntityMatchingRun RF_LABEL_LABELSF_TYPE = EntityMatchingRun.builder("RF_LABEL_LABELSF_TYPE", EntityMatchingWekaRFNewLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE)

			.build();

	public static EntityMatchingRun RF_LABEL_LABELSF_TYPE_BOW = EntityMatchingRun.builder("RF_LABEL_LABELSF_TYPE_BOW", EntityMatchingWekaRFNewLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW)

			.build();

	public static EntityMatchingRun RF_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE = EntityMatchingRun
			.builder("RF_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE", EntityMatchingWekaRFNewLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)

			.build();

	public static EntityMatchingRun RF_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT = EntityMatchingRun
			.builder("RF_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT", EntityMatchingWekaRFNewLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL)
			.addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE)
			.addEntityMatcher(EntityMatcherStrategies.BOW)
			.addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).build();

	public static EntityMatchingRun RF_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREE = EntityMatchingRun
			.builder("RF_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREE", EntityMatchingWekaRFNewLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
			.addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE).build();

	public static EntityMatchingRun RF_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREENEW = EntityMatchingRun
			.builder("RF_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREENEW", EntityMatchingWekaRFNewLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
			.addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE_NEW).build();

	public static EntityMatchingRun RF_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREE_INDEGREENEW = EntityMatchingRun
			.builder("RF_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREE_INDEGREENEW", EntityMatchingWekaRFNewLearner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
			.addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE)
			.addEntityMatcher(EntityMatcherStrategies.INDEGREE_NEW).build();

	// ET

	// public static EntityMatchingRun ET_LABEL =
	// EntityMatchingRun.builder("ET_LABEL_LABELSF",
	// EntityMatchingWekaRFNew_ET_Learner.class)
	// .addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
	//
	// .build();

	public static EntityMatchingRun ET_LABEL_LABELSF = EntityMatchingRun.builder("ET_LABEL_LABELSF", EntityMatchingWekaRFNew_ET_Learner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.build();

	public static EntityMatchingRun ET_LABEL_LABELSF_TYPE = EntityMatchingRun.builder("ET_LABEL_LABELSF_TYPE", EntityMatchingWekaRFNew_ET_Learner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)

			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE)
			.build();

	public static EntityMatchingRun ET_LABEL_LABELSF_TYPE_BOW = EntityMatchingRun.builder("ET_LABEL_LABELSF_TYPE_BOW", EntityMatchingWekaRFNew_ET_Learner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)
			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW)

			.build();

	public static EntityMatchingRun ET_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE = EntityMatchingRun
			.builder("ET_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE", EntityMatchingWekaRFNew_ET_Learner.class).addCandidateSelection(CandidateSelectionStrategies.LABEL)
			.addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE)
			.addEntityMatcher(EntityMatcherStrategies.BOW)
			.addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)

			.build();

	public static EntityMatchingRun ET_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT = EntityMatchingRun
			.builder("ET_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT", EntityMatchingWekaRFNew_ET_Learner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL)
			.addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE)
			.addEntityMatcher(EntityMatcherStrategies.BOW)
			.addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).build();

	public static EntityMatchingRun ET_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREE = EntityMatchingRun
			.builder("ET_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREE", EntityMatchingWekaRFNew_ET_Learner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
			.addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE).build();

	public static EntityMatchingRun ET_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREENEW = EntityMatchingRun
			.builder("ET_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREENEW", EntityMatchingWekaRFNew_ET_Learner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
			.addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE_NEW).build();

	public static EntityMatchingRun ET_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREE_INDEGREENEW = EntityMatchingRun
			.builder("ET_LABEL_LABELSF_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREE_INDEGREENEW", EntityMatchingWekaRFNew_ET_Learner.class)
			.addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.PRIME_LABEL)
			.addEntityMatcher(EntityMatcherStrategies.LABEL_SURFACE_FROMS)

			.addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
			.addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE)
			.addEntityMatcher(EntityMatcherStrategies.INDEGREE_NEW).build();

	// public static EntityMatchingRun
	// ENSEMBLED_LABEL_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREENEW =
	// EntityMatchingRun
	// .builder("ENSEMBLED_LABEL_TYPE_BOW_ATTRIBUTE_IMPLICIT_INDEGREENEW",
	// EntityMatchingWekaRFWithSWLearner.class)
	// .addCandidateSelection(CandidateSelectionStrategies.LABEL).addEntityMatcher(EntityMatcherStrategies.LABEL)
	// .addEntityMatcher(EntityMatcherStrategies.TYPE).addEntityMatcher(EntityMatcherStrategies.BOW).addEntityMatcher(EntityMatcherStrategies.ATTRIBUTE)
	// .addEntityMatcher(EntityMatcherStrategies.IMPLICIT_ATTRIBUTE).addEntityMatcher(EntityMatcherStrategies.INDEGREE_NEW).build();

}
