package expansion.set.evaluation;

import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.tablefusion.analysis.stores.PerformancePR;
import expansion.set.evaluation.crossvalidation.EntitySets;
import expansion.set.evaluation.matching.ScoredEntity;

public class EntitySetsEvaluator {
	@Inject
	public EntitySetsEvaluator() {
		
	}

	public PerformancePR evaluate(Map<InstanceId, List<ScoredEntity>> mappedEntities, EntitySets entitySets) {
		int truePositive = 0;
		int falsePositive = 0;
		
		Set<InstanceId> testingSet = entitySets.getTestingSet();
		for(Entry<InstanceId, List<ScoredEntity>> candidateEntry : mappedEntities.entrySet()) {
			if(testingSet.contains(candidateEntry.getKey())) {
				truePositive++;
				
				if(candidateEntry.getValue().size() > 1) {
					falsePositive += (candidateEntry.getValue().size() - 1);
				}
			}
			
		}
		 
		return new PerformancePR(truePositive, falsePositive, testingSet.size(), 0);
	}

}
