package expansion.set.evaluation;

import java.util.function.BinaryOperator;

import de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulateables.Accumulateable;

public class SlotFillingPerformance implements Accumulateable<SlotFillingPerformance> {

	private final int entities;
	private final int clusters;
	private final int values;
	private final int newValues;
	
	public SlotFillingPerformance(int entities, int clusters, int values, int newValues) {
		super();
		this.entities = entities;
		this.clusters = clusters;
		this.values = values;
		this.newValues = newValues;
	}
	
	
	int getEntities() {
		return entities;
	}


	int getClusters() {
		return clusters;
	}


	int getValues() {
		return values;
	}


	int getNewValues() {
		return newValues;
	}


	public static SlotFillingPerformance accumulater(SlotFillingPerformance a, SlotFillingPerformance b) {
		return new SlotFillingPerformance(a.entities + b.entities, a.clusters + b.clusters, a.values + b.values,
				a.newValues + b.newValues);
	}

	@Override
	public BinaryOperator<SlotFillingPerformance> getAccumulator() {
		return SlotFillingPerformance::accumulater;
	}



//	@Override
//	public ClusterPerformance copy() {
//		return new ClusterPerformance(instancesCreated, instancesInKB, precisionSum, recallSum, fMeasureSum,count, medianPerCreatedCluster.copy(), averagePerCreatedCluster.copy(), medianPerKBInstance.copy(), averagePerCreatedCluster.copy());
//	}

	@Override
	public Class<SlotFillingPerformance> getAcumClass() {
		return SlotFillingPerformance.class;
	}

	public static SlotFillingPerformance empty() {
		return new SlotFillingPerformance(0,0,0,0);
	}

	@Override
	public SlotFillingPerformance accumulate(SlotFillingPerformance other) {

		throw new UnsupportedOperationException();
	}
	
}
