package expansion.set.evaluation;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.tables.model.TableIdsSet;
import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.splitting.SplitGroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.splitting.Splitter;
import de.mannheim.uni.expansion.tablefusion.core.splitting.SplitterFactory;
import de.mannheim.uni.expansion.tablefusion.core.splitting.SplitterFactoryRepository;
import de.mannheim.uni.expansion.tablefusion.evaluation.analyzer.FusionConfig;
import de.mannheim.uni.expansion.tablefusion.services.grouping.GroupedValuesRepository;

public class SplitValuesGetter {

	@Inject
	protected GroupedValuesRepository groupedValuesRepository;

	@Inject
	protected SplitterFactoryRepository splitterFactoriesRepository;

	@Inject
	public SplitValuesGetter() {
	}

	public SplitGroupedValues getSplitGroupedValues(FusionConfig fusionConfig, TableIdsSet tableIdsSet) {
		GroupedValues groupedValues = groupedValuesRepository.getGroupedValues(fusionConfig, tableIdsSet);

		return getSplitGroupedValues(groupedValues, fusionConfig);
	}

	public SplitGroupedValues getSplitGroupedValues(GroupedValues groupedValues, FusionConfig fusionConfig) {

		SplitterFactory splitterFactory = this.splitterFactoriesRepository.get(fusionConfig.getSplitterFactory());
		Splitter splitter = splitterFactory.getSplitter(groupedValues, groupedValues, groupedValues);
		SplitGroupedValues splitGroupedValues = splitter.split(groupedValues);

		return splitGroupedValues;
	}
}
