package expansion.set.evaluation.crossvalidation;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.ontology.model.QualifiedTripleId;
import de.mannheim.uni.expansion.tablefusion.core.matching.MatchedValues;
import de.mannheim.uni.expansion.tablefusion.core.splitting.SplitGroupedValues;
import de.mannheim.uni.expansion.tablefusion.learning.SplitGroupedValuesSets;
import de.mannheim.uni.expansion.utils.PersistentParallel6;

public class EntitySetGroupedValuesSplitter {

	@Inject
	public EntitySetGroupedValuesSplitter() {

	}
	public Map<Integer, SplitGroupedValuesSets> split(SplitGroupedValues splitGroupedValues, Map<Integer, EntitySets> entitySets) {



		Map<Integer, Map<QualifiedTripleId, MatchedValues>> learningSets = new ConcurrentHashMap<>();
		Map<Integer, Map<QualifiedTripleId, MatchedValues>> testingSets = new ConcurrentHashMap<>();
		for (int i = 0; i < entitySets.size(); i++) {
			learningSets.put(i, new ConcurrentHashMap<>());
			testingSets.put(i, new ConcurrentHashMap<>());
		}

			PersistentParallel6.runAndFinish(splitGroupedValues.entrySet(), (entry) -> {
			for (int i = 0; i < entitySets.size(); i++) {

				if (entitySets.get(i).getLearningSet().contains(entry.getKey().getTripleId().getInstanceId())) {
					learningSets.get(i).put(entry.getKey(), entry.getValue());
				}
				if (entitySets.get(i).getTestingSet().contains(entry.getKey().getTripleId().getInstanceId())) {
					testingSets.get(i).put(entry.getKey(), entry.getValue());
				}
			}

			} , this.getClass());

		Map<Integer, SplitGroupedValuesSets> ret = new HashMap<>();

		for (int i = 0; i < entitySets.size(); i++) {
			SplitGroupedValuesSets sets = new SplitGroupedValuesSets(splitGroupedValues, new SplitGroupedValues(learningSets.get(i)),
					new SplitGroupedValues(testingSets.get(i)));
			ret.put(i, sets);
		}

		return ret;
	}
	
	public  SplitGroupedValuesSets split(SplitGroupedValues splitGroupedValues,  EntitySets  entitySets) {



	 Map<QualifiedTripleId, MatchedValues>  learningSets = new ConcurrentHashMap<>();
		  Map<QualifiedTripleId, MatchedValues>  testingSets = new ConcurrentHashMap<>();
 

			PersistentParallel6.runAndFinish(splitGroupedValues.entrySet(), (entry) -> {
 
				if (entitySets.getLearningSet().contains(entry.getKey().getTripleId().getInstanceId())) {
					learningSets.put(entry.getKey(), entry.getValue());
				}
				if (entitySets.getTestingSet().contains(entry.getKey().getTripleId().getInstanceId())) {
					testingSets.put(entry.getKey(), entry.getValue());
				}
	 

			} , this.getClass());

		Map<Integer, SplitGroupedValuesSets> ret = new HashMap<>();

		 
			SplitGroupedValuesSets sets = new SplitGroupedValuesSets(splitGroupedValues, new SplitGroupedValues(learningSets),
					new SplitGroupedValues(testingSets)); 
	 

		return sets;
	}
}
