package expansion.set.evaluation.crossvalidation;

import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;

public class EntitySets {
	Set<InstanceId> learningSet;
	Set<InstanceId> testingSet;

	public EntitySets(Collection<InstanceId> learningSet, Collection<InstanceId> testingSet) {
		this.learningSet = Collections.unmodifiableSet(new HashSet<>(learningSet));
		this.testingSet = Collections.unmodifiableSet(new HashSet<>(testingSet));
	}

	public Set<InstanceId> getLearningSet() {
		return learningSet;
	}



	public Set<InstanceId> getTestingSet() {
		return testingSet;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((learningSet == null) ? 0 : learningSet.hashCode());
		result = prime * result + ((testingSet == null) ? 0 : testingSet.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof EntitySets))
			return false;
		EntitySets other = (EntitySets) obj;
		if (learningSet == null) {
			if (other.learningSet != null)
				return false;
		} else if (!learningSet.equals(other.learningSet))
			return false;
		if (testingSet == null) {
			if (other.testingSet != null)
				return false;
		} else if (!testingSet.equals(other.testingSet))
			return false;
		return true;
	}
	
	


}
