package expansion.set.evaluation.entities;

import java.util.function.BinaryOperator;

import de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulateables.Accumulateable;

public class EntitiesPerformance implements Accumulateable<EntitiesPerformance> {

	private final EntitiesPerformanceSingle existingEntitiesPerformance;
	private final EntitiesPerformanceSingle newEntitiesPerformance;
	
	public EntitiesPerformance( ) {
		super();
		this.existingEntitiesPerformance = new EntitiesPerformanceSingle();
		this.newEntitiesPerformance = new EntitiesPerformanceSingle();
	}
	
	public EntitiesPerformance(EntitiesPerformanceSingle existingEntitiesPerformance, EntitiesPerformanceSingle newEntitiesPerformance) {
		super();
		this.existingEntitiesPerformance = existingEntitiesPerformance;
		this.newEntitiesPerformance = newEntitiesPerformance;
	}
	
	
	
	public EntitiesPerformanceSingle getExistingEntitiesPerformance() {
		return existingEntitiesPerformance;
	}



	public EntitiesPerformanceSingle getNewEntitiesPerformance() {
		return newEntitiesPerformance;
	}



	public static EntitiesPerformance accumulator(EntitiesPerformance a, EntitiesPerformance b) {
		return new EntitiesPerformance(a.existingEntitiesPerformance.accumulate(b.existingEntitiesPerformance), a.newEntitiesPerformance.accumulate(b.newEntitiesPerformance));
	}
	@Override
	public BinaryOperator<EntitiesPerformance> getAccumulator() {
		return EntitiesPerformance::accumulator;
	}

	@Override
	public EntitiesPerformance accumulate(EntitiesPerformance other) {
		return EntitiesPerformance.accumulator(this, other);
	}

	@Override
	public Class<EntitiesPerformance> getAcumClass() {
		return EntitiesPerformance.class;
	}

}
