package expansion.set.evaluation.entities;

import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import expansion.set.creation.Entity;
import expansion.set.evaluation.goldstandard.GoldStandardClusters;

public class EntitiesPerformanceEvaluator {

	
	@Inject
	public EntitiesPerformanceEvaluator() {
		
	}
	
	
	// public EntitiesPerformance evaluate(GoldStandardClusters gs,
	// Set<InstanceId> newEntities, Map<RowClusterUUID, Optional<InstanceId>>
	// remapped,
	// Map<InstanceId, List<Entity>> mappingForExistingClusters, List<Entity>
	// newClusters ) {
	//
	// Map<RowClusterUUID, Optional<InstanceId>> mapping = remap(gs,
	// mappingForExistingClusters, newClusters);
	//
	// Set<InstanceId> newCorrect = new HashSet<>();
	// Set<InstanceId> newWithCollisionCorrect = new HashSet<>();
	// int newCollisions = 0;
	// int newTotal = 0;
	// int newMaxCorrect = newEntities.size();
	//
	// for( Entity entity : newClusters) {
	//
	// newTotal++;
	// Optional<InstanceId> mappedInstance =
	// remapped.get(entity.getRowClusterUUID());
	// if (mappedInstance.isPresent() &&
	// newEntities.contains(mappedInstance.get())) {
	// if(newCorrect.contains(mappedInstance.get())) {
	// newWithCollisionCorrect.add(mappedInstance.get());
	// newCollisions++;
	// }
	// else {
	// newCorrect.add(mappedInstance.get());
	// }
	// }
	// }
	//
	// double newCorrectDouble = (double) newCorrect.size();
	// double newRecall = 0.0;
	// if (newMaxCorrect != 0) {
	// newRecall = newCorrectDouble / newMaxCorrect;
	// }
	// EntitiesPerformanceSingle entitiesPerformanceNew = new
	// EntitiesPerformanceSingle(newCorrectDouble / newTotal, newRecall,
	// newCorrect.size(),
	// newWithCollisionCorrect.size(), newCollisions);
	//
	//
	//
	// Set<InstanceId> existingCorrect = new HashSet<>();
	// Set<InstanceId> existingWithCollision = new HashSet<>();
	// int existingCollisions = 0;
	// int existingTotal = 0;
	// int existingMaxCorrect = gs.getTestingSetMappingClusters().size() -
	// newMaxCorrect;
	//
	// for(Entry<InstanceId, List<Entity>> mapping :
	// mappingForExistingClusters.entrySet()) {
	// for(Entity entity : mapping.getValue()) {
	// existingTotal++;
	// Optional<InstanceId> mappedInstance =
	// remapped.get(entity.getRowClusterUUID());
	// if(mappedInstance.isPresent() &&
	// mappedInstance.get().equals(mapping.getKey())) { // &&
	// !newEntities.contains(mappedInstance.get())
	// if(existingCorrect.contains(mapping.getKey())) {
	// existingWithCollision.add(mapping.getKey());
	// existingCollisions++;
	// }
	// else {
	// if(newEntities.contains(mappedInstance.get())) {
	// int sdf= 123;
	// }
	// else {
	// existingCorrect.add(mapping.getKey());
	// }
	// }
	// }
	// }
	// }
	//
	//
	// double existingCorrectDouble = (double) existingCorrect.size();
	// EntitiesPerformanceSingle entitiesPerformanceExisting = new
	// EntitiesPerformanceSingle(existingCorrectDouble / existingTotal,
	// existingCorrectDouble / existingMaxCorrect, existingCorrect.size(),
	// existingWithCollision.size(), existingCollisions);
	//
	//
	//
	// return new EntitiesPerformance(entitiesPerformanceExisting,
	// entitiesPerformanceNew);
	//
	//
	// }

	public EntitiesPerformance evaluate(GoldStandardClusters gs, Set<InstanceId> newEntities, Set<InstanceId> found,
			Map<InstanceId, List<Entity>> mappingForExistingClusters, List<Entity> remainingClusters) {

		int correctNew = 0;
		int correctExisting = 0;

		int totalExisting = mappingForExistingClusters.size();
		int totalNew = remainingClusters.size();

		int maxExisting = gs.getTestingSetMappingClusters().size() - newEntities.size();
		int maxNew = newEntities.size();

		for (InstanceId f : found) {
			if (newEntities.contains(f)) {
				correctNew++;
			} else {
				correctExisting++;
			}
		}

		double correctExistingDouble = correctExisting;
		double correctNewDouble = correctNew;
		EntitiesPerformanceSingle entitiesPerformanceExisting = new EntitiesPerformanceSingle(correctExistingDouble / totalExisting,
				correctExistingDouble / maxExisting, correctExisting, 0, 0);

		EntitiesPerformanceSingle entitiesPerformanceNew = new EntitiesPerformanceSingle(correctNewDouble / totalNew, correctNewDouble / maxNew, correctNew, 0,
				0);

		return new EntitiesPerformance(entitiesPerformanceExisting, entitiesPerformanceNew);
	}

	// public Map<RowClusterUUID, Optional<InstanceId>>
	// remap(GoldStandardClusters gs, Map<InstanceId, List<Entity>>
	// mappingForExistingClusters,
	// List<Entity> newClusters) {
	// Map<InstanceId, Set<TableRowId>> ret = new HashMap<>();
	// Map<InstanceId, Set<TableRowId>> ret = new HashMap<>();
	//
	//
	// for(Entry<InstanceId, List<Entity>> entry :
	// mappingForExistingClusters.entrySet()) {
	// Set<TableRowId> cluster = gs.getCluster(entry.getKey());
	// if(cluster != null) {
	// double overlap = 0;
	// int totalOutput = 0;
	// for(Entity e : entry.getValue()) {
	// for(TableRowId rowId : e.getRowCluster().getRows()) {
	// totalOutput++;
	// if(cluster.contains(rowId)) {
	// overlap++;
	// }
	// }
	// }
	//
	// if(overlap / cluster.size() > 0.5 && overlap / totalOutput > 0.5) {
	// ret.put(key, value)
	// }
	// }
	// }
	// // TODO Auto-generated method stub
	// return null;
	// }
	
}
