package expansion.set.evaluation.fusion;

import java.util.function.BinaryOperator;

import de.mannheim.uni.expansion.tablefusion.analysis.stores.PerformanceMacroPR;
import de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulateables.Accumulateable;

public class FusionSetPerformance implements Accumulateable<FusionSetPerformance> {

	
	private final PerformanceMacroPR allClusters;
	private final PerformanceMacroPR existingClusters;
	private final PerformanceMacroPR newClusters;
	
	
	public FusionSetPerformance(PerformanceMacroPR allClusters, PerformanceMacroPR existingClusters, PerformanceMacroPR newClusters) {
		this.allClusters = allClusters;
		this.existingClusters = existingClusters;
		this.newClusters = newClusters;
	}

	public FusionSetPerformance() {
		this.allClusters = new PerformanceMacroPR();
		this.existingClusters = new PerformanceMacroPR();
		this.newClusters = new PerformanceMacroPR();
	}

	
	
	
	public PerformanceMacroPR getAllClusters() {
		return allClusters;
	}

	public PerformanceMacroPR getExistingClusters() {
		return existingClusters;
	}

	public PerformanceMacroPR getNewClusters() {
		return newClusters;
	}

	public static FusionSetPerformance accumulator(FusionSetPerformance a, FusionSetPerformance b) {
		return new FusionSetPerformance(a.getAllClusters().accumulate(b.getAllClusters()), a.getExistingClusters().accumulate(b.getExistingClusters()), a.getNewClusters().accumulate(b.getNewClusters()));
	}
	
	
	@Override
	public BinaryOperator<FusionSetPerformance> getAccumulator() {
		return FusionSetPerformance::accumulator;
	}

	@Override
	public FusionSetPerformance accumulate(FusionSetPerformance other) {
		return FusionSetPerformance.accumulator(this, other);
	}

	@Override
	public Class<FusionSetPerformance> getAcumClass() {
		return FusionSetPerformance.class;
	}
	

}
