package expansion.set.evaluation.goldstandard;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import expansion.set.creation.Entity;

public class GoldStandardMapping {

	private final Map<InstanceId, Entity> mapping;
	private final List<Entity> unmappedEntities;
	public GoldStandardMapping(Map<InstanceId, Entity> mapping, List<Entity> unmappedEntities) {
		super();
		this.mapping = Collections.unmodifiableMap( new HashMap<>(mapping));
		this.unmappedEntities = Collections.unmodifiableList( new ArrayList<>(unmappedEntities));
	}
	public Map<InstanceId, Entity> getMapping() {
		return mapping;
	}
	public List<Entity> getUnmappedEntities() {
		return unmappedEntities;
	}
	
	
	
}
