package expansion.set.evaluation.goldstandard;

public class GoldStandardPerformance {
	private final int truePositive;
	private final int falsePositive; 
	private final int falseNegative;

	private final double precision;
	private final double recall;
	private final double fowlkesMallowsIndex;
	private final double fMeasure;
	public GoldStandardPerformance(int truePositive, int falsePositive,   int falseNegative) {
		super();
		this.truePositive = truePositive;
		this.falsePositive = falsePositive; 
		this.falseNegative = falseNegative;
		
		this.precision = ((double) truePositive) / (truePositive + falsePositive);
		this.recall = ((double) truePositive) / (truePositive + falseNegative);
		
		this.fowlkesMallowsIndex = Math.sqrt(precision * recall);
		this.fMeasure = 2 * (precision * recall) / (precision + recall);
	}
	public int getTruePositive() {
		return truePositive;
	}
	public int getFalsePositive() {
		return falsePositive;
	}
 
	public int getFalseNegative() {
		return falseNegative;
	}
	public double getPrecision() {
		return precision;
	}
	public double getRecall() {
		return recall;
	}
	public double getFowlkesMallowsIndex() {
		return fowlkesMallowsIndex;
	}
	public double getfMeasure() {
		return fMeasure;
	}
	@Override
	public String toString() {
		return "GoldStandardPerformance [truePositive=" + truePositive + ", falsePositive=" + falsePositive + ", falseNegative=" + falseNegative
				+ ", precision=" + precision + ", recall=" + recall + ", fowlkesMallowsIndex=" + fowlkesMallowsIndex + ", fMeasure=" + fMeasure + "]";
	}
	 
	
	
}
