package expansion.set.evaluation.matching;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Optional;
import java.util.Set;
import java.util.stream.Collectors;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.tables.model.TableRowId;
import de.mannheim.uni.expansion.utils.CHMHelper;
import de.mannheim.uni.expansion.utils.containers.Pair;
import de.mannheim.uni.expansion.utils.containers.Tri;
import de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulateables.AccumAverage;
import de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulateables.AccumInteger;
import de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulators.ConcurrentAccumulator;
import expansion.set.clustering.model.RowClusterUUID;
import expansion.set.creation.Entity;
import expansion.set.evaluation.goldstandard.GoldStandardClusters;
import expansion.set.evaluation.goldstandard.oktie.OktieClusterEvaluator;
import expansion.set.evaluation.goldstandard.oktie.OktiePerformance;

public class NewDetectionEvaluator {

	
	@Inject	
	protected OktieClusterEvaluator oktieClusterEvaluator;
	
	public NewDetectionEvaluator() { 
	}
	
	
	
	public <F,E> Pair<OktiePerformance, Map<InstanceId, Set<TableRowId>> >  evaluate(GoldStandardClusters gsObject,   List<Entity> originalClusters, Map<InstanceId, List<Entity>> mappedClusters,   Set<InstanceId>  newEntities) {
		throw new IllegalStateException();
		// Map<InstanceId, Set<TableRowId>> gs =
		// gsObject.getTestingSetMappingClusters();
		// Map<TableRowId, InstanceId> gsIndex =gsObject.getIndex();
		// List<Set<TableRowId>> convertedClusters =
		// originalClusters.stream().map((e) -> new
		// HashSet<>(e.getRowCluster().getRows())).collect(Collectors.toList());
		//
		// Map<InstanceId, OktieMapping> originalMapping =
		// oktieClusterEvaluator.oktieMapping(gsIndex, convertedClusters);
		//
		// Map<InstanceId, RowClusterUUID> clusterMapping =
		// originalMapping.entrySet().stream().collect(Collectors.toMap(Entry::getKey,
		// (e) -> {
		// return
		// originalClusters.get(e.getValue().getCluster()).getRowClusterUUID();
		// }));
		//
		// Map<InstanceId, OktieMapping> mapping = new HashMap<>();
		// List<Set<TableRowId>> list = new ArrayList<>();
		//
		// Set<RowClusterUUID> alreadyAdded = new HashSet<>();
		//
		// int i = 0;
		//
		// for(Entry<InstanceId, List<Entity>> entry :
		// mappedClusters.entrySet()) {
		// if(gs.containsKey(entry.getKey())) {
		// Set<TableRowId> set = new HashSet<>();
		// for(Entity entity : entry.getValue()) {
		// alreadyAdded.add(entity.getRowClusterUUID());
		// set.addAll(entity.getRowCluster().getRows());
		// }
		// int intersection = getIntersection(gs.get(entry.getKey()), set);
		// OktieMapping oktieMapping = new OktieMapping(i, intersection);
		// mapping.put(entry.getKey(), oktieMapping);
		// list.add(set);
		// i++;
		// }
		//
		// }
		//
		// for(InstanceId newInstanceId : newEntities) {
		// if(clusterMapping.containsKey(newInstanceId)) {
		// if(!alreadyAdded.contains(clusterMapping.get(newInstanceId))) {
		// OktieMapping originalMappingInstance =
		// originalMapping.get(newInstanceId);
		// list.add(convertedClusters.get(originalMappingInstance.getCluster()));
		// mapping.put(newInstanceId, new OktieMapping(i,
		// originalMappingInstance.getIntersecion()));
		// i++;
		// }
		// }
		// }
		//
		// Map<InstanceId, Set<TableRowId>> newMapping = new HashMap<>();
		// for(Entry<InstanceId, OktieMapping> mappingEntry :
		// mapping.entrySet()) {
		// newMapping.put(mappingEntry.getKey(),
		// list.get(mappingEntry.getValue().getCluster()));
		// }
		//
		//
		// OktiePerformance performance =
		// oktieClusterEvaluator.oktieEvaluate(gs, gsIndex, list, mapping,
		// newEntities);
		// return new Pair<>(performance, newMapping);
	}
	
	int getIntersection(Set<TableRowId> set1, Set<TableRowId> set2) {
		int intersection = 0;
		if(set1.size() < set2.size()) {
			for(TableRowId rowId : set1) {
				if(set2.contains(rowId)) {
					intersection++;
				}
			}
		}
		else {
			for(TableRowId rowId : set2) {
				if(set1.contains(rowId)) {
					intersection++;
				}
			}
		}
		
		
		return intersection;
	}


	public NewDetectionPerformance evaluateAccuracy(Set<InstanceId> newEntities, Map<RowClusterUUID, Optional<InstanceId>> remapped,
			Map<InstanceId, List<ScoredEntity>> mappingForExistingClusters, List<ScoredEntity> newClusters) {
		return evaluateAccuracy(newEntities, remapped, mappingForExistingClusters, newClusters, null);
	}


	public NewDetectionPerformance evaluateAccuracy(Set<InstanceId> newEntities, Map<RowClusterUUID, Optional<InstanceId>> remapped,
			Map<InstanceId, List<ScoredEntity>> mappingForExistingClusters, List<ScoredEntity> newClusters, GoldStandardClusters gsClusters) {
		
		Set<RowClusterUUID> newAccordingToMapper = newClusters.stream().map((e) -> e.getEntity().getRowClusterUUID()).collect(Collectors.toSet());

		Map<RowClusterUUID, InstanceId> mappedAccordingToMapper = mappingForExistingClusters.entrySet().stream()
				.flatMap((e) -> e.getValue().stream().map(v -> new AbstractMap.SimpleImmutableEntry<>(e.getKey(), v.getEntity().getRowClusterUUID())))
				.collect(Collectors.toMap(Entry::getValue, Entry::getKey));

		return evaluateAccuracy(newEntities, remapped, mappedAccordingToMapper, newAccordingToMapper, gsClusters, mappingForExistingClusters);

	}

	public NewDetectionPerformance evaluateAccuracy(Set<InstanceId> newEntities, Map<RowClusterUUID, Optional<InstanceId>> remapped,
			Map<RowClusterUUID, InstanceId> mappedAccordingToMapper, Set<RowClusterUUID> newAccordingToMapper) {
		return evaluateAccuracy(newEntities, remapped, mappedAccordingToMapper, newAccordingToMapper, null, null);
	}

	public NewDetectionPerformance evaluateAccuracy(Set<InstanceId> newEntities, Map<RowClusterUUID, Optional<InstanceId>> remapped,
			Map<RowClusterUUID, InstanceId> mappedAccordingToMapper, Set<RowClusterUUID> newAccordingToMapper, GoldStandardClusters gsClusters,
			Map<InstanceId, List<ScoredEntity>> mappingForExistingClusters) {

		ConcurrentAccumulator<AccumAverage> accuracy = new ConcurrentAccumulator< >(AccumAverage.empty());
		ConcurrentAccumulator<AccumAverage> recallExisting = new ConcurrentAccumulator<>(AccumAverage.empty());

		ConcurrentAccumulator<AccumAverage> precisionExisting = new ConcurrentAccumulator<>(AccumAverage.empty());
		ConcurrentAccumulator<AccumInteger> countExisting = new ConcurrentAccumulator< >(AccumInteger.empty());
		ConcurrentAccumulator<AccumAverage> recallNew = new ConcurrentAccumulator<>(AccumAverage.empty());
		ConcurrentAccumulator<AccumAverage> precisionNew = new ConcurrentAccumulator<>(AccumAverage.empty());
		ConcurrentAccumulator<AccumInteger> countNew = new ConcurrentAccumulator< >(AccumInteger.empty());
		ConcurrentAccumulator<AccumAverage> recallBad = new ConcurrentAccumulator<>(AccumAverage.empty());
		ConcurrentAccumulator<AccumAverage> precisionBad = new ConcurrentAccumulator<>(AccumAverage.empty());
		ConcurrentAccumulator<AccumInteger> countBad = new ConcurrentAccumulator< >(AccumInteger.empty());
		

		
 		for(RowClusterUUID uuid : mappedAccordingToMapper.keySet()) {
 			if(newAccordingToMapper.contains(uuid)) {
 				throw new IllegalStateException();
 			}
 		}
		
		
 		for(Entry<RowClusterUUID, Optional<InstanceId>> entry : remapped.entrySet()) {
 			
 			if(entry.getValue().isPresent()) {
 				InstanceId instanceId = entry.getValue().get();
 				if(newEntities.contains(instanceId)) {
 					countNew.add(new AccumInteger(1));
 					if(newAccordingToMapper.contains(entry.getKey())) {
						recallNew.add(new AccumAverage(1.0));
						precisionNew.add(new AccumAverage(1.0));
 						accuracy.add(new AccumAverage(1.0));
 					}
 					else {
						recallNew.add(new AccumAverage(0.0));
						accuracy.add(new AccumAverage(0.0));

						if (mappedAccordingToMapper.containsKey(entry.getKey())) {
							precisionExisting.add(new AccumAverage(0.0));
						}

						else {
							precisionBad.add(new AccumAverage(0.0));
						}
 					}
 				}
 				else {
 					countExisting.add(new AccumInteger(1));
 					if(mappedAccordingToMapper.containsKey(entry.getKey()) && mappedAccordingToMapper.get(entry.getKey()).equals(instanceId)) {
						recallExisting.add(new AccumAverage(1.0));
 						accuracy.add(new AccumAverage(1.0));
						precisionExisting.add(new AccumAverage(1.0));
					}
 					else {
						recallExisting.add(new AccumAverage(0.0));
						accuracy.add(new AccumAverage(0.0));

						if (newAccordingToMapper.contains(entry.getKey())) {
							precisionNew.add(new AccumAverage(0.0));
						} else {
							precisionBad.add(new AccumAverage(0.0));
						}
 					}
 				}
 				
 			}
 			else {
 				countBad.add(new AccumInteger(1));
 				if(!newAccordingToMapper.contains(entry.getKey()) && !mappedAccordingToMapper.containsKey(entry.getKey())) {
					recallBad.add(new AccumAverage(1.0));
						accuracy.add(new AccumAverage(1.0));
					precisionBad.add(new AccumAverage(1.0));
 				}

 				else {
					recallBad.add(new AccumAverage(0.0));
						accuracy.add(new AccumAverage(0.0));

					if (newAccordingToMapper.contains(entry.getKey())) {
						precisionNew.add(new AccumAverage(0.0));
					} else if (mappedAccordingToMapper.containsKey(entry.getKey())) {
						precisionExisting.add(new AccumAverage(0.0));
					}
 				}
 			}
 		}

		double existingPrecision = precisionExisting.get().get();
		if (Double.isNaN(existingPrecision)) {
			existingPrecision = 0.0;
		}
		double newPrecision = precisionNew.get().get();
		if (Double.isNaN(newPrecision)) {
			newPrecision = 0.0;
		}
		double badPrecision = precisionBad.get().get();
		if (Double.isNaN(badPrecision)) {
			badPrecision = 0.0;
		}

		double existingRecall = recallExisting.get().get();
		if (Double.isNaN(existingRecall)) {
			existingRecall = 0.0;
		}

		double newRecall = recallNew.get().get();
		if (Double.isNaN(newRecall)) {
			newRecall = 0.0;
		}
		
		double badRecall = recallBad.get().get();
		if (Double.isNaN(badRecall)) {
			badRecall = 0.0;
		}
		
		double existingFmeasure = (2 * existingRecall * existingPrecision) / (existingRecall + existingPrecision);
		double newFmeasure = (2 * newRecall * newPrecision) / (newRecall + newPrecision);
		double badFmeasure = (2 * badRecall * badPrecision) / (badRecall + badPrecision);

		if (Double.isNaN(existingFmeasure)) {
			existingFmeasure = 0.0;
		}
		if (Double.isNaN(newFmeasure)) {
			newFmeasure = 0.0;
		}
		if (Double.isNaN(badFmeasure)) {
			badFmeasure = 0.0;
		}

		double totalAccuracy = accuracy.get().get();
		double averageFMeasure = (existingFmeasure + newFmeasure + badFmeasure) / 3;
		int badCount = countBad.get().get();
		if (badCount == 0) {

			averageFMeasure = (existingFmeasure + newFmeasure) / 2;
		}

		if (gsClusters != null && mappingForExistingClusters != null) {
			Tri<Double, Double, Double> irPerformance = getIrPerformance(gsClusters, newEntities, mappingForExistingClusters);
			return new NewDetectionPerformance(totalAccuracy, averageFMeasure, existingPrecision, existingRecall, existingFmeasure, newPrecision, newRecall,
					newFmeasure, badPrecision, badRecall, badFmeasure, countExisting.get().get(), countNew.get().get(), countBad.get().get(),
					mappedAccordingToMapper.size(), newAccordingToMapper.size(), irPerformance.getA(), irPerformance.getB(), irPerformance.getC());
		} else {
			return new NewDetectionPerformance(totalAccuracy, averageFMeasure, existingPrecision, existingRecall, existingFmeasure, newPrecision, newRecall,
					newFmeasure, badPrecision, badRecall, badFmeasure, countExisting.get().get(), countNew.get().get(), countBad.get().get(),
					mappedAccordingToMapper.size(), newAccordingToMapper.size());
		}

	}

	private Tri<Double, Double, Double> getIrPerformance(GoldStandardClusters gsClusters, Set<InstanceId> newEntities,
			Map<InstanceId, List<ScoredEntity>> mappingForExistingClusters) {

		Map<TableRowId, InstanceId> index = gsClusters.getIndex();
		double maxCorrect = index.entrySet().stream().filter((e) -> !newEntities.contains(e.getValue())).count();
		double correct = 0.0;
		double wrong = 0.0;

		for (Entry<InstanceId, List<ScoredEntity>> entry : mappingForExistingClusters.entrySet()) {
			for (ScoredEntity e : entry.getValue()) {

				for (TableRowId rowId : e.getEntity().getRowCluster().getRows()) {
					if (index.get(rowId).equals(entry.getKey())) {
						correct++;
					} else {
						wrong++;
					}
				}
			}
		}

		double precision = correct / (correct + wrong);
		double recall = correct / maxCorrect;
		double fmeasure = (2 * precision * recall) / (precision + recall);
		return new Tri<Double, Double, Double>(precision, recall, fmeasure);
	}



	public Map<InstanceId, Set<TableRowId>> chooseClustersForFusion(GoldStandardClusters goldStandardClusters, List<Entity> newDetected,
			Map<InstanceId, List<Entity>> mappingForExistingClusters, Set<InstanceId> newEntities, Map<RowClusterUUID, Optional<InstanceId>> remapped) {
		

		Map<InstanceId, Set<TableRowId>> ret = new HashMap<>();

		// Collection the new ones by instance
		Map<InstanceId, List<Entity>> newMap = new HashMap<>();;
		for(Entity e : newDetected) {
			Optional<InstanceId> mapping = remapped.get(e.getRowClusterUUID());
			if(mapping.isPresent() && newEntities.contains(mapping.get())) {
				CHMHelper.getFromMap(newMap, mapping.get(), () -> new ArrayList<>()).add(e);
			}
		}
		
		// Finding the one with max intersection
		for(Entry<InstanceId, List<Entity>> entry : newMap.entrySet()) {
			Set<TableRowId> cluster = goldStandardClusters.getCluster(entry.getKey());
			int maxIntersection = 0;
			Entity maxEntity = null;
			for(Entity e : entry.getValue()) {
				int intersection = 0;
				for(TableRowId rowId : e.getRowCluster().getRows()) {
					if(cluster.contains(rowId)) {
						intersection++;
					}
				}
				if(intersection > maxIntersection) {
					maxIntersection = intersection;
					maxEntity = e;
				}
			}
			RowClusterUUID uuid = null;
			if (maxIntersection / ((double) cluster.size()) > 0.5) {
				ret.put(entry.getKey(), new HashSet<>(maxEntity.getRowCluster().getRows()));
				uuid = maxEntity.getRowClusterUUID();
			}

			for (Entity e : entry.getValue()) {
				if (!e.getRowClusterUUID().equals(uuid)) {
					ret.put(new InstanceId(e.getRowClusterUUID().toString()), new HashSet<>(e.getRowCluster().getRows()));
				}
			}
		}

		// combing existing entities
		for (Entry<InstanceId, List<Entity>> entry : mappingForExistingClusters.entrySet()) {
			for (Entity e : entry.getValue()) {

				CHMHelper.getFromMap(ret, entry.getKey(), () -> new HashSet<>()).addAll(e.getRowCluster().getRows());
			}
		}

		return ret;
	}

	public Map<InstanceId, Set<TableRowId>> chooseClustersForFusionOld(GoldStandardClusters goldStandardClusters, List<Entity> newDetected,
			Map<InstanceId, List<Entity>> mappingForExistingClusters, Set<InstanceId> newEntities, Map<RowClusterUUID, Optional<InstanceId>> remapped) {

		Map<InstanceId, Set<TableRowId>> ret = new HashMap<>();

		// Collection the new ones by instance
		Map<InstanceId, List<Entity>> newMap = new HashMap<>();
		;
		for (Entity e : newDetected) {
			Optional<InstanceId> mapping = remapped.get(e.getRowClusterUUID());
			if (mapping.isPresent() && newEntities.contains(mapping.get())) {
				CHMHelper.getFromMap(newMap, mapping.get(), () -> new ArrayList<>()).add(e);
			}
		}

		// Finding the one with max intersection
		for (Entry<InstanceId, List<Entity>> entry : newMap.entrySet()) {
			Set<TableRowId> cluster = goldStandardClusters.getCluster(entry.getKey());
			int maxIntersection = 0;
			Entity maxEntity = null;
			for (Entity e : entry.getValue()) {
				int intersection = 0;
				for (TableRowId rowId : e.getRowCluster().getRows()) {
					if (cluster.contains(rowId)) {
						intersection++;
					}
				}
				if (intersection > maxIntersection) {
					maxIntersection = intersection;
					maxEntity = e;
				}
			}
			ret.put(entry.getKey(), new HashSet<>(maxEntity.getRowCluster().getRows()));
		}

		// combing existing entities
		for (Entry<InstanceId, List<Entity>> entry : mappingForExistingClusters.entrySet()) {
			for (Entity e : entry.getValue()) {
				Optional<InstanceId> mapping = remapped.get(e.getRowClusterUUID());
				if (mapping.isPresent() && !newEntities.contains(mapping.get()) && entry.getKey().equals(mapping.get())) {
					CHMHelper.getFromMap(ret, mapping.get(), () -> new HashSet<>()).addAll(e.getRowCluster().getRows());
				}
			}
		}

		return ret;
	}

	public Map<InstanceId, Set<TableRowId>> chooseClustersForEntitiesFound(GoldStandardClusters goldStandardClusters, List<Entity> newDetected,
			Map<InstanceId, List<Entity>> mappingForExistingClusters, Set<InstanceId> newEntities, Map<RowClusterUUID, Optional<InstanceId>> remapped) {

		Map<InstanceId, Set<TableRowId>> ret = new HashMap<>();

		// Collection the new ones by instance
		Map<InstanceId, List<Entity>> newMap = new HashMap<>();
		;
		for (Entity e : newDetected) {
			Optional<InstanceId> mapping = remapped.get(e.getRowClusterUUID());
			if (mapping.isPresent() && newEntities.contains(mapping.get())) {
				CHMHelper.getFromMap(newMap, mapping.get(), () -> new ArrayList<>()).add(e);
			}
		}

		// Finding the one with max intersection
		for (Entry<InstanceId, List<Entity>> entry : newMap.entrySet()) {
			Set<TableRowId> cluster = goldStandardClusters.getCluster(entry.getKey());
			int maxIntersection = 0;
			Entity maxEntity = null;
			for (Entity e : entry.getValue()) {
				int intersection = 0;
				for (TableRowId rowId : e.getRowCluster().getRows()) {
					if (cluster.contains(rowId)) {
						intersection++;
					}
				}
				if (intersection > maxIntersection) {
					maxIntersection = intersection;
					maxEntity = e;
				}
			}
			if (maxIntersection / ((double) cluster.size()) > 0.5) {
				ret.put(entry.getKey(), new HashSet<>(maxEntity.getRowCluster().getRows()));
			}
		}
		
		
		// combing existing entities
		for(Entry<InstanceId, List<Entity>> entry : mappingForExistingClusters.entrySet()) {
			Set<TableRowId> cluster = goldStandardClusters.getCluster(entry.getKey());
			if (cluster != null) {
				double intersection = 0.0;
				Set<TableRowId> foundCluster = new HashSet<>();
				for (Entity e : entry.getValue()) {

					for (TableRowId rowId : e.getRowCluster().getRows()) {
						if (cluster.contains(rowId)) {
							intersection++;
						}
						foundCluster.add(rowId);
					}
				}
				if (intersection / cluster.size() > 0.5 && intersection / foundCluster.size() > 0.5) {
					ret.put(entry.getKey(), foundCluster);
				}
			}
		}
		
		
		return ret;
	}

}
