package expansion.set.evaluation.matching;

import java.util.function.BinaryOperator;

import de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulateables.Accumulateable;

public class NewDetectionPerformance implements Accumulateable<NewDetectionPerformance> {

	private final double totalAccuracy;

	private final double averageFmeasure;

	private final double existingPrecision;
	private final double existingRecall;
	private final double existingFmeasure;

	private final double newPrecision;
	private final double newRecall;
	private final double newFmeasure;

	private final double badPrecision;
	private final double badRecall;
	private final double badFmeasure;

	private final int count;
	
	private final int mappedExisting;
	private final int mappedNew;
	private final int mappedBad;
	
	private final int returnedExisting;
	private final int returnedNew;
	
	private final double irPrecision;
	private final double irRecall;
	private final double irF1;
	
	public NewDetectionPerformance() {
		this.totalAccuracy = 0.0;
		this.averageFmeasure = 0.0;
		this.existingPrecision = 0.0;
		this.existingRecall = 0.0;
		this.existingFmeasure = 0.0;
		this.newPrecision = 0.0;
		this.newRecall = 0.0;
		this.newFmeasure = 0.0;
		this.badPrecision = 0.0;
		this.badRecall = 0.0;
		this.badFmeasure = 0.0;
		this.count = 0;
		this.mappedExisting = 0;
		this.mappedNew = 0;
		this.mappedBad = 0;
		this.returnedExisting = 0;
		this.returnedNew = 0;
		this.irPrecision = 0.0;
		this.irRecall = 0.0;
		this.irF1 = 0.0;

	} 
	
	public NewDetectionPerformance(double totalAccuracy, double averageFmeasure, double existingPrecison, double existingRecall, double existingFmeasure,
			double newPrecision, double newRecall, double newFmeasure, double badPrecision, double badRecall, double badFmeasure, int mappedExisting,
			int mappedNew, int mappedBad, int returnedExisting, int returnedNew, double irPrecision, double irRecall, double irF1) {
		super();
		this.totalAccuracy = totalAccuracy;
		this.averageFmeasure = averageFmeasure;
		this.existingPrecision = existingPrecison;
		this.existingRecall = existingRecall;
		this.existingFmeasure = existingFmeasure;
		this.newPrecision = newPrecision;
		this.newRecall = newRecall;
		this.newFmeasure = newFmeasure;
		this.badPrecision = badPrecision;
		this.badRecall = badRecall;
		this.badFmeasure = badFmeasure;
		this.count = 1;
		this.mappedExisting = mappedExisting;
		this.mappedNew = mappedNew;
		this.mappedBad = mappedBad;
		this.returnedExisting = returnedExisting;
		this.returnedNew = returnedNew;
		this.irPrecision = irPrecision;
		this.irRecall = irRecall;
		this.irF1 = irF1;
	}
	public NewDetectionPerformance(double totalAccuracy, double averageFmeasure, double existingPrecison, double existingRecall, double existingFmeasure,
			double newPrecision,
			double newRecall, double newFmeasure, double badPrecision, double badRecall, double badFmeasure, int mappedExisting, int mappedNew, int mappedBad,
			int returnedExisting, int returnedNew) {
		super();
		this.totalAccuracy = totalAccuracy;
		this.averageFmeasure = averageFmeasure;
		this.existingPrecision = existingPrecison;
		this.existingRecall = existingRecall;
		this.existingFmeasure = existingFmeasure;
		this.newPrecision = newPrecision;
		this.newRecall = newRecall;
		this.newFmeasure = newFmeasure;
		this.badPrecision = badPrecision;
		this.badRecall = badRecall;
		this.badFmeasure = badFmeasure;
		this.count = 1;
		this.mappedExisting = mappedExisting;
		this.mappedNew = mappedNew;
		this.mappedBad = mappedBad;
		this.returnedExisting = returnedExisting;
		this.returnedNew = returnedNew;
		this.irPrecision = 0.0;
		this.irRecall = 0.0;
		this.irF1 = 0.0;
	}

	private NewDetectionPerformance(double totalAccuracy, double averageFmeasure, double existingPrecison, double existingRecall, double existingFmeasure,
			double newPrecision, double newRecall, double newFmeasure, double badPrecision, double badRecall, double badFmeasure, int count, int mappedExisting,
			int mappedNew, int mappedBad, int returnedExisting, int returnedNew, double irPrecision, double irRecall, double irF1) {
		super();
		this.totalAccuracy = totalAccuracy;
		this.averageFmeasure = averageFmeasure;
		this.existingPrecision = existingPrecison;
		this.existingRecall = existingRecall;
		this.existingFmeasure = existingFmeasure;
		this.newPrecision = newPrecision;
		this.newRecall = newRecall;
		this.newFmeasure = newFmeasure;
		this.badPrecision = badPrecision;
		this.badRecall = badRecall;
		this.badFmeasure = badFmeasure;
		this.count = count;
		this.mappedExisting = mappedExisting;
		this.mappedNew = mappedNew;
		this.mappedBad = mappedBad;
		this.returnedExisting = returnedExisting;
		this.returnedNew = returnedNew;
		this.irPrecision = irPrecision;
		this.irRecall = irRecall;
		this.irF1 = irF1;
	}
	
	private NewDetectionPerformance(double totalAccuracy, double averageFmeasure, double existingPrecison, double existingRecall, double existingFmeasure,
			double newPrecision,
			double newRecall, double newFmeasure, double badPrecision, double badRecall, double badFmeasure, int count, int mappedExisting, int mappedNew,
			int mappedBad,
			int returnedExisting, int returnedNew) {
		super();
		this.totalAccuracy = totalAccuracy;
		this.averageFmeasure = averageFmeasure;
		this.existingPrecision = existingPrecison;
		this.existingRecall = existingRecall;
		this.existingFmeasure = existingFmeasure;
		this.newPrecision = newPrecision;
		this.newRecall = newRecall;
		this.newFmeasure = newFmeasure;
		this.badPrecision = badPrecision;
		this.badRecall = badRecall;
		this.badFmeasure = badFmeasure;
		this.count = count;
		this.mappedExisting = mappedExisting;
		this.mappedNew = mappedNew;
		this.mappedBad = mappedBad;
		this.returnedExisting = returnedExisting;
		this.returnedNew = returnedNew;
		this.irPrecision = 0.0;
		this.irRecall = 0.0;
		this.irF1 = 0.0;
	}

	


	public int getMappedExisting() {
		return mappedExisting;
	}

	public int getMappedNew() {
		return mappedNew;
	}

	public int getMappedBad() {
		return mappedBad;
	}

	
	public int getReturnedExisting() {
		return returnedExisting;
	}

	public int getReturnedNew() {
		return returnedNew;
	}

	public double getTotalAccuracy() {
		if(count == 0)
			return 0.0;
		else
			return totalAccuracy / count;
	}

	public double getIRPrecision() {
		if (count == 0)
			return 0.0;
		else
			return irPrecision / count;
	}

	public double getIRRecall() {
		if (count == 0)
			return 0.0;
		else
			return irRecall / count;
	}

	public double getIRFmeasure() {
		if (count == 0)
			return 0.0;
		else
			return irF1 / count;
	}

	public double getExistingPrecision() {
		if (count == 0)
			return 0.0;
		else
			return existingPrecision / count;
	}

	public double getExistingRecall() {
		if (count == 0)
			return 0.0;
		else
			return existingRecall / count;
	}

	public double getExistingFmeasure() {
		if (count == 0)
			return 0.0;
		else
			return existingFmeasure / count;
	}

	public double getNewPrecision() {
		if (count == 0)
			return 0.0;
		else
			return newPrecision / count;
	}

	public double getNewRecall() {
		if (count == 0)
			return 0.0;
		else
			return newRecall / count;
	}

	public double getNewFmeasure() {
		if(count == 0)
			return 0.0;
		else
			return newFmeasure / count;
	}

	public double getBadPrecision() {
		if(count == 0)
			return 0.0;
		else
			return badPrecision / count;
	}
	
	public double getBadRecall() {
		if (count == 0)
			return 0.0;
		else
			return badRecall / count;
	}
	
	public double getBadFmeasure() {
		if(count == 0)
			return 0.0;
		else
			return badFmeasure / count;
	}

	public double getAverageFmeasure() {
		if (count == 0)
			return 0.0;
		else
			return averageFmeasure / count;
	}

	public static NewDetectionPerformance accumulator(NewDetectionPerformance a, NewDetectionPerformance b) {
		return new NewDetectionPerformance(a.totalAccuracy + b.totalAccuracy, a.averageFmeasure + b.averageFmeasure, a.existingPrecision + b.existingPrecision,

				a.existingRecall + b.existingRecall, a.existingFmeasure + b.existingFmeasure, a.newPrecision + b.newPrecision, a.newRecall + b.newRecall,
				a.newFmeasure + b.newFmeasure,

				a.badPrecision + b.badPrecision, a.badRecall + b.badRecall, a.badFmeasure + b.badFmeasure,

				a.count + b.count,
				a.mappedExisting  + b.mappedExisting, a.mappedNew + b.mappedNew, a.mappedBad + b.mappedBad,
				a.returnedExisting + b.returnedExisting, a.returnedNew + b.returnedNew, a.irPrecision + b.irPrecision, a.irRecall + b.irRecall,
				a.irF1 + b.irF1);
	}
	@Override
	public BinaryOperator<NewDetectionPerformance> getAccumulator() {
		return NewDetectionPerformance::accumulator;
	}

	@Override
	public NewDetectionPerformance accumulate(NewDetectionPerformance other) {
		return NewDetectionPerformance.accumulator(this, other);
	}

	@Override
	public Class<NewDetectionPerformance> getAcumClass() {
		return NewDetectionPerformance.class;
	}
	

}
