package expansion.set.strategies;

import java.util.ArrayList;
import java.util.List;

import javax.inject.Inject;

import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.OptimizableClass;
import expansion.set.clustering.ClustererInput;
import expansion.set.clustering.RowClusterer;
import expansion.set.clustering.RowClusteringConfig;
import expansion.set.clustering.model.similarities.RowClusterSimilarities;
import expansion.set.strategies.clustersplitters.minScoreSplitter.WeightedAverageScoreSplitterFactory;
import expansion.set.strategies.rowclusterers.label.LabelRowSimilaritiesCreator;

public class LabelSimilarityFullCluster implements RowClusterer {

	@Inject
	protected WeightedAverageScoreSplitterFactory splitterFactory;
	  
	private final OptimizableClass optimizingClazz = SetExpansionStrategiesRepository.FULL_LABEL_SIMILARITY.getOptimizableClassCluster();

	private final LabelRowSimilaritiesCreator labelRowSimilaritiesCreator;  
	 


	@Inject
	public LabelSimilarityFullCluster(  LabelRowSimilaritiesCreator labelRowSimilaritiesCreator  ) {
		super(); 
		this.labelRowSimilaritiesCreator = labelRowSimilaritiesCreator; 
	}

	@Override
	public RowClusterSimilarities clusterRows(RowClusteringConfig config, ClustererInput input) {

		RowClusterSimilarities labelScores = labelRowSimilaritiesCreator.createLucene(input.getFullCandidates(), config.isWithCache());

		// RowClusterSimilarities empty = new ZeroRowClusterSimilarities();
		// List<RowClusterSimilarities> sims = new ArrayList<>();
		//
		// sims.add(labelScores);
		// sims.add(empty);
		// return splitterFactory.getSplitter(sims,
		// config.getWeightsRepository(), optimizingClazz);
	
		List<RowClusterSimilarities> sims = new ArrayList<>();
		sims.add(labelScores);
		
		return splitterFactory.getSplitter(sims, config.getWeightsRepository(), optimizingClazz, false);
	 
	} 

	
}
