package expansion.set.strategies.blockers;

import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import de.mannheim.uni.expansion.data.tables.model.TableRowId;

public class Mappings {
	private final Map<TableRowId,Set<TableRowId>> mappings;
	
	public Mappings(Map<TableRowId, Set<TableRowId>> mappings) {
		super();
		this.mappings = mappings;
	}
	
	public Mappings(Collection<Set<TableRowId>> in) {
		super();
		Map<TableRowId, Set<TableRowId>> ret = new HashMap<>();
		for(Set<TableRowId> set : in) {
			Iterator<TableRowId> it = set.iterator();
			if(it.hasNext()) {
				ret.put(it.next(), set);
			}
		}
		
		this.mappings = ret;
	}

	public Map<TableRowId, Set<TableRowId>> getMappings() {
		return mappings;
	}

}
