package expansion.set.strategies.clustersplitters;

import java.util.HashMap;
import java.util.Map;

import javax.inject.Inject;

import expansion.set.clustering.RowClusterer;
import expansion.set.strategies.clustersplitters.attributes.AttributeBasedSplitter;

public class RowClustererSplitterRepository {

	@Inject
	AttributeBasedSplitter attributeBasedSplitter;

	private Map<Class<? extends AttributeBasedSplitter>, AttributeBasedSplitter> repository;

	public RowClustererSplitterRepository() {

	}

	private synchronized void init() {
		if (repository == null) {
			this.repository = new HashMap<>();
			this.repository.put(AttributeBasedSplitter.class, attributeBasedSplitter);
		}

	}

	public AttributeBasedSplitter get(Class<? extends RowClusterer> clazz) {
		if (repository == null)
			init();

		if (clazz == null) {
			throw new IllegalStateException("Asking for Cluster Splitter of class null is not allowed!");
		} else {
			AttributeBasedSplitter clusterer = this.repository.get(clazz);
			if (clusterer == null) {
				throw new IllegalStateException("No Cluster Splitter was registered for Class: " + clazz.getSimpleName());
			} else {
				return clusterer;
			}
		}
	}


}
