package expansion.set.strategies.clustersplitters.minScoreSplitter;
 

class SortedKey {
	private final String first;
	private final String second;
	public SortedKey(String a, String b) {
		if(a.equals(b)) {
			throw new IllegalStateException();
		}
		if(a.compareTo(b) >= 0) {
			first = a;
			second = b;
		}
		else {
			first = b;
			second = a;
			
			
		}
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((first == null) ? 0 : first.hashCode());
		result = prime * result + ((second == null) ? 0 : second.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof SortedKey))
			return false;
		SortedKey other = (SortedKey) obj;
		if (first == null) {
			if (other.first != null)
				return false;
		} else if (!first.equals(other.first))
			return false;
		if (second == null) {
			if (other.second != null)
				return false;
		} else if (!second.equals(other.second))
			return false;
		return true;
	}
	public String getFirst() {
		return first;
	}
	public String getSecond() {
		return second;
	}
	@Override
	public String toString() {
		return "SortedKey [first=" + first + ", second=" + second + "]";
	}
	
	
}