package expansion.set.strategies.ea;

import javax.inject.Inject;

import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.OptimizableClass;
import expansion.set.clustering.ClustererInput;
import expansion.set.clustering.RowClusterer;
import expansion.set.clustering.RowClusteringConfig;
import expansion.set.clustering.model.similarities.RowClusterSimilarities;
import expansion.set.strategies.SetExpansionStrategiesRepository;
import expansion.set.strategies.evaluatemethod.CLUSTERING_METHOD_CREATOR;
import expansion.set.strategies.evaluatemethod.CLUSTERING_METHOD_CREATOR.Method_Creator;
import expansion.set.strategies.evaluatemethod.CLUSTERING_SIMS_AGGREGATOR;
import expansion.set.strategies.evaluatemethod.CLUSTERING_SIMS_LIST;

public class Combined_RandomForest_ET implements RowClusterer, ParameterLearnableClusterer {

	// public final static String[] parameters = new String[] {
	//
	// "-V", "1e-4", "-U", "-attribute-importance",
	// "-store-out-of-bag-predictions", "-I", "4000", "-num-slots", "60", "-K",
	// "2", "-P", "85" };//

	public final static String[] parameters = new String[] { "-U", "-attribute-importance", "-store-out-of-bag-predictions", "-I", "2000", "-num-slots", "60",
			"-K", "2", "-V", "1e-3", "-P", "66" };//

	private final OptimizableClass optimizingClazz = SetExpansionStrategiesRepository.COMBINED_RandomForest_ET.getOptimizableClassCluster();


	@Inject
	protected CLUSTERING_METHOD_CREATOR creator;

	public Combined_RandomForest_ET() {

	}



	public RowClusterSimilarities clusterRows(RowClusteringConfig config, ClustererInput input) {

		if (KEEP_ET) {
			return creator.clusterRows(config, input, optimizingClazz, CLUSTERING_SIMS_AGGREGATOR.EXTENDED_TREE,
					CLUSTERING_SIMS_LIST.LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE, parameters);
		} else {
			return creator.clusterRows(config, input, optimizingClazz, CLUSTERING_SIMS_AGGREGATOR.AGNOSTIC_TREE,
					CLUSTERING_SIMS_LIST.LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE, parameters);
		}


	}


	public static boolean KEEP_ET = true;

	@Override
	public Method_Creator getCreator(RowClusteringConfig config, ClustererInput input) {
		if (KEEP_ET) {
			return creator.getCreator(config, input, optimizingClazz, CLUSTERING_SIMS_AGGREGATOR.EXTENDED_TREE,
					CLUSTERING_SIMS_LIST.LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE);
		}
		else {
			return creator.getCreator(config, input, optimizingClazz, CLUSTERING_SIMS_AGGREGATOR.AGNOSTIC_TREE,
					CLUSTERING_SIMS_LIST.LABEL_BOW_PHI_ATTRIBUTE_IMPLICIT_SAMETABLE);
		}
	}

	// public class RF_ET_Creator implements ParamterClusterer {
	// private final RowClusteringConfig config;
	// private final ClustererInput input;
	//
	// public RF_ET_Creator(RowClusteringConfig config, ClustererInput input) {
	// this.config = config;
	// this.input = input;
	// }
	//
	// @Override
	// public LearnableRowClusterSimilarities clusterRows(String[] parameters) {
	// return ((LearnableRowClusterSimilarities)
	// Combined_RandomForest_ET.this.clusterRows(config, input, parameters));
	// }
	//
	// }

}

