package expansion.set.strategies.ea;

import javax.inject.Inject;

import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.OptimizableClass;
import expansion.set.clustering.ClustererInput;
import expansion.set.clustering.RowClusterer;
import expansion.set.clustering.RowClusteringConfig;
import expansion.set.clustering.model.similarities.RowClusterSimilarities;
import expansion.set.strategies.SetExpansionStrategiesRepository;

public class Container_Clusterer implements RowClusterer {

	private final OptimizableClass optimizingClazz = SetExpansionStrategiesRepository.Container_Clusterer.getOptimizableClassCluster();

	@Inject
	public Container_Clusterer() {

	}
	@Override
	public RowClusterSimilarities clusterRows(RowClusteringConfig config, ClustererInput input) {
		ContainerLearnedModel learnedModel = null;
		if (config.getWeightsRepository() != null) {
			learnedModel = (ContainerLearnedModel) config.getWeightsRepository().get(optimizingClazz);
		}
		return learnedModel.getSim();

	}

}
