package expansion.set.strategies.implicit;

import java.util.List;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.tables.model.TableRowId;
import de.mannheim.uni.expansion.data.tables.model.TableRowIdPair;
import de.mannheim.uni.expansion.utils.WeightedScore;
import expansion.set.clustering.model.RowCluster;
import expansion.set.clustering.model.RowCluster.ClusterEntryKey;
import expansion.set.clustering.model.similarities.RowClusterSimilarities;
import expansion.set.strategies.clustersplitters.attributes.AttributeBasedSplitter.AttributeCachedSimilarities;
import expansion.set.strategies.clustersplitters.attributes.AttributeBasedSplitter.AttributeMethod;
import expansion.set.strategies.clustersplitters.attributes.AttributeBasedSplitter.AttributeScores;

public class AttributesWithImplicit {

	public static class AttributesWithImplicitSimilarities implements RowClusterSimilarities {
		private final AttributeMethod attributeMethod;
		private final AttributeCachedSimilarities scores;

		private AttributesWithImplicitSimilarities(AttributeMethod attributeMethod, AttributeCachedSimilarities scores) {
			super();
			this.attributeMethod = attributeMethod;
			this.scores = scores;

		}

		@Override
		public double get(List<TableRowId> rows, ClassId classId, ClusterEntryKey key) {
			TableRowId id1 = rows.get(key.getE1());
			TableRowId id2 = rows.get(key.getE2());
			return get(classId, id1, id2);
		}

		private double get(ClassId classId, TableRowId id1, TableRowId id2) {
			throw new UnsupportedOperationException();
		}

		@Override
		public List<WeightedScore> getList(List<TableRowId> rows, ClassId classId, ClusterEntryKey key) {
			TableRowId id1 = rows.get(key.getE1());
			TableRowId id2 = rows.get(key.getE2());
			return getList(classId, id1, id2);

		}

		private List<WeightedScore> getList(ClassId classId, TableRowId id1, TableRowId id2) {
			// List<WeightedScore> list = new ArrayList<>();
			if (id1.equals(id2)) {
				throw new IllegalStateException();
			}
			TableRowIdPair tableIdPair = new TableRowIdPair(id1, id2);
			AttributeScores weights = scores.get(classId, tableIdPair);

			if (id1.equals(new TableRowId("1346981172186_1346994902741_1908.arc7330478708359062489#28035184_0_7160201567823219801", 9))
					&& id2.equals(new TableRowId("1346876860614_1346890684800_1332.arc5282133196239291515#912032_0_1527817512187283215", 15))) {
				int sdf = 13;
			}

			if (id2.equals(new TableRowId("1346981172186_1346994902741_1908.arc7330478708359062489#28035184_0_7160201567823219801", 9))
					&& id1.equals(new TableRowId("1346876860614_1346890684800_1332.arc5282133196239291515#912032_0_1527817512187283215", 15))) {
				int sdf = 13;
			}

			if (weights == null)
				throw new IllegalStateException();
			else {
				return weights.get(attributeMethod);
			}
		}

		@Override
		public Set<TableRowId> regionQuery(RowCluster cluster, TableRowId point, double eps) {

			throw new UnsupportedOperationException();

		}

		@Override
		public String getName() {
			return "ATTRIBUTE_WITH_IMPLICIT";
		}

	}
}
