package expansion.set.strategies.rowclusterers;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import de.mannheim.uni.expansion.utils.containers.Pair;
import de.mannheim.uni.expansion.utils.containers.Tri;
import expansion.set.clustering.model.RowCluster.ClusterEntryKey;

public interface ClusterSimilarities {

	double get(ClusterEntryKey key);

	public default Set<Integer> getBlocks(Integer point) {
		throw new UnsupportedOperationException();
	}

	public default List<Set<Integer>> getSplitBlocks(Integer point) {
		List<Set<Integer>> list = new ArrayList<>();
		list.add(getBlocks(point));
		return list;
	}

	public default List<Pair<Set<Integer>, Integer>> getSplitBlocksWithMin(Integer point) {
		List<Pair<Set<Integer>, Integer>> list = new ArrayList<>();
		list.add(new Pair<>(getBlocks(point), 1));
		return list;
	}

	public default List<Tri<Set<Integer>, Integer, Double>> getSplitBlocksWithScores(Integer point) {
		List<Tri<Set<Integer>, Integer, Double>> list = new ArrayList<>();
		list.add(new Tri<>(getBlocks(point), 1, 1.0));
		return list;
	}

	public default boolean supportsBlocking() {
		return false;
	}

	Set<Integer> regionQuery(Integer point, double eps);

	public default boolean supportsCaching() {
		return false;
	}

	public default boolean cacheExists() {
		return false;
	}

	public default void storeClusters(List<Set<Integer>> cluster) {

	}

	public default List<Set<Integer>> readClusters() {
		return null;
	}

}
