package expansion.set.strategies.rowclusterers;

import javax.inject.Inject;

import de.mannheim.uni.expansion.utils.containers.Pair;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.OptimizableClass;
import expansion.set.clustering.ClusterList;
import expansion.set.clustering.ClustererInput;
import expansion.set.clustering.RowClusteringConfig;
import expansion.set.clustering.model.similarities.RowClusterSimilarities;
import expansion.set.exportimport.OptionalClusterCache;

public class GreedyClusteringParallelSplitter {

	@Inject
	protected GreedyClusteringSplitter clusterer;

	// @Inject
	// @Named(GreedyClusteringSplitter.DISABLE_BLOCKING)
	// protected boolean disableBlocking;

	@Inject
	public GreedyClusteringParallelSplitter() {
	}



	public ClusterList clusterRows(RowClusterSimilarities sim, RowClusteringConfig config, ClustererInput input, OptimizableClass optimizingClass) {

		// // <<<<<<< .mine
		// RowCluster oldRc = new RowCluster(input.getClassId(), new
		// ArrayList<>(input.getCandidates()), sim);
		//
		// ClusterSimilarities cs = new ClusterSimilaritiesImplNormalized(oldRc,
		// sim, disableBlocking);
		// List<RowCluster> list = clusterer.rowSplitter(oldRc, cs, false,
		// config.getWeightsRepository());
		//
		// return new ClusterList(list);
		// // =======
		return clusterer.clusterRows(sim, config, input, optimizingClass, false);
		// >>>>>>> .r33

	}

	public ClusterList clusterRows(RowClusterSimilarities sim, RowClusteringConfig config, ClustererInput input, OptimizableClass optimizingClass,
			boolean disableBlocking) {
		return clusterer.clusterRows(sim, config, input, optimizingClass, false, disableBlocking);
	}

	public ClusterList clusterRows(RowClusterSimilarities sim, RowClusteringConfig config, ClustererInput input, boolean disableBlocking) {
		return clusterer.clusterRows(sim, config, input, null, false, disableBlocking);

	}

	public ClusterList clusterRows(RowClusterSimilarities sim, RowClusteringConfig config, ClustererInput input, OptimizableClass optimizingClass,
			boolean disableBlocking,
			OptionalClusterCache cache, Pair<String, String> preCacheFolderAndString) {
		return clusterer.clusterRows(sim, config, input, optimizingClass, false, disableBlocking, cache, preCacheFolderAndString);

	}

	public ClusterList clusterRows(RowClusterSimilarities sim, RowClusteringConfig config, ClustererInput input) {
		return clusterRows(sim, config, input, null);
	}

}
