package expansion.set.strategies.rowclusterers;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import java.util.UUID;
import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.stream.Collectors;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.ontology.model.TripleIdContainer;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.tables.model.TableRowId;
import de.mannheim.uni.expansion.data.tables.repository.AnnotatedTablesRepository;
import de.mannheim.uni.expansion.utils.PersistentParallel6;
import de.mannheim.uni.expansion.utils.SimpleLockableConcurrentCache;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.StringObject;
import expansion.set.clustering.ClusterList;
import expansion.set.clustering.ClustererInput;
import expansion.set.clustering.model.RowCluster;
import expansion.set.clustering.model.similarities.RowClusterConstantSimilarities;
import expansion.set.strategies.blockers.Blocks;
import expansion.set.strategies.rowclusterers.label.LabelRowIndexClusterMapCreator;

@Deprecated
public class LabelSimilarityRowClusterer {
	
	private final LabelRowIndexClusterMapCreator clusterCreator;
private final AnnotatedTablesRepository tableRepository;

	@Inject
	public LabelSimilarityRowClusterer(LabelRowIndexClusterMapCreator clusterCreator,AnnotatedTablesRepository tableRepository) {
		this.clusterCreator = clusterCreator;
		this.tableRepository = tableRepository;
	}


//	private final static SimpleLockableConcurrentCache<UUID, LabelRowIndex> cacheIndex = new SimpleLockableConcurrentCache<>();


	private final static SimpleLockableConcurrentCache<UUID, ClusterList> cacheIndexFull = new SimpleLockableConcurrentCache<>();

	public <E extends TripleIdContainer> ClusterList cluster(ClustererInput input, boolean blockByClass) {
		return clusterPrivate(input, blockByClass);
//		return cacheIndexFull.getOrCreate(input.getUuid(), () -> {
//			return clusterPrivate(input, blockByClass);
//		});
	}

	private <E extends TripleIdContainer> ClusterList clusterPrivate(ClustererInput input, boolean blockByClass) {

		Set<TableRowId> candidates = input.getCandidates();

		try {

		

			// for (Entry<TableRowId, Set<TableRowId>> entry :
			// mappings.entrySet()) {
			// Set<TableRowId> tableRowIdSet = new HashSet<>();
			// tableRowIdSet.add(entry.getKey());
			// tableRowIdSet.addAll(entry.getValue());
			//
			// }

			// for (Entry<TableRowId, Set<TableRowId>> entry :
			// mappings.entrySet()) {
			// if (clustersIndex.containsKey(entry.getKey())) {
			// Integer index = clustersIndex.get(entry.getKey());
			// clustersMap.get(index).addAll(entry.getValue());
			// for (TableRowId tableRowId : entry.getValue()) {
			// clustersIndex.put(tableRowId, index);
			// }
			// } else {
			//
			// boolean added = false;
			//
			// for (TableRowId tableRowIdCandidate : entry.getValue()) {
			// if (clustersIndex.containsKey(tableRowIdCandidate)) {
			// Integer index = clustersIndex.get(tableRowIdCandidate);
			//
			// Set<TableRowId> tableRowIds = new HashSet<>();
			// tableRowIds.add(entry.getKey());
			// tableRowIds.addAll(entry.getValue());
			//
			// clustersMap.get(index).addAll(tableRowIds);
			// for (TableRowId tableRowId : entry.getValue()) {
			// clustersIndex.put(tableRowId, index);
			// }
			// added = true;
			// break;
			// }
			//
			// }
			//
			// if (!added) {
			//
			// int index = clustersMap.size();
			// Set<TableRowId> tableRowIds = new HashSet<>();
			// tableRowIds.add(entry.getKey());
			// tableRowIds.addAll(entry.getValue());
			//
			// clustersMap.put(index, tableRowIds);
			// clusterClassId.put(index,
			// tableRepository.getMetaData(entry.getKey().getTableId()).getDbPediaClass());
			//
			// for (TableRowId tableRowId : tableRowIds) {
			// clustersIndex.put(tableRowId, index);
			// }
			// }
			// }
			// }
			
			
			Blocks ret = clusterCreator.getClustersMap(candidates, blockByClass);

			Map<Integer, Set<TableRowId>> clustersMap = ret.getClustersMap();
			
			Map<Integer, ClassId> clusterClassId = ret.getClusterClassId();
			
			
			Map<Integer, List<TableRowId>> clustersMapWithList = clustersMap.entrySet().parallelStream().collect(Collectors.toMap(Entry::getKey, (e) -> {
				return new ArrayList<>(e.getValue());
			}));

			// ConcurrentLinkedQueue<Tri<Integer, Pair<TableRowId, TableRowId>,
			// ClusterEntryKey>> collector = new ConcurrentLinkedQueue<>();
			// ConcurrentHashMap<Integer, ConcurrentHashMap<ClusterEntryKey,
			// Double>> simMap = new ConcurrentHashMap<>();

			ConcurrentLinkedQueue<RowCluster> retList = new ConcurrentLinkedQueue<>();
			// PersistentParallel6.runAndFinish(clustersMapWithList.entrySet(),
			// (entry) -> {
			//
			// ConcurrentHashMap<ClusterEntryKey, Double> similarities = new
			// ConcurrentHashMap<>();
			//
			// PersistentParallel6.runAndFinish(ListIterable.iterable(entry.getValue()),
			// (r1) -> {
			// for (ListEntry<TableRowId> r2 :
			// ListIterable.iterable(entry.getValue())) {
			//
			// if (r1.getIndex() >= r2.getIndex()) {
			// continue;
			// }
			//
			// double sim = smSimilairty.get(getLabel(tableRepository,
			// r1.getValue()), getLabel(tableRepository, r2.getValue()));
			// ClusterEntryKey key = new ClusterEntryKey(r1.getIndex(),
			// r2.getIndex());
			// similarities.put(key, sim);
			// // collector.add(new Tri<>(entry.getKey(), new
			// // Pair<>(r1.getValue(), r2.getValue()), new
			// // ClusterEntryKey(r1.getIndex(), r2.getIndex())));
			//
			// }
			// } , this.getClass(), entry.getValue().size() < 300);
			//
			// retList.add(new RowCluster(clusterClassId.get(entry.getKey()),
			// entry.getValue(), similarities));
			//
			// // for (ListEntry<TableRowId> r1 :
			// // ListIterable.iterable(entry.getValue())) {
			// //
			// // for (ListEntry<TableRowId> r2 :
			// // ListIterable.iterable(entry.getValue())) {
			// //
			// // if (r1.getIndex() >= r2.getIndex()) {
			// // continue;
			// // }
			// // double sim = smSimilairty.get(getLabel(tableRepository,
			// // r1.getValue()), getLabel(tableRepository, r2.getValue()));
			// //
			// //
			// // collector.add(new Tri<>(entry.getKey(), new
			// // Pair<>(r1.getValue(), r2.getValue()), new
			// // ClusterEntryKey(r1.getIndex(), r2.getIndex())));
			// //
			// // }
			// // }
			//
			// } , this.getClass());

			// PersistentParallel6.runAndFinish(collector, (c) -> {
			// double sim = smSimilairty.get(getLabel(tableRepository,
			// c.getB().getFirst()), getLabel(tableRepository,
			// c.getB().getSecond()));
			// CHMHelper.getFromCHM(simMap, c.getA(), () -> new
			// ConcurrentHashMap<>()).put(c.getC(), sim);
			// } , this.getClass());
			//
			AtomicInteger removed = new AtomicInteger(0);
			PersistentParallel6.runAndFinish(clustersMapWithList.entrySet(), (entry) -> {
				if(entry.getValue().size() > 5000) {
					System.out.println("it exists");
					List<String> labels = entry.getValue().stream().map((e) -> {
						StringObject so = LabelRowIndexClusterMapCreator.getLabel(tableRepository, e);
						if (so != null) {
							return so.getString();
						} else {
							return "";
						}
						}).collect(Collectors.toList());
//					System.out.println(labels.toString());
					int sdf = 123;
				}
//				 System.out.println(entry.getValue().size());
//				 if (entry.getValue().size() < 5000)
					 retList.add(new RowCluster(clusterClassId.get(entry.getKey()), entry.getValue(), new RowClusterConstantSimilarities(1.0)));
//				 else
//					 removed.incrementAndGet();

			} , this.getClass(), "CreateClusters");

			System.out.println("Clusters removed: " + removed.get());

			ArrayList<RowCluster> retListList = new ArrayList<>(retList);

			return new ClusterList(retListList);

		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return null;
	}

	




	

}
