package expansion.set.strategies.rowclusterers;

import java.util.ArrayList;
import java.util.List;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.tables.model.TableRowId;
import de.mannheim.uni.expansion.utils.WeightedScore;
import expansion.set.clustering.model.RowCluster;
import expansion.set.clustering.model.RowCluster.ClusterEntryKey;
import expansion.set.clustering.model.similarities.RowClusterSimilarities;

public class SameTableZeroStrategy implements RowClusterSimilarities {

	@Override
	public List<WeightedScore> getList(List<TableRowId> rows, ClassId classId, ClusterEntryKey key) {
		List<WeightedScore> list = new ArrayList<>();
		if (rows.get(key.getE1()).getTableId().equals(rows.get(key.getE2()).getTableId())) {
			list.add(new WeightedScore(0.0, 1.0));
		} else {
			list.add(new WeightedScore(1.0, 1.0));
		}

		return list;
	}

	@Override
	public double get(List<TableRowId> rows, ClassId classId, ClusterEntryKey key) {
		if (rows.get(key.getE1()).getTableId().equals(rows.get(key.getE2()).getTableId())) {
			return 0.0;
		} else {
			return 1.0;
		}
	}

	@Override
	public Set<TableRowId> regionQuery(RowCluster cluster, TableRowId point, double eps) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public String getName() {
		return "SAME_TABLE_ZERO";
	}

}
