package expansion.set.strategies.rowclusterers.emptyLearnable;

import java.util.List;
import java.util.Map;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.tables.model.TableRowId;
import de.mannheim.uni.expansion.data.tables.model.TableRowIdPair;
import de.uni_mannheim.informatik.ds.expansion.utils.learning.EvaluationMethod;
import de.uni_mannheim.informatik.ds.expansion.utils.learning.LearnedModel;
import expansion.set.clustering.model.RowCluster;
import expansion.set.clustering.model.RowCluster.ClusterEntryKey;
import expansion.set.clustering.model.similarities.LearnableRowClusterSimilarities;

public class EmptyLearnableRowClusterSimilarities implements LearnableRowClusterSimilarities {

	@Override
	public double get(List<TableRowId> rows, ClassId classId, ClusterEntryKey key) {

		return 0.0;
	}

	@Override
	public Set<TableRowId> regionQuery(RowCluster cluster, TableRowId point, double eps) {
		throw new UnsupportedOperationException();
	}

	@Override
	public String getName() {
		return "EMPTY";
	}

	@Override
	public LearnedModel learn(Map<TableRowIdPair, PairLearningData> pairs, ClassId classId, EvaluationMethod evaluationMethod) {
		return new EmptyLearnableModel();
	}

}
