package expansion.set.strategies.rowclusterers.label;

import java.util.Set;
import java.util.UUID;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.tables.model.TableRowId;
import de.mannheim.uni.expansion.data.tables.repository.AnnotatedTablesRepository;
import de.mannheim.uni.expansion.utils.SimpleLockableConcurrentCache;
import expansion.set.clustering.ClusterList;
import expansion.set.clustering.RowClusterSplitterNew;
import expansion.set.strategies.blockers.Blocks;

public class LabelSimilarityClustererClassBlocked implements RowClusterSplitterNew {
 
	 
	
	private final LabelRowIndexClusterMapCreator clusterCreator;
	
	private final AnnotatedTablesRepository tableRepository;

	@Inject
	public LabelSimilarityClustererClassBlocked(  
			 LabelRowIndexClusterMapCreator clusterCreator,AnnotatedTablesRepository tableRepository) {
		super();  
		this.clusterCreator = clusterCreator;
		this.tableRepository = tableRepository;
	}

	private final static SimpleLockableConcurrentCache<UUID, ClusterList> cache = new SimpleLockableConcurrentCache<>();
 

	// @Override
	// public ClusterList clusterRows(RowClusterSimilarities sim,
	// RowClusteringConfig config, ClustererInput input) {
	// return getDirect(input.getUuid(), input.getCandidates());
	// }
	
	public ClusterList getDirect(UUID uuid, Set<TableRowId> candidates) {
	return cache.getOrCreate(uuid, () -> {
			
			try {
				Blocks blocks = clusterCreator.getClustersMap(candidates, true);
				return blocks.getClusterList(tableRepository);
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				return null;
			}
			
			 
		});
	}

	public ClusterList getDirectNoCache(Set<TableRowId> candidates) {

		try {
			Blocks blocks = clusterCreator.getClustersMap(candidates, true);
			return blocks.getClusterList(tableRepository);
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}

	}

//	public void createCache(String cacheFolder) {
//		// TODO Auto-generated method stub
//		
//	}

}
