package expansion.set.tablerow;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import de.mannheim.uni.expansion.data.ontology.model.QualifiedPropertyId;
import de.mannheim.uni.expansion.tablefusion.core.matching.MatchedValues;

public class AnnotatedQualifiedTableRow {

	private final String label;
	private final Map<QualifiedPropertyId, MatchedValues> values;

	public AnnotatedQualifiedTableRow(String label, Map<QualifiedPropertyId, MatchedValues> values) {
		this.label = label;
		this.values = Collections.unmodifiableMap(new HashMap<>(values));
	}

	public String getLabel() {
		return label;
	}

	public Map<QualifiedPropertyId, MatchedValues> getValues() {
		return values;
	}

	@Override
	public String toString() {
		return "AnnotatedTableRow [label=" + label + ", values=" + values + "]";
	}

	
}
