package expansion.set.strategies.rowclusterers;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.data.tables.model.TableRowId;
import expansion.set.clustering.model.RowClusterUUID;
import expansion.set.profiling.ClusterListEvaluator;

public class CombinatoricsTest {
	public static void main(String[] args) {
		
		ClusterListEvaluator cle = new ClusterListEvaluator();
		
		TableRowId x1 = new TableRowId(new AnnotatedTableId("X"), 1);
		TableRowId x2 = new TableRowId(new AnnotatedTableId("X"), 2);
		TableRowId x3 = new TableRowId(new AnnotatedTableId("X"), 3);
		TableRowId x4 = new TableRowId(new AnnotatedTableId("X"), 4);
		TableRowId x5 = new TableRowId(new AnnotatedTableId("X"), 5);
		TableRowId x6 = new TableRowId(new AnnotatedTableId("X"), 6);
		TableRowId x7 = new TableRowId(new AnnotatedTableId("X"), 7);
		TableRowId x8 = new TableRowId(new AnnotatedTableId("X"), 8);

		Set<TableRowId> xSet = new HashSet<>();
		xSet.add(x1);
		xSet.add(x2);
		xSet.add(x3);
		xSet.add(x4);
		xSet.add(x5);
		xSet.add(x6);
		xSet.add(x7);
		xSet.add(x8);

		TableRowId o1 = new TableRowId(new AnnotatedTableId("O"), 1);
		TableRowId o2 = new TableRowId(new AnnotatedTableId("O"), 2);
		TableRowId o3 = new TableRowId(new AnnotatedTableId("O"), 3);
		TableRowId o4 = new TableRowId(new AnnotatedTableId("O"), 4);
		TableRowId o5 = new TableRowId(new AnnotatedTableId("O"), 5);
		
		Set<TableRowId> oSet = new HashSet<>();
		oSet.add(o1);
		oSet.add(o2);
		oSet.add(o3);
		oSet.add(o4);
		oSet.add(o5);

		TableRowId d1 = new TableRowId(new AnnotatedTableId("D"),  1);
		TableRowId d2 = new TableRowId(new AnnotatedTableId("D"),  2);
		TableRowId d3 = new TableRowId(new AnnotatedTableId("D"),  3);
		TableRowId d4 = new TableRowId(new AnnotatedTableId("D"),  4);
		
		Set<TableRowId> dSet = new HashSet<>();
		dSet.add(d1);
		dSet.add(d2);
		dSet.add(d3);
		dSet.add(d4);
		
		Set<TableRowId> c1 = new HashSet<>();
		c1.add(x1);
		c1.add(x2);
		c1.add(x3);
		c1.add(x4);
		c1.add(x5);
		c1.add(o1);
		
		
		Set<TableRowId> c2 = new HashSet<>();
		c2.add(x6);
		c2.add(o2);
		c2.add(o3);
		c2.add(o4);
		c2.add(o5);
		c2.add(d1);
		
		
		
		Set<TableRowId> c3 = new HashSet<>();
		c3.add(x7);
		c3.add(x8);
		c3.add(d2);
		c3.add(d3);
		c3.add(d4);
		
		Map<RowClusterUUID, Set<TableRowId>> clusters = new HashMap<>();
		clusters.put(new RowClusterUUID(), c1);
		clusters.put(new RowClusterUUID(), c2);
		clusters.put(new RowClusterUUID(), c3);
		
		List<Set<TableRowId>> gs = new ArrayList<>();
		gs.add(xSet);
		gs.add(oSet);
		gs.add(dSet);
		
		System.out.println(cle.getPairWiseClusterComparison(clusters, gs).toString()); 
	}
}
