package expansion.set.strategies.rowclusterers;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.atomic.AtomicInteger;

import com.google.common.util.concurrent.AtomicDouble;

import de.mannheim.uni.expansion.utils.DecimalFormatter;
import de.mannheim.uni.expansion.utils.PersistentParallel6;
import de.mannheim.uni.expansion.utils.containers.Pair;
import de.mannheim.uni.expansion.utils.containers.Tri;
import expansion.set.clustering.model.RowCluster.ClusterEntryKey;
import expansion.set.evaluation.goldstandard.oktie.OktiePerformance;
import expansion.set.strategies.rowclusterers.TestClustering.Test_Runs;

public class CustomTestClustering {

	public static void main(String[] args) {
		List<Test_Runs> testRuns = new ArrayList<>();
		// testRuns.add(Test_Runs.GSIMPL);
		// testRuns.add(Test_Runs.GSIMPL_RA);
		// testRuns.add(Test_Runs.GSIMPL_SR);
		// testRuns.add(Test_Runs.GSIMPL_RA_SR);
		// testRuns.add(Test_Runs.GPARRE);
		// testRuns.add(Test_Runs.GPARRE_SR);
		testRuns.add(Test_Runs.GPARRE_RA);

		// Map<Integer, Integer> belong = new HashMap<>();
		// belong.put(0, 0);
		// belong.put(1, 0);
		// belong.put(2, 0);
		// belong.put(3, 0);
		// belong.put(4, 0);
		//
		// Map<ClusterEntryKey, Double> endSims = new HashMap<>();
		// endSims.put(new ClusterEntryKey(0, 1), 0.98);
		// endSims.put(new ClusterEntryKey(0, 2), 0.96);
		// endSims.put(new ClusterEntryKey(0, 3), 0.99);
		// endSims.put(new ClusterEntryKey(0, 4), -0.53);
		// endSims.put(new ClusterEntryKey(1, 2), 0.99);
		// endSims.put(new ClusterEntryKey(1, 3), 0.99);
		// endSims.put(new ClusterEntryKey(1, 4), 0.64);
		// endSims.put(new ClusterEntryKey(2, 3), 0.96);
		// endSims.put(new ClusterEntryKey(2, 4), -0.53);
		// endSims.put(new ClusterEntryKey(3, 4), 0.92);

		Map<Integer, Integer> belong = new HashMap<>();
		// belong.put(0, 0);
		// belong.put(1, 1);
		// belong.put(2, 2);
		// belong.put(3, 3);
		// belong.put(4, 0);
		Map<ClusterEntryKey, Double> endSims = new HashMap<>();

		int node = 0;

		for (int j = 0; j < 1800; j++) {
			if (j < 900) {
				belong.put(node, 0);
			} else {
				belong.put(node, 1);
			}

			int add = 1;
			for (int k = j + 1; k < 1800; k++) {
				if (j < 900 && k < 900) {
					endSims.put(new ClusterEntryKey(node, node + add), 1.0);
				} else if (j >= 900 && k >= 900) {
					endSims.put(new ClusterEntryKey(node, node + add), 1.0);

				} else {
					endSims.put(new ClusterEntryKey(node, node + add), -1.0);
				}
					add++;
				}

				node++;
			}


		// for (int i = 0; i < node; i++) {
		// ClusterEntryKey key = new ClusterEntryKey(i, node);
		// endSims.put(key, 0.1);
		// }
		// belong.put(node, 15);
		// node++;

		// for (int i = 0; i < node; i++) {
		// for (int j = i + 1; j < node; j++) {
		// ClusterEntryKey key = new ClusterEntryKey(i, j);
		// if (!endSims.containsKey(key)) {
		// endSims.put(key, random.nextDouble() - 0.99);
		// }
		// }
		// }

		// Map<ClusterEntryKey, Double> endSims = new HashMap<>();
		// endSims.put(new ClusterEntryKey(0, 1), 0.1);
		// endSims.put(new ClusterEntryKey(0, 2), -0.5 * 2.0);
		// endSims.put(new ClusterEntryKey(0, 3), -3.33 / 3.0);
		// endSims.put(new ClusterEntryKey(0, 4), 0.55);
		// endSims.put(new ClusterEntryKey(1, 2), -1.0);
		// endSims.put(new ClusterEntryKey(1, 3), -1.0);
		// endSims.put(new ClusterEntryKey(1, 4), 0.55);
		// endSims.put(new ClusterEntryKey(2, 3), -4.44 / 4);
		// endSims.put(new ClusterEntryKey(2, 4), 0.55 * 1.0);
		// endSims.put(new ClusterEntryKey(3, 4), 0.05 * 11.0);

		Tri<Integer, Map<Integer, Integer>, Map<ClusterEntryKey, Double>> clusterData = new Tri<>(2, belong, endSims);

		PersistentParallel6.runAndFinish(testRuns, (testRun) -> {

			AtomicDouble totalTime = new AtomicDouble();
			AtomicInteger count = new AtomicInteger();
			AtomicDouble oktiePrecision = new AtomicDouble();
			AtomicDouble oktieRecall = new AtomicDouble();
			AtomicDouble oktieFmeasure = new AtomicDouble();

			Pair<Double, OktiePerformance> res = TestClustering.run(testRun, clusterData);

			totalTime.addAndGet(res.getFirst());

			count.addAndGet(1);

			oktiePrecision.addAndGet(res.getSecond().getPenalizedClusteringPrecisionMacro());
			oktieRecall.addAndGet(res.getSecond().getRecallMacro());
			oktieFmeasure.addAndGet(res.getSecond().getFMeasureMacro());

			System.out.println(String.valueOf(1) + ";" + testRun.name() + ";" + DecimalFormatter.format(oktiePrecision.doubleValue() / count.intValue()) + ";"
					+ DecimalFormatter.format(oktieRecall.doubleValue() / count.intValue()) + ";"
					+ DecimalFormatter.format(oktieFmeasure.doubleValue() / count.intValue()) + ";" + DecimalFormatter.format(totalTime.doubleValue()));

		}, TestClustering.class, true);

	}

}
