package expansion.set.strategies.rowclusterers;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

import de.mannheim.uni.expansion.utils.containers.Pair;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.optimizer.genetic.WeightsGeneticParallelOptimizer;
import expansion.set.learning.EqualSetSplitter;

public class SetDistributionTest {

	public static void main(String[] args) {

		int denominator = 3;
		List<Integer> setSizes = new ArrayList<>();
		setSizes.add(14);
		setSizes.add(3);
		setSizes.add(10);
		setSizes.add(12);
		setSizes.add(8);
		setSizes.add(12);
		setSizes.add(4);
		setSizes.add(1);
		setSizes.add(2);
		setSizes.add(12);
		setSizes.add(4);
		setSizes.add(1);
		setSizes.add(2);
		setSizes.add(9);
		setSizes.add(5);
		setSizes.add(10);
		setSizes.add(7);
		setSizes.add(2);



		Map<Integer, Pair<Integer, Integer>> existing = new HashMap<>();
		existing.put(0, new Pair<>(4, 33));
		existing.put(1, new Pair<>(4, 31));
		existing.put(2, new Pair<>(3, 16));
		// existing.put(3, new Pair<>(3, 19));

		EqualSetSplitter splitter = new EqualSetSplitter() {
			{
				this.weightsParallelOptimizer = new WeightsGeneticParallelOptimizer();
			}
		};

		Map<Integer, Set<Integer>> finalDistribution;
		// Map<Integer, Set<Integer>> finalDistribution = splitter.get(setSizes,
		// denominator);
		//
		// System.out.println(finalDistribution.toString());
		//
		// System.err.println(
		// finalDistribution.values().stream().map((e) ->
		// e.stream().mapToInt((e2) ->
		// setSizes.get(e2)).sum()).collect(Collectors.toList()).toString());
		//
		// System.err.println(finalDistribution.values().stream().map((e) ->
		// e.size()).collect(Collectors.toList()).toString());

		finalDistribution = splitter.getSetNumberPriority(setSizes, denominator, existing);

		finalDistribution = new HashMap<>(finalDistribution);

		System.out.println(finalDistribution.toString());

		System.err.println(
				finalDistribution.values().stream().map((e) -> e.stream().mapToInt((e2) -> setSizes.get(e2)).sum()).collect(Collectors.toList()).toString());

		System.err.println(finalDistribution.values().stream().map((e) -> e.size()).collect(Collectors.toList()).toString());


		setSizes.add(3);
		setSizes.add(10);
		setSizes.add(12);
		setSizes.add(8);

		setSizes.add(12);
		setSizes.add(4);
		setSizes.add(1);
		setSizes.add(14);

		setSizes.add(2);
		setSizes.add(9);
		setSizes.add(5);

		// setSizes.add(10);
		// setSizes.add(7);
		// setSizes.add(2);

		finalDistribution = splitter.getSetNumberPriority(setSizes, denominator);

		System.out.println(finalDistribution.toString());

		System.err.println(
				finalDistribution.values().stream().map((e) -> e.stream().mapToInt((e2) -> setSizes.get(e2)).sum()).collect(Collectors.toList()).toString());

		System.err.println(finalDistribution.values().stream().map((e) -> e.size()).collect(Collectors.toList()).toString());
		int sdf = 123;


	}



}
