package expansion.set.strategies.rowclusterers;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

import de.uni_mannheim.informatik.dws.expansion.utils.optimization.optimizer.genetic.WeightsGeneticParallelOptimizer;
import expansion.set.learning.EqualSetSplitter;

public class SetDistributionTest2 {

	public static void main(String[] args) {

		int denominator = 3;

		List<Integer> setA = new ArrayList<>();
		setA.add(14);
		setA.add(3);
		setA.add(10);
		setA.add(12);

		List<Integer> setB = new ArrayList<>();
		setB.add(1);
		setB.add(2);
		setB.add(12);
		setB.add(4);
		setB.add(1);
		setB.add(2);

		List<Integer> setC = new ArrayList<>();

		setC.add(9);
		setC.add(5);
		setC.add(10);
		setC.add(7);

		List<Integer> setD = new ArrayList<>();
		setD.add(10);
		setD.add(12);
		setD.add(8);
		setD.add(12);
		setD.add(4);
		setD.add(1);
		setD.add(2);

		List<Integer> setE = new ArrayList<>();
		setE.add(1);
		setE.add(5);
		setE.add(10);
		setE.add(7);
		setE.add(2);

		List<Integer> setF = new ArrayList<>();
		setF.add(8);
		setF.add(12);
		setF.add(4);

		List<Integer> setG = new ArrayList<>();
		setG.add(2);
		setG.add(14);
		setG.add(3);

		List<Integer> setH = new ArrayList<>();
		setH.add(9);
		setH.add(5);
		setH.add(1);
		setH.add(5);
		setH.add(10);

		List<Integer> setI = new ArrayList<>();
		setI.add(2);
		setI.add(4);
		setI.add(4);
		setI.add(5);
		setI.add(9);

		List<Integer> setJ = new ArrayList<>();
		setE.add(9);
		setE.add(13);
		setE.add(2);
		setE.add(1);

		List<List<Integer>> sets = new ArrayList<>();
		sets.add(setA);
		sets.add(setB);
		sets.add(setC);
		sets.add(setD);
		sets.add(setE);
		sets.add(setF);
		sets.add(setG);
		sets.add(setH);
		sets.add(setI);
		sets.add(setJ);

		List<Integer> setSizes = sets.stream().map((e) -> e.stream().mapToInt(Integer::intValue).sum()).collect(Collectors.toList());
		List<Integer> setCount = sets.stream().map((e) -> e.size()).collect(Collectors.toList());

		EqualSetSplitter splitter = new EqualSetSplitter() {
			{
				this.weightsParallelOptimizer = new WeightsGeneticParallelOptimizer();
			}
		};

		Map<Integer, Set<Integer>> finalDistribution = splitter.get(setSizes, denominator);

		System.out.println(finalDistribution.toString());

		System.err.println(
				finalDistribution.values().stream().map((e) -> e.stream().mapToInt((e2) -> setSizes.get(e2)).sum()).collect(Collectors.toList()).toString());

		System.err.println(
				finalDistribution.values().stream().map((e) -> e.stream().mapToInt((e2) -> setCount.get(e2)).sum()).collect(Collectors.toList()).toString());

		System.err.println(finalDistribution.values().stream().map((e) -> e.size()).collect(Collectors.toList()).toString());


		finalDistribution = splitter.getSetNumberPriority(setSizes, denominator);

		System.out.println(finalDistribution.toString());

		System.err.println(
				finalDistribution.values().stream().map((e) -> e.stream().mapToInt((e2) -> setSizes.get(e2)).sum()).collect(Collectors.toList()).toString());

		System.err.println(
				finalDistribution.values().stream().map((e) -> e.stream().mapToInt((e2) -> setCount.get(e2)).sum()).collect(Collectors.toList()).toString());

		System.err.println(finalDistribution.values().stream().map((e) -> e.size()).collect(Collectors.toList()).toString());

		finalDistribution = splitter.get(setCount, setSizes, denominator);

		System.out.println(finalDistribution.toString());

		System.err.println(
				finalDistribution.values().stream().map((e) -> e.stream().mapToInt((e2) -> setSizes.get(e2)).sum()).collect(Collectors.toList()).toString());

		System.err.println(
				finalDistribution.values().stream().map((e) -> e.stream().mapToInt((e2) -> setCount.get(e2)).sum()).collect(Collectors.toList()).toString());

		System.err.println(finalDistribution.values().stream().map((e) -> e.size()).collect(Collectors.toList()).toString());

		int sdf = 123;

	}



}
