package expansion.set.strategies.rowclusterers;
 
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Optional;
import java.util.Random;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ThreadLocalRandom;
import java.util.concurrent.atomic.AtomicInteger;

import org.apache.commons.lang.mutable.MutableInt;

import com.google.common.util.concurrent.AtomicDouble;

import de.mannheim.uni.expansion.utils.CHMHelper;
import de.mannheim.uni.expansion.utils.DecimalFormatter;
import de.mannheim.uni.expansion.utils.DoubleIteraterable;
import de.mannheim.uni.expansion.utils.ListIterable;
import de.mannheim.uni.expansion.utils.ListIterable.ListEntry;
import de.mannheim.uni.expansion.utils.OtsuThresholderRounded;
import de.mannheim.uni.expansion.utils.PersistentParallel6;
import de.mannheim.uni.expansion.utils.Scorable;
import de.mannheim.uni.expansion.utils.containers.Pair;
import de.mannheim.uni.expansion.utils.containers.Tri;
import expansion.set.clustering.model.RowCluster.ClusterEntryKey;
import expansion.set.evaluation.goldstandard.oktie.OktieClusterEvaluator;
import expansion.set.evaluation.goldstandard.oktie.OktiePerformance;

public class TestClustering {

	
	public static enum Test_Runs {
		GSIMPL_RA_SR, GSIMPL_SR, GSIMPL_RA, GSIMPL, CPIVOT, DBSCAN, CPIVOT_FULL, GPARRE, GPARRE_RA, GPARRE_SR, GPARRE_RA_SR;
	}
	public static OtsuThresholderRounded thresholder = new OtsuThresholderRounded();

	public static void main(String[] args) {
		GreedyClustering.SEQUENTIAL = true;
		GreedyClustering.WITH_CENTROIDS = false;
		List<String> names = new ArrayList<>();
//		names.add("DB-SCAN");
//		names.add("YASER DB-SCAN");
		names.add("Greedy-Parralized");
		names.add("Greedy-Simple");
		// names.add("DB-SCAN");
		// names.add("PIVOT");
//		names.add("Greedy-Reassign-Filter");
//		names.add("Greedy-Reassign-Filter-Silhoutte");
		
 
		


		List<Integer> clusterSizes = new ArrayList<>();
//		 clusterSizes.add(1);
//		 clusterSizes.add(4);
//		 clusterSizes.add(2);
//		 clusterSizes.add(3);
//		 clusterSizes.add(3);
//		clusterSizes.add(50);
//		clusterSizes.add(50);
//		clusterSizes.add(50);
//		clusterSizes.add(50);
//		clusterSizes.add(50);
//		clusterSizes.add(8);
//		clusterSizes.add(1);
//		clusterSizes.add(8);
//		clusterSizes.add(10);
//		clusterSizes.add(20);
//		 clusterSizes.add(1);
//		 clusterSizes.add(2);
//		 clusterSizes.add(3);
//		 clusterSizes.add(3);
//		 clusterSizes.add(5);
//		 clusterSizes.add(5);
////		clusterSizes.add(8);
//////		clusterSizes.add(8);
////		clusterSizes.add(8);
		clusterSizes.add(10);
//		clusterSizes.add(10);
		// clusterSizes.add(500);
		// clusterSizes.add(1000);
		// clusterSizes.add(1000);
		// clusterSizes.add(1000);
		// clusterSizes.add(100);
//		clusterSizes.add(50);
//		clusterSizes.add(50);
//		clusterSizes.add(50);
//		clusterSizes.add(50);
//		clusterSizes.add(50);
//		clusterSizes.add(50);
//		clusterSizes.add(50);
//		clusterSizes.add(50);
//		clusterSizes.add(100);
//		clusterSizes.add(100);
//		clusterSizes.add(200);
//		clusterSizes.add(200);
//		clusterSizes.add(1000);
//		clusterSizes.add(1000);
//		clusterSizes.add(1000);
//		clusterSizes.add(1000);
		
//		AtomicInteger count = new AtomicInteger(0);
		
		List<Test_Runs> testRuns = new ArrayList<>();
		// testRuns.add(Test_Runs.GSIMPL);
		// testRuns.add(Test_Runs.GSIMPL_RA);
//		testRuns.add(Test_Runs.GSIMPL_SR);
//		testRuns.add(Test_Runs.GSIMPL_RA_SR);
		testRuns.add(Test_Runs.GPARRE);
		// testRuns.add(Test_Runs.GPARRE_SR);
		testRuns.add(Test_Runs.GPARRE_RA);
//		testRuns.add(Test_Runs.GPARRE_SR);
//		testRuns.add(Test_Runs.GPARRE_RA_SR);
		// testRuns.add(Test_Runs.DBSCAN);
//		testRuns.add(Test_Runs.CPIVOT);
//		testRuns.add(Test_Runs.CPIVOT_FULL);
		
		
		for (int i = 0; i < 4; i++) {
			int runFinal = Math.min(i + 3, 4);
			List<Tri<Integer, Map<Integer, Integer>, Map<ClusterEntryKey, Double>>> clusterDataList = new ArrayList<>();
	
			for(Integer clusterSize : clusterSizes) {
				clusterDataList.add(getClusterData(clusterSize, runFinal));
			}
			
	
			PersistentParallel6.runAndFinish(testRuns, (testRun) -> {
				
				AtomicDouble totalTime = new AtomicDouble();
				AtomicInteger count = new AtomicInteger();
				AtomicDouble oktiePrecision = new AtomicDouble();
				AtomicDouble oktieRecall = new AtomicDouble();
				AtomicDouble oktieFmeasure = new AtomicDouble();
				
				PersistentParallel6.runAndFinishNoProgress(clusterDataList, (clusterData) -> {
					 Pair<Double, OktiePerformance>  res = run(testRun, clusterData);
					
					 totalTime.addAndGet(res.getFirst()); 
	
					 count.addAndGet(1);
	
					 oktiePrecision.addAndGet(res.getSecond().getPenalizedClusteringPrecisionMacro()); 
					 oktieRecall.addAndGet(res.getSecond().getRecallMacro());
	 				 oktieFmeasure.addAndGet(res.getSecond().getFMeasureMacro());
	
					 
	 
					
				}, TestClustering.class);
				System.out.println(String.valueOf(runFinal) + ";" + testRun.name() + ";"+DecimalFormatter.format(oktiePrecision.doubleValue() / count.intValue())+";"+DecimalFormatter.format(oktieRecall.doubleValue()/ count.intValue())+";"+DecimalFormatter.format(oktieFmeasure.doubleValue()/ count.intValue())+";"+DecimalFormatter.format(totalTime.doubleValue()));
	
			}, TestClustering.class, true);
		
		}
		
//		 ConcurrentHashMap<Integer, AtomicDouble> precision = new ConcurrentHashMap<>();
//		 ConcurrentHashMap<Integer, AtomicDouble> recall = new ConcurrentHashMap<>();
//		 ConcurrentHashMap<Integer, AtomicDouble> fMeasure = new ConcurrentHashMap<>();
//		 ConcurrentHashMap<Integer, AtomicInteger> count = new ConcurrentHashMap<>();
//		 ConcurrentHashMap<Integer, AtomicDouble> totalTime = new ConcurrentHashMap<>();
//		 
//		 
//		 ConcurrentHashMap<Integer, AtomicDouble> oktiePrecision = new ConcurrentHashMap<>();
//		 ConcurrentHashMap<Integer, AtomicDouble> oktieRecall = new ConcurrentHashMap<>();
//		 ConcurrentHashMap<Integer, AtomicDouble> oktieCPrecision = new ConcurrentHashMap<>(); 
//		 ConcurrentHashMap<Integer, AtomicDouble> oktiePCPrecision = new ConcurrentHashMap<>(); 
//		 ConcurrentHashMap<Integer, AtomicDouble> oktieFmeasure = new ConcurrentHashMap<>();
//
//
//		PersistentParallel6.runAndFinish(clusterSizes, (e) -> {
//			List<Pair<Double, OktiePerformance>> res = run(e);
//			
//			for(ListEntry<Pair< Double , OktiePerformance>> entry : ListIterable.iterable(res)) {
////				CHMHelper.getFromCHM(precision, entry.getIndex(), () -> new AtomicDouble()).addAndGet(entry.getValue().getFirst().getFirst()); 
////				CHMHelper.getFromCHM(recall, entry.getIndex(), () -> new AtomicDouble()).addAndGet(entry.getValue().getFirst().getSecond());
////				CHMHelper.getFromCHM(fMeasure, entry.getIndex(), () -> new AtomicDouble()).addAndGet(
////						(2 * entry.getValue().getFirst().getFirst() * entry.getValue().getFirst().getSecond()) / (entry.getValue().getFirst().getFirst() + entry.getValue().getFirst().getSecond())
////					);
//				
//				
//				CHMHelper.getFromCHM(totalTime, entry.getIndex(), () -> new AtomicDouble()).addAndGet(entry.getValue().getFirst()); 
//
//				CHMHelper.getFromCHM(count, entry.getIndex(), () -> new AtomicInteger()).addAndGet(1);
//				
//				
//				
//				CHMHelper.getFromCHM(oktiePrecision, entry.getIndex(), () -> new AtomicDouble()).addAndGet(entry.getValue().getSecond().getPrecision()); 
//				CHMHelper.getFromCHM(oktieRecall, entry.getIndex(), () -> new AtomicDouble()).addAndGet(entry.getValue().getSecond().getRecall());
//
//				CHMHelper.getFromCHM(oktieCPrecision, entry.getIndex(), () -> new AtomicDouble()).addAndGet(entry.getValue().getSecond().getClusteringPrecision()); 
//				CHMHelper.getFromCHM(oktiePCPrecision, entry.getIndex(), () -> new AtomicDouble()).addAndGet(entry.getValue().getSecond().getPenalizedClusteringPrecision());
//				CHMHelper.getFromCHM(oktieFmeasure, entry.getIndex(), () -> new AtomicDouble()).addAndGet(entry.getValue().getSecond().getFMeasure());
//
//
//			}
//			
////			secondPrecision.addAndGet(res.getB().getFirst());
////			secondRecall.addAndGet(res.getB().getSecond());
////			secondFMeasure.addAndGet((2 * res.getB().getFirst() * res.getB().getSecond()) / (res.getB().getFirst() + res.getB().getSecond()));
////
////			dbScanPrecision.addAndGet(res.getA().getFirst());
////			dbScanRecall.addAndGet(res.getA().getSecond());
////			dbScanFmeasure.addAndGet((2 * res.getA().getFirst() * res.getA().getSecond()) / (res.getA().getFirst() + res.getA().getSecond()));
////
////			thirdPrecision.addAndGet(res.getC().getFirst());
////			thirdRecall.addAndGet(res.getC().getSecond());
////			double Fmeasure = (2 * res.getC().getFirst() * res.getC().getSecond()) / (res.getC().getFirst() + res.getC().getSecond());
////			if (Double.isNaN(Fmeasure)) {
////				Fmeasure = 0.0;
////			}
////			thirdFMeasure.addAndGet(Fmeasure);
////			count.incrementAndGet();
//		} , TestClustering.class, true );
//
////		 System.out.println("CCPrecision: " + (secondPrecision.doubleValue() / count.intValue()));
////		 System.out.println("CCRecall: " + (secondRecall.doubleValue() / count.intValue()));
////		 System.out.println("CCFMeasure: " + (secondFMeasure.doubleValue() / count.intValue()));
////
////		System.out.println("ThirdPrecision: " + (thirdPrecision.doubleValue() / count.intValue()));
////		System.out.println("ThirdRecall: " + (thirdRecall.doubleValue() / count.intValue()));
////		System.out.println("ThirdFMeasure: " + (thirdFMeasure.doubleValue() / count.intValue()));
//
//		// System.out.println("DBScanPrecision: " +
//		// (dbScanPrecision.doubleValue() / count.intValue()));
//		// System.out.println("DBScanRecall: " + (dbScanRecall.doubleValue() /
//		// count.intValue()));
//		// System.out.println("DBFmeasure: " + (dbScanFmeasure.doubleValue() /
//		// count.intValue()));
//		
//		for(ListEntry<String> name : ListIterable.iterable(names)) {
//			int countInt = CHMHelper.getFromCHM(count, name.getIndex(), () -> new AtomicInteger()).get();
//			 
//			if(countInt > 0) {
////				System.out.println(name.getValue() + " - Precision: " + ( CHMHelper.getFromCHM(precision, name.getIndex(), () -> new AtomicDouble()).get() / countInt));
////				System.out.println(name.getValue() + " - Recall: " + (CHMHelper.getFromCHM(recall, name.getIndex(), () -> new AtomicDouble()).get() / countInt));
////				System.out.println(name.getValue() + " - FMeasure: " + (CHMHelper.getFromCHM(fMeasure, name.getIndex(), () -> new AtomicDouble()).get() / countInt));
//				
//				
////				System.out.println(name.getValue() + " - OktiePrecision: " + ( CHMHelper.getFromCHM(oktiePrecision, name.getIndex(), () -> new AtomicDouble()).get() / countInt));
//				System.out.println(name.getValue() + " - OktieRecall: " + (CHMHelper.getFromCHM(oktieRecall, name.getIndex(), () -> new AtomicDouble()).get() / countInt));
////				System.out.println(name.getValue() + " - OktieCPrecision: " + (CHMHelper.getFromCHM(oktieCPrecision, name.getIndex(), () -> new AtomicDouble()).get() / countInt));
//				System.out.println(name.getValue() + " - OktiePCPrecision: " + (CHMHelper.getFromCHM(oktiePCPrecision, name.getIndex(), () -> new AtomicDouble()).get() / countInt));
//				System.out.println(name.getValue() + " - OktieFMeasure: " + (CHMHelper.getFromCHM(oktieFmeasure, name.getIndex(), () -> new AtomicDouble()).get() / countInt)); 
//				System.out.println(name.getValue() + " - Time(Seconds): " + (CHMHelper.getFromCHM(totalTime, name.getIndex(), () -> new AtomicDouble()).get()  )); 
//
//			}
//		}
//
//		System.out.println("NEW:" + newSeconds);
//		System.out.println("OLD:" + oldSeconds);
		
		try {
			PersistentParallel6.close();
		} catch (InterruptedException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		
	
	}

	
	public static double newSeconds = 0.0;
	public static double oldSeconds = 0.0;
	
	private final static PivotClustering pc = new PivotClustering();
	private final static OktieClusterEvaluator oktieEvaluator = new OktieClusterEvaluator();
	private final static GreedyClustering gc = new GreedyClustering();;
	private final static DBScanSliptter splitterNew = new DBScanSliptter(new OtsuThresholderRounded());
	
	public static  Pair<Double, OktiePerformance>  run(Test_Runs testRun, Tri<Integer,  Map<Integer, Integer>, Map<ClusterEntryKey, Double>> clusterData) {
		
	 
		// ClusterSplitter splitter = new ClusterSplitter();
		
		
//		List<Pair< Double , OktiePerformance>> ret = Collections.synchronizedList(new ArrayList<>());
		
		
		
 

		Map<Integer, Integer> clusterBelong = clusterData.getB();
		Map<ClusterEntryKey, Double> endSimilarities = clusterData.getC();
		
		
 
		
		switch(testRun) {
		case CPIVOT_FULL: {
			long startTime = System.nanoTime();
//			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, false );
//			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, false , true);
			List<Set<Integer>> result = pc.cluster(new ClusterSimilaritiesWrapper(endSimilarities), clusterBelong.keySet(), true);
			
			
//			Pair<Double, Double> res = getRecallAndPrecision(result, clusterBelong, clusterSize);
			OktiePerformance oktiePerformance = oktieEvaluator.oktieEvaluateWithGSIndex(clusterBelong, result);
			 
			long estimatedTime = System.nanoTime() - startTime;

			double seconds = (double) estimatedTime / 1000000000.0;
		 
			
//			System.out.println("ClusterSize " + clusterData.getA() + " : " + result.size() + "(" + Math.abs(result.size() - clusterData.getA()) + ")");

			return new Pair<>(seconds, oktiePerformance);
//			oldSeconds += seconds;
//			System.out.println("OLD:" + seconds);
		} 
		case CPIVOT: {
			long startTime = System.nanoTime();
//			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, false );
//			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, false , true);
			List<Set<Integer>> result = pc.cluster(new ClusterSimilaritiesWrapper(endSimilarities), clusterBelong.keySet(), false);
			
			
//			Pair<Double, Double> res = getRecallAndPrecision(result, clusterBelong, clusterSize);
			OktiePerformance oktiePerformance = oktieEvaluator.oktieEvaluateWithGSIndex(clusterBelong, result);
			 
			long estimatedTime = System.nanoTime() - startTime;

			double seconds = (double) estimatedTime / 1000000000.0;
		 
			
//			System.out.println("ClusterSize " + clusterData.getA() + " : " + result.size() + "(" + Math.abs(result.size() - clusterData.getA()) + ")");

			return new Pair<>(seconds, oktiePerformance);
//			oldSeconds += seconds;
//			System.out.println("OLD:" + seconds);
		} 
		case DBSCAN: {
			long startTime = System.nanoTime();
//			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, false );
//			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, false , true);
			List<Set<Integer>> result = splitterNew.DBScan(new ClusterSimilaritiesWrapper(endSimilarities), clusterBelong.keySet(), 0.5, 3);
			
			
//			Pair<Double, Double> res = getRecallAndPrecision(result, clusterBelong, clusterSize);
			OktiePerformance oktiePerformance = oktieEvaluator.oktieEvaluateWithGSIndex(clusterBelong, result);
			 
			long estimatedTime = System.nanoTime() - startTime;

			double seconds = (double) estimatedTime / 1000000000.0;
//			oldSeconds += seconds;
			return new Pair<>(seconds, oktiePerformance);
//			System.out.println("OLD:" + seconds);
		} 
		case GPARRE: {
			long startTime = System.nanoTime();
			
			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  false, false, false , false);
//			List<Set<Integer>> result = CorellationClustering2.cc(new ClusterSimilaritiesWrapper(endSimilarities), clusterBelong.keySet(), 0.0, 0, false, true, false);
			
			
//			Pair<Double, Double> res = getRecallAndPrecision(result, clusterBelong, clusterSize);
 
			OktiePerformance oktiePerformance = oktieEvaluator.oktieEvaluateWithGSIndex(clusterBelong, result);
			
			
			long estimatedTime = System.nanoTime() - startTime;

			double seconds = (double) estimatedTime / 1000000000.0;
			 

			return new Pair<>(seconds, oktiePerformance);
		} 
		case GPARRE_RA: {
			long startTime = System.nanoTime();
			
			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, false , false);
//			List<Set<Integer>> result = CorellationClustering2.cc(new ClusterSimilaritiesWrapper(endSimilarities), clusterBelong.keySet(), 0.0, 0, false, true, false);
			
			
//			Pair<Double, Double> res = getRecallAndPrecision(result, clusterBelong, clusterSize);
 
			OktiePerformance oktiePerformance = oktieEvaluator.oktieEvaluateWithGSIndex(clusterBelong, result);
			
			
			long estimatedTime = System.nanoTime() - startTime;

			double seconds = (double) estimatedTime / 1000000000.0;
			 

			return new Pair<>(seconds, oktiePerformance);
		} 
		case GPARRE_SR: {
			long startTime = System.nanoTime();
			
			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  false, false, true , false);
//			List<Set<Integer>> result = CorellationClustering2.cc(new ClusterSimilaritiesWrapper(endSimilarities), clusterBelong.keySet(), 0.0, 0, false, true, false);
			
			
//			Pair<Double, Double> res = getRecallAndPrecision(result, clusterBelong, clusterSize);
 
			OktiePerformance oktiePerformance = oktieEvaluator.oktieEvaluateWithGSIndex(clusterBelong, result);
			
			
			long estimatedTime = System.nanoTime() - startTime;

			double seconds = (double) estimatedTime / 1000000000.0;
			 

			return new Pair<>(seconds, oktiePerformance);
		} 
		case GPARRE_RA_SR: {
			long startTime = System.nanoTime();
			
			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, true , false);
//			List<Set<Integer>> result = CorellationClustering2.cc(new ClusterSimilaritiesWrapper(endSimilarities), clusterBelong.keySet(), 0.0, 0, false, true, false);
			
			
//			Pair<Double, Double> res = getRecallAndPrecision(result, clusterBelong, clusterSize);
 
			OktiePerformance oktiePerformance = oktieEvaluator.oktieEvaluateWithGSIndex(clusterBelong, result);
			
			
			long estimatedTime = System.nanoTime() - startTime;

			double seconds = (double) estimatedTime / 1000000000.0;
			 

			return new Pair<>(seconds, oktiePerformance);
		} 
		case GSIMPL: {
			long startTime = System.nanoTime(); 
//			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, false );
//			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, false , true);
//			List<Set<Integer>> result = CorellationClustering2.cc(new ClusterSimilaritiesWrapper(endSimilarities), clusterBelong.keySet(), 0.0, 0, false, true, false);
			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  false, false, false , true);

			
//			Pair<Double, Double> res = getRecallAndPrecision(result, clusterBelong, clusterSize);
			OktiePerformance oktiePerformance = oktieEvaluator.oktieEvaluateWithGSIndex(clusterBelong, result);
			
			long estimatedTime = System.nanoTime() - startTime;

			double seconds = (double) estimatedTime / 1000000000.0;

			return new Pair<>(seconds, oktiePerformance);
//			System.out.println("OLD:" + seconds);
		} 
		case GSIMPL_RA: {
			long startTime = System.nanoTime(); 
//			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, false );
//			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, false , true);
//			List<Set<Integer>> result = CorellationClustering2.cc(new ClusterSimilaritiesWrapper(endSimilarities), clusterBelong.keySet(), 0.0, 0, false, true, false);
			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, false , true);

			
//			Pair<Double, Double> res = getRecallAndPrecision(result, clusterBelong, clusterSize);
			OktiePerformance oktiePerformance = oktieEvaluator.oktieEvaluateWithGSIndex(clusterBelong, result);
			
			long estimatedTime = System.nanoTime() - startTime;

			double seconds = (double) estimatedTime / 1000000000.0;

			return new Pair<>(seconds, oktiePerformance);
//			System.out.println("OLD:" + seconds);
		} 
		case GSIMPL_SR: {
			long startTime = System.nanoTime(); 
//			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, false );
//			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, false , true);
//			List<Set<Integer>> result = CorellationClustering2.cc(new ClusterSimilaritiesWrapper(endSimilarities), clusterBelong.keySet(), 0.0, 0, false, true, false);
			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  false, false, true , true);

			
//			Pair<Double, Double> res = getRecallAndPrecision(result, clusterBelong, clusterSize);
			OktiePerformance oktiePerformance = oktieEvaluator.oktieEvaluateWithGSIndex(clusterBelong, result);
			
			long estimatedTime = System.nanoTime() - startTime;

			double seconds = (double) estimatedTime / 1000000000.0;

			return new Pair<>(seconds, oktiePerformance);
//			System.out.println("OLD:" + seconds);
		} 
		case GSIMPL_RA_SR: {
			long startTime = System.nanoTime(); 
//			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, false );
//			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, false , true);
//			List<Set<Integer>> result = CorellationClustering2.cc(new ClusterSimilaritiesWrapper(endSimilarities), clusterBelong.keySet(), 0.0, 0, false, true, false);
			List<Set<Integer>> result = gc.run( clusterBelong.keySet() , new ClusterSimilaritiesWrapper(endSimilarities),  true, false, true , true);

			
//			Pair<Double, Double> res = getRecallAndPrecision(result, clusterBelong, clusterSize);
			OktiePerformance oktiePerformance = oktieEvaluator.oktieEvaluateWithGSIndex(clusterBelong, result);
			
			long estimatedTime = System.nanoTime() - startTime;

			double seconds = (double) estimatedTime / 1000000000.0;

			return new Pair<>(seconds, oktiePerformance);
//			System.out.println("OLD:" + seconds);
		} 
		default:
			throw new IllegalStateException(); 
		
		}
//		List<Integer> it = new ArrayList<>();
//		it.add(1);
//		it.add(2);
//		it.add(3);
//	 	it.add(4);
//		PersistentParallel6.runAndFinish(it, (aa) -> {
//			if(aa == 1) {
//				{
//					
//
//				}
//			}
//			else if (aa == 2) {
//				{
//					
//
//				}
//			}
//			else if (aa == 3) {
//				{
//					
//
//				}
//			}
//			else if (aa == 4) {
//				{
//					
//
//				}
//			}
//		}
//		, TestClustering.class, true);
//	
//	
//	
//	
////		
////		{
////
////			List<Set<Integer>> result = CorellationClustering2.cc(new ClusterSimilaritiesWrapper(endSimilarities), clusterBelong.keySet() , 0.0, 0, false, true, true );
////
////			Pair<Double, Double> res = getRecallAndPrecision(result, clusterBelong, clusterSize);
//// 
////			
////			ret.add(res);
////
////		}
////		
////		{
////
////			List<Set<Integer>> result = CorellationClustering2.cc(new ClusterSimilaritiesWrapper(endSimilarities), clusterBelong.keySet() , 0.0, 0, true, true, true );
////
////			Pair<Double, Double> res = getRecallAndPrecision(result, clusterBelong, clusterSize);
//// 
////			
////			ret.add(res);
////
////		}
//
//		// {
//		//
//		// Map<Integer, Integer> endMapping = new HashMap<>();
//		//
//		// Map<Integer, Integer> clusterMapping = new HashMap<>();
//		// double threshold =
//		// thresholder.getThresholdDefault(endSimilarities.values().stream().map((e)
//		// -> {
//		// return new ScorableImpl(e);
//		// }).collect(Collectors.toList())) / 100;
//		//
//		// Cluster cluster = splitter.hierarhicalClusters(clusterBelong.size(),
//		// endSimilarities);
//		// List<Cluster> optimum = splitter.optimumClusterSplit(cluster,
//		// endSimilarities, threshold);
//		//
//		// for (ListEntry<Cluster> oCluster : ListIterable.iterable(optimum)) {
//		// Map<Integer, MutableInt> clusterCount = new HashMap<>();
//		// for (Integer end : oCluster.getValue().getAllEnds()) {
//		// CHMHelper.getFromMap(clusterCount, clusterBelong.get(end), () -> new
//		// MutableInt(0)).increment();
//		// }
//		//
//		// Optional<Entry<Integer, MutableInt>> max =
//		// clusterCount.entrySet().stream().max((e1, e2) -> {
//		// return Integer.compare(e1.getValue().intValue(),
//		// e2.getValue().intValue());
//		// });
//		// if (max.isPresent() &&
//		// !clusterMapping.containsValue(max.get().getKey())) {
//		// clusterMapping.put(oCluster.getIndex(), max.get().getKey());
//		// }
//		// }
//		//
//		// for (ListEntry<Cluster> oCluster : ListIterable.iterable(optimum)) {
//		// for (Integer end : oCluster.getValue().getAllEnds()) {
//		// endMapping.put(end, clusterMapping.getOrDefault(oCluster.getIndex(),
//		// -1));
//		// }
//		// }
//		// // System.out.println("ClusterSize " + optimum.size() + "(" +
//		// // Math.abs(optimum.size() - clusters) + ")");
//		//
//		// int correct = 0;
//		// for (Entry<Integer, Integer> entry : clusterBelong.entrySet()) {
//		// if (endMapping.get(entry.getKey()) == entry.getValue()) {
//		// correct++;
//		// }
//		// }
//		//
//		// old = correct / total;
//		// }
//		
//		
//		
//
//		return ret;

	}



	private static Tri<Integer, Map<Integer, Integer>, Map<ClusterEntryKey, Double>> getClusterData(int clusterSize, int caseNumber) {
		
		Map<Integer, Integer> clusterBelong = new HashMap<>();
		Map<Integer, String> names = new HashMap<>();
		ConcurrentHashMap<ClusterEntryKey, Double> endSimilarities = new ConcurrentHashMap<>();

		int clusters = clusterSize;
		int clusterMinSize = 400;
		int clusterMaxSize = 1200;

		double clusterMinSim; 
		List<Double> clusterMaxSim = new ArrayList<>();

		
		double noScoreInCluster ;
		double noScoreOutOfCluster ;
		double highDiffScoreProb ;
		double clusterMinDiff ;
		double clusterMaxDiffNormal;
		double clusterMaxDiff ;
		double minDensity ;
		 
		if(caseNumber == 1) {
			clusterMinSim = 0.4;
			  noScoreInCluster = 0.15;
			  noScoreOutOfCluster = 0.25;
			  highDiffScoreProb = 0.90;
			  clusterMinDiff = -1.0;
			  clusterMaxDiffNormal = -0.4;
			  clusterMaxDiff = 0.2;
			  minDensity = 0.90;
		}
		else if (caseNumber == 2) {
			clusterMinSim = 0.4;
			 noScoreInCluster = 0.30;
			  noScoreOutOfCluster = 0.50;
			  highDiffScoreProb = 0.80;
			  clusterMinDiff = -1.0;
			  clusterMaxDiffNormal = 0.0;
			  clusterMaxDiff = 0.5;
			  minDensity = 0.7;
		}
		else  if (caseNumber == 3)  {
			clusterMinSim = 0.4;
			 noScoreInCluster = 0.5;
			  noScoreOutOfCluster = 0.7;
			  highDiffScoreProb = 0.60;
			  clusterMinDiff = -1.0;
			  clusterMaxDiffNormal = 0.0;
			  clusterMaxDiff = 1.0;
			  minDensity = 0.4;
			  
		} else    {
			clusterMinSim = 0.1;
			 noScoreInCluster = 0.60;
			  noScoreOutOfCluster = 0.80;
			  highDiffScoreProb = 0.50;
			  clusterMinDiff = -1.0;
			  clusterMaxDiffNormal = 0.0;
			  clusterMaxDiff = 1.0;
			  minDensity = 0.2;
			  
		}
		
		Map<Integer, MutableInt> clusterRemainingHighDiffInCluster = new HashMap<>();
		Map<Integer, MutableInt> clusterRemainingNoScoreInCluster = new HashMap<>();
		Map<Integer, MutableInt> clusterRemainingNoScoreOutOfCluster = new HashMap<>();
		Map<Integer, MutableInt> clusterRemainingHighDiffOutOfCluster = new HashMap<>();
		
		for (int i = 0; i < clusters; i++) {
			

 
				
			clusterMaxSim.add(ThreadLocalRandom.current().nextDouble(minDensity, 1.0));

			int size = ThreadLocalRandom.current().nextInt(clusterMinSize, clusterMaxSize + 1);
			

			clusterRemainingNoScoreInCluster.put(i, new MutableInt(size * noScoreInCluster));
			clusterRemainingNoScoreOutOfCluster.put(i, new MutableInt(size * noScoreOutOfCluster));
			clusterRemainingHighDiffInCluster.put(i, new MutableInt(size * (1.0 - highDiffScoreProb)));
			clusterRemainingHighDiffOutOfCluster.put(i, new MutableInt(size * (1.0 - highDiffScoreProb)));

			for (int s = 0; s < size; s++) {
				int index = clusterBelong.size();
				clusterBelong.put(index, i);
				names.put(index, "" + i + "-" + s);
			}
		}
		
		Random random = new Random(12318975982435L);
		
		List<Integer> sortedKeys = new ArrayList<>(clusterBelong.keySet());
		Collections.sort(sortedKeys);
		Collections.shuffle(sortedKeys, random);
		
		PersistentParallel6.runAndFinishWithDefaultBatchSize(DoubleIteraterable.iterable(sortedKeys), (i) -> {
			Integer i1 = i.getFirst();
			Integer i2 = i.getSecond();
			Double sim = null;
			if (clusterBelong.get(i1).equals(clusterBelong.get(i2))) {
				MutableInt noScoreInClusterMutableInt = clusterRemainingNoScoreInCluster.get(clusterBelong.get(i1));
				
				if(noScoreInClusterMutableInt.intValue() > 0) {
					
					noScoreInClusterMutableInt.decrement();
				}
				else {
					MutableInt highDiffInClusterMutableInt = clusterRemainingHighDiffInCluster.get(clusterBelong.get(i1));
					
					if(highDiffInClusterMutableInt.intValue() > 0) {
						sim = ThreadLocalRandom.current().nextDouble(clusterMinDiff, clusterMinSim);
						highDiffInClusterMutableInt.decrement();
					}
					else {
						sim = ThreadLocalRandom.current().nextDouble(clusterMinSim, clusterMaxSim.get(clusterBelong.get(i1)));
					}
				}
				
//				if (ThreadLocalRandom.current().nextDouble(0.0, 1.0) > noScoreInCluster) { 
//					if (ThreadLocalRandom.current().nextDouble(0.0, 1.0) > highDiffScoreProb) {
//						sim = ThreadLocalRandom.current().nextDouble(clusterMinDiff, clusterMinSim);
//				
//					}
//					else {
//						sim = ThreadLocalRandom.current().nextDouble(clusterMinSim, clusterMaxSim.get(clusterBelong.get(i1)));
//						int dfdf =123 ;
//					}
//				}
			} else {
				MutableInt noScoreOutClusterMutableInt1 = clusterRemainingNoScoreOutOfCluster.get(clusterBelong.get(i1));
				MutableInt noScoreOutClusterMutableInt2 = clusterRemainingNoScoreOutOfCluster.get(clusterBelong.get(i2));
				
				
				if(noScoreOutClusterMutableInt1.intValue() > 0 && noScoreOutClusterMutableInt2.intValue() > 0) {
					noScoreOutClusterMutableInt1.decrement();
					noScoreOutClusterMutableInt2.decrement();
				}
				else {
					MutableInt highDiffInClusterMutableInt1 = clusterRemainingHighDiffOutOfCluster.get(clusterBelong.get(i1));
					MutableInt highDiffInClusterMutableInt2 = clusterRemainingHighDiffOutOfCluster.get(clusterBelong.get(i2));
					
					if(highDiffInClusterMutableInt1.intValue() > 0 || highDiffInClusterMutableInt2.intValue() > 0) {
						sim = ThreadLocalRandom.current().nextDouble(clusterMaxDiffNormal, clusterMaxDiff);
						highDiffInClusterMutableInt1.decrement();
						highDiffInClusterMutableInt2.decrement();
					}
					else {
						sim = ThreadLocalRandom.current().nextDouble(clusterMinDiff, clusterMaxDiffNormal);
					}
				}
				
//				if (ThreadLocalRandom.current().nextDouble(0.0, 1.0) > noScoreOutOfCluster) { 
//					if (ThreadLocalRandom.current().nextDouble(0.0, 1.0) > highDiffScoreProb) {
//						sim = ThreadLocalRandom.current().nextDouble(clusterMaxDiffNormal, clusterMaxDiff);
//						if (sim > 0.9) {
//							int sdf = 123;
//						}
//					} else {
//						sim = ThreadLocalRandom.current().nextDouble(clusterMinDiff, clusterMaxDiffNormal);
//					}
//				}
			}
			if(sim != null)
				endSimilarities.put(new ClusterEntryKey(i1, i2), sim);
		} , TestClustering.class);
		
		return new Tri<>(clusterSize, clusterBelong, endSimilarities);
	}



	private static Pair<Double, Double> getRecallAndPrecision(List<Set<Integer>> result, Map<Integer, Integer> clusterBelong, int clusterSize) {
		Map<Integer, Set<Integer>> endMapping = new HashMap<>();

		Map<Integer, Integer> clusterMapping = new HashMap<>();

		for (ListEntry<Set<Integer>> oCluster : ListIterable.iterable(result)) {
			Map<Integer, MutableInt> clusterCount = new HashMap<>();
			for (Integer end : oCluster.getValue()) {
				CHMHelper.getFromMap(clusterCount, clusterBelong.get(end), () -> new MutableInt(0)).increment();
			}

			Optional<Entry<Integer, MutableInt>> max = clusterCount.entrySet().stream().max((e1, e2) -> {
				return Integer.compare(e1.getValue().intValue(), e2.getValue().intValue());
			});
			if (max.isPresent() && !clusterMapping.containsValue(max.get().getKey())) {
				clusterMapping.put(oCluster.getIndex(), max.get().getKey());
			}
		}

		for (ListEntry<Set<Integer>> oCluster : ListIterable.iterable(result)) {
			for (Integer end : oCluster.getValue()) {
				Set<Integer> set = CHMHelper.getFromMap(endMapping, end, () -> new HashSet<>());

				Integer mapping = clusterMapping.get(oCluster.getIndex());
				if (mapping != null) {
					set.add(mapping);
				}
				// endMapping.put(end,
				// clusterMapping.getOrDefault(oCluster.getIndex(), -1));
			}
		}

		System.out.println("ClusterSize " + clusterSize + " : " + result.size() + "(" + Math.abs(result.size() - clusterSize) + ")");

		Map<Integer, MutableInt> clusterCorrect = new HashMap<>();
		Map<Integer, MutableInt> clusterWrong = new HashMap<>();
		Map<Integer, MutableInt> clusterMax = new HashMap<>();
		int correct = 0;
		for (Entry<Integer, Integer> entry : clusterBelong.entrySet()) {
			CHMHelper.getFromMap(clusterMax, entry.getValue(), () -> new MutableInt()).increment();
			CHMHelper.getFromMap(clusterCorrect, entry.getValue(), () -> new MutableInt());
			CHMHelper.getFromMap(clusterWrong, entry.getValue(), () -> new MutableInt());

		}
		for (Entry<Integer, Set<Integer>> entry : endMapping.entrySet()) {
			Integer correctCluster = clusterBelong.get(entry.getKey());
			for (Integer candidate : entry.getValue()) {
				if (candidate == correctCluster) {
					CHMHelper.getFromMap(clusterCorrect, candidate, () -> new MutableInt()).increment();
				} else {
					CHMHelper.getFromMap(clusterWrong, candidate, () -> new MutableInt()).increment();
				}
			}
		}

		for (ListEntry<Set<Integer>> oCluster : ListIterable.iterable(result)) {
			if (!clusterMapping.containsKey(oCluster.getIndex())) {
				int index = clusterWrong.size();
				clusterCorrect.put(index, new MutableInt());
				// clusterMax.put(index, new MutableInt());
				clusterWrong.put(index, new MutableInt(oCluster.getValue().size()));
			}
		}

		double thirdPrecision = clusterWrong.keySet().stream().map((e) -> {
			double num = ((double) clusterCorrect.get(e).intValue()) / (clusterCorrect.get(e).intValue() + clusterWrong.get(e).intValue());
			if (Double.isNaN(num)) {
				return 0.0;
			} else {
				return ((double) clusterCorrect.get(e).intValue()) / (clusterCorrect.get(e).intValue() + clusterWrong.get(e).intValue());
			}
		}).mapToDouble(Double::doubleValue).average().getAsDouble();
		double thirdRecall = clusterMax.keySet().stream().map((e) -> {
			return ((double) clusterCorrect.get(e).intValue()) / (clusterMax.get(e).intValue());
		}).mapToDouble(Double::doubleValue).average().getAsDouble();
		
		
		return new Pair<>(thirdPrecision, thirdRecall);
		
	}

	public static class ScorableImpl implements Scorable {
		private final double score;

		private ScorableImpl(double score) {
			super();
			this.score = score;
		}

		@Override
		public Double getScore() {
			return score;
		}

	}

	public static class ClusterSimilaritiesWrapper implements ClusterSimilarities {
		private final Map<ClusterEntryKey, Double> simMap;
		private final Map<Integer, Set<Integer>> index;

		private ClusterSimilaritiesWrapper(Map<ClusterEntryKey, Double> simMap) {
			super();
			this.simMap = simMap;
			ConcurrentHashMap<Integer, Set<Integer>> index = new ConcurrentHashMap<>();

			PersistentParallel6.runAndFinish(simMap.keySet(), (e) -> {
				CHMHelper.getFromCHM(index, e.getE1(), () -> Collections.newSetFromMap(new ConcurrentHashMap<>())).add(e.getE2());
				CHMHelper.getFromCHM(index, e.getE2(), () -> Collections.newSetFromMap(new ConcurrentHashMap<>())).add(e.getE1());

			} , this.getClass());
			this.index = index;
		}

		@Override
		public double get(ClusterEntryKey key) {
			return simMap.getOrDefault(key, 0.0);
		}

		@Override
		public Set<Integer> regionQuery(Integer point, double eps) {
			Set<Integer> ret = new HashSet<>();

			for (Integer candidate : index.get(point)) {
				double sim = simMap.get(new ClusterEntryKey(point, candidate));
				// System.out.println(sim);
				double threshold = (1.0 - eps);
				if (sim > threshold) {
					ret.add(candidate);
				}
			}

			return ret;
		}

	}

}
