package expansion.set.strategies.rowclusterers;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import java.util.concurrent.atomic.AtomicInteger;

import expansion.set.strategies.rowclusterers.label.TfIdfBlockCreator;

public class TfIdfHierarchyCreator {
	public static void main(String[] args) {
		Map<Integer, String> names = new HashMap<>();
		Map<Integer, Set<Integer>> parentMap = new HashMap<>();
		
		
		createHierarchy(new AtomicInteger(), names, parentMap, new HashSet<>(), 0, 3, 3, "Cluster");
		
		Map<Integer, Integer> hierarchy = TfIdfBlockCreator.createHierarchy(names.keySet(), parentMap);
		
		for(Entry<Integer, Integer> entry : hierarchy.entrySet()) {
			System.out.println(names.get(entry.getKey()) + ", Result: " + entry.getValue());
		}
		
		System.out.println("Total in Hierarchy: " + hierarchy.size());
		System.out.println("Total in Input: " + names.size());
	}

	private static void createHierarchy(AtomicInteger counter, Map<Integer, String> names, Map<Integer, Set<Integer>> parentMap, Set<Integer> parents, int currentDepth, int maxDepth, int maxWidth, String prefix) {
		if(currentDepth == maxDepth) {
			return;
		}
		
		for(int i = 0; i < maxWidth; i++) {
			int key = counter.getAndIncrement();
			String newPrefix = prefix + "_" + i;
			names.put(key, "" + currentDepth + ": " + newPrefix);
			parentMap.put(key, parents);
			Set<Integer> newParents = new HashSet<>(parents);
			newParents.add(key);
			createHierarchy(counter, names, parentMap, newParents, currentDepth + 1, maxDepth, maxWidth, newPrefix);
			
			
			
		}
		
	}
}
