package de.mannheim.uni.expansion.tablefusion.core.similarity;

import de.mannheim.uni.expansion.data.ontology.model.ClassPropertyId;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;

public interface SimilarityMeasure {

	public double get(AbstractObject a, AbstractObject b);

	public default double get(ClassPropertyId propertyId, AbstractObject a, AbstractObject b) {
		return get(a, b);
	}

	public double getQuickSimilarity(AbstractObject a, AbstractObject b);

	public double getEquivalenceThreshold();

	public boolean isEqual(AbstractObject a, AbstractObject b);

	public default boolean isEqual(ClassPropertyId propertyId, AbstractObject a, AbstractObject b) {
		return isEqual(a, b);
	}
}
