package de.mannheim.uni.expansion.tablefusion.core.similarity.measures;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.similarity.AbstractSimilarity;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.BooleanObject;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.ValueType;

public class BooleanSimilarity extends AbstractSimilarity {

	@Inject
	public BooleanSimilarity() {
		super();
	}

	@Override
	public double normalSimilarity(AbstractObject a, AbstractObject b) {
		if (a == null || b == null) {
			return 0.0;
		} else if (!(a instanceof BooleanObject) || !(b instanceof BooleanObject)) {
			return 0.0;
		} else {
			boolean v1 = ((BooleanObject) a).getValue();
			boolean v2 = ((BooleanObject) b).getValue();

			if (v1 == v2)
				return 1.0;
			else
				return 0.0;
		}
	}

	@Override
	public double getQuickSimilarity(AbstractObject a, AbstractObject b) {
		return normalSimilarity(a, b);
	}

	@Override
	protected ValueType getColumnDataType() {
		return ValueType.BOOLEAN;
	}

	@Override
	public double getEquivalenceThreshold() {
		return 0.5;
	}
}
