package de.mannheim.uni.expansion.tablefusion.core.similarity.measures;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.similarity.AbstractSimilarity;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.ValueType;

public class CategoricalIntSimilarity extends AbstractSimilarity {

	@Inject
	public CategoricalIntSimilarity() {

	}

	@Override
	public double getQuickSimilarity(AbstractObject a, AbstractObject b) {
		return normalSimilarity(a, b);
	}

	@Override
	public double getEquivalenceThreshold() {
		return 0.99;
	}

	@Override
	protected double normalSimilarity(AbstractObject a, AbstractObject b) {

		// FIXME: DO Nullcheck somewhere else
		if (a == null || b == null) {
			return 0.0;
		} else if (a.equals(b)) {
			return 1.0;
		}

		return 0.0;
	}

	@Override
	protected ValueType getColumnDataType() {
		return ValueType.CATEGORICAL_INT;
	}

}
