package de.mannheim.uni.expansion.tablefusion.core.similarity.stopwords;

import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.apache.commons.lang3.StringUtils;

import de.uni_mannheim.informatik.dws.t2k.normalisation.StringNormalizer;

public class StopWordsRepository {

	private final Set<String> stopWords;

	public StopWordsRepository(Set<String> stopWords) {
		super();
		this.stopWords = Collections.unmodifiableSet(new HashSet<>(stopWords));
	}

	public Set<String> getStopWords(String file) {
		return stopWords;
	}

	public boolean isStopWord(String token) {
		return stopWords.contains(token);
	}

	public String removeStopWords(String string) {
		List<String> tokenized = StringNormalizer.tokenise(string, false, false);

		for (Iterator<String> it = tokenized.iterator(); it.hasNext();) {
			if (stopWords.contains(it.next())) {
				it.remove();
			}
		}

		return StringUtils.join(tokenized, " ");

	}

}
