package de.mannheim.uni.expansion.tablefusion.core.similarity.thresholds;

import java.util.EnumMap;
import java.util.Map;
import java.util.Map.Entry;

public class SimilarityThresholdsRepositoryImpl implements SimilarityThresholdsRepository {

	private final Map<SimilarityMeasures, Double> thresholds = new EnumMap<>(SimilarityMeasures.class);

	public SimilarityThresholdsRepositoryImpl()

	{
	}

	public SimilarityThresholdsRepositoryImpl(Map<SimilarityMeasures, Double> thresholds) {
		setThresholds(thresholds);
	}

	public void setThresholds(Map<SimilarityMeasures, Double> thresholds) {
		for (Entry<SimilarityMeasures, Double> e : thresholds.entrySet()) {
			this.thresholds.put(e.getKey(), e.getValue());
		}
	}

	@Override
	public SimilarityThreshold get(final SimilarityMeasures cdt) {
		return new SimilarityThreshold() {

			@Override
			public double get() {
				return thresholds.get(cdt);
			}
		};
	}

}
