package de.mannheim.uni.expansion.tablefusion.modules;

import java.io.IOException;

import org.apache.uima.resource.ResourceInitializationException;
import org.apache.uima.util.InvalidXMLException;

import dagger.Module;
import dagger.Provides;
import de.mannheim.uni.expansion.utils.timestamps.HeidelTimeWrapper;

@Module(library = true)
public class HeidelTimeModule {

	private final String heidelTimeConfigPath;

	public HeidelTimeModule(String heidelTimeConfigPath) {
		super();
		this.heidelTimeConfigPath = heidelTimeConfigPath;
	}

	@Provides
	HeidelTimeWrapper getHeidelTimeWrapper() {
		if (heidelTimeConfigPath == null)
			return null;
		try {
			return new HeidelTimeWrapper(heidelTimeConfigPath);
		} catch (ResourceInitializationException | InvalidXMLException | IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return null;
		}
	}
}
