package de.mannheim.uni.expansion.tablefusion.modules;

import javax.inject.Named;
import javax.inject.Singleton;

import dagger.Module;
import dagger.Provides;
import de.mannheim.uni.expansion.data.tables.repository.AnnotatedTablesRepository;
import de.mannheim.uni.expansion.tablefusion.NamedProperties;
import de.mannheim.uni.expansion.tablefusion.adapters.ranking.RankCSVAdapter;
import de.mannheim.uni.expansion.tablefusion.adapters.ranking.RankRepository;
import de.mannheim.uni.expansion.tablefusion.adapters.ranking.RankRepositoryImpl;

@Module(library = true, complete = false)
public class RankingModule {

	private final String hostRankingsFile;
	private final String hostRankingsFileFiltered;

	public RankingModule(String hostRankingsFile, String hostRankingsFileFiltered) {
		super();
		this.hostRankingsFile = hostRankingsFile;
		this.hostRankingsFileFiltered = hostRankingsFileFiltered;
	}

	@Provides
	@Named(NamedProperties.HOST_RANKINGS_FILE)
	public String getHostRankingsFile() {
		return this.hostRankingsFile;
	}

	@Provides
	@Named(NamedProperties.HOST_RANKINGS_FILE_FILTERED)
	public String getHostRankingsFileFiltered() {
		return this.hostRankingsFileFiltered;
	}

	@Provides
	@Singleton
	RankRepository loadRankRankings(RankCSVAdapter rankCSVAdapter, @Named(NamedProperties.HOST_RANKINGS_FILE_FILTERED) String filteredRankingFile,
			AnnotatedTablesRepository annotatedTablesRepository) {

		return new RankRepositoryImpl(rankCSVAdapter, filteredRankingFile, annotatedTablesRepository);

	}

}
