package de.mannheim.uni.expansion.tablefusion.modules;

import java.io.IOException;

import javax.inject.Named;
import javax.inject.Singleton;

import dagger.Module;
import dagger.Provides;
import de.mannheim.uni.expansion.tablefusion.NamedProperties;
import de.mannheim.uni.expansion.tablefusion.adapters.regressionweights.RegressionWeightsReader;
import de.mannheim.uni.expansion.tablefusion.adapters.regressionweights.RegressionWeightsRepository;

@Module(library = true)
public class RegressionModule {

	private final String scoresFolder;
	private final String weightsFolder;

	public RegressionModule(String scoresFolder, String weightsFolder) {
		super();
		this.scoresFolder = scoresFolder;
		this.weightsFolder = weightsFolder;
	}

	@Provides
	@Named(NamedProperties.SCORES_FOLDER)
	String getScoresFolder() {
		return this.scoresFolder;
	}

	@Provides
	@Named(NamedProperties.WEIGHTS_FOLDER)
	String getWeightsFolder() {
		return this.weightsFolder;
	}

	@Provides
	@Singleton
	RegressionWeightsRepository getRegressionWeightsRepository(RegressionWeightsReader RegressionWeightsReader) {
		try {
			return RegressionWeightsReader.read();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();

			return null;
		}
	}

}
