package de.mannheim.uni.expansion.tablefusion.adapters.regressionweights;

import java.util.Collections;
import java.util.Map;

import de.mannheim.uni.expansion.data.ontology.model.ClassPropertyId;

public class RegressionWeights {

	private final RegressionWeightsContainer generalWeight;
	private final Map<ClassPropertyId, RegressionWeightsContainer> weights;

	public RegressionWeights(RegressionWeightsContainer generalWeight, Map<ClassPropertyId, RegressionWeightsContainer> weights) {
		this.generalWeight = generalWeight;
		this.weights = Collections.unmodifiableMap(weights);
	}

	public RegressionWeightsContainer getGeneralWeights() {
		return generalWeight;
	}

	public RegressionWeightsContainer getWeights(ClassPropertyId classPropertyId) {
		return weights.get(classPropertyId);
	}

	public Map<ClassPropertyId, RegressionWeightsContainer> getAllWeights() {
		return weights;
	}

}
