package de.mannheim.uni.expansion.tablefusion.analysis.stores;

import java.util.Collections;
import java.util.EnumMap;
import java.util.Map;

import de.mannheim.uni.expansion.data.ontology.model.ClassPropertyId;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.tableprocessor.model.TableColumn.ColumnDataType;

public class FusionResults {
	private final FusedResults total;
	private final Map<ColumnDataType, FusedResults> perDataType;
	private final Map<ClassId, FusedResults> perClassId;
	private final Map<ClassPropertyId, FusedResults> perProperty;

	public FusionResults(FusedResults total, Map<ColumnDataType, FusedResults> perDataType, Map<ClassId, FusedResults> perClassId,
			Map<ClassPropertyId, FusedResults> perProperty) {
		super();
		this.total = total;
		Map<ColumnDataType, FusedResults> perDataTypeTemp = new EnumMap<>(ColumnDataType.class);
		perDataTypeTemp.putAll(perDataType);
		this.perDataType = Collections.unmodifiableMap(perDataTypeTemp);
		this.perClassId = Collections.unmodifiableMap(perClassId);
		this.perProperty = Collections.unmodifiableMap(perProperty);
	}

	public FusedResults getTotal() {
		return total;
	}

	public Map<ClassPropertyId, FusedResults> getPerProperty() {
		return perProperty;
	}

	public Map<ColumnDataType, FusedResults> getPerDataType() {
		return perDataType;
	}

	public Map<ClassId, FusedResults> getPerClassId() {
		return perClassId;
	}

}