package de.mannheim.uni.expansion.tablefusion.analysis.stores;

import java.util.List;

import de.mannheim.uni.expansion.tablefusion.analysis.stores.performance.PERFMPerformanceI;

public class PRFMPerformance implements PERFMPerformanceI {
	private final double precision;
	private final double recall;
	private final double fMeasure;

	public PRFMPerformance(List<PerformancePR> list) {
		double precisionSum = 0.0;
		double recallSum = 0.0;
		double fMeasureSum = 0.0;

		int count = 0;

		for (PerformancePR p : list) {
			precisionSum += p.getPrecision();
			recallSum += p.getRecall();
			fMeasureSum += p.getfMeasure();
			count++;
		}

		this.precision = precisionSum / count;
		this.recall = recallSum / count;
		this.fMeasure = fMeasureSum / count;

	}

	public PRFMPerformance(double precision, double recall, double fMeasure) {
		this.precision = precision;
		this.recall = recall;
		this.fMeasure = fMeasure;
	}

	public double getPrecision() {
		return precision;
	}

	public double getRecall() {
		return recall;
	}

	public double getfMeasure() {
		return fMeasure;
	}

	@Override
	public String toString() {
		return "PRFMPerformance [precision=" + precision + ", recall=" + recall + ", fMeasure=" + fMeasure + "]";
	}

}
