package de.mannheim.uni.expansion.tablefusion.analysis.stores;

import de.mannheim.uni.expansion.tablefusion.analysis.Accuracy;

public class PrecisionPerformance {
	private final int correct;
	private final int wrong;
	private final int maxCorrect;

	private final double precision;

	private final int newTriples;

	public PrecisionPerformance(int correct, int wrong, int newTriples) {

		this.correct = correct;
		this.wrong = wrong;
		this.precision = ((double) correct) / (correct + wrong);

		this.maxCorrect = 0;

		this.newTriples = newTriples;

	}

	public int getCorrect() {
		return correct;
	}

	public int getWrong() {
		return wrong;
	}

	public int getOverlapping() {
		return wrong + correct;
	}

	public int getMaxCorrect() {
		return maxCorrect;
	}

	public double getPrecision() {
		return precision;
	}

	public int getNew() {
		return this.newTriples;
	}

	public int getTotal() {
		return wrong + correct + newTriples;
	}

	public Accuracy getAccuracy() {
		return new Accuracy(this.precision, this.getOverlapping());
	}

	@Override
	public String toString() {
		return "PrecisionPerformance [correct=" + correct + ", wrong=" + wrong + ", maxCorrect=" + maxCorrect + ", precision=" + precision + ", newTriples="
				+ newTriples + "]";
	}

}
