package de.mannheim.uni.expansion.tablefusion.analysis.stores;

import java.util.EnumMap;
import java.util.Map;

import de.mannheim.uni.expansion.tablefusion.core.similarity.Similarity.SimilarityType;

public class SynchronizedFusionResultsCreator {

	Map<SimilarityType, FusedResultsSingle> map = new EnumMap<>(SimilarityType.class);

	public SynchronizedFusionResultsCreator()

	{
		for (SimilarityType type : SimilarityType.values()) {
			map.put(type, new FusedResultsSingle());
		}
	}

	public void incCorrect(SimilarityType type) {
		this.map.get(type).incCorrect();
	}

	public void incWrong(SimilarityType type) {
		this.map.get(type).incWrong();
	}

	public void incNew(SimilarityType type) {
		this.map.get(type).incNew();
	}
}
