package de.mannheim.uni.expansion.tablefusion.analysis.writer.generic;

import java.util.function.Function;

import de.mannheim.uni.expansion.data.ontology.model.repository.OntologyRepository;
import de.uni_mannheim.informatik.dws.expansion.model.utils.performance.FusionPerformance;
import de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulators.AccumRepository;
import de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulators.ColumnList;
import de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulators.GenericAccumaltableResult;

public class GenericResultsWriterAccumRepository extends GenericResultsWriter<AccumRepository> {

	public GenericResultsWriterAccumRepository(ColumnList<AccumRepository> columnList) {
		super(columnList);
	}

	private final Function<GenericAccumaltableResult, AccumRepository> converter = (p) -> {
		return p.getAcummulatorRepository();
	};

	public void writeTotalAccumRepository(String name, FusionPerformance<GenericAccumaltableResult> performance) {
		super.writeTotal(name, performance, converter);
	}

	public void writeClassIdAccumRepository(String name, FusionPerformance<GenericAccumaltableResult> performance) {
		super.writeClassId(name, performance, converter);
	}

	// public void writeClassIdAndSet(String name,
	// FusionPerformance<GenericAccumaltableResult> performance) {
	// for (Entry<Pair<ClassId, String>, GenericAccumaltableResult> e :
	// performance.getPerClassAndSet().entrySet()) {
	// String[] prefix = ResultsCategory.getClassIdAndSetPrefix(name,
	// e.getKey().getFirst(), e.getKey().getSecond());
	// write(ResultsCategory.CLASS_ID_AND_SET, prefix, e.getValue());
	// }
	// }

	public void writeAccumRepository(String name, OntologyRepository ontologyRepository, FusionPerformance<GenericAccumaltableResult> performance) {
		super.write(name, ontologyRepository, performance, (p) -> {
			return p.getAcummulatorRepository();
		});

	}

}
