package de.mannheim.uni.expansion.tablefusion.core.matching;

import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import java.util.UUID;

import com.fasterxml.uuid.Generators;

import de.mannheim.uni.expansion.data.ontology.model.TripleIdContainer;

public abstract class AbstractGroupledValues<E extends TripleIdContainer> {
	private final UUID uuid = Generators.timeBasedGenerator().generate();

	public abstract Set<Entry<E, MatchedValues>> entrySet();

	public abstract Set<E> keySet();

	public UUID getUUID() {
		return uuid;
	}

	public abstract MatchedValues get(E tripleId);

	public abstract int size();

	public abstract Map<E, MatchedValues> getValues();

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((uuid == null) ? 0 : uuid.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		AbstractGroupledValues other = (AbstractGroupledValues) obj;
		if (uuid == null) {
			if (other.uuid != null)
				return false;
		} else if (!uuid.equals(other.uuid))
			return false;
		return true;
	}

}
