package de.mannheim.uni.expansion.tablefusion.core.matching;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;
import java.util.concurrent.ConcurrentHashMap;

import de.mannheim.uni.expansion.data.ontology.model.TripleIdContainer;
import de.mannheim.uni.expansion.tablefusion.core.matching.MatchedValues.SingleValue;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.ValueType;

public class SynchronizedMatchedValuesMapMerger<E extends TripleIdContainer> {

	final ConcurrentHashMap<E, MatchedValues> map = new ConcurrentHashMap<E, MatchedValues>();

	public void merge(Map<E, MatchedValues> m2) {

		for (Entry<E, MatchedValues> e : m2.entrySet()) {

			E mid = e.getKey();
			SynchronizedMatchedValuesCreator smvc = getMatchedValues(mid, e.getValue().getDataType());
			smvc.addSynchronized(e.getValue());

		}

	}

	public void merge(E tid, MatchedValues mv) {

		SynchronizedMatchedValuesCreator smvc = getMatchedValues(tid, mv.getDataType());
		smvc.addSynchronized(mv);

	}

	public SynchronizedMatchedValuesCreator getMatchedValues(E mid, ValueType columnDataType) {

		if (!map.containsKey(mid)) {
			SynchronizedMatchedValuesCreator smvc = new SynchronizedMatchedValuesCreator(columnDataType);

			SynchronizedMatchedValuesCreator previous = (SynchronizedMatchedValuesCreator) map.putIfAbsent(mid, smvc);
			if (previous == null) {
				return smvc;
			} else {
				return previous;
			}

		} else {
			return (SynchronizedMatchedValuesCreator) map.get(mid);
		}

	}

	public Map<E, MatchedValues> getMap() {

		return map;
	}

	public Map<E, MatchedValues> getCleanMap() {

		Map<E, MatchedValues> returnMap = new HashMap<>();
		for (Entry<E, MatchedValues> e : map.entrySet()) {
			returnMap.put(e.getKey(), new MatchedValues(e.getValue()));
		}
		return returnMap;
	}

	public void merge(E tid, SingleValue singleValue, ValueType dataType) {
		SynchronizedMatchedValuesCreator smvc = getMatchedValues(tid, dataType);
		smvc.addSynchronized(singleValue);

	}
}
