package de.mannheim.uni.expansion.tablefusion.core.scoring.packs;

import java.util.Collections;
import java.util.Map;

import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.data.tables.model.ColumnIdx;
import de.mannheim.uni.expansion.data.tables.model.RowIdx;
import de.mannheim.uni.expansion.data.tables.model.TableColumnId;
import de.mannheim.uni.expansion.tablefusion.core.scoring.Probability;

public class CellScoresByTableColumn implements TableScores {

	private final Map<TableColumnId, Probability> scores;

	public CellScoresByTableColumn(Map<TableColumnId, Probability> scores) {
		this.scores = Collections.unmodifiableMap(scores);
	}

	@Override
	public boolean containsKey(AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx) {
		return scores.containsKey(new TableColumnId(tableId, columnIdx));
	}

	@Override
	public Probability get(AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx) {
		return scores.get(new TableColumnId(tableId, columnIdx));
	}

}
