package de.mannheim.uni.expansion.tablefusion.core.scoring.packs;

import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.data.tables.model.ColumnIdx;
import de.mannheim.uni.expansion.data.tables.model.RowIdx;
import de.mannheim.uni.expansion.tablefusion.core.scoring.Probability;

public class FixedTableScores implements TableScores {

	private final Probability score;

	public FixedTableScores(Probability score) {
		this.score = score;
	}

	@Override
	public Probability get(AnnotatedTableId tabledId, ColumnIdx columnIdx, RowIdx rowIdx) {
		return score;
	}

	@Override
	public boolean containsKey(AnnotatedTableId tabledId, ColumnIdx columnIdx, RowIdx rowIdx) {
		return true;
	}

}
