package de.mannheim.uni.expansion.tablefusion.core.scoring.packs;

import java.util.Map;
import java.util.Map.Entry;
import java.util.concurrent.ConcurrentHashMap;

import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.data.tables.model.ColumnIdx;
import de.mannheim.uni.expansion.data.tables.model.RowIdx;
import de.mannheim.uni.expansion.tablefusion.core.scoring.Probability;
import de.mannheim.uni.expansion.utils.CHMHelper;
import de.mannheim.uni.expansion.utils.CHMHelper.Creator;
import de.mannheim.uni.expansion.utils.PersistentParallel;

@Deprecated
public class InstanceScores implements ScoresContainer {

	private final Map<InstanceId, Map<AnnotatedTableId, Probability>> scores;

	public InstanceScores(Map<InstanceId, Map<AnnotatedTableId, Probability>> scores) {
		this.scores = scores;
	}

	@Override
	public TableScoresImpl getTableScores(ClassId classId, PropertyId propertyId, InstanceId instanceId) {
		return null;
	}

	private Creator<Map<InstanceId, Probability>> creator = () -> {
		return new ConcurrentHashMap<>();
	};

	public Map<AnnotatedTableId, Map<InstanceId, Probability>> getByTable() {
		ConcurrentHashMap<AnnotatedTableId, Map<InstanceId, Probability>> map = new ConcurrentHashMap<>();

		PersistentParallel.runAndFinish(scores.entrySet(), (e) -> {

			for (Entry<AnnotatedTableId, Probability> innerEntry : e.getValue().entrySet()) {
				Map<InstanceId, Probability> nestedMap = CHMHelper.getFromCHM(map, innerEntry.getKey(), creator);
				nestedMap.put(e.getKey(), innerEntry.getValue());
			}

		} , "getByTable");

		return map;
	}

	@Override
	public Probability getScore(ClassId classId, PropertyId propertyId, InstanceId instanceId, AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx) {
		return this.scores.get(instanceId).get(tableId);
	}

	@Override
	public boolean containsKey(ClassId classId, PropertyId propertyId, InstanceId instanceId, AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx) {
		// TODO Auto-generated method stub
		return false;
	}

}
