package de.mannheim.uni.expansion.tablefusion.core.scoring.packs;

import java.util.Map;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.AbstractQualifier;
import de.mannheim.uni.expansion.data.ontology.model.QualifiedPropertyId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.data.tables.model.CellId;
import de.mannheim.uni.expansion.data.tables.model.ColumnIdx;
import de.mannheim.uni.expansion.data.tables.model.RowIdx;
import de.mannheim.uni.expansion.data.tables.model.TableColumnId;
import de.mannheim.uni.expansion.tablefusion.core.scoring.Probability;

public class QualifiedColumnTableScores implements TableScores {

	private final PropertyId propertyId;
	private final Map<TableColumnId, Map<QualifiedPropertyId, Probability>> map;

	public QualifiedColumnTableScores(PropertyId propertyId, Map<TableColumnId, Map<QualifiedPropertyId, Probability>> map) {
		this.map = map;
		this.propertyId = propertyId;
	}

	@Override
	public Probability get(AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx) {
		throw new IllegalStateException();
	}

	@Override
	public boolean containsKey(AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx) {
		throw new IllegalStateException();
	}

	@Override
	public Probability get(CellId cellId, Set<AbstractQualifier> qualifiers) {
		if (containsKey(cellId, qualifiers)) {
			return this.map.get(new TableColumnId(cellId)).get(new QualifiedPropertyId(propertyId, qualifiers));
		}

		return null;
	}

	@Override
	public boolean containsKey(CellId cellId, Set<AbstractQualifier> qualifiers) {
		Map<QualifiedPropertyId, Probability> innerMap = this.map.get(new TableColumnId(cellId));
		if (innerMap != null) {
			if (innerMap.containsKey(new QualifiedPropertyId(propertyId, qualifiers))) {
				return true;
			}
		}

		return false;
	}

}
