package de.mannheim.uni.expansion.tablefusion.core.scoring.packs;

import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.AbstractQualifier;
import de.mannheim.uni.expansion.data.ontology.model.TripleId;
import de.mannheim.uni.expansion.data.ontology.model.classes.ClassId;
import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.data.tables.model.CellId;
import de.mannheim.uni.expansion.data.tables.model.ColumnIdx;
import de.mannheim.uni.expansion.data.tables.model.RowIdx;
import de.mannheim.uni.expansion.tablefusion.core.scoring.Probability;

public interface ScoresContainer {

	public TableScores getTableScores(ClassId classId, PropertyId propertyId, InstanceId instanceId);
	//
	// @Deprecated
	// public default Probability getScore(ClassId classId, PropertyId
	// propertyId, InstanceId instanceId, AnnotatedTableId tableId, ColumnIdx
	// columnIdx,
	// RowIdx rowIdx, Qualifier qualifier) {
	// return getScore(classId, propertyId, instanceId, tableId, columnIdx,
	// rowIdx);
	// }
	//
	// @Deprecated
	// public default Probability getScore(ClassId classId, PropertyId
	// propertyId, InstanceId instanceId, CellId cellId, Qualifier qualifier) {
	// return getScore(classId, propertyId, instanceId, cellId.getTableId(),
	// cellId.getColumnIdx(), cellId.getRowIdx(), qualifier);
	// }

	@Deprecated
	public Probability getScore(ClassId classId, PropertyId propertyId, InstanceId instanceId, AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx);

	@Deprecated
	public default Probability getScore(ClassId classId, PropertyId propertyId, InstanceId instanceId, CellId cellId) {
		return getScore(classId, propertyId, instanceId, cellId.getTableId(), cellId.getColumnIdx(), cellId.getRowIdx());
	}

	@Deprecated
	public boolean containsKey(ClassId classId, PropertyId propertyId, InstanceId instanceId, AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx);

	// @Deprecated
	// default public boolean containsKey(ClassId classId, PropertyId
	// propertyId, InstanceId instanceId, AnnotatedTableId tableId, ColumnIdx
	// columnIdx,
	// RowIdx rowIdx, Qualifier qualifier) {
	// return containsKey(classId, propertyId, instanceId, tableId, columnIdx,
	// rowIdx);
	// }

	@Deprecated
	public default boolean containsKey(ClassId classId, PropertyId propertyId, InstanceId instanceId, CellId cellId) {
		return containsKey(classId, propertyId, instanceId, cellId.getTableId(), cellId.getColumnIdx(), cellId.getRowIdx());
	}

	public default Probability getScore(TripleId tripleId, CellId cellId, Set<AbstractQualifier> qualifiers) {
		return getScore(tripleId.getClassId(), tripleId.getPropertyId(), tripleId.getInstanceId(), cellId.getTableId(), cellId.getColumnIdx(),
				cellId.getRowIdx());
	}

	public default boolean containsKey(TripleId tripleId, CellId cellId, Set<AbstractQualifier> qualifiers) {
		return containsKey(tripleId.getClassId(), tripleId.getPropertyId(), tripleId.getInstanceId(), cellId.getTableId(), cellId.getColumnIdx(),
				cellId.getRowIdx());
	}
}
