package de.mannheim.uni.expansion.tablefusion.core.scoring.packs;

import java.util.HashMap;
import java.util.Map;

import de.mannheim.uni.expansion.data.tables.model.CellIdx;
import de.mannheim.uni.expansion.tablefusion.core.scoring.Probability;

public class SingleTableScores {

	private Map<CellIdx, Probability> scores;

	public SingleTableScores(Map<CellIdx, Probability> scores) {
		super();
		this.scores = new HashMap<>(scores);
	}

	public boolean containsKey(int columnIdx, int instanceIdx) {
		return scores.containsKey(new CellIdx(columnIdx, instanceIdx));
	}

	public Probability getScore(int columnIdx, int instanceIdx) {
		return scores.get(new CellIdx(columnIdx, instanceIdx));
	}
}
