package de.mannheim.uni.expansion.tablefusion.core.scoring.packs;

import java.util.Collections;
import java.util.Map;

import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.data.tables.model.CellId;
import de.mannheim.uni.expansion.data.tables.model.ColumnIdx;
import de.mannheim.uni.expansion.data.tables.model.RowIdx;
import de.mannheim.uni.expansion.tablefusion.core.scoring.Probability;

public class TableScoresImpl implements TableScores {

	private final Map<CellId, Probability> scores;

	public TableScoresImpl(Map<CellId, Probability> scores) {
		this.scores = Collections.unmodifiableMap(scores);
	}

	@Override
	public boolean containsKey(AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx) {
		return scores.containsKey(new CellId(tableId, columnIdx, rowIdx));
	}

	@Override
	public Probability get(AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx) {
		return scores.get(new CellId(tableId, columnIdx, rowIdx));
	}

}
