package de.mannheim.uni.expansion.tablefusion.core.scoring.packs.cellscores;

import java.util.Map;

import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.data.tables.model.ColumnIdx;
import de.mannheim.uni.expansion.data.tables.model.HostId;
import de.mannheim.uni.expansion.data.tables.model.RowIdx;
import de.mannheim.uni.expansion.tablefusion.core.scoring.Probability;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.TableScores;

public class CellScoresByHost implements TableScores {
	private final Map<HostId, Probability> scores;

	private Map<AnnotatedTableId, HostId> mappings;

	public CellScoresByHost(Map<HostId, Probability> scores, Map<AnnotatedTableId, HostId> mappings) {
		this.scores = scores;
		this.mappings = mappings;
	}

	@Override
	public Probability get(AnnotatedTableId tabledId, ColumnIdx columnIdx, RowIdx rowIdx) {
		HostId hostId = mappings.get(tabledId);
		if (hostId != null)
			return scores.get(hostId);
		else
			return null;
	}

	@Override
	public boolean containsKey(AnnotatedTableId tabledId, ColumnIdx columnIdx, RowIdx rowIdx) {
		HostId hostId = mappings.get(tabledId);
		if (hostId != null)
			return scores.containsKey(hostId);
		else
			return false;
	}

}
