package de.mannheim.uni.expansion.tablefusion.core.scoring.packs.cellscores;

import java.util.Map;

import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableId;
import de.mannheim.uni.expansion.data.tables.model.ColumnIdx;
import de.mannheim.uni.expansion.data.tables.model.RowIdx;
import de.mannheim.uni.expansion.tablefusion.core.scoring.Probability;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.TableScores;

public class CellScoresByTable implements TableScores {
	private Map<AnnotatedTableId, Probability> scores;

	public CellScoresByTable(Map<AnnotatedTableId, Probability> scores) {
		this.scores = scores;
	}

	@Override
	public Probability get(AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx) {
		return scores.get(tableId);
	}

	@Override
	public boolean containsKey(AnnotatedTableId tableId, ColumnIdx columnIdx, RowIdx rowIdx) {
		return scores.containsKey(tableId);
	}

}
