package de.mannheim.uni.expansion.tablefusion.core.splitting;

import java.util.Collections;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;

import de.mannheim.uni.expansion.data.ontology.model.QualifiedTripleId;
import de.mannheim.uni.expansion.tablefusion.core.matching.AbstractGroupledValues;
import de.mannheim.uni.expansion.tablefusion.core.matching.MatchedValues;

public class SplitGroupedValues extends AbstractGroupledValues<QualifiedTripleId> {
	private final Map<QualifiedTripleId, MatchedValues> values;

	public SplitGroupedValues(Map<QualifiedTripleId, MatchedValues> groupedValues) {
		this.values = Collections.unmodifiableMap(groupedValues);
	}

	public Set<Entry<QualifiedTripleId, MatchedValues>> entrySet() {
		return values.entrySet();
	}

	public MatchedValues get(QualifiedTripleId tripleId) {
		return values.get(tripleId);
	}

	public boolean containsKey(QualifiedTripleId tripleId) {
		return values.containsKey(tripleId);
	}

	public int size() {
		return values.size();
	}

	public Map<QualifiedTripleId, MatchedValues> getValues() {
		return values;
	}

	@Override
	public Set<QualifiedTripleId> keySet() {
		return values.keySet();
	}

}
