package de.mannheim.uni.expansion.tablefusion.core.splitting;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.tables.repository.AnnotatedTablesRepository;
import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.TimestampScorer;

public class TimestampSplitterFactory implements SplitterFactory {

	private final AnnotatedTablesRepository repository;
	private final TimestampScorer timestampScorer;

	@Inject
	public TimestampSplitterFactory(AnnotatedTablesRepository repository, TimestampScorer timestampScorer) {
		this.repository = repository;
		this.timestampScorer = timestampScorer;
	}

	@Override
	public Splitter getSplitter(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {
		return new TimestampSplitter(repository, timestampScorer.getTimestampScores(learningSet));
	}

}
