package de.mannheim.uni.expansion.tablefusion.evaluation.analyzer;

import de.mannheim.uni.expansion.tablefusion.services.fusion.runner.FusionDataType;
import de.mannheim.uni.expansion.tablefusion.services.fusion.runner.FusionPreproccesser;
import de.mannheim.uni.expansion.tablefusion.services.fusion.runner.FusionStrategy;

public class FusionRun {
	private final FusionDataType dataType;
	private final FusionPreproccesser preproccesser;
	private final FusionStrategy runType;

	public FusionRun(FusionDataType dataType, FusionPreproccesser preproccesser, FusionStrategy runType) {
		super();
		this.dataType = dataType;
		this.preproccesser = preproccesser;
		this.runType = runType;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((dataType == null) ? 0 : dataType.hashCode());
		result = prime * result + ((preproccesser == null) ? 0 : preproccesser.hashCode());
		result = prime * result + ((runType == null) ? 0 : runType.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		FusionRun other = (FusionRun) obj;
		if (dataType != other.dataType)
			return false;
		if (preproccesser != other.preproccesser)
			return false;
		if (runType != other.runType)
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "FusionRun [dataType=" + dataType + ", preproccesser=" + preproccesser + ", runType=" + runType + "]";
	}

}