package de.mannheim.uni.expansion.tablefusion.evaluation.analyzer;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.ontology.model.TripleIdContainer;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.expansion.data.ontology.model.repository.OntologyRepository;
import de.mannheim.uni.expansion.tablefusion.evaluation.analyzer.PropertiesConfig.TimeDependence;

public class PropertiesConfigFilter {

	private final OntologyRepository ontologyRepository;

	@Inject
	public PropertiesConfigFilter(OntologyRepository ontologyRepository) {
		super();
		this.ontologyRepository = ontologyRepository;
	}

	public boolean include(PropertiesConfig config, TripleIdContainer tripleIdContainer) {
		if (config.getTimeDependence() == TimeDependence.ALL) {
			return true;
		} else if (config.getTimeDependence() == TimeDependence.YES) {
			if (ontologyRepository.isTimeDependent(tripleIdContainer.tripleId().getPropertyId()))
				return true;
			else
				return false;
		} else if (config.getTimeDependence() == TimeDependence.NO) {
			if (ontologyRepository.isTimeDependent(tripleIdContainer.tripleId().getPropertyId()))
				return false;
			else
				return true;
		}
		return false;
	}

	public boolean include(PropertiesConfig config, PropertyId propertyId) {
		if (config.getTimeDependence() == TimeDependence.ALL) {
			return true;
		} else if (config.getTimeDependence() == TimeDependence.YES) {
			if (ontologyRepository.isTimeDependent(propertyId))
				return true;
			else
				return false;
		} else if (config.getTimeDependence() == TimeDependence.NO) {
			if (ontologyRepository.isTimeDependent(propertyId))
				return false;
			else
				return true;
		}
		return false;
	}
}
