package de.mannheim.uni.expansion.tablefusion.evaluation.stores;

import de.mannheim.uni.expansion.data.ontology.model.TripleId;

public class PairData {
	private final TripleId tripleId;
	private final ValuePair valuePair;

	public PairData(TripleId tripleId, ValuePair valuePair) {
		super();
		this.tripleId = tripleId;
		this.valuePair = valuePair;
	}

	public TripleId getTripleId() {
		return tripleId;
	}

	public ValuePair getValuePair() {
		return valuePair;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((tripleId == null) ? 0 : tripleId.hashCode());
		result = prime * result + ((valuePair == null) ? 0 : valuePair.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		PairData other = (PairData) obj;
		if (tripleId == null) {
			if (other.tripleId != null)
				return false;
		} else if (!tripleId.equals(other.tripleId))
			return false;
		if (valuePair == null) {
			if (other.valuePair != null)
				return false;
		} else if (!valuePair.equals(other.valuePair))
			return false;
		return true;
	}

}