package de.mannheim.uni.expansion.tablefusion.evaluation.stores;

import de.mannheim.uni.expansion.data.ontology.model.TripleId;

public class ValueData {
	private final TripleId tripleId;
	private final Object value;

	public ValueData(TripleId tripleId, Object value) {
		super();
		this.tripleId = tripleId;
		this.value = value;
	}

	public TripleId getTripleId() {
		return tripleId;
	}

	public Object getValue() {
		return value;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((tripleId == null) ? 0 : tripleId.hashCode());
		result = prime * result + ((value == null) ? 0 : value.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ValueData other = (ValueData) obj;
		if (tripleId == null) {
			if (other.tripleId != null)
				return false;
		} else if (!tripleId.equals(other.tripleId))
			return false;
		if (value == null) {
			if (other.value != null)
				return false;
		} else if (!value.equals(other.value))
			return false;
		return true;
	}

}