package de.mannheim.uni.expansion.tablefusion.evaluation.stores;

import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;

public class ValuePair {
	private final AbstractObject fusedValue;
	private final AbstractObject dbPediaValue;

	public ValuePair(AbstractObject fusedValue, AbstractObject dbPediaValue) {
		this.fusedValue = fusedValue;
		this.dbPediaValue = dbPediaValue;
	}

	public AbstractObject getFusedValue() {
		return fusedValue;
	}

	public AbstractObject getDBPediaValue() {
		return dbPediaValue;
	}

	@Override
	public String toString() {
		return "ValuePair [fusedValue=" + fusedValue + ", dbPediaValue=" + dbPediaValue + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((dbPediaValue == null) ? 0 : dbPediaValue.hashCode());
		result = prime * result + ((fusedValue == null) ? 0 : fusedValue.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ValuePair other = (ValuePair) obj;
		if (dbPediaValue == null) {
			if (other.dbPediaValue != null)
				return false;
		} else if (!dbPediaValue.equals(other.dbPediaValue))
			return false;
		if (fusedValue == null) {
			if (other.fusedValue != null)
				return false;
		} else if (!fusedValue.equals(other.fusedValue))
			return false;
		return true;
	}

}