package de.mannheim.uni.expansion.tablefusion.learning;

import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.ontology.model.QualifiedTripleId;
import de.mannheim.uni.expansion.data.ontology.model.TripleId;
import de.mannheim.uni.expansion.tablefusion.core.matching.MatchedValues;
import de.mannheim.uni.expansion.tablefusion.core.matching.MatchedValues.SingleValue;
import de.mannheim.uni.expansion.tablefusion.core.matching.SynchronizedMatchedValuesMapMerger;
import de.mannheim.uni.expansion.tablefusion.core.splitting.SplitGroupedValues;

public class LearningSetCreatorFilling {

	@Inject
	public LearningSetCreatorFilling() {

	}

	public Map<Integer, SplitGroupedValuesSets> createByTableProperty(int numberOfSets, SplitGroupedValues splitGroupedValues) {

		double percent = 1.0 / numberOfSets;
		Map<Integer, SplitGroupedValuesSets> createdSets = new HashMap<Integer, SplitGroupedValuesSets>();

		for (int i = 0; i < numberOfSets; i++) {
			SynchronizedMatchedValuesMapMerger<QualifiedTripleId> learningSetMerger = new SynchronizedMatchedValuesMapMerger<>();
			SynchronizedMatchedValuesMapMerger<QualifiedTripleId> testingSetMerger = new SynchronizedMatchedValuesMapMerger<>();

			final int currentI = i;
			//
			// Map<TripleId, MatchedValues> learningSet = new HashMap<TripleId,
			// MatchedValues>();
			// Map<TripleId, MatchedValues> testingSet = new HashMap<TripleId,
			// MatchedValues>();

			int smallSetSize = (int) (percent * splitGroupedValues.size());

			int s = 0;
			int sStart = smallSetSize * currentI;
			int sEnd = smallSetSize * (currentI + 1);
			for (Entry<QualifiedTripleId, MatchedValues> vwi : splitGroupedValues.entrySet()) {
				if (s >= sStart & s < sEnd) {
					testingSetMerger.merge(vwi.getKey(), vwi.getValue());

				} else {
					learningSetMerger.merge(vwi.getKey(), vwi.getValue());

				}

				s++;
			}

			createdSets.put(i, new SplitGroupedValuesSets(splitGroupedValues, new SplitGroupedValues(learningSetMerger.getCleanMap()),
					new SplitGroupedValues(testingSetMerger.getCleanMap())));

		}
		return createdSets;
	}

	private static class ValueWithIdentifier {
		private final TripleId tripleId;
		private final SingleValue singleValue;

		public ValueWithIdentifier(TripleId tripleId, SingleValue singleValue) {
			this.tripleId = tripleId;
			this.singleValue = singleValue;
		}

		public TripleId getTripleId() {
			return tripleId;
		}

		public SingleValue getSingleValue() {
			return singleValue;
		}

	}
}
