package de.mannheim.uni.expansion.tablefusion.optimization;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Optional;

import javax.inject.Inject;

import de.uni_mannheim.dws.expansion.data.utils.kryo.ThreadSafeKryo;
import de.uni_mannheim.informatik.dws.expansion.model.utils.thresholdpacks.ThresholdContainer;

public class ThresholdKryoCache {

	private final ThreadSafeKryo kryo;

	@Inject
	public ThresholdKryoCache(ThreadSafeKryo kryo) {
		this.kryo = kryo;
	}

	public void writeThresholdContainer(ThresholdContainer container, String folder, String fusionStrategy) throws IOException {
		this.kryo.write(container, folder + "/" + fusionStrategy);
	}

	public Optional<ThresholdContainer> readThresholdContainer(String folder, String fusionStrategy) throws IOException {
		Path path = Paths.get(folder + "/" + fusionStrategy);
		if (Files.exists(path)) {
			Object threshold = kryo.read(folder + "/" + fusionStrategy);
			if (threshold instanceof ThresholdContainer) {
				return Optional.of((ThresholdContainer) threshold);
			}
		}

		return Optional.empty();

	}
}
