package de.mannheim.uni.expansion.tablefusion.profiling.timestamps;

import java.io.IOException;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.ontology.model.ClassPropertyId;
import de.mannheim.uni.expansion.data.ontology.model.TripleId;
import de.mannheim.uni.expansion.data.ontology.model.repository.OntologyRepository;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTable;
import de.mannheim.uni.expansion.data.tables.model.ColumnIdx;
import de.mannheim.uni.expansion.data.tables.model.RowIdx;
import de.mannheim.uni.expansion.data.tables.model.timestamp.TimestampIdentifier;
import de.mannheim.uni.expansion.data.tables.repository.AnnotatedTablesRepository;
import de.mannheim.uni.expansion.tablefusion.analysis.stores.FusionPerformanceSynchronizedCreator;
import de.mannheim.uni.expansion.tablefusion.analysis.writer.ResultsCategory;
import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.matching.MatchedValues.SingleValue;
import de.mannheim.uni.expansion.tablefusion.core.similarity.SimilarityCalculator;
import de.mannheim.uni.expansion.tablefusion.services.grouping.GroupedValuesRepository;
import de.mannheim.uni.expansion.utils.PersistentParallel4;
import de.uni_mannheim.dws.expansion.data.kb.repository.KnowledgeBase;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.TimeObject;
import de.uni_mannheim.dws.expansion.data.ontology.model.qualifiers.TimestampPointInTime;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.QualifiedValueHolder;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.QualifiedValueList;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.ValueType;
import de.uni_mannheim.informatik.dws.expansion.evaluation.timestamps.TimestampQualifiersAdapter;
import de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulateables.AccumInteger;

@Deprecated
public class TimeStampOverlapProfilerOld {
	private final AnnotatedTablesRepository tableRepository;
	private final KnowledgeBase knowledgeBase;
	private final GroupedValuesRepository groupedValuesRepository;
	private final SimilarityCalculator similarityCalculator;
	private final OntologyRepository ontologyRepository;
	private final TimestampQualifiersAdapter timestampQualifiersAdapter;

	@Inject
	public TimeStampOverlapProfilerOld(AnnotatedTablesRepository tableRepository, KnowledgeBase knowledgeBase, GroupedValuesRepository groupedValuesRepository,
			SimilarityCalculator similarityCalculator, OntologyRepository ontologyRepository, TimestampQualifiersAdapter timestampQualifiersAdapter) {
		this.tableRepository = tableRepository;
		this.knowledgeBase = knowledgeBase;
		this.groupedValuesRepository = groupedValuesRepository;
		this.similarityCalculator = similarityCalculator;
		this.ontologyRepository = ontologyRepository;
		this.timestampQualifiersAdapter = timestampQualifiersAdapter;
	}

	public void profile() {

		FusionPerformanceSynchronizedCreator<AccumInteger> creatorSingle = new FusionPerformanceSynchronizedCreator<AccumInteger>(new AccumInteger(0));

		GroupedValues groupedValues = groupedValuesRepository.getGroupedValues();

		PersistentParallel4.runAndFinish(groupedValues.entrySet(), (e) -> {

			TripleId tid = e.getKey();

			QualifiedValueList qvl = knowledgeBase.getQualifiedValueList(tid.getValueId());
			if (qvl != null) {
				for (SingleValue sv : e.getValue().getValues()) {
					AbstractObject value = sv.getValue();

					for (QualifiedValueHolder qvh : qvl.getClaims()) {

						if (similarityCalculator.isEqual(value, qvh.getValue())) {

							Map<TimestampPointInTime, List<Integer>> qualifierMap = this.timestampQualifiersAdapter.getQualifierMapFromQVL(qvl);

							RowIdx rowIdx = sv.getId().getRowIdx();

							AnnotatedTable table = tableRepository.getTable(sv.getId().getTableId());
							List<ColumnIdx> timeColumns = table.getTimeColumns();
							for (ColumnIdx columnIdx : timeColumns) {
								Integer columnYear = TimeObject.getYear(table.getColumn(columnIdx).get(rowIdx));
								if (columnYear != null) {
									TimestampPointInTime tpit = new TimestampPointInTime(columnYear);
									if (qualifierMap.containsKey(tpit)) {
										creatorSingle.addPerProperty(tid.getClassPropertyId(), new AccumInteger(qualifierMap.get(tpit).size()));
										qualifierMap.remove(tpit);
									}

								}
							}

							Map<TimestampIdentifier, Integer> tableYears = tableRepository.getMetaData(sv.getId().getTableId()).getTableYears();

							for (Entry<TimestampIdentifier, Integer> tableYear : tableYears.entrySet()) {
								TimestampPointInTime tpit = new TimestampPointInTime(tableYear.getValue());
								if (qualifierMap.containsKey(tpit)) {
									creatorSingle.addPerProperty(tid.getClassPropertyId(), new AccumInteger(qualifierMap.get(tpit).size()));
									qualifierMap.remove(tpit);
								}

							}

							//
							// for (Entry<TimestampPointInTime, List<Integer>>
							// qMEntry : qualifierMap.entrySet()) {
							//
							// }
							//
							// List<Qualifier> qualifiers = qvh.getQualifiers();
							// if (qualifiers != null) {
							//
							// boolean add = false;
							//
							// for (Qualifier q : qualifiers) {
							// if (q.getQualifierValue() instanceof TimeObject)
							// {
							// add = true;
							// break;
							// }
							// }
							// if (add) {
							//
							// for (Qualifier q : qualifiers) {
							// if (q.getQualifierValue() instanceof TimeObject)
							// {
							// Integer year =
							// TimeObject.getYear(q.getQualifierValue());
							// boolean correct = false;
							// AnnotatedTable table =
							// tableRepository.getTable(sv.getId().getTableId());
							// List<ColumnIdx> timeColumns =
							// table.getTimeColumns();
							// for (ColumnIdx columnIdx : timeColumns) {
							// Integer columnYear =
							// TimeObject.getYear(table.getColumn(columnIdx).get(rowIdx));
							// if (columnYear != null &&
							// columnYear.equals(year)) {
							// correct = true;
							// break;
							// }
							// }
							//
							// if (!correct) {
							// Map<TimestampIdentifier, Integer> tableYears =
							// tableRepository.getMetaData(sv.getId().getTableId())
							// .getTableYears();
							//
							// for (Entry<TimestampIdentifier, Integer>
							// tableYear : tableYears.entrySet()) {
							// if (year.equals(tableYear.getValue())) {
							// correct = true;
							// break;
							// }
							// }
							//
							// }
							//
							// if (!correct) {
							// add = false;
							// }
							// }
							// }
							// }
							//
							// if (add) {
							// creatorSingle.addPerProperty(tid.getClassPropertyId(),
							// new AccumInteger(1));
							// }

						}

					}
				}
			}

		} , "OverlapProfiler");

		TimeStampsOverlapWriter writer = new TimeStampsOverlapWriter();

		for (Entry<ClassPropertyId, AccumInteger> e : creatorSingle.get().getPerProperty().entrySet()) {
			ValueType cdt = ontologyRepository.getDataType(e.getKey().getPropertyId());
			String[] prefix = ResultsCategory.getClassPropertyIdPrefix("PROPERTY", ontologyRepository.isTimeDependent(e.getKey().getPropertyId()), cdt,
					e.getKey());
			writer.write(ResultsCategory.CLASS_PROPERTY_ID, prefix, e.getValue());
		}

		try {
			System.out.println(writer.getAll(ResultsCategory.CLASS_PROPERTY_ID));
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
	}

}
