package de.mannheim.uni.expansion.tablefusion.services;

import java.util.Map;
import java.util.Optional;

import javax.inject.Inject;

import de.mannheim.uni.expansion.data.tables.model.AnnotatedTableMetaData;
import de.mannheim.uni.expansion.data.tables.model.AnnotatedTablesReaderData;
import de.mannheim.uni.expansion.data.tables.model.InstanceIndexComposite;
import de.mannheim.uni.expansion.data.tables.reader.AnnotatedTableFilter;

public class AnnotatedTableInstanceRescorer implements AnnotatedTableFilter {

	private final AnnotatedTableInstanceScorer scorer;

	@Inject
	public AnnotatedTableInstanceRescorer(AnnotatedTableInstanceScorer scorer) {
		this.scorer = scorer;
	}

	@Override
	public Optional<AnnotatedTablesReaderData> filter(AnnotatedTablesReaderData data) {
		Map<InstanceIndexComposite, Double> instanceScores = scorer.getScores(data);

		AnnotatedTableMetaData md = data.getMetaData().rebuilder().setInstanceScores(instanceScores).build();

		return Optional.of(new AnnotatedTablesReaderData(data.getId(), md, data.getTableData()));
	}

}
