package de.mannheim.uni.expansion.tablefusion.services.fusion.strategies;

import java.util.HashMap;
import java.util.Map;

public class ScorerRepository {

	private final Map<Class<? extends Scorer>, Scorer> repository = new HashMap<>();

	public <E extends Scorer> void add(Class<E> clazz, E scorer) {
		this.repository.put(clazz, scorer);
	}

	// @SuppressWarnings("unchecked")
	// public <E extends Scorer> E getTyped(Class<E> clazz) {
	// if (clazz == null) {
	// throw new IllegalStateException("Asking for Scorer of class null is not
	// allowed!");
	// } else {
	// Scorer scorer = this.repository.get(clazz);
	//
	// if (scorer == null) {
	// throw new IllegalStateException("No Scorer was registered for Class: " +
	// clazz.getSimpleName());
	// } else {
	// if (scorer.getClass().equals(clazz))
	// return (E) scorer;
	// else {
	// throw new IllegalStateException("This scorer is not of the requested
	// type");
	// }
	//
	// }
	// }
	// }

	public Scorer get(Class<? extends Scorer> clazz) {
		if (clazz == null) {
			throw new IllegalStateException("Asking for Scorer of class null is not allowed!");
		} else {
			Scorer scorer = this.repository.get(clazz);
			if (scorer == null) {
				throw new IllegalStateException("No Scorer was registered for Class: " + clazz.getSimpleName());
			} else {
				return scorer;
			}
		}
	}
}
