package de.mannheim.uni.expansion.tablefusion.services.fusion.strategies;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.scoring.QualifiedKbtCalculator;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.ScoresContainer;
import de.mannheim.uni.expansion.tablefusion.learning.SplitGroupedValuesSets;

public class Scorer_KBT_PRPGTD implements Scorer {

	private final QualifiedKbtCalculator qualifiedKbtCalculator;

	@Inject
	public Scorer_KBT_PRPGTD(QualifiedKbtCalculator qualifiedKbtCalculator) {
		this.qualifiedKbtCalculator = qualifiedKbtCalculator;
	}

	@Override
	public ScoresContainer getScores(SplitGroupedValuesSets sets) {
		return qualifiedKbtCalculator.getNonQualifiedPropogated(sets.getLearningSet());
	}
}
