package de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.newTS;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.QualifiedKbtCalculator;
import de.mannheim.uni.expansion.tablefusion.core.scoring.TimestampScorer;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.ScoresContainer;
import de.mannheim.uni.expansion.tablefusion.core.splitting.SplitGroupedValues;
import de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.RegressionScorer;
import de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.Scorer;

public class Scorer_NewTs_KBT implements Scorer {

	private final TimestampScorer timestampScorer;

	private final QualifiedKbtCalculator kbtScorer;

	private final RegressionScorer regressionScorer;

	@Inject
	public Scorer_NewTs_KBT(QualifiedKbtCalculator kbtScorer, TimestampScorer timestampScorer, RegressionScorer regressionScorer) {
		this.kbtScorer = kbtScorer;
		this.timestampScorer = timestampScorer;
		this.regressionScorer = regressionScorer;
	}

	@Override
	public ScoresContainer getScores(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {
		// return timestampScorer.getScores(learningSet, testingSet);
		return null;
	}

	@Override
	public ScoresContainer getScores(SplitGroupedValues sgvLearning, SplitGroupedValues sgvTesting) {
		ScoresContainer kbt = kbtScorer.byColumnIdNonQualified(sgvLearning);
		ScoresContainer ts = timestampScorer.getScores(sgvLearning, sgvTesting, kbt);

		// Map<String, ScoresContainer> map = new LinkedHashMap<>();
		// map.put("KBT", kbt);
		// map.put("TS", ts);
		// map.put("KBT_TS", new MultipliedScores(kbt, ts));

		// RegressionScoresClassPropertyId rs =
		// regressionScorer.getClassPropertyId(sgvLearning, map);

		return ts;
	}
}
