package de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.pagerank;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.adapters.ranking.RankRepository;
import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.ScoresContainer;
import de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.Scorer;

public class Scorer_PageRank implements Scorer {

	private final RankRepository rankRepository;

	@Inject
	public Scorer_PageRank(RankRepository rankRepository) {
		this.rankRepository = rankRepository;
	}

	@Override
	public ScoresContainer getScores(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {
		return rankRepository.getScores(fullSet);
	}

}
