package de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.timestamps;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.TimeStampsScoringCalculator;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.ScoresContainer;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.SimpleMultipliedScores;
import de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.Scorer;

public class Scorer_Combined_HierarchyTS_TableText implements Scorer {

	private final TimeStampsScoringCalculator timeStampsScoringCalculator;

	@Inject
	public Scorer_Combined_HierarchyTS_TableText(TimeStampsScoringCalculator timeStampsScoringCalculator) {
		this.timeStampsScoringCalculator = timeStampsScoringCalculator;
	}

	@Override
	public ScoresContainer getScores(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {
		ScoresContainer[] containers = new ScoresContainer[2];

		containers[0] = timeStampsScoringCalculator.genericYearScorer(fullSet, timeStampsScoringCalculator.GET_HIERARICAL_YEAR);

		containers[1] = timeStampsScoringCalculator.genericYearScorer(fullSet, timeStampsScoringCalculator.MOST_COMMON_TABLE_TEXT_YEAR);

		return new SimpleMultipliedScores(containers);
	}

}
