package de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.timestamps;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.ProbabilitiesCalculator;
import de.mannheim.uni.expansion.tablefusion.core.scoring.TimeStampsScoringCalculator;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.ScoresContainer;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.WeightedMultipliedScores;
import de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.Scorer;

public class Scorer_KBT_Combined_HierarchyTS_TableText_WeightedMultiplied implements Scorer {

	private final ProbabilitiesCalculator probabilitiesCalculator;
	private final TimeStampsScoringCalculator timeStampsScoringCalculator;

	@Inject
	public Scorer_KBT_Combined_HierarchyTS_TableText_WeightedMultiplied(ProbabilitiesCalculator probabilitiesCalculator,
			TimeStampsScoringCalculator timeStampsScoringCalculator) {
		this.probabilitiesCalculator = probabilitiesCalculator;
		this.timeStampsScoringCalculator = timeStampsScoringCalculator;
	}

	@Override
	public ScoresContainer getScores(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {

		ScoresContainer[] containers = new ScoresContainer[2];
		Double[] weights = new Double[2];
		containers[0] = timeStampsScoringCalculator.genericYearScorer(fullSet, timeStampsScoringCalculator.GET_HIERARICAL_YEAR);
		weights[0] = 0.2;

		containers[1] = timeStampsScoringCalculator.genericYearScorer(fullSet, timeStampsScoringCalculator.MOST_COMMON_TABLE_TEXT_YEAR);
		weights[1] = 0.2;

		ScoresContainer main = probabilitiesCalculator.byProperty(learningSet);

		return new WeightedMultipliedScores(main, 0.6, containers, weights);
	}

}
