package de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.timestamps.column;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.TimeStampsScoringCalculator;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.ScoresContainer;
import de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.Scorer;

public class Scorer_ColumnTS_Max_Propagated implements Scorer {

	private final TimeStampsScoringCalculator timeStampsScoringCalculator;

	@Inject
	public Scorer_ColumnTS_Max_Propagated(TimeStampsScoringCalculator timeStampsScoringCalculator) {

		this.timeStampsScoringCalculator = timeStampsScoringCalculator;
	}

	@Override
	public ScoresContainer getScores(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {

		return timeStampsScoringCalculator.genericYearScorer(fullSet, timeStampsScoringCalculator.MAX_COLUMN_YEAR, true);

	}

}
