package de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.timestamps.column;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.ProbabilitiesCalculator;
import de.mannheim.uni.expansion.tablefusion.core.scoring.TimeStampsScoringCalculator;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.RequiredResizedScores;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.ScoresContainer;
import de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.Scorer;

public class Scorer_KBT_ColumnTS_Max_FilteredResized implements Scorer {

	private final ProbabilitiesCalculator probabilitiesCalculator;
	private final TimeStampsScoringCalculator timeStampsScoringCalculator;

	@Inject
	public Scorer_KBT_ColumnTS_Max_FilteredResized(ProbabilitiesCalculator probabilitiesCalculator, TimeStampsScoringCalculator timeStampsScoringCalculator) {
		this.probabilitiesCalculator = probabilitiesCalculator;
		this.timeStampsScoringCalculator = timeStampsScoringCalculator;

	}

	@Override
	public ScoresContainer getScores(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {
		return new RequiredResizedScores(probabilitiesCalculator.byProperty(learningSet),
				timeStampsScoringCalculator.genericYearScorer(fullSet, timeStampsScoringCalculator.MAX_COLUMN_YEAR));

	}

}
