package de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.timestamps.pageTitle;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.TimeStampsScoringCalculator;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.ScoresContainer;
import de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.Scorer;

public class Scorer_PageTitleTS_Max implements Scorer {

	private final TimeStampsScoringCalculator timeStampsScoringCalculator;

	@Inject
	public Scorer_PageTitleTS_Max(TimeStampsScoringCalculator timeStampsScoringCalculator) {

		this.timeStampsScoringCalculator = timeStampsScoringCalculator;
	}

	@Override
	public ScoresContainer getScores(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {
		return timeStampsScoringCalculator.genericYearScorer(fullSet, timeStampsScoringCalculator.MAX_PAGE_TITLE);

	}

}
