package de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.timestamps.tableText;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.TimeStampsScoringCalculator;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.ScoresContainer;
import de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.Scorer;

public class Scorer_TableTextTS implements Scorer {

	private final TimeStampsScoringCalculator timeStampsScoringCalculator;

	@Inject
	public Scorer_TableTextTS(TimeStampsScoringCalculator timeStampsScoringCalculator) {
		this.timeStampsScoringCalculator = timeStampsScoringCalculator;
	}

	@Override
	public ScoresContainer getScores(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {

		return timeStampsScoringCalculator.genericYearScorer(fullSet, timeStampsScoringCalculator.MOST_COMMON_TABLE_TEXT_YEAR);

	}

}
