package de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.timestamps.tableYear;

import javax.inject.Inject;

import de.mannheim.uni.expansion.tablefusion.core.matching.GroupedValues;
import de.mannheim.uni.expansion.tablefusion.core.scoring.ProbabilitiesCalculator;
import de.mannheim.uni.expansion.tablefusion.core.scoring.TimeStampsScoringCalculator;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.ScoresContainer;
import de.mannheim.uni.expansion.tablefusion.core.scoring.packs.WeightedScores;
import de.mannheim.uni.expansion.tablefusion.services.fusion.strategies.Scorer;

public class Scorer_KBT_TableYearsHierarchy_Weighted implements Scorer {

	private final ProbabilitiesCalculator probabilitiesCalculator;
	private final TimeStampsScoringCalculator timeStampsScoringCalculator;

	@Inject
	public Scorer_KBT_TableYearsHierarchy_Weighted(ProbabilitiesCalculator probabilitiesCalculator, TimeStampsScoringCalculator timeStampsScoringCalculator) {
		this.probabilitiesCalculator = probabilitiesCalculator;
		this.timeStampsScoringCalculator = timeStampsScoringCalculator;
	}

	@Override
	public ScoresContainer getScores(GroupedValues fullSet, GroupedValues learningSet, GroupedValues testingSet) {

		ScoresContainer[] containers = new ScoresContainer[2];
		Double[] weights = new Double[2];
		containers[0] = timeStampsScoringCalculator.genericYearScorer(fullSet, timeStampsScoringCalculator.TABLE_YEAR_HIERARCHY);
		weights[0] = 0.5;
		containers[1] = probabilitiesCalculator.byProperty(learningSet);
		weights[1] = 0.5;
		return new WeightedScores(containers, weights);
	}

}
