package de.mannheim.uni.expansion.tablefusion.testers;

import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.function.Function;

import javax.inject.Inject;

public class ToReadableString {
	private final SimpleDateFormat dt = new SimpleDateFormat("yyyy-MM-dd hh:mm:ss");
	private final DecimalFormat dfmt = new DecimalFormat(",000.0");

	@Inject
	public ToReadableString() {

	}

	public final String getString(Object o) {

		Function<Object, String> getReadableSingle = (obj) -> {
			if (obj instanceof String) {
				return obj.toString();
			} else if (obj instanceof Date) {
				return dt.format((Date) obj);
			} else if (obj instanceof Double) {
				return String.format("%.0f", (Double) obj);
			}
			throw new IllegalStateException("CAN'T RECOGNIZE THIS FORMAT: " + o.getClass() + "::" + o.toString());
		};

		if (o instanceof List) {
			List<String> newList = new ArrayList<>();
			for (Object obj : (List<?>) o) {
				newList.add(getReadableSingle.apply(obj));
			}
			return newList.toString();
		} else {
			return getReadableSingle.apply(o);
		}

	}

}
