package de.uni_mannheim.informatik.dws.expansion.tools.converters.datasets;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.net.HttpURLConnection;
import java.net.URL;
import java.security.SecureRandom;
import java.security.cert.X509Certificate;
import java.util.concurrent.TimeUnit;

import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManager;
import javax.net.ssl.X509TrustManager;

import org.apache.commons.io.IOUtils;

import de.mannheim.uni.expansion.utils.containers.Pair;

public class CrawlerTools {

	public static void main(String[] args) {
		noSSLCheckInit();
		Pair<Integer, String> response = CrawlerTools.getDocument("https://stockrow.com/GOfdfOGL/financials?d=y&s=balance");
		System.out.println(response.toString());
	}

	public static String getCleanHtml(String html) {
		return html.replace("&nbsp;", "").trim();
	}

	public static void noSSLCheckInit() {

		TrustManager[] trustAllCerts = new TrustManager[] { new X509TrustManager() {
			public X509Certificate[] getAcceptedIssuers() {
				return null;
			}

			public void checkClientTrusted(X509Certificate[] certs, String authType) {
			}

			public void checkServerTrusted(X509Certificate[] certs, String authType) {
			}
		} };

		// Install the all-trusting trust manager
		try {
			SSLContext sc = SSLContext.getInstance("TLS");
			sc.init(null, trustAllCerts, new SecureRandom());
			HttpsURLConnection.setDefaultSSLSocketFactory(sc.getSocketFactory());
		} catch (Exception e) {
			;
		}

	}

	public static Pair<Integer, String> getDocument(String urlString) {
		InputStream in = null;
		HttpURLConnection connection = null;
		try {
			URL url = new URL(urlString);
			connection = (HttpURLConnection) url.openConnection();
			connection.setRequestMethod("GET");
			connection.connect();
			in = connection.getInputStream();

			int code = connection.getResponseCode();

			return new Pair<>(code, IOUtils.toString(in));
		} catch (FileNotFoundException e) {
			return new Pair<>(404, "");
		} catch (IOException e) {
			try {
				TimeUnit.SECONDS.sleep(5);
			} catch (InterruptedException e1) {
				// TODO Auto-generated catch block
				e1.printStackTrace();
			}
			e.printStackTrace();
			return getDocument(urlString);
		} finally {
			connection.disconnect();
			IOUtils.closeQuietly(in);
		}
	}
}
