package de.uni_mannheim.informatik.ds.expansion.utils.learning;

public class EvaluationPrediction {
	private final String label;
	private final double weight;
	private final RecordPrediction prediction;
	
	public EvaluationPrediction(String label, String predictedLabel, double confidence) {
		super();
		this.label = label;
		this.prediction = new RecordPrediction(predictedLabel, confidence);
		this.weight = 1.0;
	}

	public EvaluationPrediction(String label, RecordPrediction prediction) {
		this.label = label;
	this.prediction = prediction;
	this.weight = 1.0;
	}
	public EvaluationPrediction(String label, double weight, RecordPrediction prediction) {
		this.label = label;
		this.weight = weight;
	this.prediction = prediction;
	}

	public String getLabel() {
		return label;
	}

	public double getConfidence() {
		return prediction.getConfidence();
	}

	public String getPredictedLabel() {
		return prediction.getLabel();
	}

	public RecordPrediction getPrediction() {
		return prediction;
	}

	public double getWeight() {
		return weight;
	}
	

}
