package de.uni_mannheim.informatik.ds.expansion.utils.learning;

import java.io.Serializable;
import java.util.Collection;
import java.util.Optional;

import de.uni_mannheim.informatik.ds.expansion.utils.learning.TrainingData.RecordData;
import de.uni_mannheim.informatik.ds.expansion.utils.learning.TrainingData.RecordFeature;

public interface LearnedModel extends OutputableModel   {

	 RecordPrediction apply(RecordFeature d);
	 
	 
	 
	 byte[] outputModelFile();

	double runAndEvaluate(Collection<RecordData> data, EvaluationMethod evaluator);



	Optional<Double> getNormalizingThreshold();



	default Optional<Double> getClusteringThreshold() {
		return Optional.empty();
	}
	
	default Optional<Double> getVeryLowPairThreshold() {
		return Optional.empty();
	}



	
}
