package de.uni_mannheim.informatik.ds.expansion.utils.learning;

import java.io.Serializable;
import java.util.Collection;
import java.util.Collections;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;

import de.mannheim.uni.expansion.utils.ListIterable;
import de.mannheim.uni.expansion.utils.ListIterable.ListEntry;

public class LearningFeatures implements Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final Map<String, Integer> features;
	private final SortedMap<Integer, String> featuresIndex;
	
	public LearningFeatures(List<String> featuresList) {
		LinkedHashMap<String, Integer> features = new LinkedHashMap<>();
		TreeMap<Integer, String> featuresIndex = new TreeMap<>();
		for(ListEntry<String> entry : ListIterable.iterable(featuresList)) {
			if(features.containsKey(entry.getValue())) {
				throw new IllegalStateException();
			}
			else {
				features.put(entry.getValue(), entry.getIndex());
				featuresIndex.put(entry.getIndex(), entry.getValue());
			}
			
			
		}
		
		this.features = Collections.unmodifiableMap(features);
		this.featuresIndex = Collections.unmodifiableSortedMap(featuresIndex);
	}

	public SortedMap<Integer, String> getFeatures() {
		return featuresIndex;
	}
	
//	public static enum FeatureType {
//		NUMERIC, STRING;
//	}
//	
//	public static class Feature
//	
//	
	
}
