package de.uni_mannheim.informatik.dws.expansion.utils.optimization.learner;

import java.util.Collection;
import java.util.Optional;

import de.uni_mannheim.informatik.ds.expansion.utils.learning.EvaluationMethod;
import de.uni_mannheim.informatik.ds.expansion.utils.learning.LearnedModel;
import de.uni_mannheim.informatik.ds.expansion.utils.learning.RecordPrediction;
import de.uni_mannheim.informatik.ds.expansion.utils.learning.TrainingData.RecordData;
import de.uni_mannheim.informatik.ds.expansion.utils.learning.TrainingData.RecordFeature;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.OptimizableClass;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.WeightsRepository;

public class WeightsLearnedModel implements LearnedModel {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private final WeightsRepository weights;
	private final OptimizableClass optimizableClass;
	public static final String THRESHOLD_FEATURE = "SIMILARITY_THRESHOLD";

	public WeightsLearnedModel(OptimizableClass optimizableClass, WeightsRepository weights) {

		this.optimizableClass = optimizableClass;
		this.weights = weights;
	}

	// @Override
	// public RecordPrediction apply(RecordFeature f) {
	// return run.predict(f, weights);
	// }

	@Override
	public byte[] outputModelFile() {
		// TODO Auto-generated method stub
		return null;
	}

	// @Override
	// public double runAndEvaluate(Collection<RecordData> data,
	// EvaluationMethod evaluator) {
	//
	// List<EvaluationPrediction> predictions = new ArrayList<>();
	//
	// for (RecordData record : data) {
	// RecordPrediction prediction = run.predict(record.getFeatures(), weights);
	// predictions.add(new EvaluationPrediction(record.getLabel(), prediction));
	// }
	//
	// return evaluator.performance(predictions);
	//
	// }

	public WeightsRepository getWeights() {
		return weights;
	}

	@Override
	public RecordPrediction apply(RecordFeature d) {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public double runAndEvaluate(Collection<RecordData> data, EvaluationMethod evaluator) {
		// TODO Auto-generated method stub
		return 0;
	}

	@Override
	public Optional<Double> getNormalizingThreshold() {
		return Optional.of(weights.getOrDefault(optimizableClass.getWeight(THRESHOLD_FEATURE, 0.5)));
	}

	@Override
	public String toString() {
		return "WeightsLearnedModel [weights=" + weights + ", optimizableClass=" + optimizableClass + "]";
	}

}
