package de.uni_mannheim.informatik.dws.expansion.utils.optimization.learner;

import javax.inject.Inject;

import de.uni_mannheim.informatik.dws.expansion.utils.optimization.optimizer.OptimizableRun;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.optimizer.genetic.WeightsGeneticParallelOptimizer;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.OptimizableClass;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.WeightsRepository;

public class WeightsModelLearner {

	@Inject
	protected WeightsGeneticParallelOptimizer genetic;

	@Inject
	public WeightsModelLearner() {

	}

	public WeightsLearnedModel learn(OptimizableRun run, OptimizableClass optimizableClass) {
		WeightsRepository finalWeights = genetic.optimize(run);
		WeightsLearnedModel weights = new WeightsLearnedModel(optimizableClass, finalWeights);
		double score = run.run(weights.getWeights());
		return weights;
	}
}
