package de.uni_mannheim.informatik.dws.expansion.utils.optimization.optimizer;

import java.util.HashMap;
import java.util.Map;
import java.util.SortedSet;
import java.util.TreeSet;

import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.OptimizableClass;

public class WeightsCollectorData {

	private final SortedSet<String> names;
	private final Map<String, Integer> namesIndex;
	private final Map<Integer, String> namesIndexReverse;
	private final int STEPS;
	private final float STEP;
	private final OptimizableClass workingClass;

	public WeightsCollectorData(WeightsRepositoryCollector collector) {
		SortedSet<String> names = new TreeSet<>(collector.getCollectorIndex().keySet());
		Map<String, Integer> namesIndex = new HashMap<>();
		Map<Integer, String> namesIndexReverse = new HashMap<>();
		int i = 0;
		for (String name : names) {
			namesIndex.put(name, i);
			namesIndexReverse.put(i, name);
			i++;
		}

		this.names = names;
		this.namesIndex = namesIndex;
		this.namesIndexReverse = namesIndexReverse;
		this.STEPS = collector.getSTEPS();
		this.STEP = collector.getSTEP();
		this.workingClass = collector.getWorkingClass();
	}

	public SortedSet<String> getNames() {
		return names;
	}

	public Map<String, Integer> getNamesIndex() {
		return namesIndex;
	}

	public Map<Integer, String> getNamesIndexReverse() {
		return namesIndexReverse;
	}

	public int getSTEPS() {
		return STEPS;
	}

	public float getSTEP() {
		return STEP;
	}

	public OptimizableClass getWorkingClass() {
		return workingClass;
	}

}
