package de.uni_mannheim.informatik.dws.expansion.utils.optimization.optimizer.random;
 
import java.util.HashMap;
import java.util.Map;

import javax.inject.Inject;

import de.mannheim.uni.expansion.utils.PersistentParallel6;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.optimizer.OptimizableRun;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.optimizer.WeightsRepositoryCollector;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.OptimizableWeightKey;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.WeightsRepository;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.WeightsRepositoryImpl;

public class WeightsRandomParallelOptimizer {

	public static float STEP = 0.01f;
	public static int STEPS = Math.round((1.0f / STEP));

	@Inject
	public WeightsRandomParallelOptimizer() {

	}

	public WeightsRepository optimize(OptimizableRun run) {
		if (true)
			throw new RuntimeException();

		WeightsRepositoryCollector collector = new WeightsRepositoryCollector(STEPS, STEP);
		
		run.run(collector);


		Map<OptimizableWeightKey, Double> weights;
		if (collector.getWorkingClass() == null) {
			weights = new HashMap<>();
		} else {
		WeightsRandomRunner runner  = new WeightsRandomRunner(collector);
 
		
	  
			PersistentParallel6.runAndFinish(runner.getRuns(), (currentRun) -> {
				WeightsRepository currentWeightsRepository = runner.getRun(currentRun);
				double performance = run.run(currentWeightsRepository);

				runner.addPerformance(currentRun, performance);
			}, this.getClass());
		 
		
		

			weights = runner.getLearnedWeights();
		}
		return new WeightsRepositoryImpl(weights);
	}
}
