package de.uni_mannheim.informatik.dws.expansion.utils.optimization.optimizer.simple;

import de.uni_mannheim.informatik.dws.expansion.utils.optimization.optimizer.OptimizableRun;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.optimizer.WeightsOptimizer;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.WeightsRepository;
import de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights.WeightsRepositoryImpl;

public class SimpleOptimizer implements WeightsOptimizer {

	@Override
	public WeightsRepository optimize(OptimizableRun run) {
		
		
		WeightsOptimizingRepository weights = new WeightsOptimizingRepository();
		
		
		do {
			
			double performance = run.run(weights);
			weights.lastRunPerformance(performance);

		} while (!weights.isDoneOptimizing());

		return new WeightsRepositoryImpl(weights.getWeights());
	}

}
