package de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import de.uni_mannheim.informatik.ds.expansion.utils.learning.OutputableModel;

public abstract class GenericLearnedModelRepository<E extends OutputableModel, F extends GenericLearnedModelRepository<E, F>> {

	private final Map<OptimizableClass, E> map;

	protected abstract F getFromMap(Map<OptimizableClass, E> newMap);

	public GenericLearnedModelRepository(Map<OptimizableClass, E> map) {
		super();
		this.map = Collections.unmodifiableMap(new HashMap<>(map));
	}

	public GenericLearnedModelRepository() {
		this.map = new HashMap<>();
	}

	public F combineWith(F rep2) {
		Map<OptimizableClass, E> newMap = new HashMap<>(map);
		newMap.putAll(rep2.getMap());
		return getFromMap(newMap);
	}


	public Map<OptimizableClass, E> getMap() {
		return map;
	}

	public boolean contains(OptimizableClass optimizableClass) {
		return map.containsKey(optimizableClass);
	}

	public E get(OptimizableClass optimizableClass) {
		return map.get(optimizableClass);
	}

}
