package de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights;

import java.io.Serializable;

import de.uni_mannheim.informatik.ds.expansion.utils.learning.MethodId;

public class OptimizableClass extends MethodId implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final String name;

	public OptimizableClass(String name) {
		super();
		this.name = name;
	}

	public String getName() {
		return name;
	}

	public OptimizableWeight getWeight(String name, double defaultValue) {
		return new OptimizableWeight(this, name, defaultValue);
	}

	public OptimizableWeightKey getKey(String name) {
		return new OptimizableWeightKey(this, name);
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof OptimizableClass))
			return false;
		OptimizableClass other = (OptimizableClass) obj;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return name;
	}

}
