package de.uni_mannheim.informatik.dws.expansion.utils.optimization.weights;

import java.io.Serializable;

public class OptimizableWeightKey implements Comparable<OptimizableWeightKey>, Serializable {

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private final OptimizableClass clazz;
	private final String name;

	public OptimizableWeightKey(OptimizableClass clazz, String name) {
		this.clazz = clazz;
		this.name = name;
	}

	public OptimizableClass getOptimizableClazz() {
		return clazz;
	}




	public String getName() {
		return name;
	}



	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((clazz == null) ? 0 : clazz.hashCode());
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}



	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (!(obj instanceof OptimizableWeightKey))
			return false;
		OptimizableWeightKey other = (OptimizableWeightKey) obj;
		if (clazz == null) {
			if (other.clazz != null)
				return false;
		} else if (!clazz.equals(other.clazz))
			return false;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		return true;
	}

	@Override
	public int compareTo(OptimizableWeightKey o) {
		int compare = this.getOptimizableClazz().getName().compareTo(o.getOptimizableClazz().getName());
		if (compare != 0) {
			return compare;
		}
		compare = this.getName().compareTo(o.getName());
		return compare;
	}

	@Override
	public String toString() {
		return "[clazz=" + clazz + ", name=" + name + "]";
	}
 

}
