package de.mannheim.uni.expansion.utils;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.concurrent.atomic.AtomicInteger;

public class ThreadCounter {

	private final ThreadLocal<AtomicInteger> ints = new ThreadLocal<>();

	private final List<AtomicInteger> intsList = Collections.synchronizedList(new ArrayList<>());

	public void inc() {
		AtomicInteger count = ints.get();
		if (count == null) {
			count = new AtomicInteger();
			ints.set(count);
			intsList.add(count);
		}
		count.incrementAndGet();
	}

	public int get() {
		int ret = 0;
		for (AtomicInteger i : intsList) {
			ret += i.get();
		}
		return ret;
	}
}
