package expansion.utils.parallel;

import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import java.util.concurrent.ThreadLocalRandom;
import java.util.concurrent.TimeUnit;
import java.util.concurrent.atomic.AtomicInteger;

import org.apache.commons.lang.mutable.MutableInt;

import de.mannheim.uni.expansion.utils.BatchConsumerProducer;

public class TestingBatchConsumer {

	public static void main(String[] args) {
		
	  
		BatchConsumerProducer<Integer> consumer = BatchConsumerProducer.create("Test", (i) -> {
			
			 
			
			MutableInt mi = getThreadLocalMutableInt();
			for(int f = 0; f < 5000; f++) {
				for(int g= 0; g < 400; g++) {
					run();
				}
				mi.add(i * f);
				if(f == 4999) {
					try {
						TimeUnit.SECONDS.sleep(5);
					} catch (Exception e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
			}

		} );
		long startTime = System.nanoTime();
		
		int sum2 = 0;
		for(int i = 0; i < 20; i++) {	
			for(int g= 0; g < 400; g++) {
				run();
			}
			List<Integer> list = new ArrayList<>();
			list.add(i);
			consumer.addBatch(list);
			for(int f = 0; f < 5000; f++) {
				sum2 += i * f;
			}
			System.out.println("Finished batch: " + i);
		}
		
		consumer.finish();
		
		System.out.println("NON-Batch:" + sum2);
		System.out.println("Batch:" + getAllThreadhLocalsSum());
		
		long estimatedTime = 0;
		estimatedTime += System.nanoTime() - startTime;
		
		System.out.println("ThisRunTook: " + formatInterval(estimatedTime));

	}
	
	
	private static ThreadLocal<MutableInt> counter = new ThreadLocal<>();
	private static List<MutableInt> counterList = Collections.synchronizedList(new LinkedList<>());

	public static MutableInt getThreadLocalMutableInt() {
		MutableInt mi = counter.get();
		if (mi == null) {
			mi = new MutableInt();
			counter.set(mi);
			counterList.add(mi);
		}
		return mi;
	}

	public static int getAllThreadhLocalsSum() {
		int sum = 0;
		for (MutableInt mi : counterList) {
			sum += mi.intValue();
		}
		return sum;
	}
	

	public static void run() {
		tan(atan(tan(atan(tan(atan(tan(atan(tan(atan(0.5))))))))));
	}
	
	public static double tan(double a) {
		return Math.tan(a);
	}

	public static double atan(double a) {
		return Math.atan(a);
	}
	
	public static String formatInterval(final long nano) {
		final long l = TimeUnit.NANOSECONDS.toMillis(nano);

		final long hr = TimeUnit.MILLISECONDS.toHours(l);
		final long min = TimeUnit.MILLISECONDS.toMinutes(l - TimeUnit.HOURS.toMillis(hr));
		final long sec = TimeUnit.MILLISECONDS.toSeconds(l - TimeUnit.HOURS.toMillis(hr) - TimeUnit.MINUTES.toMillis(min));
		final long ms = TimeUnit.MILLISECONDS.toMillis(l - TimeUnit.HOURS.toMillis(hr) - TimeUnit.MINUTES.toMillis(min) - TimeUnit.SECONDS.toMillis(sec));
		return String.format("%02d:%02d:%02d.%03d", hr, min, sec, ms);
	}
}
