package de.mannheim.uni.expansion.utils;

import java.util.Collection;
import java.util.function.Consumer;

public class MassConsumerHelper<E> {

	private final ConsumerHelper<E> helper;

	public MassConsumerHelper(ConsumerHelper<E> helper) {
		this.helper = helper;

		helper.start();
	}

	public static <E> MassConsumerHelper<E> withLinkedQueue(String name, Consumer<E> consumer, E poisen) {
		ConsumerHelper<E> helper = ConsumerHelper.withLinkedQueue(name, consumer, poisen);
		return new MassConsumerHelper<E>(helper);
	}

	public static <E> MassConsumerHelper<E> withLinkedQueue(String name, int threads, Consumer<E> consumer, E poisen) {
		ConsumerHelper<E> helper = ConsumerHelper.withLinkedQueue(name, threads, consumer, poisen);
		return new MassConsumerHelper<E>(helper);
	}

	public void runAll(Collection<E> all, Consumer<E> newConsumer) throws InterruptedException {

		helper.setConsumer(newConsumer);

		for (E e : all) {
			helper.add(e);
		}

		helper.finishAwaitAndRestart();
	}
}
