package de.mannheim.uni.expansion.utils;

import java.math.BigInteger;

public class MathsUtil {
	public static long combination(int originalSize, int perSet) {

		BigInteger ret = factorial(originalSize).divide(factorial(perSet).multiply(factorial(originalSize - perSet)));

		return ret.longValue();

	}

	public static BigInteger outcomes(int originalSize, int perSet) {
		BigInteger size = BigInteger.valueOf(originalSize);
		BigInteger ret = BigInteger.valueOf(1);
		for (int i = 0; i < perSet; i++) {
			ret = ret.multiply(size);

		}
		return ret;

	}

	public static long permutation(int originalSize, int perSet) {

		BigInteger ret = factorial(originalSize).divide(factorial(originalSize - perSet));

		return ret.longValue();

	}

	public static BigInteger factorial(int number) {
		BigInteger n = BigInteger.valueOf(number);
		BigInteger result = BigInteger.ONE;

		while (!n.equals(BigInteger.ZERO)) {
			result = result.multiply(n);
			n = n.subtract(BigInteger.ONE);
		}

		return result;
	}

	// public static void main(String[] args) {
	//
	// int steps = 20;
	// int variables = 5;
	//
	// NavigableMap<Integer, NavigableMap<Integer, Integer>> actual =
	// getAllRuns(steps, variables);
	// long computed = outcomes(steps + 1, variables);
	//
	// System.out.println("Actual: " + actual.size());
	// System.out.println("Computed: " + computed);
	// }
	//
	// private static NavigableMap<Integer, NavigableMap<Integer, Integer>>
	// getAllRuns(int STEPS, int variables) {
	// TreeMap<Integer, NavigableMap<Integer, Integer>> allRuns = new
	// TreeMap<>();
	//
	// NavigableMap<Integer, Integer> lastRun = null;
	//
	// {
	// NavigableMap<Integer, Integer> currentRun = new TreeMap<>();
	// for (int index = 0; index < variables; index++) {
	// currentRun.put(index, STEPS);
	// }
	// allRuns.put(allRuns.size(), currentRun);
	// lastRun = currentRun;
	// }
	//
	// boolean isDone = false;
	// while (!isDone) {
	//
	// NavigableMap<Integer, Integer> currentRun = new TreeMap<>(lastRun);
	//
	// int changeIndex = -1;
	// for (Entry<Integer, Integer> entry :
	// currentRun.descendingMap().entrySet()) {
	// if (entry.getValue().equals(0)) {
	// changeIndex = entry.getKey() - 1;
	// } else {
	// changeIndex = entry.getKey();
	// break;
	// }
	// }
	//
	// if (changeIndex == -1) {
	// isDone = true;
	// } else {
	// {
	// Integer step = currentRun.get(changeIndex);
	// step--;
	// currentRun.put(changeIndex, step);
	// }
	// for (int i = changeIndex + 1; i < currentRun.size(); i++) {
	// currentRun.put(i, STEPS);
	// }
	// allRuns.put(allRuns.size(), currentRun);
	// lastRun = currentRun;
	// }
	//
	// }
	//
	// return allRuns;
	//
	// }
}
