package de.mannheim.uni.expansion.utils;

import java.util.Collections;
import java.util.HashSet;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;

public class NGramBLocker {

	private final ConcurrentHashMap<String, Set<String>> stringToNgram = new ConcurrentHashMap<>();

	public NGramBLocker() {
	}

	public boolean ngramOverlap(String a, String b, int ngramSize) {

		Set<String> aTokens = CHMHelper.getFromCHM(stringToNgram, a, () -> ngrams(ngramSize, a));

		Set<String> bTokens = CHMHelper.getFromCHM(stringToNgram, b, () -> ngrams(ngramSize, b));

		return !Collections.disjoint(aTokens, bTokens);
	}

	public Set<String> ngrams(int n, String str) {
		Set<String> ngrams = new HashSet<String>();
		for (int i = 0; i < str.length() - n + 1; i++)
			ngrams.add(str.substring(i, i + n));
		return ngrams;
	}

}
