package de.mannheim.uni.expansion.utils;

import java.util.Calendar;

import javax.inject.Inject;

public class ThreadSafeLocalCalendar {

	private final ThreadLocal<Calendar> calendars = new ThreadLocal<Calendar>();

	@Inject
	public ThreadSafeLocalCalendar() {

	}

	public Calendar getCalendar() {
		Calendar calendar = calendars.get();

		if (calendar == null) {
			calendar = Calendar.getInstance();
			calendars.set(calendar);
		}

		return calendar;

	}
}
