package de.mannheim.uni.expansion.utils;

import java.time.format.DateTimeFormatter;
import java.time.format.DateTimeParseException;
import java.time.temporal.ChronoField;
import java.time.temporal.TemporalAccessor;
import java.util.Optional;

public class TimeParser {
	public static int countOccurunces(String s) {
		int counter = 0;
		for (int i = 0; i < s.length(); i++) {
			if (s.charAt(i) == ':') {
				counter++;
			}
		}
		return counter;
	}

	public static DateTimeFormatter longMinutePattern = DateTimeFormatter.ofPattern("mm:ss");
	public static DateTimeFormatter shortMinutePattern = DateTimeFormatter.ofPattern("m:ss");

	public static DateTimeFormatter longHourPattern = DateTimeFormatter.ofPattern("HH:mm:ss");
	public static DateTimeFormatter shortHourPattern = DateTimeFormatter.ofPattern("H:mm:ss");

	public static Optional<Integer> parseTime(String parse) {
		try {
			int count = countOccurunces(parse);
			if (count == 1) {
				if (parse.length() == 5) {
					TemporalAccessor parsed = longMinutePattern.parse(parse);

					int minute = parsed.get(ChronoField.MINUTE_OF_HOUR);
					int second = parsed.get(ChronoField.SECOND_OF_MINUTE);

					int result = second + minute * 60;
					return Optional.of(result);
				} else if (parse.length() == 4) {
					TemporalAccessor parsed = shortMinutePattern.parse(parse);

					int minute = parsed.get(ChronoField.MINUTE_OF_HOUR);
					int second = parsed.get(ChronoField.SECOND_OF_MINUTE);

					int result = second + minute * 60;
					return Optional.of(result);
				} else {
					return Optional.empty();
				}
			} else if (count == 2) {
				if (parse.length() == 8) {
					TemporalAccessor parsed = longHourPattern.parse(parse);
					int hour = parsed.get(ChronoField.CLOCK_HOUR_OF_DAY);
					int minute = parsed.get(ChronoField.MINUTE_OF_HOUR);
					int second = parsed.get(ChronoField.SECOND_OF_MINUTE);

					int result = second + minute * 60 + hour * 60 * 60;
					return Optional.of(result);
				} else if (parse.length() == 7) {
					TemporalAccessor parsed = shortHourPattern.parse(parse);
					int hour = parsed.get(ChronoField.CLOCK_HOUR_OF_DAY);
					int minute = parsed.get(ChronoField.MINUTE_OF_HOUR);
					int second = parsed.get(ChronoField.SECOND_OF_MINUTE);

					int result = second + minute * 60 + hour * 60 * 60;
					return Optional.of(result);
				} else {
					return Optional.empty();
				}
			} else {
				return Optional.empty();
			}
		} catch (DateTimeParseException e) {
			return Optional.empty();
		}

	}
}
