package de.mannheim.uni.expansion.utils;

import java.util.UUID;

import com.fasterxml.uuid.Generators;

public class UuidStringId {

	private final UUID uuid;
	private final String string;

	public UuidStringId(String string) {
		super();
		this.uuid = null;
		this.string = string;
	}

	public UuidStringId() {
		this.uuid = Generators.timeBasedGenerator().generate();
		this.string = null;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((string == null) ? 0 : string.hashCode());
		result = prime * result + ((uuid == null) ? 0 : uuid.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		UuidStringId other = (UuidStringId) obj;
		if (string == null) {
			if (other.string != null)
				return false;
		} else if (!string.equals(other.string))
			return false;
		if (uuid == null) {
			if (other.uuid != null)
				return false;
		} else if (!uuid.equals(other.uuid))
			return false;
		return true;
	}

	@Override
	public String toString() {
		if (uuid != null)
			return uuid.toString();
		else
			return string;
	}

}
