package de.mannheim.uni.expansion.utils;

import java.util.Optional;

public class WeightedScore {
	private final double score;
	private final double weight;
	private final String suffix;
	private final boolean isMatch;

	public WeightedScore(double score, double weight) {
		super();
		this.score = score;
		this.weight = weight;
		this.suffix = null;
		this.isMatch = true;
	}
	
	public WeightedScore(double score, double weight, String suffix) {
		super();
		this.score = score;
		this.weight = weight;
		this.suffix = suffix;
		this.isMatch = true;
	}

	public WeightedScore(double score, double weight, String suffix, boolean isMatch) {
		super();
		this.score = score;
		this.weight = weight;
		this.suffix = suffix;
		this.isMatch = isMatch;
	}

	public double getScore() {
		return score;
	}

	public double getWeight() {
		return weight;
	}

	public boolean isMatch() {
		return isMatch;
	}


	@Override
	public String toString() {
		return "WeightedScore [score=" + score + ", weight=" + weight + ", suffix=" + suffix + ", isMatch=" + isMatch + "]";
	}

	public Optional<String> getSuffix() {
		if(suffix != null) {
			return Optional.of(suffix);
		}
		else {
			return Optional.empty();
		}
	}

}
