package de.uni_mannheim.informatik.dws.expansion.utils;

import java.util.function.BinaryOperator;

public class MutableReference<E> {

	private E val;

	public MutableReference(E initial) {
		this.val = initial;
	}

	public MutableReference() {
		this.val = null;
	}

	public boolean isPresent() {
		return val != null;
	}

	public void accumulate(E val, BinaryOperator<E> accumulator) {
		this.val = accumulator.apply(this.val, val);

	}

	public E get() {
		return this.val;
	}

	public void set(E val) {
		this.val = val;
	}

	@Override
	public String toString() {
		return "MutableReference [val=" + val + "]";
	}

}
