package de.uni_mannheim.informatik.dws.expansion.wikidata.evaluation.stats;

import de.uni_mannheim.dws.expansion.data.ontology.model.types.WikidataParsedItem;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.QualifiedValueList;
import de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulators.ConcurrentInt;

public class CityStats extends Stats {

	private ConcurrentInt num = new ConcurrentInt(0);

	private ConcurrentInt populationStatements = new ConcurrentInt(0);

	private ConcurrentInt populationStatementsWithDate = new ConcurrentInt(0);

	private ConcurrentInt mayorStatements = new ConcurrentInt(0);

	private ConcurrentInt mayorStatementsWithStartTime = new ConcurrentInt(0);

	private ConcurrentInt mayorStatementsWithEndTime = new ConcurrentInt(0);

	void evaluate(WikidataParsedItem item) {

		num.inc();

		QualifiedValueList populations = item.getValues(Stats.population);
		if (populations != null) {
			populations.getClaims().forEach((e) -> {
				populationStatements.inc();
				if (e.hasQualifier(Stats.pointInTime)) {
					populationStatementsWithDate.inc();

					addToSelection(Stats.population, item.getInstanceId(), e);
				}
			});

		}

		if (true) {
			throw new IllegalStateException();
		}
		// QualifiedValueList val = item.getValues(Stats.mayor);
		// if (val != null) {
		// val.getClaims().forEach((e) -> {
		// mayorStatements.inc();
		// if (e.hasQualifier(Stats.startTimeQualifier)) {
		// mayorStatementsWithStartTime.inc();
		// if (e.hasQualifier(Stats.endTimeQualifier)) {
		// mayorStatementsWithEndTime.inc();
		//
		// addToSelection(Stats.mayor, item.getInstanceId(), e);
		// }
		// }
		// });
		//
		// }

	}

	@Override
	public String toString() {
		return getClass().getName() + "\nnum;" + num + "\npopulationStatements;" + populationStatements + "\npopulationStatementsWithDate;"
				+ populationStatementsWithDate + "\nmayorStatements;" + mayorStatements + "\nmayorStatementsWithStartTime;" + mayorStatementsWithStartTime
				+ "\nmayorStatementsWithEndTime;" + mayorStatementsWithEndTime;
	}

}
