package de.uni_mannheim.informatik.dws.expansion.wikidata.evaluation.stats;

import de.uni_mannheim.dws.expansion.data.ontology.model.types.WikidataParsedItem;
import de.uni_mannheim.dws.expansion.data.ontology.model.valueholders.QualifiedValueList;
import de.uni_mannheim.informatik.dws.expansion.profiling.accumulation.accumulators.ConcurrentInt;

public class NBAStats extends Stats {

	void evaluate(WikidataParsedItem item) {
		if (true) {
			throw new IllegalStateException();
		}
		num.inc();

		QualifiedValueList val = item.getValues(Stats.teams);
		if (val != null) {

			val.getClaims().forEach((e) -> {
				hasTeam.inc();

				boolean stop = false;
				if (e.hasQualifier(Stats.startTimeQualifier)) {
					teamsHaveStartDate.inc();

					if (e.hasQualifier(Stats.endTimeQualifier)) {
						teamsHaveEndDate.inc();

						stop = true;
						addToSelection(Stats.teams, item.getInstanceId(), e);
					}

				}

				// if (e.hasQualifier(Stats.positionQualifier)) {
				// teamsHavePosition.inc();
				//
				// if (!stop) {
				// addToSelection(Stats.teams, item.getInstanceId(), e);
				// stop = true;
				// }
				// }

				// if (e.hasQualifier(Stats.numberQualifier)) {
				// teamsHaveNumber.inc();
				// if (!stop) {
				// addToSelection(Stats.teams, item.getInstanceId(), e);
				// stop = true;
				// }
				// }
			});

		}

		// val = item.getValues(Stats.citizenShip);
		// if (val != null) {
		// country.inc();
		// }

		val = item.getValues(Stats.dateOfBirth);
		if (val != null) {
			hasBirthDate.inc();
		}
		val = item.getValues(Stats.placeOfBirth);
		if (val != null) {
			hasBirthPlace.inc();
		}

	}

	private ConcurrentInt num = new ConcurrentInt(0);
	private ConcurrentInt hasBirthDate = new ConcurrentInt(0);
	private ConcurrentInt hasBirthPlace = new ConcurrentInt(0);
	private ConcurrentInt country = new ConcurrentInt(0);

	private ConcurrentInt hasTeam = new ConcurrentInt(0);
	private ConcurrentInt teamsHaveStartDate = new ConcurrentInt(0);
	private ConcurrentInt teamsHaveEndDate = new ConcurrentInt(0);

	private ConcurrentInt teamsHavePosition = new ConcurrentInt(0);
	private ConcurrentInt teamsHaveNumber = new ConcurrentInt(0);

	@Override
	public String toString() {
		return getClass().getName() + "\nnum;" + num + "\nhasBirthDate;" + hasBirthDate + "\nhasBirthPlace;" + hasBirthPlace + "\ncountry;" + country
				+ "\nhasTeam;" + hasTeam + "\nteamsHaveStartDate;" + teamsHaveStartDate + "\nteamsHaveEndDate;" + teamsHaveEndDate + "\nteamsHavePosition;"
				+ teamsHavePosition + "\nteamsHaveNumber;" + teamsHaveNumber;
	}

}
