package de.uni_mannheim.informatik.dws.expansion.wikidata.parser;

import javax.inject.Inject;

import org.json.JSONObject;

import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.CoordinateObject;

public class WikidataJSONParserCoordinate {

	@Inject
	public WikidataJSONParserCoordinate() {
		System.out.println("FIX GLOBE DETECTION");
		// TODO Auto-generated constructor stub
	}

	public AbstractObject parse(JSONObject jsonObject) {
		if (!"globecoordinate".equals(jsonObject.get("type"))) {
			throw new IllegalStateException("This is not a JSON Object of the type globecoordinate.");
		}

		JSONObject value = jsonObject.getJSONObject("value");

		double latitude = value.getDouble("latitude");
		double longitude = value.getDouble("longitude");
		double precision = 0.0;

		if (!value.isNull("precision")) {
			precision = value.getDouble("precision");
		}

		String globe = value.getString("globe");

		if (!globe.equals("http://www.wikidata.org/entity/Q2")) {
			// System.out.println("Different Globe: " + globe);
		}

		return new CoordinateObject(latitude, longitude, precision);
	}

}
