package de.uni_mannheim.informatik.dws.expansion.wikidata.parser;

import javax.inject.Inject;

import org.json.JSONObject;

import de.uni_mannheim.dws.expansion.data.ontology.model.objects.AbstractObject;
import de.uni_mannheim.dws.expansion.data.ontology.model.objects.QuantityObject;

public class WikidataJSONParserQuantity {

	@Inject
	public WikidataJSONParserQuantity() {
	}

	public AbstractObject parse(JSONObject jsonObject) {
		if (!"quantity".equals(jsonObject.get("type"))) {
			throw new IllegalStateException("This is not a JSON Object of the type quantity.");
		}

		JSONObject value = jsonObject.getJSONObject("value");

		double amount = Double.parseDouble(value.getString("amount"));
		Double upperBound = null;
		Double lowerBound = null;
		if (value.has("upperBound") && value.has("lowerBound")) {
			upperBound = Double.parseDouble(value.getString("upperBound"));
			lowerBound = Double.parseDouble(value.getString("lowerBound"));
		}
		String unit = value.getString("unit");

		return new QuantityObject(amount, upperBound, lowerBound, unit);

	}
}
