package de.uni_mannheim.informatik.dws.expansion.wikidata.reader;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.List;
import java.util.function.Consumer;
import java.util.zip.GZIPInputStream;

import javax.inject.Inject;

import de.mannheim.uni.expansion.utils.BatchConsumerProducer;

public class WikidataJSONReader {

	@Inject
	public WikidataJSONReader() {

	}

	public void read(String file, Consumer<String> consumer) throws FileNotFoundException, IOException {
		final BatchConsumerProducer<String> batchConsumerProducer = BatchConsumerProducer.create("Read Wikidata", consumer, 5000, 1);

		BufferedReader br = new BufferedReader(new InputStreamReader(new GZIPInputStream(new FileInputStream(file)), StandardCharsets.UTF_8));
		List<String> list = new ArrayList<>();
		String nextLine = null;
		int sum = 0;
		while ((nextLine = br.readLine()) != null) {
			if (!nextLine.equals("[") && !nextLine.equals("]")) {
				list.add(nextLine.substring(0, nextLine.length() - 1));
				// if (list.size() == 10000) {
				// batchConsumerProducer.addBatch(list);
				// break;
				// }
				if (list.size() == 200000) {
					sum += 200000;
					batchConsumerProducer.addBatch(list);
					list = new ArrayList<>();
					// break;
				}
				if (sum == 400000) {
					sum = 0;
					System.out.println("read 1000000");
					// break;
				}
			}

		}

		br.close();

		batchConsumerProducer.finish();

	}
}
