package de.uni_mannheim.informatik.dws.expansion.wikidata.reader;

import java.util.concurrent.ConcurrentHashMap;

import de.mannheim.uni.expansion.data.ontology.model.instances.InstanceId;
import de.mannheim.uni.expansion.data.ontology.model.properties.PropertyId;
import de.mannheim.uni.expansion.utils.containers.Pair;
import de.uni_mannheim.dws.expansion.data.ontology.model.types.WikidataParsedItem;
import de.uni_mannheim.dws.expansion.data.ontology.model.types.WikidataParsedObject;
import de.uni_mannheim.dws.expansion.data.ontology.model.types.WikidataParsedProperty;
import de.uni_mannheim.dws.expansion.data.ontology.model.types.WikidataType;

public class WikidataNameRepository {

	private ConcurrentHashMap<PropertyId, String> propertyNames = new ConcurrentHashMap<>();
	private ConcurrentHashMap<InstanceId, String> instanceNames = new ConcurrentHashMap<>();

	public void add(Pair<WikidataType, WikidataParsedObject> ite) {

		// FIXME: this is not good
		if (ite.getSecond().getLabel() == null) {
			return;
		}
		if (ite.getFirst() == WikidataType.ITEM) {

			WikidataParsedItem item = (WikidataParsedItem) ite.getSecond();
			instanceNames.put(item.getInstanceId(), item.getLabel());

		} else if (ite.getFirst() == WikidataType.PROPERTY) {
			WikidataParsedProperty property = (WikidataParsedProperty) ite.getSecond();
			propertyNames.put(property.getPropertyId(), property.getLabel());

		}
	}

	public String get(PropertyId propertyId) {
		return propertyNames.get(propertyId);
	}

	public String get(InstanceId instanceId) {
		return instanceNames.get(instanceId);
	}

	public String getOr(InstanceId instanceId, String or) {
		return instanceNames.getOrDefault(instanceId, or);
	}

	public String getOr(PropertyId propertyId, String or) {
		return propertyNames.getOrDefault(propertyId, or);
	}

}
