/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package de.mannheim.uni.index.pageResolving;

import de.mannheim.uni.index.io.DefaultIndex;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;
import java.util.zip.GZIPInputStream;
import org.apache.lucene.index.IndexWriter;

/**
 *
 * @author domi
 */
public class WebPageResolver {

    public static void main(String[] args) throws FileNotFoundException, IOException, ClassNotFoundException {
        BufferedReader readFiles = new BufferedReader(new FileReader(new File(args[0])));
        InputStream in = new GZIPInputStream(new FileInputStream(new File(args[1])));
        BufferedReader read = new BufferedReader(new InputStreamReader(in));
        Map<String, String> idToURI = new HashMap();
        String line = read.readLine();
        long cnt = 0;
        while (line != null) {
            String content[];
            content = line.split("\"\\|");
            if (content.length > 5) {
                try {
                    idToURI.put(content[5].replace("\"", ""),content[0].replace("\"", ""));
                } catch (Exception e) {
                    e.printStackTrace();
                    System.out.println(line);
                }
            }
            cnt++;
            if (cnt % 100000 == 0) {
                System.out.println("Indexed " + cnt + " items." + " id: " + content[5].replace("\"", "") + " uri " + content[0].replace("\"", ""));
            }
            line = read.readLine();
        }
        line = readFiles.readLine();
        while(line!=null) {
            for(String s : idToURI.keySet()) {
                if(s.contains(line)) {
                    System.out.println(line+"\t"+idToURI.get(s));
                }
            }            
            line = readFiles.readLine();
        }
        
        //index(args[0],args[1]);
    }

    private static void index(String args0, String args1) throws IOException {
        DefaultIndex idx = new DefaultIndex(args0);
        InputStream in = new GZIPInputStream(new FileInputStream(new File(args1)));
        //boolean smallFile = Boolean.parseBoolean(args[2]);
        BufferedReader read = new BufferedReader(new InputStreamReader(in));
        Map<String, String> idToURI = new HashMap();
        String line = read.readLine();
        long cnt = 0;
        while (line != null) {
            String content[];
//            if (smallFile) {
//                content = line.split("\t");
//                System.out.println(content[0].replace(".csv", "") + " --- "+ content[1]);
//                idToURI.put(content[0].replace(".csv", ""), content[1]);
//            } else {
            content = line.split("\"\\|");
            if (content.length > 5) {
                try {
                    idToURI.put(content[5].replace("\"", "").replace("/", "__").replace(".arc.gz", "arc").replace(".csv", ""), content[0].replace("\"", ""));
                } catch (Exception e) {
                    e.printStackTrace();
                    System.out.println(line);
                }
            }
//            }
            cnt++;
            if (cnt % 100000 == 0) {
                System.out.println("Indexed " + cnt + " items." + " id: " + content[5].replace("\"", "") + " uri " + content[0].replace("\"", ""));
            }
            line = read.readLine();
        }

        IndexWriter writer = idx.getIndexWriter();

        for (String id : idToURI.keySet()) {
            WebPageEntry e = new WebPageEntry();
            e.setTableID(id);
            e.setUri(idToURI.get(id));
            try {
                writer.addDocument(e.createDocument());
            } catch (IOException e1) {
                e1.printStackTrace();
            }
        }

        System.out.println("Indexed " + cnt + " items.");

        idx.closeIndexWriter();

        System.out.println("done.");
    }
}
