package de.mannheim.uni.matching.dbpedia.model;

import java.util.Date;

import org.apache.commons.lang3.builder.HashCodeBuilder;

import de.mannheim.uni.tableprocessor.model.Table;
import de.mannheim.uni.tableprocessor.model.TableColumn;
import de.mannheim.uni.tableprocessor.model.TableColumn.ColumnDataType;

public class TableCell implements Comparable<TableCell> {

    private Table table;
    private int rowIndex;
    private int columnIndex;
    private int hashCode;
    
    private Object value;
    private Object type;

    public Table getTable() {
        return table;
    }

    protected void setTable(Table table) {
        this.table = table;
    }

    public int getRowIndex() {
        return rowIndex;
    }

    protected void setRowIndex(int rowIndex) {
        this.rowIndex = rowIndex;
    }

    public int getColumnIndex() {
        return columnIndex;
    }

    protected void setColumnIndex(int columnIndex) {
        this.columnIndex = columnIndex;
    }

    public TableCell(Table t, int row, int column) {
        setTable(t);
        setRowIndex(row);
        setColumnIndex(column); 
        hashCode = new HashCodeBuilder().append(getTable().hashCode())
                .append(getRowIndex()).append(getColumnIndex()).toHashCode();
        
        value = getTable().getColumns().get(getColumnIndex()).getValues()
                .get(getRowIndex());
        
        type = getTable().getColumns().get(getColumnIndex()).getDataType();
        int sdf = 123;
        if(value.equals("") && type.equals(ColumnDataType.date)) {
        	  sdf = 123;
        }
        if(type == ColumnDataType.numeric && value instanceof Date) {
        	int sdfsdf = 123;
        }
    }

    public Object getValue() {
//    	TableColumn tc = table.getColumns().get(columnIndex);
//        return getTable().getColumns().get(getColumnIndex()).getValues()
//                .get(getRowIndex());
//    	ColumnDataType dt = tc.getDataType();
        return value;
    }

    public Object getType() {
        //return getTable().getColumns().get(getColumnIndex()).getDataType();
        return type;
    }

    
    @Override
  	public boolean equals(Object obj) {
  		if (this == obj)
  			return true;
  		if (obj == null)
  			return false;
  		if (getClass() != obj.getClass())
  			return false;
  		TableCell other = (TableCell) obj;
  		if (columnIndex != other.columnIndex)
  			return false;
  		if (rowIndex != other.rowIndex)
  			return false;
  		if (table == null) {
  			if (other.table != null)
  				return false;
  		} else if (!table.equals(other.table))
  			return false;
  		return true;
  	}
    
    @Override
    public int hashCode() {
        return this.hashCode;
    }

    @Override
    public String toString() {
        return "" + getValue();
    }

    public int compareTo(TableCell o) {
        if(o==null) {
            return -1;
        }
        
//        int comp = getTable().getHeader().compareTo(o.getTable().getHeader());
//        
//        if(comp==0) {
//            comp = Integer.compare(getColumnIndex(),o.getColumnIndex());
//            
//            if(comp==0) {
//                comp = Integer.compare(getRowIndex(), o.getRowIndex());
//            }
//        }
//        
//        return comp;
        
        String me = String.format("%s.%s.%s", getTable().getHeader(), getColumnIndex(), getRowIndex());
        String other = String.format("%s.%s.%s", o.getTable().getHeader(), o.getColumnIndex(), o.getRowIndex());
        
        return me.compareTo(other);
    }

}
