package de.mannheim.uni.matching.dbpedia.model;

import java.util.HashMap;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

import de.mannheim.uni.expansion.utils.CHMHelper;
import de.mannheim.uni.matching.dbpedia.model.adapters.TableColumnMatchingAdapter;
import de.mannheim.uni.matching.dbpedia.model.adapters.TableColumnToCellHierarchyAdapter;
import de.mannheim.uni.matching.dbpedia.model.adapters.TableToRowHierarchyAdapter;
import de.mannheim.uni.tableprocessor.model.Table;
import de.mannheim.uni.tableprocessor.model.TableColumn;

public class TableCellCache {

	/*
	 * Caches the cells generated for candidates, hence there are a few tables
	 * with a few rows each, but always containing all columns So we use a
	 * HashMap for the tables, a HashMap for the rows and an Array for the
	 * columns
	 */

	private ConcurrentHashMap<Object, ConcurrentHashMap<RowCol, TableCell>> cache = new ConcurrentHashMap<>();

//	protected Map<Object, Map<Integer, TableCell[]>> getCache() {
//		return cache;
//	}

	protected Map<Table, Map<Integer, TableCell[]>> createTableMap() {
		//return new HashMap<Table, Map<Integer, TableCell[]>>();
	    return new ConcurrentHashMap<Table, Map<Integer, TableCell[]>>(10, 0.9f, 1);
	}

	protected Map<Integer, TableCell[]> createRowMap() {
		//return new HashMap<Integer, TableCell[]>();
	    return new ConcurrentHashMap<>(10, 0.9f, 1);
	}

	protected TableCell[] createCellArray(Table t) {
		return new TableCell[t.getColumns().size()];
	}

	protected TableCellCache() {
//		cache = createTableMap();
	}

	private static TableCellCache singleton = new TableCellCache();

	public static TableCellCache get() {
//		if (singleton == null) {
//			singleton = new TableCellCache();
//		}

		return singleton;
	}

	public TableCell get(Table t, int row, int col) {
	    Map<RowCol, TableCell> rowMap = cache.get(t);
	    
		if (rowMap!=null) {

		    TableCell cell = rowMap.get(new RowCol(row, col));
		    
			if (cell!=null) {
				return cell;
			}
		}

		return null;
	}

 

//	public TableCell[] getCells(Table t, int row) {
//        Map<RowCol, TableCell> rowMap = cache.get(t.getIdObject());
//        
//        if (rowMap!=null) {
//
//            TableCell[] cellCollection = rowMap.get(row);
//            
//            return cellCollection;
//        }
//        
//        return null;
//	}
	
	
	private ConcurrentHashMap<Object, TableCell[][]> cacheNew = new ConcurrentHashMap<>();
	
	public TableCell getOrCreate(Table t, int row, int col) {
		return new TableCell(t, row, col);
//	    ConcurrentHashMap<RowCol, TableCell> rowMap = CHMHelper.getFromCHM(this.cache, t.getIdObject(), () -> new ConcurrentHashMap<>());
//	    
//	    TableCell c = CHMHelper.getFromCHM(rowMap, new RowCol(row,col), () -> new TableCell(t, row, col));
//		return c;
		
		
//		TableCell[][] rowMap = CHMHelper.getFromCHM(this.cacheNew, t.getIdObject(), () -> new TableCell[t.getTotalNumOfRows()][t.getColumns().size()]);
//		if(rowMap[row][col] == null) {
//			rowMap[row][col] = new TableCell(t, row, col);
//		}
//		return rowMap[row][col];
//	    TableCell c = CHMHelper.getFromCHM(rowMap, new RowCol(row,col), () -> new TableCell(t, row, col));
//		return c;
		
		
		
//	    		getCache().get(t);
//	    
//		if (rowMap!=null) {

//		    TableCell[] cellCollection = rowMap.get(row);
//		    
//			if (cellCollection!=null) {
//				if (cellCollection[col] != null) {
//					return cellCollection[col];
//				}
//
//			}
////		}
//
//		TableCell c = new TableCell(t, row, col);
//		set(c);
	
	}

//	public void set(TableCell c) {
//	    synchronized (TableToRowHierarchyAdapter.tableCacheGetter.get(c.getTable())) {
//    		Map<Integer, TableCell[]> rowMap = getCache().get(c.getTable());;
//    
//    		if (rowMap==null) {
//    			rowMap = createRowMap();
//    			getCache().put(c.getTable(), rowMap);
//    		}
//    
//    		TableCell[] cellCollection = rowMap.get(c.getRowIndex());
//    
//    		if (cellCollection==null) {
//    			cellCollection = createCellArray(c.getTable());
//    			rowMap.put(c.getRowIndex(), cellCollection);
//    		}
//    
//    		cellCollection[c.getColumnIndex()] = c;
//        }
//	}
	
	public void removeTable(Table t) {
	    cache.remove(t.getIdObject());
	    for(TableColumn tc : t.getColumns()) {
	    	TableColumnMatchingAdapter.removeFromCache(tc);
	    	TableColumnToCellHierarchyAdapter.removeFromCache(tc);
	    }
	}
	
	private static class RowCol {
		private final int row;
		private final int col;
		public RowCol(int row, int col) {
			super();
			this.row = row;
			this.col = col;
		}
		@Override
		public int hashCode() {
			final int prime = 31;
			int result = 1;
			result = prime * result + col;
			result = prime * result + row;
			return result;
		}
		@Override
		public boolean equals(Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (!(obj instanceof RowCol))
				return false;
			RowCol other = (RowCol) obj;
			if (col != other.col)
				return false;
			if (row != other.row)
				return false;
			return true;
		}
		
		
	}
}
