package de.mannheim.uni.matching.dbpedia.model.adapters;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentLinkedQueue;

import de.mannheim.uni.expansion.utils.PersistentParallel4;
import de.mannheim.uni.expansion.utils.PersistentParallel6;
import de.mannheim.uni.expansion.utils.SimpleLockableConcurrentCache;
import de.mannheim.uni.matching.MatchingHierarchyAdapater;
import de.mannheim.uni.matching.dbpedia.model.TableCell;
import de.mannheim.uni.matching.dbpedia.model.TableCellCache;
import de.mannheim.uni.matching.dbpedia.model.TableColumnCache;
import de.mannheim.uni.matching.dbpedia.model.TableRow;
import de.mannheim.uni.matching.dbpedia.model.adapters.TableColumnToCellHierarchyAdapter.TableColumnCacheGetter;
import de.mannheim.uni.matching.dbpedia.model.adapters.TableToRowHierarchyAdapter.TableCacheGetter;
import de.mannheim.uni.tableprocessor.model.Table;
import de.mannheim.uni.tableprocessor.model.TableColumn;

public class TableColumnToCellHierarchyAdapter extends MatchingHierarchyAdapater<TableColumn, TableCell> {

	public static interface TableColumnCacheGetter {
			
			TableColumn get(TableColumn tc);

			TableColumn getRaw(Object tc);
			
		}
	
	public static   TableColumnCacheGetter tableColumnCacheGetter;
	
	
 
	private static SimpleLockableConcurrentCache<Object, Collection<TableCell> > tableColumnRowCacheGetter = new SimpleLockableConcurrentCache<>();

	
	
		 public static void removeFromCache(TableColumn tc) {
			 tableColumnRowCacheGetter.remove(tc.getHashCodeObject());
		 }

	
	
	@Override
	public Collection<TableCell> getParts(TableColumn nonFinalInstance) {

//	    TableColumnCache colCache = TableColumnCache.get();
	    
	    TableColumn instance = tableColumnCacheGetter.get(nonFinalInstance);
        Collection<TableCell> cells = tableColumnRowCacheGetter.get(instance.getHashCodeObject());
        
        TableCellCache cache = TableCellCache.get();
        
	    if(cells==null) {
//	    PersistentParallel6.setThreadPaused();
	   
	    	cells = tableColumnRowCacheGetter.getOrCreate(instance.getHashCodeObject(), () -> {
	    		ConcurrentLinkedQueue<TableCell> cellsTmp =new ConcurrentLinkedQueue<>();

                int colIndex = instance.getTable().getColumns().indexOf(instance);

                Table t = instance.getTable();
//                TableCellCache cache = TableCellCache.get();

                PersistentParallel6.runAndFinish(instance.getValues().keySet(), (key) -> {
               	 
                	  cellsTmp.add(cache.getOrCreate(t, key, colIndex)); 
                 
                }, "TableColumnToCellHierarchyAdapter", instance.getValues().size() < 1000);
                return new ArrayList<>(cellsTmp);
	    	});
	    	
	 

	    }
		
		return cells;
	}

	public synchronized static void setCacheSynchronizedIfNotExists(TableColumnCacheGetter tableColumnCacheGetter) {
		if(TableColumnToCellHierarchyAdapter.tableColumnCacheGetter == null) {
			TableColumnToCellHierarchyAdapter.tableColumnCacheGetter = tableColumnCacheGetter;
		}
		
	}

}
