package de.mannheim.uni.matching.dbpedia.properties;

import java.util.Collection;
import java.util.LinkedList;
import java.util.SortedSet;
import java.util.TreeSet;

import de.mannheim.uni.utils.io.CSVUtils;
import java.util.ArrayList;
import java.util.List;

public class Canoniser {

    private Collection<List<String>> equivalentResources;
    public Collection<List<String>> getEquivalentResources() {
        return equivalentResources;
    }
    
    public void loadEquivalentResources(String fileName) {
        Collection<String[]> lines = CSVUtils.readCSV(fileName, "\t");
        
        equivalentResources = new LinkedList<List<String>>();
        
        for(String[] line : lines) {
            List<String> equivalent = new ArrayList<String>();
            
            for(String prop : line) {
                equivalent.add(prop);
            }
            
            equivalentResources.add(equivalent);
        }
    }
    
    public String canoniseResource(String resource) {
        for(List<String> set : equivalentResources) {            
            if(set.contains(resource)) {                
                return set.get(0);              
            }            
        }        
        return resource;
    }    
}
