package de.mannheim.uni.matching.similarity.signatures;

import java.util.Collection;
import java.util.List;

import de.mannheim.uni.similarity.functions.SimilarityFunction;
import de.mannheim.uni.utils.data.Pair;

public class JaccardPrefixFiltering<T extends Comparable<T>> extends PrefixFiltering<T> {

    @Override
    protected int getPrefixLength(Collection<T> signature, double threshold,
            SimilarityFunction<T> sim) {
        return signature.size() - (int)Math.ceil(threshold * signature.size()) + 1;
    }

}
