package de.mannheim.uni.similarity.functions;

import de.mannheim.uni.matching.ValueRange;

public class SimilarityFunctionDecorator<T> extends SimilarityFunction<T> {

    private SimilarityFunction<T> innerFunction;
    protected SimilarityFunction<T> getInnerFunction() {
        return innerFunction;
    }
    
    public SimilarityFunctionDecorator(SimilarityFunction<T> innerFunction) {
        this.innerFunction = innerFunction;
    }
    
    @Override
    public Double calculate(T first, T second) {
        return innerFunction.calculate(first, second);
    }
    
    @Override
    public void setValueRange(ValueRange range) {
        innerFunction.setValueRange(range);
    }
    
}
